/* util-email.c generated by valac 0.42.5, the Vala compiler
 * generated from util-email.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */


#include <glib.h>
#include <glib-object.h>
#include "geary-engine.h"
#include <stdlib.h>
#include <string.h>
#include <glib/gi18n-lib.h>

#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
#define _g_free0(var) (var = (g_free (var), NULL))



gint compare_conversation_ascending (GearyAppConversation* a,
                                     GearyAppConversation* b);
gint compare_conversation_descending (GearyAppConversation* a,
                                      GearyAppConversation* b);
gchar* email_util_strip_subject_prefixes (GearyEmail* email);
gchar* email_util_to_short_recipient_display (GearyRFC822MailboxAddresses* mailboxes);


gint
compare_conversation_ascending (GearyAppConversation* a,
                                GearyAppConversation* b)
{
	gint result = 0;
	GearyEmail* a_latest = NULL;
	GearyEmail* _tmp0_;
	GearyEmail* b_latest = NULL;
	GearyEmail* _tmp1_;
	GearyEmail* _tmp2_;
	GearyEmail* _tmp6_;
	GearyEmail* _tmp7_;
#line 7 "../src/client/util/util-email.vala"
	g_return_val_if_fail (GEARY_APP_IS_CONVERSATION (a), 0);
#line 7 "../src/client/util/util-email.vala"
	g_return_val_if_fail (GEARY_APP_IS_CONVERSATION (b), 0);
#line 8 "../src/client/util/util-email.vala"
	_tmp0_ = geary_app_conversation_get_latest_recv_email (a, GEARY_APP_CONVERSATION_LOCATION_IN_FOLDER_OUT_OF_FOLDER, NULL);
#line 8 "../src/client/util/util-email.vala"
	a_latest = _tmp0_;
#line 9 "../src/client/util/util-email.vala"
	_tmp1_ = geary_app_conversation_get_latest_recv_email (b, GEARY_APP_CONVERSATION_LOCATION_IN_FOLDER_OUT_OF_FOLDER, NULL);
#line 9 "../src/client/util/util-email.vala"
	b_latest = _tmp1_;
#line 11 "../src/client/util/util-email.vala"
	_tmp2_ = a_latest;
#line 11 "../src/client/util/util-email.vala"
	if (_tmp2_ == NULL) {
#line 60 "util-email.c"
		gint _tmp3_ = 0;
		GearyEmail* _tmp4_;
#line 12 "../src/client/util/util-email.vala"
		_tmp4_ = b_latest;
#line 12 "../src/client/util/util-email.vala"
		if (_tmp4_ == NULL) {
#line 12 "../src/client/util/util-email.vala"
			_tmp3_ = 0;
#line 69 "util-email.c"
		} else {
#line 12 "../src/client/util/util-email.vala"
			_tmp3_ = -1;
#line 73 "util-email.c"
		}
#line 12 "../src/client/util/util-email.vala"
		result = _tmp3_;
#line 12 "../src/client/util/util-email.vala"
		_g_object_unref0 (b_latest);
#line 12 "../src/client/util/util-email.vala"
		_g_object_unref0 (a_latest);
#line 12 "../src/client/util/util-email.vala"
		return result;
#line 83 "util-email.c"
	} else {
		GearyEmail* _tmp5_;
#line 13 "../src/client/util/util-email.vala"
		_tmp5_ = b_latest;
#line 13 "../src/client/util/util-email.vala"
		if (_tmp5_ == NULL) {
#line 14 "../src/client/util/util-email.vala"
			result = 1;
#line 14 "../src/client/util/util-email.vala"
			_g_object_unref0 (b_latest);
#line 14 "../src/client/util/util-email.vala"
			_g_object_unref0 (a_latest);
#line 14 "../src/client/util/util-email.vala"
			return result;
#line 98 "util-email.c"
		}
	}
#line 18 "../src/client/util/util-email.vala"
	_tmp6_ = a_latest;
#line 18 "../src/client/util/util-email.vala"
	_tmp7_ = b_latest;
#line 18 "../src/client/util/util-email.vala"
	result = geary_email_compare_recv_date_ascending (_tmp6_, _tmp7_);
#line 18 "../src/client/util/util-email.vala"
	_g_object_unref0 (b_latest);
#line 18 "../src/client/util/util-email.vala"
	_g_object_unref0 (a_latest);
#line 18 "../src/client/util/util-email.vala"
	return result;
#line 113 "util-email.c"
}


gint
compare_conversation_descending (GearyAppConversation* a,
                                 GearyAppConversation* b)
{
	gint result = 0;
#line 21 "../src/client/util/util-email.vala"
	g_return_val_if_fail (GEARY_APP_IS_CONVERSATION (a), 0);
#line 21 "../src/client/util/util-email.vala"
	g_return_val_if_fail (GEARY_APP_IS_CONVERSATION (b), 0);
#line 22 "../src/client/util/util-email.vala"
	result = compare_conversation_ascending (b, a);
#line 22 "../src/client/util/util-email.vala"
	return result;
#line 130 "util-email.c"
}


gchar*
email_util_strip_subject_prefixes (GearyEmail* email)
{
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
	GearyRFC822Subject* _tmp1_;
	GearyRFC822Subject* _tmp2_;
	gchar* cleaned = NULL;
	gchar* _tmp6_;
	const gchar* _tmp7_ = NULL;
	const gchar* _tmp8_;
	gchar* _tmp10_;
#line 27 "../src/client/util/util-email.vala"
	g_return_val_if_fail (GEARY_IS_EMAIL (email), NULL);
#line 28 "../src/client/util/util-email.vala"
	_tmp1_ = geary_email_get_subject (email);
#line 28 "../src/client/util/util-email.vala"
	_tmp2_ = _tmp1_;
#line 28 "../src/client/util/util-email.vala"
	if (_tmp2_ != NULL) {
#line 154 "util-email.c"
		GearyRFC822Subject* _tmp3_;
		GearyRFC822Subject* _tmp4_;
		gchar* _tmp5_;
#line 28 "../src/client/util/util-email.vala"
		_tmp3_ = geary_email_get_subject (email);
#line 28 "../src/client/util/util-email.vala"
		_tmp4_ = _tmp3_;
#line 28 "../src/client/util/util-email.vala"
		_tmp5_ = geary_rf_c822_subject_strip_prefixes (_tmp4_);
#line 28 "../src/client/util/util-email.vala"
		_g_free0 (_tmp0_);
#line 28 "../src/client/util/util-email.vala"
		_tmp0_ = _tmp5_;
#line 168 "util-email.c"
	} else {
#line 28 "../src/client/util/util-email.vala"
		_g_free0 (_tmp0_);
#line 28 "../src/client/util/util-email.vala"
		_tmp0_ = NULL;
#line 174 "util-email.c"
	}
#line 28 "../src/client/util/util-email.vala"
	_tmp6_ = g_strdup (_tmp0_);
#line 28 "../src/client/util/util-email.vala"
	cleaned = _tmp6_;
#line 30 "../src/client/util/util-email.vala"
	_tmp8_ = cleaned;
#line 30 "../src/client/util/util-email.vala"
	if (!geary_string_is_empty (_tmp8_)) {
#line 184 "util-email.c"
		const gchar* _tmp9_;
#line 30 "../src/client/util/util-email.vala"
		_tmp9_ = cleaned;
#line 30 "../src/client/util/util-email.vala"
		_tmp7_ = _tmp9_;
#line 190 "util-email.c"
	} else {
#line 30 "../src/client/util/util-email.vala"
		_tmp7_ = _ ("(no subject)");
#line 194 "util-email.c"
	}
#line 30 "../src/client/util/util-email.vala"
	_tmp10_ = g_strdup (_tmp7_);
#line 30 "../src/client/util/util-email.vala"
	result = _tmp10_;
#line 30 "../src/client/util/util-email.vala"
	_g_free0 (cleaned);
#line 30 "../src/client/util/util-email.vala"
	_g_free0 (_tmp0_);
#line 30 "../src/client/util/util-email.vala"
	return result;
#line 206 "util-email.c"
}


/**
     * Returns a shortened recipient list suitable for display.
     *
     * This is useful in case there are a lot of recipients, or there
     * is little room for the display.
     *
     * @return a string containing at least the first mailbox
     * serialised by {@link MailboxAddress.to_short_display}, if the
     * list contains more mailboxes then an indication of how many
     * additional are present.
     */
gchar*
email_util_to_short_recipient_display (GearyRFC822MailboxAddresses* mailboxes)
{
	gchar* result = NULL;
	gint _tmp0_;
	gint _tmp1_;
	gchar* first_recipient = NULL;
	GearyRFC822MailboxAddress* _tmp3_;
	GearyRFC822MailboxAddress* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gint _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
	gint _tmp10_;
	const gchar* _tmp11_;
	gint _tmp12_;
	gint _tmp13_;
	gchar* _tmp14_;
#line 44 "../src/client/util/util-email.vala"
	g_return_val_if_fail (GEARY_RF_C822_IS_MAILBOX_ADDRESSES (mailboxes), NULL);
#line 45 "../src/client/util/util-email.vala"
	_tmp0_ = geary_rf_c822_mailbox_addresses_get_size (mailboxes);
#line 45 "../src/client/util/util-email.vala"
	_tmp1_ = _tmp0_;
#line 45 "../src/client/util/util-email.vala"
	if (_tmp1_ == 0) {
#line 248 "util-email.c"
		gchar* _tmp2_;
#line 49 "../src/client/util/util-email.vala"
		_tmp2_ = g_strdup (_ ("(No recipients)"));
#line 49 "../src/client/util/util-email.vala"
		result = _tmp2_;
#line 49 "../src/client/util/util-email.vala"
		return result;
#line 256 "util-email.c"
	}
#line 53 "../src/client/util/util-email.vala"
	_tmp3_ = geary_rf_c822_mailbox_addresses_get (mailboxes, 0);
#line 53 "../src/client/util/util-email.vala"
	_tmp4_ = _tmp3_;
#line 53 "../src/client/util/util-email.vala"
	_tmp5_ = geary_rf_c822_mailbox_address_to_short_display (_tmp4_);
#line 53 "../src/client/util/util-email.vala"
	_tmp6_ = _tmp5_;
#line 53 "../src/client/util/util-email.vala"
	_g_object_unref0 (_tmp4_);
#line 53 "../src/client/util/util-email.vala"
	first_recipient = _tmp6_;
#line 54 "../src/client/util/util-email.vala"
	_tmp7_ = geary_rf_c822_mailbox_addresses_get_size (mailboxes);
#line 54 "../src/client/util/util-email.vala"
	_tmp8_ = _tmp7_;
#line 54 "../src/client/util/util-email.vala"
	if (_tmp8_ == 1) {
#line 55 "../src/client/util/util-email.vala"
		result = first_recipient;
#line 55 "../src/client/util/util-email.vala"
		return result;
#line 280 "util-email.c"
	}
#line 62 "../src/client/util/util-email.vala"
	_tmp9_ = geary_rf_c822_mailbox_addresses_get_size (mailboxes);
#line 62 "../src/client/util/util-email.vala"
	_tmp10_ = _tmp9_;
#line 62 "../src/client/util/util-email.vala"
	_tmp11_ = first_recipient;
#line 62 "../src/client/util/util-email.vala"
	_tmp12_ = geary_rf_c822_mailbox_addresses_get_size (mailboxes);
#line 62 "../src/client/util/util-email.vala"
	_tmp13_ = _tmp12_;
#line 62 "../src/client/util/util-email.vala"
	_tmp14_ = g_strdup_printf (ngettext ("%s and %d other", "%s and %d others", (gulong) (_tmp10_ - 1)), _tmp11_, _tmp13_ - 1);
#line 62 "../src/client/util/util-email.vala"
	result = _tmp14_;
#line 62 "../src/client/util/util-email.vala"
	_g_free0 (first_recipient);
#line 62 "../src/client/util/util-email.vala"
	return result;
#line 300 "util-email.c"
}



