/* imap-engine.c generated by valac 0.42.5, the Vala compiler
 * generated from imap-engine.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */


#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>


typedef enum  {
	GEARY_ENGINE_ERROR_OPEN_REQUIRED,
	GEARY_ENGINE_ERROR_ALREADY_OPEN,
	GEARY_ENGINE_ERROR_ALREADY_EXISTS,
	GEARY_ENGINE_ERROR_ALREADY_CLOSED,
	GEARY_ENGINE_ERROR_CLOSE_REQUIRED,
	GEARY_ENGINE_ERROR_NOT_FOUND,
	GEARY_ENGINE_ERROR_BAD_PARAMETERS,
	GEARY_ENGINE_ERROR_INCOMPLETE_MESSAGE,
	GEARY_ENGINE_ERROR_SERVER_UNAVAILABLE,
	GEARY_ENGINE_ERROR_CORRUPT,
	GEARY_ENGINE_ERROR_PERMISSIONS,
	GEARY_ENGINE_ERROR_VERSION,
	GEARY_ENGINE_ERROR_UNSUPPORTED
} GearyEngineError;
#define GEARY_ENGINE_ERROR geary_engine_error_quark ()
typedef enum  {
	GEARY_IMAP_ERROR_PARSE_ERROR,
	GEARY_IMAP_ERROR_TYPE_ERROR,
	GEARY_IMAP_ERROR_NOT_CONNECTED,
	GEARY_IMAP_ERROR_ALREADY_CONNECTED,
	GEARY_IMAP_ERROR_SERVER_ERROR,
	GEARY_IMAP_ERROR_UNAUTHENTICATED,
	GEARY_IMAP_ERROR_NOT_SUPPORTED,
	GEARY_IMAP_ERROR_INVALID,
	GEARY_IMAP_ERROR_TIMED_OUT,
	GEARY_IMAP_ERROR_UNAVAILABLE
} GearyImapError;
#define GEARY_IMAP_ERROR geary_imap_error_quark ()


gboolean geary_imap_engine_is_recoverable_failure (GError* err);
GQuark geary_engine_error_quark (void);
GQuark geary_imap_error_quark (void);
gboolean geary_imap_engine_is_remote_error (GError* err);


/**
     * Determines if retrying an operation might succeed or not.
     *
     * A recoverable failure is defined as one that may not occur
     * again if the operation that caused it is retried, without
     * needing to make some change in the mean time. For example,
     * recoverable failures may occur due to transient network
     * connectivity issues or server rate limiting. On the other hand,
     * an unrecoverable failure is due to some problem that will not
     * succeed if tried again unless some action is taken, such as
     * authentication failures, protocol parsing errors, and so on.
     */
gboolean
geary_imap_engine_is_recoverable_failure (GError* err)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_ = FALSE;
#line 23 "../src/engine/imap-engine/imap-engine.vala"
	if (g_error_matches (err, GEARY_ENGINE_ERROR, GEARY_ENGINE_ERROR_SERVER_UNAVAILABLE)) {
#line 23 "../src/engine/imap-engine/imap-engine.vala"
		_tmp7_ = TRUE;
#line 82 "imap-engine.c"
	} else {
#line 24 "../src/engine/imap-engine/imap-engine.vala"
		_tmp7_ = g_error_matches (err, G_IO_ERROR, G_IO_ERROR_BROKEN_PIPE);
#line 86 "imap-engine.c"
	}
#line 23 "../src/engine/imap-engine/imap-engine.vala"
	if (_tmp7_) {
#line 23 "../src/engine/imap-engine/imap-engine.vala"
		_tmp6_ = TRUE;
#line 92 "imap-engine.c"
	} else {
#line 25 "../src/engine/imap-engine/imap-engine.vala"
		_tmp6_ = g_error_matches (err, G_IO_ERROR, G_IO_ERROR_BUSY);
#line 96 "imap-engine.c"
	}
#line 23 "../src/engine/imap-engine/imap-engine.vala"
	if (_tmp6_) {
#line 23 "../src/engine/imap-engine/imap-engine.vala"
		_tmp5_ = TRUE;
#line 102 "imap-engine.c"
	} else {
#line 26 "../src/engine/imap-engine/imap-engine.vala"
		_tmp5_ = g_error_matches (err, G_IO_ERROR, G_IO_ERROR_CONNECTION_CLOSED);
#line 106 "imap-engine.c"
	}
#line 23 "../src/engine/imap-engine/imap-engine.vala"
	if (_tmp5_) {
#line 23 "../src/engine/imap-engine/imap-engine.vala"
		_tmp4_ = TRUE;
#line 112 "imap-engine.c"
	} else {
#line 27 "../src/engine/imap-engine/imap-engine.vala"
		_tmp4_ = g_error_matches (err, G_IO_ERROR, G_IO_ERROR_NOT_CONNECTED);
#line 116 "imap-engine.c"
	}
#line 23 "../src/engine/imap-engine/imap-engine.vala"
	if (_tmp4_) {
#line 23 "../src/engine/imap-engine/imap-engine.vala"
		_tmp3_ = TRUE;
#line 122 "imap-engine.c"
	} else {
#line 28 "../src/engine/imap-engine/imap-engine.vala"
		_tmp3_ = g_error_matches (err, G_IO_ERROR, G_IO_ERROR_TIMED_OUT);
#line 126 "imap-engine.c"
	}
#line 23 "../src/engine/imap-engine/imap-engine.vala"
	if (_tmp3_) {
#line 23 "../src/engine/imap-engine/imap-engine.vala"
		_tmp2_ = TRUE;
#line 132 "imap-engine.c"
	} else {
#line 29 "../src/engine/imap-engine/imap-engine.vala"
		_tmp2_ = g_error_matches (err, GEARY_IMAP_ERROR, GEARY_IMAP_ERROR_NOT_CONNECTED);
#line 136 "imap-engine.c"
	}
#line 23 "../src/engine/imap-engine/imap-engine.vala"
	if (_tmp2_) {
#line 23 "../src/engine/imap-engine/imap-engine.vala"
		_tmp1_ = TRUE;
#line 142 "imap-engine.c"
	} else {
#line 30 "../src/engine/imap-engine/imap-engine.vala"
		_tmp1_ = g_error_matches (err, GEARY_IMAP_ERROR, GEARY_IMAP_ERROR_TIMED_OUT);
#line 146 "imap-engine.c"
	}
#line 23 "../src/engine/imap-engine/imap-engine.vala"
	if (_tmp1_) {
#line 23 "../src/engine/imap-engine/imap-engine.vala"
		_tmp0_ = TRUE;
#line 152 "imap-engine.c"
	} else {
#line 31 "../src/engine/imap-engine/imap-engine.vala"
		_tmp0_ = g_error_matches (err, GEARY_IMAP_ERROR, GEARY_IMAP_ERROR_UNAVAILABLE);
#line 156 "imap-engine.c"
	}
#line 22 "../src/engine/imap-engine/imap-engine.vala"
	result = _tmp0_;
#line 22 "../src/engine/imap-engine/imap-engine.vala"
	return result;
#line 162 "imap-engine.c"
}


/**
     * Determines if an error was caused by the remote host or not.
     */
gboolean
geary_imap_engine_is_remote_error (GError* err)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	gboolean _tmp4_ = FALSE;
	gboolean _tmp5_ = FALSE;
	gboolean _tmp6_ = FALSE;
	gboolean _tmp7_ = FALSE;
	gboolean _tmp8_ = FALSE;
	gboolean _tmp9_ = FALSE;
	gboolean _tmp10_ = FALSE;
	gboolean _tmp11_ = FALSE;
#line 40 "../src/engine/imap-engine/imap-engine.vala"
	if (g_error_matches (err, GEARY_ENGINE_ERROR, GEARY_ENGINE_ERROR_NOT_FOUND)) {
#line 40 "../src/engine/imap-engine/imap-engine.vala"
		_tmp11_ = TRUE;
#line 189 "imap-engine.c"
	} else {
#line 41 "../src/engine/imap-engine/imap-engine.vala"
		_tmp11_ = g_error_matches (err, GEARY_ENGINE_ERROR, GEARY_ENGINE_ERROR_SERVER_UNAVAILABLE);
#line 193 "imap-engine.c"
	}
#line 40 "../src/engine/imap-engine/imap-engine.vala"
	if (_tmp11_) {
#line 40 "../src/engine/imap-engine/imap-engine.vala"
		_tmp10_ = TRUE;
#line 199 "imap-engine.c"
	} else {
#line 42 "../src/engine/imap-engine/imap-engine.vala"
		_tmp10_ = g_error_matches (err, G_IO_ERROR, G_IO_ERROR_CONNECTION_CLOSED);
#line 203 "imap-engine.c"
	}
#line 40 "../src/engine/imap-engine/imap-engine.vala"
	if (_tmp10_) {
#line 40 "../src/engine/imap-engine/imap-engine.vala"
		_tmp9_ = TRUE;
#line 209 "imap-engine.c"
	} else {
#line 43 "../src/engine/imap-engine/imap-engine.vala"
		_tmp9_ = g_error_matches (err, G_IO_ERROR, G_IO_ERROR_CONNECTION_REFUSED);
#line 213 "imap-engine.c"
	}
#line 40 "../src/engine/imap-engine/imap-engine.vala"
	if (_tmp9_) {
#line 40 "../src/engine/imap-engine/imap-engine.vala"
		_tmp8_ = TRUE;
#line 219 "imap-engine.c"
	} else {
#line 44 "../src/engine/imap-engine/imap-engine.vala"
		_tmp8_ = g_error_matches (err, G_IO_ERROR, G_IO_ERROR_HOST_UNREACHABLE);
#line 223 "imap-engine.c"
	}
#line 40 "../src/engine/imap-engine/imap-engine.vala"
	if (_tmp8_) {
#line 40 "../src/engine/imap-engine/imap-engine.vala"
		_tmp7_ = TRUE;
#line 229 "imap-engine.c"
	} else {
#line 45 "../src/engine/imap-engine/imap-engine.vala"
		_tmp7_ = g_error_matches (err, G_IO_ERROR, G_IO_ERROR_MESSAGE_TOO_LARGE);
#line 233 "imap-engine.c"
	}
#line 40 "../src/engine/imap-engine/imap-engine.vala"
	if (_tmp7_) {
#line 40 "../src/engine/imap-engine/imap-engine.vala"
		_tmp6_ = TRUE;
#line 239 "imap-engine.c"
	} else {
#line 46 "../src/engine/imap-engine/imap-engine.vala"
		_tmp6_ = g_error_matches (err, G_IO_ERROR, G_IO_ERROR_NETWORK_UNREACHABLE);
#line 243 "imap-engine.c"
	}
#line 40 "../src/engine/imap-engine/imap-engine.vala"
	if (_tmp6_) {
#line 40 "../src/engine/imap-engine/imap-engine.vala"
		_tmp5_ = TRUE;
#line 249 "imap-engine.c"
	} else {
#line 47 "../src/engine/imap-engine/imap-engine.vala"
		_tmp5_ = g_error_matches (err, G_IO_ERROR, G_IO_ERROR_NOT_CONNECTED);
#line 253 "imap-engine.c"
	}
#line 40 "../src/engine/imap-engine/imap-engine.vala"
	if (_tmp5_) {
#line 40 "../src/engine/imap-engine/imap-engine.vala"
		_tmp4_ = TRUE;
#line 259 "imap-engine.c"
	} else {
#line 48 "../src/engine/imap-engine/imap-engine.vala"
		_tmp4_ = g_error_matches (err, G_IO_ERROR, G_IO_ERROR_PROXY_AUTH_FAILED);
#line 263 "imap-engine.c"
	}
#line 40 "../src/engine/imap-engine/imap-engine.vala"
	if (_tmp4_) {
#line 40 "../src/engine/imap-engine/imap-engine.vala"
		_tmp3_ = TRUE;
#line 269 "imap-engine.c"
	} else {
#line 49 "../src/engine/imap-engine/imap-engine.vala"
		_tmp3_ = g_error_matches (err, G_IO_ERROR, G_IO_ERROR_PROXY_FAILED);
#line 273 "imap-engine.c"
	}
#line 40 "../src/engine/imap-engine/imap-engine.vala"
	if (_tmp3_) {
#line 40 "../src/engine/imap-engine/imap-engine.vala"
		_tmp2_ = TRUE;
#line 279 "imap-engine.c"
	} else {
#line 50 "../src/engine/imap-engine/imap-engine.vala"
		_tmp2_ = g_error_matches (err, G_IO_ERROR, G_IO_ERROR_PROXY_NEED_AUTH);
#line 283 "imap-engine.c"
	}
#line 40 "../src/engine/imap-engine/imap-engine.vala"
	if (_tmp2_) {
#line 40 "../src/engine/imap-engine/imap-engine.vala"
		_tmp1_ = TRUE;
#line 289 "imap-engine.c"
	} else {
#line 51 "../src/engine/imap-engine/imap-engine.vala"
		_tmp1_ = g_error_matches (err, G_IO_ERROR, G_IO_ERROR_PROXY_NOT_ALLOWED);
#line 293 "imap-engine.c"
	}
#line 40 "../src/engine/imap-engine/imap-engine.vala"
	if (_tmp1_) {
#line 40 "../src/engine/imap-engine/imap-engine.vala"
		_tmp0_ = TRUE;
#line 299 "imap-engine.c"
	} else {
#line 52 "../src/engine/imap-engine/imap-engine.vala"
		_tmp0_ = err->domain == GEARY_IMAP_ERROR;
#line 303 "imap-engine.c"
	}
#line 39 "../src/engine/imap-engine/imap-engine.vala"
	result = _tmp0_;
#line 39 "../src/engine/imap-engine/imap-engine.vala"
	return result;
#line 309 "imap-engine.c"
}



