/* imap-data-format.c generated by valac 0.42.5, the Vala compiler
 * generated from imap-data-format.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */


#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>

typedef enum  {
	GEARY_IMAP_DATA_FORMAT_QUOTING_REQUIRED,
	GEARY_IMAP_DATA_FORMAT_QUOTING_OPTIONAL,
	GEARY_IMAP_DATA_FORMAT_QUOTING_UNALLOWED
} GearyImapDataFormatQuoting;


#define GEARY_IMAP_DATA_FORMAT_TYPE_QUOTING (geary_imap_data_format_quoting_get_type ())



GType geary_imap_data_format_quoting_get_type (void) G_GNUC_CONST;
gboolean geary_imap_data_format_is_special_char (gchar ch,
                                                 gchar* ar,
                                                 int ar_length1,
                                                 const gchar* exceptions);
static gboolean _vala_char_array_contains (gchar * stack,
                                    int stack_length,
                                    const gchar needle);
gint geary_ascii_index_of (const gchar* str,
                           gchar ch);
gboolean geary_imap_data_format_is_atom_special (gchar ch,
                                                 const gchar* exceptions);
gboolean geary_imap_data_format_is_tag_special (gchar ch,
                                                const gchar* exceptions);
GearyImapDataFormatQuoting geary_imap_data_format_is_quoting_required (const gchar* str);
gboolean geary_string_is_empty (const gchar* str);
#define GEARY_STRING_EOS '\0'

const gchar GEARY_IMAP_DATA_FORMAT_ATOM_SPECIALS[9] = {'(', ')', '{', ' ', '%', '*', '"', '\\', ']'};
const gchar GEARY_IMAP_DATA_FORMAT_TAG_SPECIALS[7] = {'(', ')', '{', '%', '\"', '\\', '+'};

GType
geary_imap_data_format_quoting_get_type (void)
{
	static volatile gsize geary_imap_data_format_quoting_type_id__volatile = 0;
	if (g_once_init_enter (&geary_imap_data_format_quoting_type_id__volatile)) {
		static const GEnumValue values[] = {{GEARY_IMAP_DATA_FORMAT_QUOTING_REQUIRED, "GEARY_IMAP_DATA_FORMAT_QUOTING_REQUIRED", "required"}, {GEARY_IMAP_DATA_FORMAT_QUOTING_OPTIONAL, "GEARY_IMAP_DATA_FORMAT_QUOTING_OPTIONAL", "optional"}, {GEARY_IMAP_DATA_FORMAT_QUOTING_UNALLOWED, "GEARY_IMAP_DATA_FORMAT_QUOTING_UNALLOWED", "unallowed"}, {0, NULL, NULL}};
		GType geary_imap_data_format_quoting_type_id;
		geary_imap_data_format_quoting_type_id = g_enum_register_static ("GearyImapDataFormatQuoting", values);
		g_once_init_leave (&geary_imap_data_format_quoting_type_id__volatile, geary_imap_data_format_quoting_type_id);
	}
	return geary_imap_data_format_quoting_type_id__volatile;
}


static gboolean
_vala_char_array_contains (gchar * stack,
                           int stack_length,
                           const gchar needle)
{
	int i;
#line 32 "../src/engine/imap/message/imap-data-format.vala"
	for (i = 0; i < stack_length; i++) {
#line 32 "../src/engine/imap/message/imap-data-format.vala"
		if (needle == stack[i]) {
#line 32 "../src/engine/imap/message/imap-data-format.vala"
			return TRUE;
#line 75 "imap-data-format.c"
		}
	}
#line 32 "../src/engine/imap/message/imap-data-format.vala"
	return FALSE;
#line 80 "imap-data-format.c"
}


gboolean
geary_imap_data_format_is_special_char (gchar ch,
                                        gchar* ar,
                                        int ar_length1,
                                        const gchar* exceptions)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 28 "../src/engine/imap/message/imap-data-format.vala"
	if (((gint) ch) <= 0x1F) {
#line 28 "../src/engine/imap/message/imap-data-format.vala"
		_tmp0_ = TRUE;
#line 96 "imap-data-format.c"
	} else {
#line 28 "../src/engine/imap/message/imap-data-format.vala"
		_tmp0_ = ((gint) ch) >= 0x7F;
#line 100 "imap-data-format.c"
	}
#line 28 "../src/engine/imap/message/imap-data-format.vala"
	if (_tmp0_) {
#line 29 "../src/engine/imap/message/imap-data-format.vala"
		result = TRUE;
#line 29 "../src/engine/imap/message/imap-data-format.vala"
		return result;
#line 108 "imap-data-format.c"
	}
#line 32 "../src/engine/imap/message/imap-data-format.vala"
	if (_vala_char_array_contains (ar, ar_length1, ch)) {
#line 112 "imap-data-format.c"
		gboolean _tmp1_ = FALSE;
#line 33 "../src/engine/imap/message/imap-data-format.vala"
		if (exceptions != NULL) {
#line 33 "../src/engine/imap/message/imap-data-format.vala"
			_tmp1_ = geary_ascii_index_of (exceptions, ch) < 0;
#line 118 "imap-data-format.c"
		} else {
#line 33 "../src/engine/imap/message/imap-data-format.vala"
			_tmp1_ = TRUE;
#line 122 "imap-data-format.c"
		}
#line 33 "../src/engine/imap/message/imap-data-format.vala"
		result = _tmp1_;
#line 33 "../src/engine/imap/message/imap-data-format.vala"
		return result;
#line 128 "imap-data-format.c"
	}
#line 36 "../src/engine/imap/message/imap-data-format.vala"
	result = FALSE;
#line 36 "../src/engine/imap/message/imap-data-format.vala"
	return result;
#line 134 "imap-data-format.c"
}


/**
 * Returns true if the character is considered an atom special.  Note that while documentation
 * indicates that the backslash cannot be used in an atom, they *are* used for message flags and
 * thus must be special cased by the caller.
 */
inline gboolean
geary_imap_data_format_is_atom_special (gchar ch,
                                        const gchar* exceptions)
{
	gboolean result = FALSE;
#line 45 "../src/engine/imap/message/imap-data-format.vala"
	result = geary_imap_data_format_is_special_char (ch, GEARY_IMAP_DATA_FORMAT_ATOM_SPECIALS, G_N_ELEMENTS (GEARY_IMAP_DATA_FORMAT_ATOM_SPECIALS), exceptions);
#line 45 "../src/engine/imap/message/imap-data-format.vala"
	return result;
#line 152 "imap-data-format.c"
}


/**
 * Tag specials are like atom specials but include the continuation character ('+').  Also, the
 * star character is allowed, although technically only correct in the context of a status response;
 * it's the responsibility of the caller to catch this.
 */
gboolean
geary_imap_data_format_is_tag_special (gchar ch,
                                       const gchar* exceptions)
{
	gboolean result = FALSE;
#line 54 "../src/engine/imap/message/imap-data-format.vala"
	result = geary_imap_data_format_is_special_char (ch, GEARY_IMAP_DATA_FORMAT_TAG_SPECIALS, G_N_ELEMENTS (GEARY_IMAP_DATA_FORMAT_TAG_SPECIALS), exceptions);
#line 54 "../src/engine/imap/message/imap-data-format.vala"
	return result;
#line 170 "imap-data-format.c"
}


/**
 * Returns Quoting to indicate if the string must be quoted before sent on the wire, of if it
 * must be sent as a literal.
 */
static gchar
string_get (const gchar* self,
            glong index)
{
	gchar result = '\0';
	gchar _tmp0_;
#line 1180 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, '\0');
#line 1181 "glib-2.0.vapi"
	_tmp0_ = ((gchar*) self)[index];
#line 1181 "glib-2.0.vapi"
	result = _tmp0_;
#line 1181 "glib-2.0.vapi"
	return result;
#line 192 "imap-data-format.c"
}


GearyImapDataFormatQuoting
geary_imap_data_format_is_quoting_required (const gchar* str)
{
	GearyImapDataFormatQuoting result = 0;
	gint index = 0;
#line 61 "../src/engine/imap/message/imap-data-format.vala"
	g_return_val_if_fail (str != NULL, 0);
#line 62 "../src/engine/imap/message/imap-data-format.vala"
	if (geary_string_is_empty (str)) {
#line 63 "../src/engine/imap/message/imap-data-format.vala"
		result = GEARY_IMAP_DATA_FORMAT_QUOTING_REQUIRED;
#line 63 "../src/engine/imap/message/imap-data-format.vala"
		return result;
#line 209 "imap-data-format.c"
	}
#line 65 "../src/engine/imap/message/imap-data-format.vala"
	index = 0;
#line 213 "imap-data-format.c"
	{
		gboolean _tmp0_ = FALSE;
#line 66 "../src/engine/imap/message/imap-data-format.vala"
		_tmp0_ = TRUE;
#line 66 "../src/engine/imap/message/imap-data-format.vala"
		while (TRUE) {
#line 220 "imap-data-format.c"
			gchar ch = '\0';
			gint _tmp1_;
			gchar _tmp2_;
			gchar _tmp3_;
			gchar _tmp4_;
#line 66 "../src/engine/imap/message/imap-data-format.vala"
			if (!_tmp0_) {
#line 228 "imap-data-format.c"
			}
#line 66 "../src/engine/imap/message/imap-data-format.vala"
			_tmp0_ = FALSE;
#line 67 "../src/engine/imap/message/imap-data-format.vala"
			_tmp1_ = index;
#line 67 "../src/engine/imap/message/imap-data-format.vala"
			index = _tmp1_ + 1;
#line 67 "../src/engine/imap/message/imap-data-format.vala"
			ch = string_get (str, (glong) _tmp1_);
#line 68 "../src/engine/imap/message/imap-data-format.vala"
			_tmp2_ = ch;
#line 68 "../src/engine/imap/message/imap-data-format.vala"
			if (_tmp2_ == GEARY_STRING_EOS) {
#line 69 "../src/engine/imap/message/imap-data-format.vala"
				break;
#line 244 "imap-data-format.c"
			}
#line 71 "../src/engine/imap/message/imap-data-format.vala"
			_tmp3_ = ch;
#line 71 "../src/engine/imap/message/imap-data-format.vala"
			if (((gint) _tmp3_) > 0x7F) {
#line 72 "../src/engine/imap/message/imap-data-format.vala"
				result = GEARY_IMAP_DATA_FORMAT_QUOTING_UNALLOWED;
#line 72 "../src/engine/imap/message/imap-data-format.vala"
				return result;
#line 254 "imap-data-format.c"
			}
#line 74 "../src/engine/imap/message/imap-data-format.vala"
			_tmp4_ = ch;
#line 74 "../src/engine/imap/message/imap-data-format.vala"
			switch (_tmp4_) {
#line 74 "../src/engine/imap/message/imap-data-format.vala"
				case '\n':
#line 74 "../src/engine/imap/message/imap-data-format.vala"
				case '\r':
#line 264 "imap-data-format.c"
				{
#line 77 "../src/engine/imap/message/imap-data-format.vala"
					result = GEARY_IMAP_DATA_FORMAT_QUOTING_UNALLOWED;
#line 77 "../src/engine/imap/message/imap-data-format.vala"
					return result;
#line 270 "imap-data-format.c"
				}
				default:
				{
					gchar _tmp5_;
#line 80 "../src/engine/imap/message/imap-data-format.vala"
					_tmp5_ = ch;
#line 80 "../src/engine/imap/message/imap-data-format.vala"
					if (geary_imap_data_format_is_atom_special (_tmp5_, NULL)) {
#line 81 "../src/engine/imap/message/imap-data-format.vala"
						result = GEARY_IMAP_DATA_FORMAT_QUOTING_REQUIRED;
#line 81 "../src/engine/imap/message/imap-data-format.vala"
						return result;
#line 283 "imap-data-format.c"
					}
#line 82 "../src/engine/imap/message/imap-data-format.vala"
					break;
#line 287 "imap-data-format.c"
				}
			}
		}
	}
#line 86 "../src/engine/imap/message/imap-data-format.vala"
	result = GEARY_IMAP_DATA_FORMAT_QUOTING_OPTIONAL;
#line 86 "../src/engine/imap/message/imap-data-format.vala"
	return result;
#line 296 "imap-data-format.c"
}



