/* smtp-command.c generated by valac 0.42.5, the Vala compiler
 * generated from smtp-command.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */


#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>

typedef enum  {
	GEARY_SMTP_COMMAND_HELO,
	GEARY_SMTP_COMMAND_EHLO,
	GEARY_SMTP_COMMAND_QUIT,
	GEARY_SMTP_COMMAND_HELP,
	GEARY_SMTP_COMMAND_NOOP,
	GEARY_SMTP_COMMAND_RSET,
	GEARY_SMTP_COMMAND_AUTH,
	GEARY_SMTP_COMMAND_MAIL,
	GEARY_SMTP_COMMAND_RCPT,
	GEARY_SMTP_COMMAND_DATA,
	GEARY_SMTP_COMMAND_STARTTLS
} GearySmtpCommand;


#define GEARY_SMTP_TYPE_COMMAND (geary_smtp_command_get_type ())

typedef enum  {
	GEARY_SMTP_ERROR_ALREADY_CONNECTED,
	GEARY_SMTP_ERROR_AUTHENTICATION_FAILED,
	GEARY_SMTP_ERROR_NOT_CONNECTED,
	GEARY_SMTP_ERROR_NOT_SUPPORTED,
	GEARY_SMTP_ERROR_PARSE_ERROR,
	GEARY_SMTP_ERROR_REQUIRED_FIELD,
	GEARY_SMTP_ERROR_SERVER_ERROR,
	GEARY_SMTP_ERROR_STARTTLS_FAILED
} GearySmtpError;
#define GEARY_SMTP_ERROR geary_smtp_error_quark ()


GType geary_smtp_command_get_type (void) G_GNUC_CONST;
gchar* geary_smtp_command_serialize (GearySmtpCommand self);
GQuark geary_smtp_error_quark (void);
GearySmtpCommand geary_smtp_command_deserialize (const gchar* str,
                                                 GError** error);
gchar* geary_ascii_strdown (const gchar* str);


gchar*
geary_smtp_command_serialize (GearySmtpCommand self)
{
	gchar* result = NULL;
#line 21 "../src/engine/smtp/smtp-command.vala"
	switch (self) {
#line 21 "../src/engine/smtp/smtp-command.vala"
		case GEARY_SMTP_COMMAND_HELO:
#line 63 "smtp-command.c"
		{
			gchar* _tmp0_;
#line 23 "../src/engine/smtp/smtp-command.vala"
			_tmp0_ = g_strdup ("helo");
#line 23 "../src/engine/smtp/smtp-command.vala"
			result = _tmp0_;
#line 23 "../src/engine/smtp/smtp-command.vala"
			return result;
#line 72 "smtp-command.c"
		}
#line 21 "../src/engine/smtp/smtp-command.vala"
		case GEARY_SMTP_COMMAND_EHLO:
#line 76 "smtp-command.c"
		{
			gchar* _tmp1_;
#line 26 "../src/engine/smtp/smtp-command.vala"
			_tmp1_ = g_strdup ("ehlo");
#line 26 "../src/engine/smtp/smtp-command.vala"
			result = _tmp1_;
#line 26 "../src/engine/smtp/smtp-command.vala"
			return result;
#line 85 "smtp-command.c"
		}
#line 21 "../src/engine/smtp/smtp-command.vala"
		case GEARY_SMTP_COMMAND_QUIT:
#line 89 "smtp-command.c"
		{
			gchar* _tmp2_;
#line 29 "../src/engine/smtp/smtp-command.vala"
			_tmp2_ = g_strdup ("quit");
#line 29 "../src/engine/smtp/smtp-command.vala"
			result = _tmp2_;
#line 29 "../src/engine/smtp/smtp-command.vala"
			return result;
#line 98 "smtp-command.c"
		}
#line 21 "../src/engine/smtp/smtp-command.vala"
		case GEARY_SMTP_COMMAND_HELP:
#line 102 "smtp-command.c"
		{
			gchar* _tmp3_;
#line 32 "../src/engine/smtp/smtp-command.vala"
			_tmp3_ = g_strdup ("help");
#line 32 "../src/engine/smtp/smtp-command.vala"
			result = _tmp3_;
#line 32 "../src/engine/smtp/smtp-command.vala"
			return result;
#line 111 "smtp-command.c"
		}
#line 21 "../src/engine/smtp/smtp-command.vala"
		case GEARY_SMTP_COMMAND_NOOP:
#line 115 "smtp-command.c"
		{
			gchar* _tmp4_;
#line 35 "../src/engine/smtp/smtp-command.vala"
			_tmp4_ = g_strdup ("noop");
#line 35 "../src/engine/smtp/smtp-command.vala"
			result = _tmp4_;
#line 35 "../src/engine/smtp/smtp-command.vala"
			return result;
#line 124 "smtp-command.c"
		}
#line 21 "../src/engine/smtp/smtp-command.vala"
		case GEARY_SMTP_COMMAND_RSET:
#line 128 "smtp-command.c"
		{
			gchar* _tmp5_;
#line 38 "../src/engine/smtp/smtp-command.vala"
			_tmp5_ = g_strdup ("rset");
#line 38 "../src/engine/smtp/smtp-command.vala"
			result = _tmp5_;
#line 38 "../src/engine/smtp/smtp-command.vala"
			return result;
#line 137 "smtp-command.c"
		}
#line 21 "../src/engine/smtp/smtp-command.vala"
		case GEARY_SMTP_COMMAND_AUTH:
#line 141 "smtp-command.c"
		{
			gchar* _tmp6_;
#line 41 "../src/engine/smtp/smtp-command.vala"
			_tmp6_ = g_strdup ("auth");
#line 41 "../src/engine/smtp/smtp-command.vala"
			result = _tmp6_;
#line 41 "../src/engine/smtp/smtp-command.vala"
			return result;
#line 150 "smtp-command.c"
		}
#line 21 "../src/engine/smtp/smtp-command.vala"
		case GEARY_SMTP_COMMAND_MAIL:
#line 154 "smtp-command.c"
		{
			gchar* _tmp7_;
#line 44 "../src/engine/smtp/smtp-command.vala"
			_tmp7_ = g_strdup ("mail");
#line 44 "../src/engine/smtp/smtp-command.vala"
			result = _tmp7_;
#line 44 "../src/engine/smtp/smtp-command.vala"
			return result;
#line 163 "smtp-command.c"
		}
#line 21 "../src/engine/smtp/smtp-command.vala"
		case GEARY_SMTP_COMMAND_RCPT:
#line 167 "smtp-command.c"
		{
			gchar* _tmp8_;
#line 47 "../src/engine/smtp/smtp-command.vala"
			_tmp8_ = g_strdup ("rcpt");
#line 47 "../src/engine/smtp/smtp-command.vala"
			result = _tmp8_;
#line 47 "../src/engine/smtp/smtp-command.vala"
			return result;
#line 176 "smtp-command.c"
		}
#line 21 "../src/engine/smtp/smtp-command.vala"
		case GEARY_SMTP_COMMAND_DATA:
#line 180 "smtp-command.c"
		{
			gchar* _tmp9_;
#line 50 "../src/engine/smtp/smtp-command.vala"
			_tmp9_ = g_strdup ("data");
#line 50 "../src/engine/smtp/smtp-command.vala"
			result = _tmp9_;
#line 50 "../src/engine/smtp/smtp-command.vala"
			return result;
#line 189 "smtp-command.c"
		}
#line 21 "../src/engine/smtp/smtp-command.vala"
		case GEARY_SMTP_COMMAND_STARTTLS:
#line 193 "smtp-command.c"
		{
			gchar* _tmp10_;
#line 53 "../src/engine/smtp/smtp-command.vala"
			_tmp10_ = g_strdup ("STARTTLS");
#line 53 "../src/engine/smtp/smtp-command.vala"
			result = _tmp10_;
#line 53 "../src/engine/smtp/smtp-command.vala"
			return result;
#line 202 "smtp-command.c"
		}
		default:
		{
#line 56 "../src/engine/smtp/smtp-command.vala"
			g_assert_not_reached ();
#line 208 "smtp-command.c"
		}
	}
}


GearySmtpCommand
geary_smtp_command_deserialize (const gchar* str,
                                GError** error)
{
	GearySmtpCommand result = 0;
	gchar* _tmp0_;
	gchar* _tmp1_;
	GQuark _tmp3_ = 0U;
#line 61 "../src/engine/smtp/smtp-command.vala"
	static GQuark _tmp2_label0 = 0;
#line 61 "../src/engine/smtp/smtp-command.vala"
	static GQuark _tmp2_label1 = 0;
#line 61 "../src/engine/smtp/smtp-command.vala"
	static GQuark _tmp2_label2 = 0;
#line 61 "../src/engine/smtp/smtp-command.vala"
	static GQuark _tmp2_label3 = 0;
#line 61 "../src/engine/smtp/smtp-command.vala"
	static GQuark _tmp2_label4 = 0;
#line 61 "../src/engine/smtp/smtp-command.vala"
	static GQuark _tmp2_label5 = 0;
#line 61 "../src/engine/smtp/smtp-command.vala"
	static GQuark _tmp2_label6 = 0;
#line 61 "../src/engine/smtp/smtp-command.vala"
	static GQuark _tmp2_label7 = 0;
#line 61 "../src/engine/smtp/smtp-command.vala"
	static GQuark _tmp2_label8 = 0;
#line 61 "../src/engine/smtp/smtp-command.vala"
	static GQuark _tmp2_label9 = 0;
#line 61 "../src/engine/smtp/smtp-command.vala"
	static GQuark _tmp2_label10 = 0;
#line 244 "smtp-command.c"
	GError * _inner_error_ = NULL;
#line 60 "../src/engine/smtp/smtp-command.vala"
	g_return_val_if_fail (str != NULL, 0);
#line 61 "../src/engine/smtp/smtp-command.vala"
	_tmp0_ = geary_ascii_strdown (str);
#line 61 "../src/engine/smtp/smtp-command.vala"
	_tmp1_ = _tmp0_;
#line 61 "../src/engine/smtp/smtp-command.vala"
	_tmp3_ = (NULL == _tmp1_) ? 0 : g_quark_from_string (_tmp1_);
#line 61 "../src/engine/smtp/smtp-command.vala"
	g_free (_tmp1_);
#line 61 "../src/engine/smtp/smtp-command.vala"
	if (_tmp3_ == ((0 != _tmp2_label0) ? _tmp2_label0 : (_tmp2_label0 = g_quark_from_static_string ("helo")))) {
#line 61 "../src/engine/smtp/smtp-command.vala"
		switch (0) {
#line 260 "smtp-command.c"
			default:
			{
#line 63 "../src/engine/smtp/smtp-command.vala"
				result = GEARY_SMTP_COMMAND_HELO;
#line 63 "../src/engine/smtp/smtp-command.vala"
				return result;
#line 267 "smtp-command.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label1) ? _tmp2_label1 : (_tmp2_label1 = g_quark_from_static_string ("ehlo")))) {
#line 61 "../src/engine/smtp/smtp-command.vala"
		switch (0) {
#line 273 "smtp-command.c"
			default:
			{
#line 66 "../src/engine/smtp/smtp-command.vala"
				result = GEARY_SMTP_COMMAND_EHLO;
#line 66 "../src/engine/smtp/smtp-command.vala"
				return result;
#line 280 "smtp-command.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label2) ? _tmp2_label2 : (_tmp2_label2 = g_quark_from_static_string ("quit")))) {
#line 61 "../src/engine/smtp/smtp-command.vala"
		switch (0) {
#line 286 "smtp-command.c"
			default:
			{
#line 69 "../src/engine/smtp/smtp-command.vala"
				result = GEARY_SMTP_COMMAND_QUIT;
#line 69 "../src/engine/smtp/smtp-command.vala"
				return result;
#line 293 "smtp-command.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label3) ? _tmp2_label3 : (_tmp2_label3 = g_quark_from_static_string ("help")))) {
#line 61 "../src/engine/smtp/smtp-command.vala"
		switch (0) {
#line 299 "smtp-command.c"
			default:
			{
#line 72 "../src/engine/smtp/smtp-command.vala"
				result = GEARY_SMTP_COMMAND_HELP;
#line 72 "../src/engine/smtp/smtp-command.vala"
				return result;
#line 306 "smtp-command.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label4) ? _tmp2_label4 : (_tmp2_label4 = g_quark_from_static_string ("noop")))) {
#line 61 "../src/engine/smtp/smtp-command.vala"
		switch (0) {
#line 312 "smtp-command.c"
			default:
			{
#line 75 "../src/engine/smtp/smtp-command.vala"
				result = GEARY_SMTP_COMMAND_NOOP;
#line 75 "../src/engine/smtp/smtp-command.vala"
				return result;
#line 319 "smtp-command.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label5) ? _tmp2_label5 : (_tmp2_label5 = g_quark_from_static_string ("rset")))) {
#line 61 "../src/engine/smtp/smtp-command.vala"
		switch (0) {
#line 325 "smtp-command.c"
			default:
			{
#line 78 "../src/engine/smtp/smtp-command.vala"
				result = GEARY_SMTP_COMMAND_RSET;
#line 78 "../src/engine/smtp/smtp-command.vala"
				return result;
#line 332 "smtp-command.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label6) ? _tmp2_label6 : (_tmp2_label6 = g_quark_from_static_string ("auth")))) {
#line 61 "../src/engine/smtp/smtp-command.vala"
		switch (0) {
#line 338 "smtp-command.c"
			default:
			{
#line 81 "../src/engine/smtp/smtp-command.vala"
				result = GEARY_SMTP_COMMAND_AUTH;
#line 81 "../src/engine/smtp/smtp-command.vala"
				return result;
#line 345 "smtp-command.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label7) ? _tmp2_label7 : (_tmp2_label7 = g_quark_from_static_string ("mail")))) {
#line 61 "../src/engine/smtp/smtp-command.vala"
		switch (0) {
#line 351 "smtp-command.c"
			default:
			{
#line 84 "../src/engine/smtp/smtp-command.vala"
				result = GEARY_SMTP_COMMAND_MAIL;
#line 84 "../src/engine/smtp/smtp-command.vala"
				return result;
#line 358 "smtp-command.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label8) ? _tmp2_label8 : (_tmp2_label8 = g_quark_from_static_string ("rcpt")))) {
#line 61 "../src/engine/smtp/smtp-command.vala"
		switch (0) {
#line 364 "smtp-command.c"
			default:
			{
#line 87 "../src/engine/smtp/smtp-command.vala"
				result = GEARY_SMTP_COMMAND_RCPT;
#line 87 "../src/engine/smtp/smtp-command.vala"
				return result;
#line 371 "smtp-command.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label9) ? _tmp2_label9 : (_tmp2_label9 = g_quark_from_static_string ("data")))) {
#line 61 "../src/engine/smtp/smtp-command.vala"
		switch (0) {
#line 377 "smtp-command.c"
			default:
			{
#line 90 "../src/engine/smtp/smtp-command.vala"
				result = GEARY_SMTP_COMMAND_DATA;
#line 90 "../src/engine/smtp/smtp-command.vala"
				return result;
#line 384 "smtp-command.c"
			}
		}
	} else if (_tmp3_ == ((0 != _tmp2_label10) ? _tmp2_label10 : (_tmp2_label10 = g_quark_from_static_string ("starttls")))) {
#line 61 "../src/engine/smtp/smtp-command.vala"
		switch (0) {
#line 390 "smtp-command.c"
			default:
			{
#line 93 "../src/engine/smtp/smtp-command.vala"
				result = GEARY_SMTP_COMMAND_STARTTLS;
#line 93 "../src/engine/smtp/smtp-command.vala"
				return result;
#line 397 "smtp-command.c"
			}
		}
	} else {
#line 61 "../src/engine/smtp/smtp-command.vala"
		switch (0) {
#line 403 "smtp-command.c"
			default:
			{
				GError* _tmp4_;
#line 96 "../src/engine/smtp/smtp-command.vala"
				_tmp4_ = g_error_new (GEARY_SMTP_ERROR, GEARY_SMTP_ERROR_PARSE_ERROR, "Unknown command \"%s\"", str);
#line 96 "../src/engine/smtp/smtp-command.vala"
				_inner_error_ = _tmp4_;
#line 96 "../src/engine/smtp/smtp-command.vala"
				if (_inner_error_->domain == GEARY_SMTP_ERROR) {
#line 96 "../src/engine/smtp/smtp-command.vala"
					g_propagate_error (error, _inner_error_);
#line 96 "../src/engine/smtp/smtp-command.vala"
					return 0;
#line 417 "smtp-command.c"
				} else {
#line 96 "../src/engine/smtp/smtp-command.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 96 "../src/engine/smtp/smtp-command.vala"
					g_clear_error (&_inner_error_);
#line 96 "../src/engine/smtp/smtp-command.vala"
					return 0;
#line 425 "smtp-command.c"
				}
			}
		}
	}
}


GType
geary_smtp_command_get_type (void)
{
	static volatile gsize geary_smtp_command_type_id__volatile = 0;
	if (g_once_init_enter (&geary_smtp_command_type_id__volatile)) {
		static const GEnumValue values[] = {{GEARY_SMTP_COMMAND_HELO, "GEARY_SMTP_COMMAND_HELO", "helo"}, {GEARY_SMTP_COMMAND_EHLO, "GEARY_SMTP_COMMAND_EHLO", "ehlo"}, {GEARY_SMTP_COMMAND_QUIT, "GEARY_SMTP_COMMAND_QUIT", "quit"}, {GEARY_SMTP_COMMAND_HELP, "GEARY_SMTP_COMMAND_HELP", "help"}, {GEARY_SMTP_COMMAND_NOOP, "GEARY_SMTP_COMMAND_NOOP", "noop"}, {GEARY_SMTP_COMMAND_RSET, "GEARY_SMTP_COMMAND_RSET", "rset"}, {GEARY_SMTP_COMMAND_AUTH, "GEARY_SMTP_COMMAND_AUTH", "auth"}, {GEARY_SMTP_COMMAND_MAIL, "GEARY_SMTP_COMMAND_MAIL", "mail"}, {GEARY_SMTP_COMMAND_RCPT, "GEARY_SMTP_COMMAND_RCPT", "rcpt"}, {GEARY_SMTP_COMMAND_DATA, "GEARY_SMTP_COMMAND_DATA", "data"}, {GEARY_SMTP_COMMAND_STARTTLS, "GEARY_SMTP_COMMAND_STARTTLS", "starttls"}, {0, NULL, NULL}};
		GType geary_smtp_command_type_id;
		geary_smtp_command_type_id = g_enum_register_static ("GearySmtpCommand", values);
		g_once_init_leave (&geary_smtp_command_type_id__volatile, geary_smtp_command_type_id);
	}
	return geary_smtp_command_type_id__volatile;
}



