/* util-string.c generated by valac 0.42.5, the Vala compiler
 * generated from util-string.vala, do not modify */

/* Copyright 2016 Software Freedom Conservancy Inc.
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */
/* GLib's character-based substring function.*/


#include <glib.h>
#include <glib-object.h>
#include <stdlib.h>
#include <string.h>

#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_regex_unref0(var) ((var == NULL) ? NULL : (var = (g_regex_unref (var), NULL)))
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))



gchar* g_utf8_substring (const gchar* str,
                         glong start_pos,
                         glong end_pos);
#define GEARY_STRING_EOS '\0'
#define GEARY_STRING_WS_OR_NP "[[:space:][:cntrl:]]+"
gboolean geary_string_is_empty_or_whitespace (const gchar* str);
gboolean geary_string_is_empty (const gchar* str);
gint geary_string_count_char (const gchar* s,
                              gunichar c);
gboolean geary_string_contains_any_char (const gchar* str,
                                         gunichar* chars,
                                         int chars_length1);
static gboolean _vala_unichar_array_contains (gunichar * stack,
                                       int stack_length,
                                       const gunichar needle);
guint geary_string_stri_hash (const gchar* str);
gboolean geary_string_stri_equal (const gchar* a,
                                  const gchar* b);
gint geary_string_stri_cmp (const gchar* a,
                            const gchar* b);
gchar* geary_string_reduce_whitespace (const gchar* str);
gchar* geary_string_safe_byte_substring (const gchar* s,
                                         gssize max_length);


static gchar
string_get (const gchar* self,
            glong index)
{
	gchar result = '\0';
	gchar _tmp0_;
#line 1180 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, '\0');
#line 1181 "glib-2.0.vapi"
	_tmp0_ = ((gchar*) self)[index];
#line 1181 "glib-2.0.vapi"
	result = _tmp0_;
#line 1181 "glib-2.0.vapi"
	return result;
#line 63 "util-string.c"
}


static gchar*
string_strip (const gchar* self)
{
	gchar* result = NULL;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	const gchar* _tmp1_;
#line 1304 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1305 "glib-2.0.vapi"
	_tmp0_ = g_strdup (self);
#line 1305 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1306 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1306 "glib-2.0.vapi"
	g_strstrip (_tmp1_);
#line 1307 "glib-2.0.vapi"
	result = _result_;
#line 1307 "glib-2.0.vapi"
	return result;
#line 88 "util-string.c"
}


gboolean
geary_string_is_empty_or_whitespace (const gchar* str)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
	gboolean _tmp1_ = FALSE;
#line 21 "../src/engine/util/util-string.vala"
	if (str == NULL) {
#line 21 "../src/engine/util/util-string.vala"
		_tmp1_ = TRUE;
#line 102 "util-string.c"
	} else {
#line 21 "../src/engine/util/util-string.vala"
		_tmp1_ = string_get (str, (glong) 0) == GEARY_STRING_EOS;
#line 106 "util-string.c"
	}
#line 21 "../src/engine/util/util-string.vala"
	if (_tmp1_) {
#line 21 "../src/engine/util/util-string.vala"
		_tmp0_ = TRUE;
#line 112 "util-string.c"
	} else {
		gchar* _tmp2_;
		gchar* _tmp3_;
#line 21 "../src/engine/util/util-string.vala"
		_tmp2_ = string_strip (str);
#line 21 "../src/engine/util/util-string.vala"
		_tmp3_ = _tmp2_;
#line 21 "../src/engine/util/util-string.vala"
		_tmp0_ = string_get (_tmp3_, (glong) 0) == GEARY_STRING_EOS;
#line 21 "../src/engine/util/util-string.vala"
		_g_free0 (_tmp3_);
#line 124 "util-string.c"
	}
#line 21 "../src/engine/util/util-string.vala"
	result = _tmp0_;
#line 21 "../src/engine/util/util-string.vala"
	return result;
#line 130 "util-string.c"
}


inline gboolean
geary_string_is_empty (const gchar* str)
{
	gboolean result = FALSE;
	gboolean _tmp0_ = FALSE;
#line 25 "../src/engine/util/util-string.vala"
	if (str == NULL) {
#line 25 "../src/engine/util/util-string.vala"
		_tmp0_ = TRUE;
#line 143 "util-string.c"
	} else {
#line 25 "../src/engine/util/util-string.vala"
		_tmp0_ = string_get (str, (glong) 0) == GEARY_STRING_EOS;
#line 147 "util-string.c"
	}
#line 25 "../src/engine/util/util-string.vala"
	result = _tmp0_;
#line 25 "../src/engine/util/util-string.vala"
	return result;
#line 153 "util-string.c"
}


static gint
string_index_of_char (const gchar* self,
                      gunichar c,
                      gint start_index)
{
	gint result = 0;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 1101 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, 0);
#line 1102 "glib-2.0.vapi"
	_tmp0_ = g_utf8_strchr (((gchar*) self) + start_index, (gssize) -1, c);
#line 1102 "glib-2.0.vapi"
	_result_ = _tmp0_;
#line 1104 "glib-2.0.vapi"
	_tmp1_ = _result_;
#line 1104 "glib-2.0.vapi"
	if (_tmp1_ != NULL) {
#line 176 "util-string.c"
		gchar* _tmp2_;
#line 1105 "glib-2.0.vapi"
		_tmp2_ = _result_;
#line 1105 "glib-2.0.vapi"
		result = (gint) (_tmp2_ - ((gchar*) self));
#line 1105 "glib-2.0.vapi"
		return result;
#line 184 "util-string.c"
	} else {
#line 1107 "glib-2.0.vapi"
		result = -1;
#line 1107 "glib-2.0.vapi"
		return result;
#line 190 "util-string.c"
	}
}


gint
geary_string_count_char (const gchar* s,
                         gunichar c)
{
	gint result = 0;
	gint count = 0;
#line 28 "../src/engine/util/util-string.vala"
	g_return_val_if_fail (s != NULL, 0);
#line 29 "../src/engine/util/util-string.vala"
	count = 0;
#line 205 "util-string.c"
	{
		gint index = 0;
#line 30 "../src/engine/util/util-string.vala"
		index = 0;
#line 210 "util-string.c"
		{
			gboolean _tmp0_ = FALSE;
#line 30 "../src/engine/util/util-string.vala"
			_tmp0_ = TRUE;
#line 30 "../src/engine/util/util-string.vala"
			while (TRUE) {
#line 217 "util-string.c"
				gint _tmp3_;
				gint _tmp4_;
#line 30 "../src/engine/util/util-string.vala"
				if (!_tmp0_) {
#line 222 "util-string.c"
					gint _tmp1_;
					gint _tmp2_;
#line 30 "../src/engine/util/util-string.vala"
					_tmp1_ = index;
#line 30 "../src/engine/util/util-string.vala"
					index = _tmp1_ + 1;
#line 30 "../src/engine/util/util-string.vala"
					_tmp2_ = count;
#line 30 "../src/engine/util/util-string.vala"
					count = _tmp2_ + 1;
#line 233 "util-string.c"
				}
#line 30 "../src/engine/util/util-string.vala"
				_tmp0_ = FALSE;
#line 30 "../src/engine/util/util-string.vala"
				_tmp3_ = index;
#line 30 "../src/engine/util/util-string.vala"
				index = string_index_of_char (s, c, _tmp3_);
#line 30 "../src/engine/util/util-string.vala"
				_tmp4_ = index;
#line 30 "../src/engine/util/util-string.vala"
				if (!(_tmp4_ >= 0)) {
#line 30 "../src/engine/util/util-string.vala"
					break;
#line 247 "util-string.c"
				}
			}
		}
	}
#line 32 "../src/engine/util/util-string.vala"
	result = count;
#line 32 "../src/engine/util/util-string.vala"
	return result;
#line 256 "util-string.c"
}


static gboolean
string_get_next_char (const gchar* self,
                      gint* index,
                      gunichar* c)
{
	gunichar _vala_c = 0U;
	gboolean result = FALSE;
	gunichar _tmp0_;
#line 1199 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, FALSE);
#line 1200 "glib-2.0.vapi"
	_vala_c = g_utf8_get_char (((gchar*) self) + (*index));
#line 1201 "glib-2.0.vapi"
	_tmp0_ = _vala_c;
#line 1201 "glib-2.0.vapi"
	if (_tmp0_ != ((gunichar) 0)) {
#line 276 "util-string.c"
		gchar* _tmp1_;
#line 1202 "glib-2.0.vapi"
		_tmp1_ = g_utf8_next_char (((gchar*) self) + (*index));
#line 1202 "glib-2.0.vapi"
		*index = (gint) (_tmp1_ - ((gchar*) self));
#line 1203 "glib-2.0.vapi"
		result = TRUE;
#line 1203 "glib-2.0.vapi"
		if (c) {
#line 1203 "glib-2.0.vapi"
			*c = _vala_c;
#line 288 "util-string.c"
		}
#line 1203 "glib-2.0.vapi"
		return result;
#line 292 "util-string.c"
	} else {
#line 1205 "glib-2.0.vapi"
		result = FALSE;
#line 1205 "glib-2.0.vapi"
		if (c) {
#line 1205 "glib-2.0.vapi"
			*c = _vala_c;
#line 300 "util-string.c"
		}
#line 1205 "glib-2.0.vapi"
		return result;
#line 304 "util-string.c"
	}
#line 1199 "glib-2.0.vapi"
	if (c) {
#line 1199 "glib-2.0.vapi"
		*c = _vala_c;
#line 310 "util-string.c"
	}
}


static gboolean
_vala_unichar_array_contains (gunichar * stack,
                              int stack_length,
                              const gunichar needle)
{
	int i;
#line 39 "../src/engine/util/util-string.vala"
	for (i = 0; i < stack_length; i++) {
#line 39 "../src/engine/util/util-string.vala"
		if (needle == stack[i]) {
#line 39 "../src/engine/util/util-string.vala"
			return TRUE;
#line 327 "util-string.c"
		}
	}
#line 39 "../src/engine/util/util-string.vala"
	return FALSE;
#line 332 "util-string.c"
}


gboolean
geary_string_contains_any_char (const gchar* str,
                                gunichar* chars,
                                int chars_length1)
{
	gboolean result = FALSE;
	gint index = 0;
	gunichar ch = 0U;
#line 35 "../src/engine/util/util-string.vala"
	g_return_val_if_fail (str != NULL, FALSE);
#line 36 "../src/engine/util/util-string.vala"
	index = 0;
#line 38 "../src/engine/util/util-string.vala"
	while (TRUE) {
#line 350 "util-string.c"
		gunichar _tmp0_ = 0U;
		gboolean _tmp1_;
		gunichar _tmp2_;
#line 38 "../src/engine/util/util-string.vala"
		_tmp1_ = string_get_next_char (str, &index, &_tmp0_);
#line 38 "../src/engine/util/util-string.vala"
		ch = _tmp0_;
#line 38 "../src/engine/util/util-string.vala"
		if (!_tmp1_) {
#line 38 "../src/engine/util/util-string.vala"
			break;
#line 362 "util-string.c"
		}
#line 39 "../src/engine/util/util-string.vala"
		_tmp2_ = ch;
#line 39 "../src/engine/util/util-string.vala"
		if (_vala_unichar_array_contains (chars, chars_length1, _tmp2_)) {
#line 40 "../src/engine/util/util-string.vala"
			result = TRUE;
#line 40 "../src/engine/util/util-string.vala"
			return result;
#line 372 "util-string.c"
		}
	}
#line 43 "../src/engine/util/util-string.vala"
	result = FALSE;
#line 43 "../src/engine/util/util-string.vala"
	return result;
#line 379 "util-string.c"
}


guint
geary_string_stri_hash (const gchar* str)
{
	guint result = 0U;
	GHashFunc _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	guint _tmp3_;
#line 46 "../src/engine/util/util-string.vala"
	g_return_val_if_fail (str != NULL, 0U);
#line 47 "../src/engine/util/util-string.vala"
	_tmp0_ = g_str_hash;
#line 47 "../src/engine/util/util-string.vala"
	_tmp1_ = g_utf8_strdown (str, (gssize) -1);
#line 47 "../src/engine/util/util-string.vala"
	_tmp2_ = _tmp1_;
#line 47 "../src/engine/util/util-string.vala"
	_tmp3_ = _tmp0_ (_tmp2_);
#line 47 "../src/engine/util/util-string.vala"
	_g_free0 (_tmp2_);
#line 47 "../src/engine/util/util-string.vala"
	result = _tmp3_;
#line 47 "../src/engine/util/util-string.vala"
	return result;
#line 407 "util-string.c"
}


gboolean
geary_string_stri_equal (const gchar* a,
                         const gchar* b)
{
	gboolean result = FALSE;
	GEqualFunc _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gboolean _tmp5_;
#line 50 "../src/engine/util/util-string.vala"
	g_return_val_if_fail (a != NULL, FALSE);
#line 50 "../src/engine/util/util-string.vala"
	g_return_val_if_fail (b != NULL, FALSE);
#line 51 "../src/engine/util/util-string.vala"
	_tmp0_ = g_str_equal;
#line 51 "../src/engine/util/util-string.vala"
	_tmp1_ = g_utf8_strdown (a, (gssize) -1);
#line 51 "../src/engine/util/util-string.vala"
	_tmp2_ = _tmp1_;
#line 51 "../src/engine/util/util-string.vala"
	_tmp3_ = g_utf8_strdown (b, (gssize) -1);
#line 51 "../src/engine/util/util-string.vala"
	_tmp4_ = _tmp3_;
#line 51 "../src/engine/util/util-string.vala"
	_tmp5_ = _tmp0_ (_tmp2_, _tmp4_);
#line 51 "../src/engine/util/util-string.vala"
	_g_free0 (_tmp4_);
#line 51 "../src/engine/util/util-string.vala"
	_g_free0 (_tmp2_);
#line 51 "../src/engine/util/util-string.vala"
	result = _tmp5_;
#line 51 "../src/engine/util/util-string.vala"
	return result;
#line 446 "util-string.c"
}


gint
geary_string_stri_cmp (const gchar* a,
                       const gchar* b)
{
	gint result = 0;
	GCompareFunc _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gint _tmp5_;
#line 54 "../src/engine/util/util-string.vala"
	g_return_val_if_fail (a != NULL, 0);
#line 54 "../src/engine/util/util-string.vala"
	g_return_val_if_fail (b != NULL, 0);
#line 55 "../src/engine/util/util-string.vala"
	_tmp0_ = ((GCompareFunc) g_strcmp0);
#line 55 "../src/engine/util/util-string.vala"
	_tmp1_ = g_utf8_strdown (a, (gssize) -1);
#line 55 "../src/engine/util/util-string.vala"
	_tmp2_ = _tmp1_;
#line 55 "../src/engine/util/util-string.vala"
	_tmp3_ = g_utf8_strdown (b, (gssize) -1);
#line 55 "../src/engine/util/util-string.vala"
	_tmp4_ = _tmp3_;
#line 55 "../src/engine/util/util-string.vala"
	_tmp5_ = _tmp0_ (_tmp2_, _tmp4_);
#line 55 "../src/engine/util/util-string.vala"
	_g_free0 (_tmp4_);
#line 55 "../src/engine/util/util-string.vala"
	_g_free0 (_tmp2_);
#line 55 "../src/engine/util/util-string.vala"
	result = _tmp5_;
#line 55 "../src/engine/util/util-string.vala"
	return result;
#line 485 "util-string.c"
}


/**
 * Removes redundant white space and non-printing characters.
 *
 * @return the input string /str/, modified so that any non-printing
 * characters are converted to spaces, all consecutive spaces are
 * coalesced into a single space, and stripped of leading and trailing
 * white space. If //null// is passed in, the empty string is
 * returned.
 */
gchar*
geary_string_reduce_whitespace (const gchar* str)
{
	gchar* result = NULL;
	const gchar* _tmp0_ = NULL;
	gchar* s = NULL;
	gchar* _tmp1_;
	const gchar* _tmp8_;
	gchar* _tmp9_;
	GError * _inner_error_ = NULL;
#line 68 "../src/engine/util/util-string.vala"
	_tmp0_ = str;
#line 68 "../src/engine/util/util-string.vala"
	if (_tmp0_ == NULL) {
#line 68 "../src/engine/util/util-string.vala"
		_tmp0_ = "";
#line 514 "util-string.c"
	}
#line 68 "../src/engine/util/util-string.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 68 "../src/engine/util/util-string.vala"
	s = _tmp1_;
#line 520 "util-string.c"
	{
		GRegex* _tmp2_ = NULL;
		GRegex* _tmp3_;
		gchar* _tmp4_ = NULL;
		const gchar* _tmp5_;
		gchar* _tmp6_;
		gchar* _tmp7_;
#line 70 "../src/engine/util/util-string.vala"
		_tmp3_ = g_regex_new (GEARY_STRING_WS_OR_NP, 0, 0, &_inner_error_);
#line 70 "../src/engine/util/util-string.vala"
		_tmp2_ = _tmp3_;
#line 70 "../src/engine/util/util-string.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 534 "util-string.c"
			goto __catch291_g_error;
		}
#line 70 "../src/engine/util/util-string.vala"
		_tmp5_ = s;
#line 70 "../src/engine/util/util-string.vala"
		_tmp6_ = g_regex_replace (_tmp2_, _tmp5_, (gssize) -1, 0, " ", 0, &_inner_error_);
#line 70 "../src/engine/util/util-string.vala"
		_tmp4_ = _tmp6_;
#line 70 "../src/engine/util/util-string.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 70 "../src/engine/util/util-string.vala"
			_g_regex_unref0 (_tmp2_);
#line 547 "util-string.c"
			goto __catch291_g_error;
		}
#line 70 "../src/engine/util/util-string.vala"
		_tmp7_ = _tmp4_;
#line 70 "../src/engine/util/util-string.vala"
		_tmp4_ = NULL;
#line 70 "../src/engine/util/util-string.vala"
		_g_free0 (s);
#line 70 "../src/engine/util/util-string.vala"
		s = _tmp7_;
#line 69 "../src/engine/util/util-string.vala"
		_g_free0 (_tmp4_);
#line 69 "../src/engine/util/util-string.vala"
		_g_regex_unref0 (_tmp2_);
#line 562 "util-string.c"
	}
	goto __finally291;
	__catch291_g_error:
	{
		GError* err = NULL;
#line 69 "../src/engine/util/util-string.vala"
		err = _inner_error_;
#line 69 "../src/engine/util/util-string.vala"
		_inner_error_ = NULL;
#line 69 "../src/engine/util/util-string.vala"
		_g_error_free0 (err);
#line 574 "util-string.c"
	}
	__finally291:
#line 69 "../src/engine/util/util-string.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 69 "../src/engine/util/util-string.vala"
		_g_free0 (s);
#line 69 "../src/engine/util/util-string.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 69 "../src/engine/util/util-string.vala"
		g_clear_error (&_inner_error_);
#line 69 "../src/engine/util/util-string.vala"
		return NULL;
#line 587 "util-string.c"
	}
#line 74 "../src/engine/util/util-string.vala"
	_tmp8_ = s;
#line 74 "../src/engine/util/util-string.vala"
	_tmp9_ = string_strip (_tmp8_);
#line 74 "../src/engine/util/util-string.vala"
	result = _tmp9_;
#line 74 "../src/engine/util/util-string.vala"
	_g_free0 (s);
#line 74 "../src/engine/util/util-string.vala"
	return result;
#line 599 "util-string.c"
}


gchar*
geary_string_safe_byte_substring (const gchar* s,
                                  gssize max_length)
{
	gchar* result = NULL;
	gint _tmp0_;
	gint _tmp1_;
	gchar* _tmp3_;
#line 81 "../src/engine/util/util-string.vala"
	g_return_val_if_fail (s != NULL, NULL);
#line 82 "../src/engine/util/util-string.vala"
	_tmp0_ = strlen (s);
#line 82 "../src/engine/util/util-string.vala"
	_tmp1_ = _tmp0_;
#line 82 "../src/engine/util/util-string.vala"
	if (((gssize) _tmp1_) < max_length) {
#line 619 "util-string.c"
		gchar* _tmp2_;
#line 83 "../src/engine/util/util-string.vala"
		_tmp2_ = g_strdup (s);
#line 83 "../src/engine/util/util-string.vala"
		result = _tmp2_;
#line 83 "../src/engine/util/util-string.vala"
		return result;
#line 627 "util-string.c"
	}
#line 85 "../src/engine/util/util-string.vala"
	_tmp3_ = g_utf8_substring (s, (glong) 0, (glong) g_utf8_strlen (s, max_length));
#line 85 "../src/engine/util/util-string.vala"
	result = _tmp3_;
#line 85 "../src/engine/util/util-string.vala"
	return result;
#line 635 "util-string.c"
}



