/* accounts-manager.c generated by valac 0.42.5, the Vala compiler
 * generated from accounts-manager.vala, do not modify */

/*
 * Copyright 2017 Software Freedom Conservancy Inc.
 * Copyright 2018 Michael Gratton <mike@vee.net>
 *
 * This software is licensed under the GNU Lesser General Public License
 * (version 2.1 or later).  See the COPYING file in this distribution.
 */


#include <glib.h>
#include <glib-object.h>
#include <gio/gio.h>
#include <gee.h>
#include <stdlib.h>
#include <string.h>
#include "geary-engine.h"
#include <goa/goa.h>
#include <gobject/gvaluecollector.h>


#define ACCOUNTS_TYPE_MANAGER (accounts_manager_get_type ())
#define ACCOUNTS_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), ACCOUNTS_TYPE_MANAGER, AccountsManager))
#define ACCOUNTS_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), ACCOUNTS_TYPE_MANAGER, AccountsManagerClass))
#define ACCOUNTS_IS_MANAGER(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), ACCOUNTS_TYPE_MANAGER))
#define ACCOUNTS_IS_MANAGER_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), ACCOUNTS_TYPE_MANAGER))
#define ACCOUNTS_MANAGER_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), ACCOUNTS_TYPE_MANAGER, AccountsManagerClass))

typedef struct _AccountsManager AccountsManager;
typedef struct _AccountsManagerClass AccountsManagerClass;
typedef struct _AccountsManagerPrivate AccountsManagerPrivate;

#define ACCOUNTS_MANAGER_TYPE_ACCOUNT_STATE (accounts_manager_account_state_get_type ())
#define ACCOUNTS_MANAGER_ACCOUNT_STATE(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), ACCOUNTS_MANAGER_TYPE_ACCOUNT_STATE, AccountsManagerAccountState))
#define ACCOUNTS_MANAGER_ACCOUNT_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), ACCOUNTS_MANAGER_TYPE_ACCOUNT_STATE, AccountsManagerAccountStateClass))
#define ACCOUNTS_MANAGER_IS_ACCOUNT_STATE(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), ACCOUNTS_MANAGER_TYPE_ACCOUNT_STATE))
#define ACCOUNTS_MANAGER_IS_ACCOUNT_STATE_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), ACCOUNTS_MANAGER_TYPE_ACCOUNT_STATE))
#define ACCOUNTS_MANAGER_ACCOUNT_STATE_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), ACCOUNTS_MANAGER_TYPE_ACCOUNT_STATE, AccountsManagerAccountStateClass))

typedef struct _AccountsManagerAccountState AccountsManagerAccountState;
typedef struct _AccountsManagerAccountStateClass AccountsManagerAccountStateClass;
enum  {
	ACCOUNTS_MANAGER_0_PROPERTY,
	ACCOUNTS_MANAGER_SIZE_PROPERTY,
	ACCOUNTS_MANAGER_CONFIG_DIR_PROPERTY,
	ACCOUNTS_MANAGER_DATA_DIR_PROPERTY,
	ACCOUNTS_MANAGER_NUM_PROPERTIES
};
static GParamSpec* accounts_manager_properties[ACCOUNTS_MANAGER_NUM_PROPERTIES];
typedef enum  {
	ACCOUNTS_MANAGER_STATUS_ENABLED,
	ACCOUNTS_MANAGER_STATUS_DISABLED,
	ACCOUNTS_MANAGER_STATUS_UNAVAILABLE,
	ACCOUNTS_MANAGER_STATUS_REMOVED
} AccountsManagerStatus;


#define ACCOUNTS_MANAGER_TYPE_STATUS (accounts_manager_status_get_type ())
#define _g_free0(var) (var = (g_free (var), NULL))
#define _g_object_unref0(var) ((var == NULL) ? NULL : (var = (g_object_unref (var), NULL)))
typedef struct _AccountsManagerConnectGoaData AccountsManagerConnectGoaData;
#define _accounts_manager_account_state_unref0(var) ((var == NULL) ? NULL : (var = (accounts_manager_account_state_unref (var), NULL)))
typedef struct _AccountsManagerNewOrphanAccountData AccountsManagerNewOrphanAccountData;

#define TYPE_SECRET_MEDIATOR (secret_mediator_get_type ())
#define SECRET_MEDIATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_SECRET_MEDIATOR, SecretMediator))
#define SECRET_MEDIATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_SECRET_MEDIATOR, SecretMediatorClass))
#define IS_SECRET_MEDIATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_SECRET_MEDIATOR))
#define IS_SECRET_MEDIATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_SECRET_MEDIATOR))
#define SECRET_MEDIATOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_SECRET_MEDIATOR, SecretMediatorClass))

typedef struct _SecretMediator SecretMediator;
typedef struct _SecretMediatorClass SecretMediatorClass;
typedef struct _AccountsManagerCreateAccountData AccountsManagerCreateAccountData;
#define _g_error_free0(var) ((var == NULL) ? NULL : (var = (g_error_free (var), NULL)))
typedef struct _AccountsManagerLoadAccountsData AccountsManagerLoadAccountsData;
typedef struct _AccountsManagerRemoveAccountData AccountsManagerRemoveAccountData;
typedef struct _AccountsManagerRestoreAccountData AccountsManagerRestoreAccountData;
typedef struct _AccountsManagerExpungeAccountsData AccountsManagerExpungeAccountsData;
typedef struct _AccountsManagerSaveAccountData AccountsManagerSaveAccountData;
typedef struct _AccountsManagerUpdateLocalCredentialsData AccountsManagerUpdateLocalCredentialsData;

#define TYPE_GOA_MEDIATOR (goa_mediator_get_type ())
#define GOA_MEDIATOR(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), TYPE_GOA_MEDIATOR, GoaMediator))
#define GOA_MEDIATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), TYPE_GOA_MEDIATOR, GoaMediatorClass))
#define IS_GOA_MEDIATOR(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), TYPE_GOA_MEDIATOR))
#define IS_GOA_MEDIATOR_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), TYPE_GOA_MEDIATOR))
#define GOA_MEDIATOR_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), TYPE_GOA_MEDIATOR, GoaMediatorClass))

typedef struct _GoaMediator GoaMediator;
typedef struct _GoaMediatorClass GoaMediatorClass;
typedef struct _AccountsManagerAddGoaAccountData AccountsManagerAddGoaAccountData;
typedef struct _AccountsManagerShowGoaAccountData AccountsManagerShowGoaAccountData;
typedef struct _AccountsManagerNextIdData AccountsManagerNextIdData;
#define _geary_config_file_unref0(var) ((var == NULL) ? NULL : (var = (geary_config_file_unref (var), NULL)))
#define _geary_config_file_group_unref0(var) ((var == NULL) ? NULL : (var = (geary_config_file_group_unref (var), NULL)))

#define ACCOUNTS_TYPE_ACCOUNT_CONFIG (accounts_account_config_get_type ())
#define ACCOUNTS_ACCOUNT_CONFIG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), ACCOUNTS_TYPE_ACCOUNT_CONFIG, AccountsAccountConfig))
#define ACCOUNTS_IS_ACCOUNT_CONFIG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), ACCOUNTS_TYPE_ACCOUNT_CONFIG))
#define ACCOUNTS_ACCOUNT_CONFIG_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), ACCOUNTS_TYPE_ACCOUNT_CONFIG, AccountsAccountConfigIface))

typedef struct _AccountsAccountConfig AccountsAccountConfig;
typedef struct _AccountsAccountConfigIface AccountsAccountConfigIface;

#define ACCOUNTS_TYPE_SERVICE_CONFIG (accounts_service_config_get_type ())
#define ACCOUNTS_SERVICE_CONFIG(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), ACCOUNTS_TYPE_SERVICE_CONFIG, AccountsServiceConfig))
#define ACCOUNTS_IS_SERVICE_CONFIG(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), ACCOUNTS_TYPE_SERVICE_CONFIG))
#define ACCOUNTS_SERVICE_CONFIG_GET_INTERFACE(obj) (G_TYPE_INSTANCE_GET_INTERFACE ((obj), ACCOUNTS_TYPE_SERVICE_CONFIG, AccountsServiceConfigIface))

typedef struct _AccountsServiceConfig AccountsServiceConfig;
typedef struct _AccountsServiceConfigIface AccountsServiceConfigIface;

#define ACCOUNTS_TYPE_ACCOUNT_CONFIG_LEGACY (accounts_account_config_legacy_get_type ())
#define ACCOUNTS_ACCOUNT_CONFIG_LEGACY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), ACCOUNTS_TYPE_ACCOUNT_CONFIG_LEGACY, AccountsAccountConfigLegacy))
#define ACCOUNTS_ACCOUNT_CONFIG_LEGACY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), ACCOUNTS_TYPE_ACCOUNT_CONFIG_LEGACY, AccountsAccountConfigLegacyClass))
#define ACCOUNTS_IS_ACCOUNT_CONFIG_LEGACY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), ACCOUNTS_TYPE_ACCOUNT_CONFIG_LEGACY))
#define ACCOUNTS_IS_ACCOUNT_CONFIG_LEGACY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), ACCOUNTS_TYPE_ACCOUNT_CONFIG_LEGACY))
#define ACCOUNTS_ACCOUNT_CONFIG_LEGACY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), ACCOUNTS_TYPE_ACCOUNT_CONFIG_LEGACY, AccountsAccountConfigLegacyClass))

typedef struct _AccountsAccountConfigLegacy AccountsAccountConfigLegacy;
typedef struct _AccountsAccountConfigLegacyClass AccountsAccountConfigLegacyClass;

#define ACCOUNTS_TYPE_SERVICE_CONFIG_LEGACY (accounts_service_config_legacy_get_type ())
#define ACCOUNTS_SERVICE_CONFIG_LEGACY(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), ACCOUNTS_TYPE_SERVICE_CONFIG_LEGACY, AccountsServiceConfigLegacy))
#define ACCOUNTS_SERVICE_CONFIG_LEGACY_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), ACCOUNTS_TYPE_SERVICE_CONFIG_LEGACY, AccountsServiceConfigLegacyClass))
#define ACCOUNTS_IS_SERVICE_CONFIG_LEGACY(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), ACCOUNTS_TYPE_SERVICE_CONFIG_LEGACY))
#define ACCOUNTS_IS_SERVICE_CONFIG_LEGACY_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), ACCOUNTS_TYPE_SERVICE_CONFIG_LEGACY))
#define ACCOUNTS_SERVICE_CONFIG_LEGACY_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), ACCOUNTS_TYPE_SERVICE_CONFIG_LEGACY, AccountsServiceConfigLegacyClass))

typedef struct _AccountsServiceConfigLegacy AccountsServiceConfigLegacy;
typedef struct _AccountsServiceConfigLegacyClass AccountsServiceConfigLegacyClass;

#define ACCOUNTS_TYPE_ACCOUNT_CONFIG_V1 (accounts_account_config_v1_get_type ())
#define ACCOUNTS_ACCOUNT_CONFIG_V1(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), ACCOUNTS_TYPE_ACCOUNT_CONFIG_V1, AccountsAccountConfigV1))
#define ACCOUNTS_ACCOUNT_CONFIG_V1_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), ACCOUNTS_TYPE_ACCOUNT_CONFIG_V1, AccountsAccountConfigV1Class))
#define ACCOUNTS_IS_ACCOUNT_CONFIG_V1(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), ACCOUNTS_TYPE_ACCOUNT_CONFIG_V1))
#define ACCOUNTS_IS_ACCOUNT_CONFIG_V1_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), ACCOUNTS_TYPE_ACCOUNT_CONFIG_V1))
#define ACCOUNTS_ACCOUNT_CONFIG_V1_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), ACCOUNTS_TYPE_ACCOUNT_CONFIG_V1, AccountsAccountConfigV1Class))

typedef struct _AccountsAccountConfigV1 AccountsAccountConfigV1;
typedef struct _AccountsAccountConfigV1Class AccountsAccountConfigV1Class;

#define ACCOUNTS_TYPE_SERVICE_CONFIG_V1 (accounts_service_config_v1_get_type ())
#define ACCOUNTS_SERVICE_CONFIG_V1(obj) (G_TYPE_CHECK_INSTANCE_CAST ((obj), ACCOUNTS_TYPE_SERVICE_CONFIG_V1, AccountsServiceConfigV1))
#define ACCOUNTS_SERVICE_CONFIG_V1_CLASS(klass) (G_TYPE_CHECK_CLASS_CAST ((klass), ACCOUNTS_TYPE_SERVICE_CONFIG_V1, AccountsServiceConfigV1Class))
#define ACCOUNTS_IS_SERVICE_CONFIG_V1(obj) (G_TYPE_CHECK_INSTANCE_TYPE ((obj), ACCOUNTS_TYPE_SERVICE_CONFIG_V1))
#define ACCOUNTS_IS_SERVICE_CONFIG_V1_CLASS(klass) (G_TYPE_CHECK_CLASS_TYPE ((klass), ACCOUNTS_TYPE_SERVICE_CONFIG_V1))
#define ACCOUNTS_SERVICE_CONFIG_V1_GET_CLASS(obj) (G_TYPE_INSTANCE_GET_CLASS ((obj), ACCOUNTS_TYPE_SERVICE_CONFIG_V1, AccountsServiceConfigV1Class))

typedef struct _AccountsServiceConfigV1 AccountsServiceConfigV1;
typedef struct _AccountsServiceConfigV1Class AccountsServiceConfigV1Class;
typedef struct _AccountsManagerLoadAccountData AccountsManagerLoadAccountData;
typedef struct _AccountsManagerSaveAccountLockedData AccountsManagerSaveAccountLockedData;
typedef struct _AccountsManagerDeleteAccountData AccountsManagerDeleteAccountData;
typedef struct _AccountsManagerCreateAccountDirsData AccountsManagerCreateAccountDirsData;
typedef struct _AccountsManagerCreateGoaAccountData AccountsManagerCreateGoaAccountData;
typedef struct _AccountsManagerUpdateGoaAccountData AccountsManagerUpdateGoaAccountData;
#define _g_variant_unref0(var) ((var == NULL) ? NULL : (var = (g_variant_unref (var), NULL)))
typedef struct _AccountsManagerOpenGoaSettingsData AccountsManagerOpenGoaSettingsData;
typedef struct _Block23Data Block23Data;
typedef struct _AccountsManagerAccountStatePrivate AccountsManagerAccountStatePrivate;
typedef struct _AccountsManagerParamSpecAccountState AccountsManagerParamSpecAccountState;
enum  {
	ACCOUNTS_MANAGER_ACCOUNT_ADDED_SIGNAL,
	ACCOUNTS_MANAGER_ACCOUNT_STATUS_CHANGED_SIGNAL,
	ACCOUNTS_MANAGER_ACCOUNT_REMOVED_SIGNAL,
	ACCOUNTS_MANAGER_REPORT_PROBLEM_SIGNAL,
	ACCOUNTS_MANAGER_NUM_SIGNALS
};
static guint accounts_manager_signals[ACCOUNTS_MANAGER_NUM_SIGNALS] = {0};
typedef struct _AccountsAccountConfigV1Private AccountsAccountConfigV1Private;
enum  {
	ACCOUNTS_ACCOUNT_CONFIG_V1_0_PROPERTY,
	ACCOUNTS_ACCOUNT_CONFIG_V1_NUM_PROPERTIES
};
static GParamSpec* accounts_account_config_v1_properties[ACCOUNTS_ACCOUNT_CONFIG_V1_NUM_PROPERTIES];
typedef struct _AccountsAccountConfigLegacyPrivate AccountsAccountConfigLegacyPrivate;
enum  {
	ACCOUNTS_ACCOUNT_CONFIG_LEGACY_0_PROPERTY,
	ACCOUNTS_ACCOUNT_CONFIG_LEGACY_NUM_PROPERTIES
};
static GParamSpec* accounts_account_config_legacy_properties[ACCOUNTS_ACCOUNT_CONFIG_LEGACY_NUM_PROPERTIES];
typedef struct _AccountsServiceConfigV1Private AccountsServiceConfigV1Private;
enum  {
	ACCOUNTS_SERVICE_CONFIG_V1_0_PROPERTY,
	ACCOUNTS_SERVICE_CONFIG_V1_NUM_PROPERTIES
};
static GParamSpec* accounts_service_config_v1_properties[ACCOUNTS_SERVICE_CONFIG_V1_NUM_PROPERTIES];
typedef struct _AccountsServiceConfigLegacyPrivate AccountsServiceConfigLegacyPrivate;
enum  {
	ACCOUNTS_SERVICE_CONFIG_LEGACY_0_PROPERTY,
	ACCOUNTS_SERVICE_CONFIG_LEGACY_NUM_PROPERTIES
};
static GParamSpec* accounts_service_config_legacy_properties[ACCOUNTS_SERVICE_CONFIG_LEGACY_NUM_PROPERTIES];

struct _AccountsManager {
	GObject parent_instance;
	AccountsManagerPrivate * priv;
};

struct _AccountsManagerClass {
	GObjectClass parent_class;
};

struct _AccountsManagerPrivate {
	GFile* _config_dir;
	GFile* _data_dir;
	GeeMap* accounts;
	GeeLinkedList* removed;
	GearyCredentialsMediator* local_mediator;
	GoaClient* goa_service;
};

struct _AccountsManagerConnectGoaData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	AccountsManager* self;
	GCancellable* cancellable;
	GoaClient* _tmp0_;
	GoaClient* _tmp1_;
	GoaClient* _tmp2_;
	GoaClient* _tmp3_;
	GoaClient* _tmp4_;
	GoaClient* _tmp5_;
	GError * _inner_error_;
};

struct _AccountsManagerNewOrphanAccountData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	AccountsManager* self;
	GearyServiceProvider provider;
	GearyRFC822MailboxAddress* primary_mailbox;
	GCancellable* cancellable;
	GearyAccountInformation* result;
	gchar* id;
	gchar* _tmp0_;
	GearyCredentialsMediator* _tmp1_;
	GearyAccountInformation* _tmp2_;
};

struct _AccountsManagerCreateAccountData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	AccountsManager* self;
	GearyAccountInformation* account;
	GCancellable* cancellable;
	SecretMediator* mediator;
	GearyCredentialsMediator* _tmp0_;
	GearyCredentialsMediator* _tmp1_;
	SecretMediator* _tmp2_;
	SecretMediator* _tmp3_;
	SecretMediator* _tmp4_;
	GearyServiceInformation* _tmp5_;
	GearyServiceInformation* _tmp6_;
	SecretMediator* _tmp7_;
	GearyServiceInformation* _tmp8_;
	GearyServiceInformation* _tmp9_;
	GError * _inner_error_;
};

typedef enum  {
	ACCOUNTS_CONFIG_ERROR_IO,
	ACCOUNTS_CONFIG_ERROR_MANAGEMENT,
	ACCOUNTS_CONFIG_ERROR_SYNTAX,
	ACCOUNTS_CONFIG_ERROR_VERSION,
	ACCOUNTS_CONFIG_ERROR_UNAVAILABLE,
	ACCOUNTS_CONFIG_ERROR_REMOVED
} AccountsConfigError;
#define ACCOUNTS_CONFIG_ERROR accounts_config_error_quark ()
struct _AccountsManagerLoadAccountsData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	AccountsManager* self;
	GCancellable* cancellable;
	GFileEnumerator* enumerator;
	GFileEnumerator* _tmp0_;
	GFile* _tmp1_;
	GFileEnumerator* _tmp2_;
	GFileEnumerator* _tmp3_;
	GError* err;
	gboolean _tmp4_;
	GFileEnumerator* _tmp5_;
	GList* info_list;
	GFileEnumerator* _tmp6_;
	GList* _tmp7_;
	guint len;
	GList* _tmp8_;
	guint i;
	gboolean _tmp9_;
	guint _tmp10_;
	gboolean _tmp11_;
	guint _tmp12_;
	guint _tmp13_;
	GFileInfo* file;
	GList* _tmp14_;
	guint _tmp15_;
	gconstpointer _tmp16_;
	GFileInfo* _tmp17_;
	GFileInfo* _tmp18_;
	gchar* id;
	GFileInfo* _tmp19_;
	const gchar* _tmp20_;
	gchar* _tmp21_;
	GearyAccountInformation* info;
	const gchar* _tmp22_;
	GearyAccountInformation* _tmp23_;
	GearyAccountInformation* _tmp24_;
	GError* _vala1_err;
	GError* _vala2_err;
	GError* _vala3_err;
	const gchar* _tmp25_;
	GError* _tmp26_;
	GearyProblemReport* _tmp27_;
	GearyProblemReport* _tmp28_;
	guint _tmp29_;
	GoaClient* _tmp30_;
	GList* list;
	GoaClient* _tmp31_;
	GList* _tmp32_;
	gint _vala1_i;
	gboolean _tmp33_;
	gint _tmp34_;
	gboolean _tmp35_;
	gint _tmp36_;
	GList* _tmp37_;
	GoaObject* account;
	GList* _tmp38_;
	gint _tmp39_;
	gconstpointer _tmp40_;
	GoaObject* _tmp41_;
	gchar* _vala1_id;
	GoaObject* _tmp42_;
	gchar* _tmp43_;
	GeeMap* _tmp44_;
	const gchar* _tmp45_;
	GoaObject* _tmp46_;
	GError * _inner_error_;
};

struct _AccountsManagerRemoveAccountData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	AccountsManager* self;
	GearyAccountInformation* account;
	GCancellable* cancellable;
	GeeMap* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	GeeLinkedList* _tmp3_;
	guint _tmp4_;
	GError * _inner_error_;
};

struct _AccountsManagerRestoreAccountData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	AccountsManager* self;
	GearyAccountInformation* account;
	GCancellable* cancellable;
	GeeLinkedList* _tmp0_;
	GError * _inner_error_;
};

struct _AccountsManagerExpungeAccountsData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	AccountsManager* self;
	GCancellable* cancellable;
	gboolean _tmp0_;
	GeeLinkedList* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
	GeeLinkedList* _tmp4_;
	gpointer _tmp5_;
	GearyAccountInformation* _tmp6_;
	GError * _inner_error_;
};

struct _AccountsManagerSaveAccountData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	AccountsManager* self;
	GearyAccountInformation* info;
	GCancellable* cancellable;
	gint token;
	GearyNonblockingMutex* _tmp0_;
	GearyNonblockingMutex* _tmp1_;
	GError* thrown;
	GError* err;
	GError* _tmp2_;
	GError* _tmp3_;
	GearyNonblockingMutex* _tmp4_;
	GearyNonblockingMutex* _tmp5_;
	GError* _tmp6_;
	GError* _tmp7_;
	GError* _tmp8_;
	GError * _inner_error_;
};

struct _AccountsManagerUpdateLocalCredentialsData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	AccountsManager* self;
	GearyAccountInformation* account;
	GearyServiceInformation* old_service;
	GearyServiceInformation* new_service;
	GCancellable* cancellable;
	SecretMediator* mediator;
	GearyCredentialsMediator* _tmp0_;
	GearyCredentialsMediator* _tmp1_;
	SecretMediator* _tmp2_;
	SecretMediator* _tmp3_;
	GearyCredentials* _tmp4_;
	GearyCredentials* _tmp5_;
	SecretMediator* _tmp6_;
	gboolean _tmp7_;
	GearyCredentials* _tmp8_;
	GearyCredentials* _tmp9_;
	gboolean _tmp10_;
	GearyCredentials* _tmp11_;
	GearyCredentials* _tmp12_;
	gboolean _tmp13_;
	GearyCredentials* _tmp14_;
	GearyCredentials* _tmp15_;
	GearyCredentials* _tmp16_;
	GearyCredentials* _tmp17_;
	const gchar* _tmp18_;
	const gchar* _tmp19_;
	GearyCredentials* _tmp20_;
	GearyCredentials* _tmp21_;
	const gchar* _tmp22_;
	const gchar* _tmp23_;
	SecretMediator* _tmp24_;
	GError * _inner_error_;
};

struct _AccountsManagerAddGoaAccountData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	AccountsManager* self;
	GearyServiceProvider type;
	GCancellable* cancellable;
	GError* _tmp0_;
	GError * _inner_error_;
};

struct _AccountsManagerShowGoaAccountData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	AccountsManager* self;
	GearyAccountInformation* account;
	GCancellable* cancellable;
	GError* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	GError * _inner_error_;
};

struct _AccountsManagerNextIdData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	AccountsManager* self;
	GCancellable* cancellable;
	gchar* result;
	gchar* last_account;
	GeeMap* _tmp0_;
	GeeSet* _tmp1_;
	GeeSet* _tmp2_;
	GeeSet* _tmp3_;
	gpointer _tmp4_;
	gchar* _tmp5_;
	guint next_id;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
	gchar* _tmp10_;
	gchar* _tmp11_;
	gchar* id;
	guint _tmp12_;
	gchar* _tmp13_;
	gboolean _tmp14_;
	gboolean _tmp15_;
	GFile* _tmp16_;
	const gchar* _tmp17_;
	GFile* _tmp18_;
	GFile* _tmp19_;
	gboolean _tmp20_;
	gboolean _tmp21_;
	GFile* _tmp22_;
	const gchar* _tmp23_;
	GFile* _tmp24_;
	GFile* _tmp25_;
	gboolean _tmp26_;
	guint _tmp27_;
	guint _tmp28_;
	gchar* _tmp29_;
	GError* err;
	GError* _tmp30_;
	const gchar* _tmp31_;
	GError * _inner_error_;
};

struct _AccountsAccountConfigIface {
	GTypeInterface parent_iface;
	GearyAccountInformation* (*load) (AccountsAccountConfig* self, GearyConfigFile* config, const gchar* id, GearyCredentialsMediator* mediator, GearyServiceProvider* default_provider, const gchar* default_name, GError** error);
	void (*save) (AccountsAccountConfig* self, GearyAccountInformation* account, GearyConfigFile* config);
};

struct _AccountsServiceConfigIface {
	GTypeInterface parent_iface;
	void (*load) (AccountsServiceConfig* self, GearyConfigFile* config, GearyAccountInformation* account, GearyServiceInformation* service, GError** error);
	void (*save) (AccountsServiceConfig* self, GearyAccountInformation* account, GearyServiceInformation* service, GearyConfigFile* config);
};

struct _AccountsManagerLoadAccountData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	AccountsManager* self;
	gchar* id;
	GCancellable* cancellable;
	GearyAccountInformation* result;
	GFile* config_dir;
	GFile* _tmp0_;
	GFile* _tmp1_;
	GFile* data_dir;
	GFile* _tmp2_;
	GFile* _tmp3_;
	GearyConfigFile* config;
	GFile* _tmp4_;
	GFile* _tmp5_;
	GFile* _tmp6_;
	GearyConfigFile* _tmp7_;
	GearyConfigFile* _tmp8_;
	GearyConfigFile* _tmp9_;
	GError* err;
	GError* _tmp10_;
	const gchar* _tmp11_;
	GError* _tmp12_;
	GError* _vala1_err;
	GError* _tmp13_;
	const gchar* _tmp14_;
	GError* _tmp15_;
	GearyConfigFileGroup* metadata_config;
	GearyConfigFile* _tmp16_;
	GearyConfigFileGroup* _tmp17_;
	gint version;
	GearyConfigFileGroup* _tmp18_;
	AccountsManagerStatus status;
	AccountsManagerStatus _tmp19_;
	GearyConfigFileGroup* _tmp20_;
	AccountsManagerStatus _tmp21_;
	gchar* _tmp22_;
	gchar* _tmp23_;
	gchar* _tmp24_;
	gchar* _tmp25_;
	AccountsManagerStatus _tmp26_;
	GError* _vala2_err;
	GError* _tmp27_;
	gchar* goa_id;
	GearyConfigFileGroup* _tmp28_;
	gchar* _tmp29_;
	gboolean is_goa;
	const gchar* _tmp30_;
	gboolean _tmp31_;
	const gchar* _tmp32_;
	gchar* _tmp33_;
	GoaObject* goa_handle;
	GoaMediator* goa_mediator;
	GearyServiceProvider* default_provider;
	GearyCredentialsMediator* mediator;
	GearyCredentialsMediator* _tmp34_;
	GearyCredentialsMediator* _tmp35_;
	gboolean _tmp36_;
	GoaClient* _tmp37_;
	GError* _tmp38_;
	GoaClient* _tmp39_;
	const gchar* _tmp40_;
	GoaObject* _tmp41_;
	GoaObject* _tmp42_;
	GoaObject* _tmp43_;
	GoaMediator* _tmp44_;
	GoaMediator* _tmp45_;
	GearyCredentialsMediator* _tmp46_;
	GoaMediator* _tmp47_;
	GearyServiceProvider _tmp48_;
	GearyServiceProvider* _tmp49_;
	const gchar* _tmp50_;
	GearyServiceProvider _tmp51_;
	GearyServiceProvider* _tmp52_;
	AccountsAccountConfig* accounts;
	AccountsServiceConfig* services;
	gint _tmp53_;
	AccountsAccountConfigLegacy* _tmp54_;
	AccountsServiceConfigLegacy* _tmp55_;
	gboolean _tmp56_;
	AccountsAccountConfigV1* _tmp57_;
	AccountsServiceConfigV1* _tmp58_;
	gint _tmp59_;
	GError* _tmp60_;
	GearyAccountInformation* account;
	GearyAccountInformation* _tmp61_;
	AccountsAccountConfig* _tmp62_;
	GearyConfigFile* _tmp63_;
	GearyCredentialsMediator* _tmp64_;
	GearyServiceProvider* _tmp65_;
	gchar* _tmp66_;
	gchar* _tmp67_;
	GearyAccountInformation* _tmp68_;
	GearyAccountInformation* _tmp69_;
	GearyAccountInformation* _tmp70_;
	GearyAccountInformation* _tmp71_;
	GFile* _tmp72_;
	GFile* _tmp73_;
	GError* _vala3_err;
	GError* _tmp74_;
	const gchar* _tmp75_;
	GError* _tmp76_;
	AccountsManagerStatus _tmp77_;
	GeeLinkedList* _tmp78_;
	GearyAccountInformation* _tmp79_;
	GError* _tmp80_;
	gboolean _tmp81_;
	AccountsServiceConfig* _tmp82_;
	GearyConfigFile* _tmp83_;
	GearyAccountInformation* _tmp84_;
	GearyAccountInformation* _tmp85_;
	GearyServiceInformation* _tmp86_;
	GearyServiceInformation* _tmp87_;
	AccountsServiceConfig* _tmp88_;
	GearyConfigFile* _tmp89_;
	GearyAccountInformation* _tmp90_;
	GearyAccountInformation* _tmp91_;
	GearyServiceInformation* _tmp92_;
	GearyServiceInformation* _tmp93_;
	GError* _vala4_err;
	GError* _tmp94_;
	const gchar* _tmp95_;
	GError* _tmp96_;
	GearyAccountInformation* _tmp97_;
	GoaMediator* _tmp98_;
	gchar* _tmp99_;
	gchar* _tmp100_;
	GoaMediator* _tmp101_;
	GearyAccountInformation* _tmp102_;
	GError* _vala5_err;
	GError* _tmp103_;
	const gchar* _tmp104_;
	GError* _tmp105_;
	GoaObject* _tmp106_;
	GearyAccountInformation* _tmp107_;
	GError* _tmp108_;
	AccountsManagerStatus _tmp109_;
	GearyAccountInformation* _tmp110_;
	GError* _tmp111_;
	GError * _inner_error_;
};

struct _AccountsManagerSaveAccountLockedData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	AccountsManager* self;
	GearyAccountInformation* account;
	GCancellable* cancellable;
	GFile* _tmp0_;
	GFile* _tmp1_;
	const gchar* _tmp2_;
	const gchar* _tmp3_;
	GError* _tmp4_;
	GearyConfigFile* config;
	GFile* _tmp5_;
	GFile* _tmp6_;
	GFile* _tmp7_;
	GFile* _tmp8_;
	GearyConfigFile* _tmp9_;
	GearyConfigFile* _tmp10_;
	GError* err;
	GError* _tmp11_;
	const gchar* _tmp12_;
	GearyConfigFileGroup* metadata_config;
	GearyConfigFileGroup* _tmp13_;
	GearyConfigFileGroup* _tmp14_;
	GearyConfigFileGroup* _tmp15_;
	gchar* _tmp16_;
	gchar* _tmp17_;
	gboolean is_goa;
	gboolean _tmp18_;
	GearyConfigFileGroup* _tmp19_;
	const gchar* _tmp20_;
	const gchar* _tmp21_;
	gchar* _tmp22_;
	gchar* _tmp23_;
	AccountsAccountConfig* accounts;
	gboolean _tmp24_;
	AccountsAccountConfigV1* _tmp25_;
	AccountsAccountConfig* _tmp26_;
	gboolean _tmp27_;
	AccountsServiceConfig* services;
	AccountsServiceConfigV1* _tmp28_;
	AccountsServiceConfig* _tmp29_;
	GearyServiceInformation* _tmp30_;
	GearyServiceInformation* _tmp31_;
	AccountsServiceConfig* _tmp32_;
	GearyServiceInformation* _tmp33_;
	GearyServiceInformation* _tmp34_;
	GFile* _tmp35_;
	GFile* _tmp36_;
	gchar* _tmp37_;
	gchar* _tmp38_;
	GError * _inner_error_;
};

struct _AccountsManagerDeleteAccountData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	AccountsManager* self;
	GearyAccountInformation* info;
	GCancellable* cancellable;
	SecretMediator* mediator;
	GearyCredentialsMediator* _tmp0_;
	GearyCredentialsMediator* _tmp1_;
	SecretMediator* _tmp2_;
	SecretMediator* _tmp3_;
	SecretMediator* _tmp4_;
	GearyServiceInformation* _tmp5_;
	GearyServiceInformation* _tmp6_;
	GError* e;
	GError* _tmp7_;
	const gchar* _tmp8_;
	SecretMediator* _tmp9_;
	GearyServiceInformation* _tmp10_;
	GearyServiceInformation* _tmp11_;
	GError* _vala1_e;
	GError* _tmp12_;
	const gchar* _tmp13_;
	GFile* _tmp14_;
	GFile* _tmp15_;
	GFile* _tmp16_;
	GFile* _tmp17_;
	GFile* _tmp18_;
	GFile* _tmp19_;
	GFile* _tmp20_;
	GFile* _tmp21_;
	GError * _inner_error_;
};

struct _AccountsManagerCreateAccountDirsData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	AccountsManager* self;
	GearyAccountInformation* info;
	GCancellable* cancellable;
	GFile* config;
	GFile* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	GFile* _tmp3_;
	GFile* data;
	GFile* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	GFile* _tmp7_;
	GFile* _tmp8_;
	GFile* _tmp9_;
	GFile* _tmp10_;
	GFile* _tmp11_;
	GError * _inner_error_;
};

struct _AccountsManagerCreateGoaAccountData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	AccountsManager* self;
	GoaObject* account;
	GCancellable* cancellable;
	GoaMail* mail;
	GoaMail* _tmp0_;
	gchar* name;
	GoaMail* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	const gchar* _tmp4_;
	gchar* _tmp5_;
	GoaMediator* mediator;
	GoaMediator* _tmp6_;
	GearyAccountInformation* info;
	gchar* _tmp7_;
	gchar* _tmp8_;
	GoaMediator* _tmp9_;
	GoaMediator* _tmp10_;
	const gchar* _tmp11_;
	GoaMail* _tmp12_;
	gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	GearyRFC822MailboxAddress* _tmp16_;
	GearyRFC822MailboxAddress* _tmp17_;
	GearyAccountInformation* _tmp18_;
	GearyAccountInformation* _tmp19_;
	GearyAccountInformation* _tmp20_;
	gint _tmp21_;
	GearyAccountInformation* _tmp22_;
	GoaMediator* _tmp23_;
	gchar* _tmp24_;
	gchar* _tmp25_;
	GearyAccountInformation* _tmp26_;
	GoaAccount* _tmp27_;
	GoaAccount* _tmp28_;
	gchar* _tmp29_;
	gchar* _tmp30_;
	gchar* _tmp31_;
	GearyAccountInformation* _tmp32_;
	GearyAccountInformation* _tmp33_;
	GoaMediator* _tmp34_;
	GearyAccountInformation* _tmp35_;
	GError* err;
	GError* _tmp36_;
	GearyProblemReport* _tmp37_;
	GearyProblemReport* _tmp38_;
	GearyAccountInformation* _tmp39_;
	GoaAccount* _tmp40_;
	GoaAccount* _tmp41_;
	gchar* _tmp42_;
	gchar* _tmp43_;
	gchar* _tmp44_;
	GoaAccount* _tmp45_;
	GoaAccount* _tmp46_;
	gchar* _tmp47_;
	gchar* _tmp48_;
	gchar* _tmp49_;
	GError * _inner_error_;
};

struct _AccountsManagerUpdateGoaAccountData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	AccountsManager* self;
	GearyAccountInformation* account;
	gboolean is_available;
	GCancellable* cancellable;
	GoaMediator* mediator;
	GearyCredentialsMediator* _tmp0_;
	GearyCredentialsMediator* _tmp1_;
	GoaMediator* _tmp2_;
	GoaMediator* _tmp3_;
	GError* err;
	GError* _tmp4_;
	GearyAccountProblemReport* _tmp5_;
	GearyAccountProblemReport* _tmp6_;
	GError * _inner_error_;
};

struct _AccountsManagerOpenGoaSettingsData {
	int _state_;
	GObject* _source_object_;
	GAsyncResult* _res_;
	GTask* _async_result;
	AccountsManager* self;
	gchar* action;
	gchar* param;
	GCancellable* cancellable;
	GDBusProxy* settings;
	GDBusProxy* _tmp0_;
	GVariant** args;
	GVariant* _tmp1_;
	GVariant* _tmp2_;
	GVariant* _tmp3_;
	GVariant** _tmp4_;
	GVariant** _tmp5_;
	gint _tmp5__length1;
	gint args_length1;
	gint _args_size_;
	GVariant** _tmp6_;
	gint _tmp6__length1;
	GVariant* _tmp7_;
	GVariant* _tmp8_;
	GVariant* _tmp9_;
	GVariant* command;
	GVariant* _tmp10_;
	const GVariantType* _tmp11_;
	GVariant** _tmp12_;
	gint _tmp12__length1;
	GVariant* _tmp13_;
	GVariant** _tmp14_;
	GVariant** _tmp15_;
	gint _tmp15__length1;
	GVariant* _tmp16_;
	GVariant* _tmp17_;
	GVariant* params;
	GVariant* _tmp18_;
	const GVariantType* _tmp19_;
	GVariant* _tmp20_;
	GVariant* _tmp21_;
	GVariant** _tmp22_;
	GVariant** _tmp23_;
	gint _tmp23__length1;
	GVariant* _tmp24_;
	GVariant* _tmp25_;
	GVariant** _tmp26_;
	GVariant** _tmp27_;
	gint _tmp27__length1;
	GVariant* _tmp28_;
	GVariant* _tmp29_;
	GDBusProxy* _tmp30_;
	GVariant* _tmp31_;
	GVariant* _tmp32_;
	GVariant* _tmp33_;
	GError * _inner_error_;
};

struct _Block23Data {
	int _ref_count_;
	AccountsManager* self;
	GearyAccountInformation* account;
};

struct _AccountsManagerAccountState {
	GTypeInstance parent_instance;
	volatile int ref_count;
	AccountsManagerAccountStatePrivate * priv;
};

struct _AccountsManagerAccountStateClass {
	GTypeClass parent_class;
	void (*finalize) (AccountsManagerAccountState *self);
};

struct _AccountsManagerAccountStatePrivate {
	GearyAccountInformation* _account;
	gboolean _enabled;
	gboolean _available;
};

struct _AccountsManagerParamSpecAccountState {
	GParamSpec parent_instance;
};

struct _AccountsAccountConfigV1 {
	GObject parent_instance;
	AccountsAccountConfigV1Private * priv;
};

struct _AccountsAccountConfigV1Class {
	GObjectClass parent_class;
};

struct _AccountsAccountConfigV1Private {
	gboolean is_managed;
};

struct _AccountsAccountConfigLegacy {
	GObject parent_instance;
	AccountsAccountConfigLegacyPrivate * priv;
};

struct _AccountsAccountConfigLegacyClass {
	GObjectClass parent_class;
};

struct _AccountsServiceConfigV1 {
	GObject parent_instance;
	AccountsServiceConfigV1Private * priv;
};

struct _AccountsServiceConfigV1Class {
	GObjectClass parent_class;
};

struct _AccountsServiceConfigLegacy {
	GObject parent_instance;
	AccountsServiceConfigLegacyPrivate * priv;
};

struct _AccountsServiceConfigLegacyClass {
	GObjectClass parent_class;
};


static gint AccountsManager_private_offset;
static gpointer accounts_manager_parent_class = NULL;
static gint AccountsManagerAccountState_private_offset;
static gpointer accounts_manager_account_state_parent_class = NULL;
static gint AccountsAccountConfigV1_private_offset;
static gpointer accounts_account_config_v1_parent_class = NULL;
static AccountsAccountConfigIface * accounts_account_config_v1_accounts_account_config_parent_iface = NULL;
static gpointer accounts_account_config_legacy_parent_class = NULL;
static AccountsAccountConfigIface * accounts_account_config_legacy_accounts_account_config_parent_iface = NULL;
static gpointer accounts_service_config_v1_parent_class = NULL;
static AccountsServiceConfigIface * accounts_service_config_v1_accounts_service_config_parent_iface = NULL;
static gpointer accounts_service_config_legacy_parent_class = NULL;
static AccountsServiceConfigIface * accounts_service_config_legacy_accounts_service_config_parent_iface = NULL;

GType accounts_manager_get_type (void) G_GNUC_CONST;
static gpointer accounts_manager_account_state_ref (gpointer instance);
static void accounts_manager_account_state_unref (gpointer instance);
static GParamSpec* accounts_manager_param_spec_account_state (const gchar* name,
                                                       const gchar* nick,
                                                       const gchar* blurb,
                                                       GType object_type,
                                                       GParamFlags flags) G_GNUC_UNUSED;
static void accounts_manager_value_set_account_state (GValue* value,
                                               gpointer v_object) G_GNUC_UNUSED;
static void accounts_manager_value_take_account_state (GValue* value,
                                                gpointer v_object) G_GNUC_UNUSED;
static gpointer accounts_manager_value_get_account_state (const GValue* value) G_GNUC_UNUSED;
static GType accounts_manager_account_state_get_type (void) G_GNUC_CONST G_GNUC_UNUSED;
GType accounts_manager_status_get_type (void) G_GNUC_CONST;
AccountsManagerStatus accounts_manager_status_for_value (const gchar* value,
                                                         GError** error);
gchar* accounts_manager_status_to_value (AccountsManagerStatus self);
#define ACCOUNTS_MANAGER_SETTINGS_FILENAME "geary.ini"
#define ACCOUNTS_MANAGER_LOCAL_ID_PREFIX "account_"
#define ACCOUNTS_MANAGER_LOCAL_ID_FORMAT "account_%02u"
#define ACCOUNTS_MANAGER_GOA_ID_PREFIX "goa_"
#define ACCOUNTS_MANAGER_CONFIG_VERSION 1
#define ACCOUNTS_MANAGER_GROUP_METADATA "Metadata"
#define ACCOUNTS_MANAGER_METADATA_STATUS "status"
#define ACCOUNTS_MANAGER_METADATA_VERSION "version"
#define ACCOUNTS_MANAGER_METADATA_GOA "goa_id"
AccountsManager* accounts_manager_new (GearyCredentialsMediator* local_mediator,
                                       GFile* config_dir,
                                       GFile* data_dir);
AccountsManager* accounts_manager_construct (GType object_type,
                                             GearyCredentialsMediator* local_mediator,
                                             GFile* config_dir,
                                             GFile* data_dir);
static void accounts_manager_set_config_dir (AccountsManager* self,
                                      GFile* value);
static void accounts_manager_set_data_dir (AccountsManager* self,
                                    GFile* value);
static void accounts_manager_connect_goa_data_free (gpointer _data);
void accounts_manager_connect_goa (AccountsManager* self,
                                   GCancellable* cancellable,
                                   GAsyncReadyCallback _callback_,
                                   gpointer _user_data_);
void accounts_manager_connect_goa_finish (AccountsManager* self,
                                          GAsyncResult* _res_,
                                          GError** error);
static gboolean accounts_manager_connect_goa_co (AccountsManagerConnectGoaData* _data_);
static void accounts_manager_connect_goa_ready (GObject* source_object,
                                         GAsyncResult* _res_,
                                         gpointer _user_data_);
static void accounts_manager_on_goa_account_added (AccountsManager* self,
                                            GoaObject* account);
static void _accounts_manager_on_goa_account_added_goa_client_account_added (GoaClient* _sender,
                                                                      GoaObject* object,
                                                                      gpointer self);
static void accounts_manager_on_goa_account_changed (AccountsManager* self,
                                              GoaObject* account);
static void _accounts_manager_on_goa_account_changed_goa_client_account_changed (GoaClient* _sender,
                                                                          GoaObject* object,
                                                                          gpointer self);
static void accounts_manager_on_goa_account_removed (AccountsManager* self,
                                              GoaObject* account);
static void _accounts_manager_on_goa_account_removed_goa_client_account_removed (GoaClient* _sender,
                                                                          GoaObject* object,
                                                                          gpointer self);
GearyAccountInformation* accounts_manager_get_account (AccountsManager* self,
                                                       const gchar* id);
static GearyAccountInformation* accounts_manager_account_state_get_account (AccountsManagerAccountState* self);
AccountsManagerStatus accounts_manager_get_status (AccountsManager* self,
                                                   GearyAccountInformation* account);
static AccountsManagerStatus accounts_manager_account_state_get_status (AccountsManagerAccountState* self);
GearyIterable* accounts_manager_iterable (AccountsManager* self);
static GearyAccountInformation* __lambda9_ (AccountsManager* self,
                                     AccountsManagerAccountState* state);
static gpointer ___lambda9__gee_map_func (gpointer g,
                                   gpointer self);
gchar* accounts_manager_get_account_name (AccountsManager* self);
static void accounts_manager_new_orphan_account_data_free (gpointer _data);
void accounts_manager_new_orphan_account (AccountsManager* self,
                                          GearyServiceProvider provider,
                                          GearyRFC822MailboxAddress* primary_mailbox,
                                          GCancellable* cancellable,
                                          GAsyncReadyCallback _callback_,
                                          gpointer _user_data_);
GearyAccountInformation* accounts_manager_new_orphan_account_finish (AccountsManager* self,
                                                                     GAsyncResult* _res_);
static gboolean accounts_manager_new_orphan_account_co (AccountsManagerNewOrphanAccountData* _data_);
static void accounts_manager_next_id (AccountsManager* self,
                               GCancellable* cancellable,
                               GAsyncReadyCallback _callback_,
                               gpointer _user_data_);
static gchar* accounts_manager_next_id_finish (AccountsManager* self,
                                        GAsyncResult* _res_);
static void accounts_manager_new_orphan_account_ready (GObject* source_object,
                                                GAsyncResult* _res_,
                                                gpointer _user_data_);
static void accounts_manager_create_account_data_free (gpointer _data);
void accounts_manager_create_account (AccountsManager* self,
                                      GearyAccountInformation* account,
                                      GCancellable* cancellable,
                                      GAsyncReadyCallback _callback_,
                                      gpointer _user_data_);
void accounts_manager_create_account_finish (AccountsManager* self,
                                             GAsyncResult* _res_,
                                             GError** error);
static gboolean accounts_manager_create_account_co (AccountsManagerCreateAccountData* _data_);
static void accounts_manager_create_account_dirs (AccountsManager* self,
                                           GearyAccountInformation* info,
                                           GCancellable* cancellable,
                                           GAsyncReadyCallback _callback_,
                                           gpointer _user_data_);
static void accounts_manager_create_account_dirs_finish (AccountsManager* self,
                                                  GAsyncResult* _res_,
                                                  GError** error);
static void accounts_manager_create_account_ready (GObject* source_object,
                                            GAsyncResult* _res_,
                                            gpointer _user_data_);
void accounts_manager_save_account (AccountsManager* self,
                                    GearyAccountInformation* info,
                                    GCancellable* cancellable,
                                    GAsyncReadyCallback _callback_,
                                    gpointer _user_data_);
void accounts_manager_save_account_finish (AccountsManager* self,
                                           GAsyncResult* _res_,
                                           GError** error);
static gboolean accounts_manager_set_enabled (AccountsManager* self,
                                       GearyAccountInformation* account,
                                       gboolean is_enabled);
GType secret_mediator_get_type (void) G_GNUC_CONST;
void secret_mediator_update_token (SecretMediator* self,
                                   GearyAccountInformation* account,
                                   GearyServiceInformation* service,
                                   GCancellable* cancellable,
                                   GAsyncReadyCallback _callback_,
                                   gpointer _user_data_);
void secret_mediator_update_token_finish (SecretMediator* self,
                                          GAsyncResult* _res_,
                                          GError** error);
static void accounts_manager_load_accounts_data_free (gpointer _data);
void accounts_manager_load_accounts (AccountsManager* self,
                                     GCancellable* cancellable,
                                     GAsyncReadyCallback _callback_,
                                     gpointer _user_data_);
void accounts_manager_load_accounts_finish (AccountsManager* self,
                                            GAsyncResult* _res_,
                                            GError** error);
static gboolean accounts_manager_load_accounts_co (AccountsManagerLoadAccountsData* _data_);
GFile* accounts_manager_get_config_dir (AccountsManager* self);
static void accounts_manager_load_accounts_ready (GObject* source_object,
                                           GAsyncResult* _res_,
                                           gpointer _user_data_);
static void accounts_manager_load_account (AccountsManager* self,
                                    const gchar* id,
                                    GCancellable* cancellable,
                                    GAsyncReadyCallback _callback_,
                                    gpointer _user_data_);
GQuark accounts_config_error_quark (void);
static GearyAccountInformation* accounts_manager_load_account_finish (AccountsManager* self,
                                                               GAsyncResult* _res_,
                                                               GError** error);
static void _g_object_unref0_ (gpointer var);
static inline void _g_list_free__g_object_unref0_ (GList* self);
static inline gchar* accounts_manager_to_geary_id (AccountsManager* self,
                                     GoaObject* account);
static void accounts_manager_create_goa_account (AccountsManager* self,
                                          GoaObject* account,
                                          GCancellable* cancellable,
                                          GAsyncReadyCallback _callback_,
                                          gpointer _user_data_);
static void accounts_manager_create_goa_account_finish (AccountsManager* self,
                                                 GAsyncResult* _res_);
void accounts_manager_disable_account (AccountsManager* self,
                                       GearyAccountInformation* account);
static gboolean accounts_manager_set_available (AccountsManager* self,
                                         GearyAccountInformation* account,
                                         gboolean is_available);
static void accounts_manager_remove_account_data_free (gpointer _data);
void accounts_manager_remove_account (AccountsManager* self,
                                      GearyAccountInformation* account,
                                      GCancellable* cancellable,
                                      GAsyncReadyCallback _callback_,
                                      gpointer _user_data_);
void accounts_manager_remove_account_finish (AccountsManager* self,
                                             GAsyncResult* _res_,
                                             GError** error);
static gboolean accounts_manager_remove_account_co (AccountsManagerRemoveAccountData* _data_);
static void accounts_manager_on_account_changed (AccountsManager* self,
                                          GearyAccountInformation* account);
static void _accounts_manager_on_account_changed_geary_account_information_changed (GearyAccountInformation* _sender,
                                                                             gpointer self);
static void accounts_manager_remove_account_ready (GObject* source_object,
                                            GAsyncResult* _res_,
                                            gpointer _user_data_);
static void accounts_manager_restore_account_data_free (gpointer _data);
void accounts_manager_restore_account (AccountsManager* self,
                                       GearyAccountInformation* account,
                                       GCancellable* cancellable,
                                       GAsyncReadyCallback _callback_,
                                       gpointer _user_data_);
void accounts_manager_restore_account_finish (AccountsManager* self,
                                              GAsyncResult* _res_,
                                              GError** error);
static gboolean accounts_manager_restore_account_co (AccountsManagerRestoreAccountData* _data_);
static void accounts_manager_restore_account_ready (GObject* source_object,
                                             GAsyncResult* _res_,
                                             gpointer _user_data_);
static void accounts_manager_expunge_accounts_data_free (gpointer _data);
void accounts_manager_expunge_accounts (AccountsManager* self,
                                        GCancellable* cancellable,
                                        GAsyncReadyCallback _callback_,
                                        gpointer _user_data_);
void accounts_manager_expunge_accounts_finish (AccountsManager* self,
                                               GAsyncResult* _res_,
                                               GError** error);
static gboolean accounts_manager_expunge_accounts_co (AccountsManagerExpungeAccountsData* _data_);
static void accounts_manager_delete_account (AccountsManager* self,
                                      GearyAccountInformation* info,
                                      GCancellable* cancellable,
                                      GAsyncReadyCallback _callback_,
                                      gpointer _user_data_);
static void accounts_manager_delete_account_finish (AccountsManager* self,
                                             GAsyncResult* _res_,
                                             GError** error);
static void accounts_manager_expunge_accounts_ready (GObject* source_object,
                                              GAsyncResult* _res_,
                                              gpointer _user_data_);
static void accounts_manager_save_account_data_free (gpointer _data);
static gboolean accounts_manager_save_account_co (AccountsManagerSaveAccountData* _data_);
static void accounts_manager_save_account_ready (GObject* source_object,
                                          GAsyncResult* _res_,
                                          gpointer _user_data_);
static void accounts_manager_save_account_locked (AccountsManager* self,
                                           GearyAccountInformation* account,
                                           GCancellable* cancellable,
                                           GAsyncReadyCallback _callback_,
                                           gpointer _user_data_);
static void accounts_manager_save_account_locked_finish (AccountsManager* self,
                                                  GAsyncResult* _res_,
                                                  GError** error);
static void accounts_manager_update_local_credentials_data_free (gpointer _data);
void accounts_manager_update_local_credentials (AccountsManager* self,
                                                GearyAccountInformation* account,
                                                GearyServiceInformation* old_service,
                                                GearyServiceInformation* new_service,
                                                GCancellable* cancellable,
                                                GAsyncReadyCallback _callback_,
                                                gpointer _user_data_);
void accounts_manager_update_local_credentials_finish (AccountsManager* self,
                                                       GAsyncResult* _res_,
                                                       GError** error);
static gboolean accounts_manager_update_local_credentials_co (AccountsManagerUpdateLocalCredentialsData* _data_);
static void accounts_manager_update_local_credentials_ready (GObject* source_object,
                                                      GAsyncResult* _res_,
                                                      gpointer _user_data_);
void secret_mediator_clear_token (SecretMediator* self,
                                  GearyAccountInformation* account,
                                  GearyServiceInformation* service,
                                  GCancellable* cancellable,
                                  GAsyncReadyCallback _callback_,
                                  gpointer _user_data_);
void secret_mediator_clear_token_finish (SecretMediator* self,
                                         GAsyncResult* _res_,
                                         GError** error);
gboolean accounts_manager_is_goa_account (AccountsManager* self,
                                          GearyAccountInformation* account);
GType goa_mediator_get_type (void) G_GNUC_CONST;
static void accounts_manager_add_goa_account_data_free (gpointer _data);
void accounts_manager_add_goa_account (AccountsManager* self,
                                       GearyServiceProvider type,
                                       GCancellable* cancellable,
                                       GAsyncReadyCallback _callback_,
                                       gpointer _user_data_);
void accounts_manager_add_goa_account_finish (AccountsManager* self,
                                              GAsyncResult* _res_,
                                              GError** error);
static gboolean accounts_manager_add_goa_account_co (AccountsManagerAddGoaAccountData* _data_);
static void accounts_manager_open_goa_settings (AccountsManager* self,
                                         const gchar* action,
                                         const gchar* param,
                                         GCancellable* cancellable,
                                         GAsyncReadyCallback _callback_,
                                         gpointer _user_data_);
static void accounts_manager_open_goa_settings_finish (AccountsManager* self,
                                                GAsyncResult* _res_,
                                                GError** error);
static void accounts_manager_add_goa_account_ready (GObject* source_object,
                                             GAsyncResult* _res_,
                                             gpointer _user_data_);
static void accounts_manager_show_goa_account_data_free (gpointer _data);
void accounts_manager_show_goa_account (AccountsManager* self,
                                        GearyAccountInformation* account,
                                        GCancellable* cancellable,
                                        GAsyncReadyCallback _callback_,
                                        gpointer _user_data_);
void accounts_manager_show_goa_account_finish (AccountsManager* self,
                                               GAsyncResult* _res_,
                                               GError** error);
static gboolean accounts_manager_show_goa_account_co (AccountsManagerShowGoaAccountData* _data_);
static inline gchar* accounts_manager_to_goa_id (AccountsManager* self,
                                   const gchar* id);
static void accounts_manager_show_goa_account_ready (GObject* source_object,
                                              GAsyncResult* _res_,
                                              gpointer _user_data_);
static void accounts_manager_next_id_data_free (gpointer _data);
static gboolean accounts_manager_next_id_co (AccountsManagerNextIdData* _data_);
static gchar* __lambda10_ (AccountsManager* self,
                    gchar* next,
                    gchar* last);
static gpointer ___lambda10__gee_fold_func (gpointer g,
                                     gpointer a,
                                     gpointer self);
static void accounts_manager_next_id_ready (GObject* source_object,
                                     GAsyncResult* _res_,
                                     gpointer _user_data_);
GFile* accounts_manager_get_data_dir (AccountsManager* self);
static void accounts_manager_load_account_data_free (gpointer _data);
static gboolean accounts_manager_load_account_co (AccountsManagerLoadAccountData* _data_);
static void accounts_manager_load_account_ready (GObject* source_object,
                                          GAsyncResult* _res_,
                                          gpointer _user_data_);
GoaMediator* goa_mediator_new (GoaObject* handle);
GoaMediator* goa_mediator_construct (GType object_type,
                                     GoaObject* handle);
GearyServiceProvider goa_mediator_get_service_provider (GoaMediator* self);
static GearyServiceProvider* _geary_service_provider_dup (GearyServiceProvider* self);
GType accounts_account_config_get_type (void) G_GNUC_CONST;
GType accounts_service_config_get_type (void) G_GNUC_CONST;
AccountsAccountConfigLegacy* accounts_account_config_legacy_new (void);
AccountsAccountConfigLegacy* accounts_account_config_legacy_construct (GType object_type);
GType accounts_account_config_legacy_get_type (void) G_GNUC_CONST;
AccountsServiceConfigLegacy* accounts_service_config_legacy_new (void);
AccountsServiceConfigLegacy* accounts_service_config_legacy_construct (GType object_type);
GType accounts_service_config_legacy_get_type (void) G_GNUC_CONST;
AccountsAccountConfigV1* accounts_account_config_v1_new (gboolean is_managed);
AccountsAccountConfigV1* accounts_account_config_v1_construct (GType object_type,
                                                               gboolean is_managed);
GType accounts_account_config_v1_get_type (void) G_GNUC_CONST;
AccountsServiceConfigV1* accounts_service_config_v1_new (void);
AccountsServiceConfigV1* accounts_service_config_v1_construct (GType object_type);
GType accounts_service_config_v1_get_type (void) G_GNUC_CONST;
GearyAccountInformation* accounts_account_config_load (AccountsAccountConfig* self,
                                                       GearyConfigFile* config,
                                                       const gchar* id,
                                                       GearyCredentialsMediator* mediator,
                                                       GearyServiceProvider* default_provider,
                                                       const gchar* default_name,
                                                       GError** error);
void accounts_service_config_load (AccountsServiceConfig* self,
                                   GearyConfigFile* config,
                                   GearyAccountInformation* account,
                                   GearyServiceInformation* service,
                                   GError** error);
gchar* goa_mediator_get_service_label (GoaMediator* self);
void goa_mediator_update (GoaMediator* self,
                          GearyAccountInformation* geary_account,
                          GCancellable* cancellable,
                          GAsyncReadyCallback _callback_,
                          gpointer _user_data_);
void goa_mediator_update_finish (GoaMediator* self,
                                 GAsyncResult* _res_,
                                 GError** error);
static gboolean accounts_manager_is_valid_goa_account (AccountsManager* self,
                                                GoaObject* handle);
static void accounts_manager_save_account_locked_data_free (gpointer _data);
static gboolean accounts_manager_save_account_locked_co (AccountsManagerSaveAccountLockedData* _data_);
static void accounts_manager_save_account_locked_ready (GObject* source_object,
                                                 GAsyncResult* _res_,
                                                 gpointer _user_data_);
void accounts_account_config_save (AccountsAccountConfig* self,
                                   GearyAccountInformation* account,
                                   GearyConfigFile* config);
void accounts_service_config_save (AccountsServiceConfig* self,
                                   GearyAccountInformation* account,
                                   GearyServiceInformation* service,
                                   GearyConfigFile* config);
static void accounts_manager_delete_account_data_free (gpointer _data);
static gboolean accounts_manager_delete_account_co (AccountsManagerDeleteAccountData* _data_);
static void accounts_manager_delete_account_ready (GObject* source_object,
                                            GAsyncResult* _res_,
                                            gpointer _user_data_);
static inline AccountsManagerAccountState* accounts_manager_lookup_state (AccountsManager* self,
                                                            GearyAccountInformation* account);
static AccountsManagerAccountState* accounts_manager_account_state_new (GearyAccountInformation* account);
static AccountsManagerAccountState* accounts_manager_account_state_construct (GType object_type,
                                                                       GearyAccountInformation* account);
static void accounts_manager_account_state_set_enabled (AccountsManagerAccountState* self,
                                                 gboolean value);
static void accounts_manager_account_state_set_available (AccountsManagerAccountState* self,
                                                   gboolean value);
static void accounts_manager_create_account_dirs_data_free (gpointer _data);
static gboolean accounts_manager_create_account_dirs_co (AccountsManagerCreateAccountDirsData* _data_);
static void accounts_manager_create_account_dirs_ready (GObject* source_object,
                                                 GAsyncResult* _res_,
                                                 gpointer _user_data_);
static void accounts_manager_create_goa_account_data_free (gpointer _data);
static gboolean accounts_manager_create_goa_account_co (AccountsManagerCreateGoaAccountData* _data_);
static void accounts_manager_create_goa_account_ready (GObject* source_object,
                                                GAsyncResult* _res_,
                                                gpointer _user_data_);
static void accounts_manager_update_goa_account_data_free (gpointer _data);
static void accounts_manager_update_goa_account (AccountsManager* self,
                                          GearyAccountInformation* account,
                                          gboolean is_available,
                                          GCancellable* cancellable,
                                          GAsyncReadyCallback _callback_,
                                          gpointer _user_data_);
static void accounts_manager_update_goa_account_finish (AccountsManager* self,
                                                 GAsyncResult* _res_);
static gboolean accounts_manager_update_goa_account_co (AccountsManagerUpdateGoaAccountData* _data_);
static void accounts_manager_update_goa_account_ready (GObject* source_object,
                                                GAsyncResult* _res_,
                                                gpointer _user_data_);
static void accounts_manager_open_goa_settings_data_free (gpointer _data);
static gboolean accounts_manager_open_goa_settings_co (AccountsManagerOpenGoaSettingsData* _data_);
static void accounts_manager_open_goa_settings_ready (GObject* source_object,
                                               GAsyncResult* _res_,
                                               gpointer _user_data_);
static void _vala_array_add1 (GVariant** * array,
                       int* length,
                       int* size,
                       GVariant* value);
static Block23Data* block23_data_ref (Block23Data* _data23_);
static void block23_data_unref (void * _userdata_);
static void __lambda8_ (Block23Data* _data23_,
                 GObject* obj,
                 GAsyncResult* res);
static void ___lambda8__gasync_ready_callback (GObject* source_object,
                                        GAsyncResult* res,
                                        gpointer self);
gint accounts_manager_get_size (AccountsManager* self);
static void g_cclosure_user_marshal_VOID__OBJECT_ENUM (GClosure * closure,
                                                GValue * return_value,
                                                guint n_param_values,
                                                const GValue * param_values,
                                                gpointer invocation_hint,
                                                gpointer marshal_data);
static void accounts_manager_account_state_set_account (AccountsManagerAccountState* self,
                                                 GearyAccountInformation* value);
static gboolean accounts_manager_account_state_get_enabled (AccountsManagerAccountState* self);
static gboolean accounts_manager_account_state_get_available (AccountsManagerAccountState* self);
static void accounts_manager_account_state_finalize (AccountsManagerAccountState * obj);
static void accounts_manager_finalize (GObject * obj);
static void _vala_accounts_manager_get_property (GObject * object,
                                          guint property_id,
                                          GValue * value,
                                          GParamSpec * pspec);
static void _vala_accounts_manager_set_property (GObject * object,
                                          guint property_id,
                                          const GValue * value,
                                          GParamSpec * pspec);
#define ACCOUNTS_ACCOUNT_CONFIG_V1_GROUP_ACCOUNT "Account"
#define ACCOUNTS_ACCOUNT_CONFIG_V1_GROUP_FOLDERS "Folders"
#define ACCOUNTS_ACCOUNT_CONFIG_V1_ACCOUNT_LABEL "label"
#define ACCOUNTS_ACCOUNT_CONFIG_V1_ACCOUNT_ORDINAL "ordinal"
#define ACCOUNTS_ACCOUNT_CONFIG_V1_ACCOUNT_PREFETCH "prefetch_days"
#define ACCOUNTS_ACCOUNT_CONFIG_V1_ACCOUNT_PROVIDER "service_provider"
#define ACCOUNTS_ACCOUNT_CONFIG_V1_ACCOUNT_SAVE_DRAFTS "save_drafts"
#define ACCOUNTS_ACCOUNT_CONFIG_V1_ACCOUNT_SAVE_SENT "save_sent"
#define ACCOUNTS_ACCOUNT_CONFIG_V1_ACCOUNT_SENDERS "sender_mailboxes"
#define ACCOUNTS_ACCOUNT_CONFIG_V1_ACCOUNT_SIG "signature"
#define ACCOUNTS_ACCOUNT_CONFIG_V1_ACCOUNT_USE_SIG "use_signature"
#define ACCOUNTS_ACCOUNT_CONFIG_V1_FOLDER_ARCHIVE "archive_folder"
#define ACCOUNTS_ACCOUNT_CONFIG_V1_FOLDER_DRAFTS "drafts_folder"
#define ACCOUNTS_ACCOUNT_CONFIG_V1_FOLDER_SENT "sent_folder"
#define ACCOUNTS_ACCOUNT_CONFIG_V1_FOLDER_SPAM "spam_folder"
#define ACCOUNTS_ACCOUNT_CONFIG_V1_FOLDER_TRASH "trash_folder"
static GearyAccountInformation* accounts_account_config_v1_real_load (AccountsAccountConfig* base,
                                                               GearyConfigFile* config,
                                                               const gchar* id,
                                                               GearyCredentialsMediator* mediator,
                                                               GearyServiceProvider* default_provider,
                                                               const gchar* default_name,
                                                               GError** error);
static GearyServiceProvider ___lambda4_ (AccountsAccountConfigV1* self,
                                  const gchar* value,
                                  GError** error);
static gpointer ____lambda4__geary_config_file_parser (const gchar* value,
                                                gpointer self,
                                                GError** error);
static GearyFolderPath* accounts_account_config_v1_load_folder (AccountsAccountConfigV1* self,
                                                         GearyConfigFileGroup* config,
                                                         const gchar* key);
static void accounts_account_config_v1_real_save (AccountsAccountConfig* base,
                                           GearyAccountInformation* account,
                                           GearyConfigFile* config);
static gchar* __lambda5_ (AccountsAccountConfigV1* self,
                   GearyRFC822MailboxAddress* sender);
static gpointer ___lambda5__gee_map_func (gpointer g,
                                   gpointer self);
static void accounts_account_config_v1_save_folder (AccountsAccountConfigV1* self,
                                             GearyConfigFileGroup* config,
                                             const gchar* key,
                                             GearyFolderPath* path);
static void accounts_account_config_v1_finalize (GObject * obj);
#define ACCOUNTS_ACCOUNT_CONFIG_LEGACY_GROUP "AccountInformation"
#define ACCOUNTS_ACCOUNT_CONFIG_LEGACY_ALTERNATE_EMAILS_KEY "alternate_emails"
#define ACCOUNTS_ACCOUNT_CONFIG_LEGACY_ARCHIVE_FOLDER_KEY "archive_folder"
#define ACCOUNTS_ACCOUNT_CONFIG_LEGACY_CREDENTIALS_METHOD_KEY "credentials_method"
#define ACCOUNTS_ACCOUNT_CONFIG_LEGACY_CREDENTIALS_PROVIDER_KEY "credentials_provider"
#define ACCOUNTS_ACCOUNT_CONFIG_LEGACY_DRAFTS_FOLDER_KEY "drafts_folder"
#define ACCOUNTS_ACCOUNT_CONFIG_LEGACY_EMAIL_SIGNATURE_KEY "email_signature"
#define ACCOUNTS_ACCOUNT_CONFIG_LEGACY_NICKNAME_KEY "nickname"
#define ACCOUNTS_ACCOUNT_CONFIG_LEGACY_ORDINAL_KEY "ordinal"
#define ACCOUNTS_ACCOUNT_CONFIG_LEGACY_PREFETCH_PERIOD_DAYS_KEY "prefetch_period_days"
#define ACCOUNTS_ACCOUNT_CONFIG_LEGACY_PRIMARY_EMAIL_KEY "primary_email"
#define ACCOUNTS_ACCOUNT_CONFIG_LEGACY_REAL_NAME_KEY "real_name"
#define ACCOUNTS_ACCOUNT_CONFIG_LEGACY_SAVE_DRAFTS_KEY "save_drafts"
#define ACCOUNTS_ACCOUNT_CONFIG_LEGACY_SAVE_SENT_MAIL_KEY "save_sent_mail"
#define ACCOUNTS_ACCOUNT_CONFIG_LEGACY_SENT_MAIL_FOLDER_KEY "sent_mail_folder"
#define ACCOUNTS_ACCOUNT_CONFIG_LEGACY_SERVICE_PROVIDER_KEY "service_provider"
#define ACCOUNTS_ACCOUNT_CONFIG_LEGACY_SPAM_FOLDER_KEY "spam_folder"
#define ACCOUNTS_ACCOUNT_CONFIG_LEGACY_TRASH_FOLDER_KEY "trash_folder"
#define ACCOUNTS_ACCOUNT_CONFIG_LEGACY_USE_EMAIL_SIGNATURE_KEY "use_email_signature"
static GearyAccountInformation* accounts_account_config_legacy_real_load (AccountsAccountConfig* base,
                                                                   GearyConfigFile* config_file,
                                                                   const gchar* id,
                                                                   GearyCredentialsMediator* mediator,
                                                                   GearyServiceProvider* default_provider,
                                                                   const gchar* default_name,
                                                                   GError** error);
static GearyServiceProvider ___lambda11_ (AccountsAccountConfigLegacy* self,
                                   const gchar* value,
                                   GError** error);
static gpointer ____lambda11__geary_config_file_parser (const gchar* value,
                                                 gpointer self,
                                                 GError** error);
static void accounts_account_config_legacy_real_save (AccountsAccountConfig* base,
                                               GearyAccountInformation* info,
                                               GearyConfigFile* config_file);
static gchar* ___lambda12_ (AccountsAccountConfigLegacy* self,
                     GearyRFC822MailboxAddress* alt);
static gpointer ____lambda12__gee_map_func (gpointer g,
                                     gpointer self);
#define ACCOUNTS_SERVICE_CONFIG_V1_GROUP_INCOMING "Incoming"
#define ACCOUNTS_SERVICE_CONFIG_V1_GROUP_OUTGOING "Outgoing"
#define ACCOUNTS_SERVICE_CONFIG_V1_CREDENTIALS "credentials"
#define ACCOUNTS_SERVICE_CONFIG_V1_HOST "host"
#define ACCOUNTS_SERVICE_CONFIG_V1_LOGIN "login"
#define ACCOUNTS_SERVICE_CONFIG_V1_PORT "port"
#define ACCOUNTS_SERVICE_CONFIG_V1_REMEMBER_PASSWORD "remember_password"
#define ACCOUNTS_SERVICE_CONFIG_V1_SECURITY "transport_security"
static void accounts_service_config_v1_real_load (AccountsServiceConfig* base,
                                           GearyConfigFile* config,
                                           GearyAccountInformation* account,
                                           GearyServiceInformation* service,
                                           GError** error);
static GearyTlsNegotiationMethod ___lambda6_ (AccountsServiceConfigV1* self,
                                       const gchar* value,
                                       GError** error);
static gpointer ____lambda6__geary_config_file_parser (const gchar* value,
                                                gpointer self,
                                                GError** error);
static GearyCredentialsRequirement ___lambda7_ (AccountsServiceConfigV1* self,
                                         const gchar* value,
                                         GError** error);
static gpointer ____lambda7__geary_config_file_parser (const gchar* value,
                                                gpointer self,
                                                GError** error);
static void accounts_service_config_v1_real_save (AccountsServiceConfig* base,
                                           GearyAccountInformation* account,
                                           GearyServiceInformation* service,
                                           GearyConfigFile* config);
#define ACCOUNTS_SERVICE_CONFIG_LEGACY_HOST "host"
#define ACCOUNTS_SERVICE_CONFIG_LEGACY_PORT "port"
#define ACCOUNTS_SERVICE_CONFIG_LEGACY_REMEMBER_PASSWORD "remember_password"
#define ACCOUNTS_SERVICE_CONFIG_LEGACY_SSL "ssl"
#define ACCOUNTS_SERVICE_CONFIG_LEGACY_STARTTLS "starttls"
#define ACCOUNTS_SERVICE_CONFIG_LEGACY_USERNAME "username"
#define ACCOUNTS_SERVICE_CONFIG_LEGACY_SMTP_NOAUTH "smtp_noauth"
#define ACCOUNTS_SERVICE_CONFIG_LEGACY_SMTP_USE_IMAP_CREDENTIALS "smtp_use_imap_credentials"
static void accounts_service_config_legacy_real_load (AccountsServiceConfig* base,
                                               GearyConfigFile* config,
                                               GearyAccountInformation* account,
                                               GearyServiceInformation* service,
                                               GError** error);
static void accounts_service_config_legacy_real_save (AccountsServiceConfig* base,
                                               GearyAccountInformation* account,
                                               GearyServiceInformation* service,
                                               GearyConfigFile* config);
static void _vala_array_destroy (gpointer array,
                          gint array_length,
                          GDestroyNotify destroy_func);
static void _vala_array_free (gpointer array,
                       gint array_length,
                       GDestroyNotify destroy_func);


static inline gpointer
accounts_manager_get_instance_private (AccountsManager* self)
{
	return G_STRUCT_MEMBER_P (self, AccountsManager_private_offset);
}


AccountsManagerStatus
accounts_manager_status_for_value (const gchar* value,
                                   GError** error)
{
	AccountsManagerStatus result = 0;
	AccountsManagerStatus _tmp0_ = 0;
	gchar* _tmp1_;
	gchar* _tmp2_;
	gpointer _tmp3_;
	AccountsManagerStatus _tmp4_;
	GError * _inner_error_ = NULL;
#line 59 "../src/client/accounts/accounts-manager.vala"
	g_return_val_if_fail (value != NULL, 0);
#line 61 "../src/client/accounts/accounts-manager.vala"
	_tmp1_ = g_ascii_strdown (value, (gssize) -1);
#line 61 "../src/client/accounts/accounts-manager.vala"
	_tmp2_ = _tmp1_;
#line 61 "../src/client/accounts/accounts-manager.vala"
	_tmp3_ = geary_object_utils_from_enum_nick (ACCOUNTS_MANAGER_TYPE_STATUS, NULL, NULL, ACCOUNTS_MANAGER_TYPE_STATUS, _tmp2_, &_inner_error_);
#line 61 "../src/client/accounts/accounts-manager.vala"
	_tmp4_ = (AccountsManagerStatus) ((gintptr) _tmp3_);
#line 61 "../src/client/accounts/accounts-manager.vala"
	_g_free0 (_tmp2_);
#line 61 "../src/client/accounts/accounts-manager.vala"
	_tmp0_ = _tmp4_;
#line 61 "../src/client/accounts/accounts-manager.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 61 "../src/client/accounts/accounts-manager.vala"
		if (_inner_error_->domain == GEARY_ENGINE_ERROR) {
#line 61 "../src/client/accounts/accounts-manager.vala"
			g_propagate_error (error, _inner_error_);
#line 61 "../src/client/accounts/accounts-manager.vala"
			return 0;
#line 1663 "accounts-manager.c"
		} else {
#line 61 "../src/client/accounts/accounts-manager.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 61 "../src/client/accounts/accounts-manager.vala"
			g_clear_error (&_inner_error_);
#line 61 "../src/client/accounts/accounts-manager.vala"
			return 0;
#line 1671 "accounts-manager.c"
		}
	}
#line 61 "../src/client/accounts/accounts-manager.vala"
	result = _tmp0_;
#line 61 "../src/client/accounts/accounts-manager.vala"
	return result;
#line 1678 "accounts-manager.c"
}


gchar*
accounts_manager_status_to_value (AccountsManagerStatus self)
{
	gchar* result = NULL;
	gchar* _tmp0_;
#line 67 "../src/client/accounts/accounts-manager.vala"
	_tmp0_ = geary_object_utils_to_enum_nick (ACCOUNTS_MANAGER_TYPE_STATUS, NULL, NULL, ACCOUNTS_MANAGER_TYPE_STATUS, (gpointer) ((gintptr) self));
#line 67 "../src/client/accounts/accounts-manager.vala"
	result = _tmp0_;
#line 67 "../src/client/accounts/accounts-manager.vala"
	return result;
#line 1693 "accounts-manager.c"
}


/**
     * Specifies the overall status of an account.
     */
GType
accounts_manager_status_get_type (void)
{
	static volatile gsize accounts_manager_status_type_id__volatile = 0;
	if (g_once_init_enter (&accounts_manager_status_type_id__volatile)) {
		static const GEnumValue values[] = {{ACCOUNTS_MANAGER_STATUS_ENABLED, "ACCOUNTS_MANAGER_STATUS_ENABLED", "enabled"}, {ACCOUNTS_MANAGER_STATUS_DISABLED, "ACCOUNTS_MANAGER_STATUS_DISABLED", "disabled"}, {ACCOUNTS_MANAGER_STATUS_UNAVAILABLE, "ACCOUNTS_MANAGER_STATUS_UNAVAILABLE", "unavailable"}, {ACCOUNTS_MANAGER_STATUS_REMOVED, "ACCOUNTS_MANAGER_STATUS_REMOVED", "removed"}, {0, NULL, NULL}};
		GType accounts_manager_status_type_id;
		accounts_manager_status_type_id = g_enum_register_static ("AccountsManagerStatus", values);
		g_once_init_leave (&accounts_manager_status_type_id__volatile, accounts_manager_status_type_id);
	}
	return accounts_manager_status_type_id__volatile;
}


static gpointer
_g_object_ref0 (gpointer self)
{
#line 147 "../src/client/accounts/accounts-manager.vala"
	return self ? g_object_ref (self) : NULL;
#line 1719 "accounts-manager.c"
}


AccountsManager*
accounts_manager_construct (GType object_type,
                            GearyCredentialsMediator* local_mediator,
                            GFile* config_dir,
                            GFile* data_dir)
{
	AccountsManager * self = NULL;
	GearyCredentialsMediator* _tmp0_;
#line 144 "../src/client/accounts/accounts-manager.vala"
	g_return_val_if_fail (GEARY_IS_CREDENTIALS_MEDIATOR (local_mediator), NULL);
#line 144 "../src/client/accounts/accounts-manager.vala"
	g_return_val_if_fail (G_IS_FILE (config_dir), NULL);
#line 144 "../src/client/accounts/accounts-manager.vala"
	g_return_val_if_fail (G_IS_FILE (data_dir), NULL);
#line 144 "../src/client/accounts/accounts-manager.vala"
	self = (AccountsManager*) g_object_new (object_type, NULL);
#line 147 "../src/client/accounts/accounts-manager.vala"
	_tmp0_ = _g_object_ref0 (local_mediator);
#line 147 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (self->priv->local_mediator);
#line 147 "../src/client/accounts/accounts-manager.vala"
	self->priv->local_mediator = _tmp0_;
#line 148 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_set_config_dir (self, config_dir);
#line 149 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_set_data_dir (self, data_dir);
#line 144 "../src/client/accounts/accounts-manager.vala"
	return self;
#line 1751 "accounts-manager.c"
}


AccountsManager*
accounts_manager_new (GearyCredentialsMediator* local_mediator,
                      GFile* config_dir,
                      GFile* data_dir)
{
#line 144 "../src/client/accounts/accounts-manager.vala"
	return accounts_manager_construct (ACCOUNTS_TYPE_MANAGER, local_mediator, config_dir, data_dir);
#line 1762 "accounts-manager.c"
}


static void
accounts_manager_connect_goa_data_free (gpointer _data)
{
	AccountsManagerConnectGoaData* _data_;
	_data_ = _data;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->cancellable);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->self);
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_slice_free (AccountsManagerConnectGoaData, _data_);
#line 1777 "accounts-manager.c"
}


void
accounts_manager_connect_goa (AccountsManager* self,
                              GCancellable* cancellable,
                              GAsyncReadyCallback _callback_,
                              gpointer _user_data_)
{
	AccountsManagerConnectGoaData* _data_;
	AccountsManager* _tmp0_;
	GCancellable* _tmp1_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_ = g_slice_new0 (AccountsManagerConnectGoaData);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_task_set_task_data (_data_->_async_result, _data_, accounts_manager_connect_goa_data_free);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->self = _tmp0_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_tmp1_ = _g_object_ref0 (cancellable);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->cancellable);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->cancellable = _tmp1_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_connect_goa_co (_data_);
#line 1808 "accounts-manager.c"
}


void
accounts_manager_connect_goa_finish (AccountsManager* self,
                                     GAsyncResult* _res_,
                                     GError** error)
{
	AccountsManagerConnectGoaData* _data_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 24 "../src/client/accounts/accounts-manager.vala"
	if (NULL == _data_) {
#line 24 "../src/client/accounts/accounts-manager.vala"
		return;
#line 1824 "accounts-manager.c"
	}
}


static void
accounts_manager_connect_goa_ready (GObject* source_object,
                                    GAsyncResult* _res_,
                                    gpointer _user_data_)
{
	AccountsManagerConnectGoaData* _data_;
#line 154 "../src/client/accounts/accounts-manager.vala"
	_data_ = _user_data_;
#line 154 "../src/client/accounts/accounts-manager.vala"
	_data_->_source_object_ = source_object;
#line 154 "../src/client/accounts/accounts-manager.vala"
	_data_->_res_ = _res_;
#line 154 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_connect_goa_co (_data_);
#line 1843 "accounts-manager.c"
}


static void
_accounts_manager_on_goa_account_added_goa_client_account_added (GoaClient* _sender,
                                                                 GoaObject* object,
                                                                 gpointer self)
{
#line 155 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_on_goa_account_added ((AccountsManager*) self, object);
#line 1854 "accounts-manager.c"
}


static void
_accounts_manager_on_goa_account_changed_goa_client_account_changed (GoaClient* _sender,
                                                                     GoaObject* object,
                                                                     gpointer self)
{
#line 156 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_on_goa_account_changed ((AccountsManager*) self, object);
#line 1865 "accounts-manager.c"
}


static void
_accounts_manager_on_goa_account_removed_goa_client_account_removed (GoaClient* _sender,
                                                                     GoaObject* object,
                                                                     gpointer self)
{
#line 157 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_on_goa_account_removed ((AccountsManager*) self, object);
#line 1876 "accounts-manager.c"
}


static gboolean
accounts_manager_connect_goa_co (AccountsManagerConnectGoaData* _data_)
{
#line 152 "../src/client/accounts/accounts-manager.vala"
	switch (_data_->_state_) {
#line 152 "../src/client/accounts/accounts-manager.vala"
		case 0:
#line 1887 "accounts-manager.c"
		goto _state_0;
#line 152 "../src/client/accounts/accounts-manager.vala"
		case 1:
#line 1891 "accounts-manager.c"
		goto _state_1;
		default:
#line 152 "../src/client/accounts/accounts-manager.vala"
		g_assert_not_reached ();
#line 1896 "accounts-manager.c"
	}
	_state_0:
#line 154 "../src/client/accounts/accounts-manager.vala"
	_data_->_state_ = 1;
#line 154 "../src/client/accounts/accounts-manager.vala"
	goa_client_new (_data_->cancellable, accounts_manager_connect_goa_ready, _data_);
#line 154 "../src/client/accounts/accounts-manager.vala"
	return FALSE;
#line 1905 "accounts-manager.c"
	_state_1:
#line 154 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp1_ = goa_client_new_finish (_data_->_res_, &_data_->_inner_error_);
#line 154 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp0_ = _data_->_tmp1_;
#line 154 "../src/client/accounts/accounts-manager.vala"
	if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 154 "../src/client/accounts/accounts-manager.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error_);
#line 154 "../src/client/accounts/accounts-manager.vala"
		g_object_unref (_data_->_async_result);
#line 154 "../src/client/accounts/accounts-manager.vala"
		return FALSE;
#line 1919 "accounts-manager.c"
	}
#line 154 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp2_ = _data_->_tmp0_;
#line 154 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp0_ = NULL;
#line 154 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->self->priv->goa_service);
#line 154 "../src/client/accounts/accounts-manager.vala"
	_data_->self->priv->goa_service = _data_->_tmp2_;
#line 155 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp3_ = _data_->self->priv->goa_service;
#line 155 "../src/client/accounts/accounts-manager.vala"
	g_signal_connect_object (_data_->_tmp3_, "account-added", (GCallback) _accounts_manager_on_goa_account_added_goa_client_account_added, _data_->self, 0);
#line 156 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp4_ = _data_->self->priv->goa_service;
#line 156 "../src/client/accounts/accounts-manager.vala"
	g_signal_connect_object (_data_->_tmp4_, "account-changed", (GCallback) _accounts_manager_on_goa_account_changed_goa_client_account_changed, _data_->self, 0);
#line 157 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp5_ = _data_->self->priv->goa_service;
#line 157 "../src/client/accounts/accounts-manager.vala"
	g_signal_connect_object (_data_->_tmp5_, "account-removed", (GCallback) _accounts_manager_on_goa_account_removed_goa_client_account_removed, _data_->self, 0);
#line 152 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->_tmp0_);
#line 152 "../src/client/accounts/accounts-manager.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 152 "../src/client/accounts/accounts-manager.vala"
	if (_data_->_state_ != 0) {
#line 152 "../src/client/accounts/accounts-manager.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 152 "../src/client/accounts/accounts-manager.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 1951 "accounts-manager.c"
		}
	}
#line 152 "../src/client/accounts/accounts-manager.vala"
	g_object_unref (_data_->_async_result);
#line 152 "../src/client/accounts/accounts-manager.vala"
	return FALSE;
#line 1958 "accounts-manager.c"
}


/** Returns the account with the given id. */
GearyAccountInformation*
accounts_manager_get_account (AccountsManager* self,
                              const gchar* id)
{
	GearyAccountInformation* result = NULL;
	AccountsManagerAccountState* state = NULL;
	GeeMap* _tmp0_;
	gpointer _tmp1_;
	GearyAccountInformation* _tmp2_ = NULL;
	AccountsManagerAccountState* _tmp3_;
	GearyAccountInformation* _tmp7_;
#line 161 "../src/client/accounts/accounts-manager.vala"
	g_return_val_if_fail (ACCOUNTS_IS_MANAGER (self), NULL);
#line 161 "../src/client/accounts/accounts-manager.vala"
	g_return_val_if_fail (id != NULL, NULL);
#line 162 "../src/client/accounts/accounts-manager.vala"
	_tmp0_ = self->priv->accounts;
#line 162 "../src/client/accounts/accounts-manager.vala"
	_tmp1_ = gee_map_get (_tmp0_, id);
#line 162 "../src/client/accounts/accounts-manager.vala"
	state = (AccountsManagerAccountState*) _tmp1_;
#line 163 "../src/client/accounts/accounts-manager.vala"
	_tmp3_ = state;
#line 163 "../src/client/accounts/accounts-manager.vala"
	if (_tmp3_ != NULL) {
#line 1988 "accounts-manager.c"
		AccountsManagerAccountState* _tmp4_;
		GearyAccountInformation* _tmp5_;
		GearyAccountInformation* _tmp6_;
#line 163 "../src/client/accounts/accounts-manager.vala"
		_tmp4_ = state;
#line 163 "../src/client/accounts/accounts-manager.vala"
		_tmp5_ = accounts_manager_account_state_get_account (_tmp4_);
#line 163 "../src/client/accounts/accounts-manager.vala"
		_tmp6_ = _tmp5_;
#line 163 "../src/client/accounts/accounts-manager.vala"
		_tmp2_ = _tmp6_;
#line 2000 "accounts-manager.c"
	} else {
#line 163 "../src/client/accounts/accounts-manager.vala"
		_tmp2_ = NULL;
#line 2004 "accounts-manager.c"
	}
#line 163 "../src/client/accounts/accounts-manager.vala"
	_tmp7_ = _g_object_ref0 (_tmp2_);
#line 163 "../src/client/accounts/accounts-manager.vala"
	result = _tmp7_;
#line 163 "../src/client/accounts/accounts-manager.vala"
	_accounts_manager_account_state_unref0 (state);
#line 163 "../src/client/accounts/accounts-manager.vala"
	return result;
#line 2014 "accounts-manager.c"
}


/** Returns the status for the given account. */
AccountsManagerStatus
accounts_manager_get_status (AccountsManager* self,
                             GearyAccountInformation* account)
{
	AccountsManagerStatus result = 0;
	AccountsManagerAccountState* state = NULL;
	GeeMap* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gpointer _tmp3_;
	AccountsManagerStatus _tmp4_ = 0;
	AccountsManagerAccountState* _tmp5_;
#line 167 "../src/client/accounts/accounts-manager.vala"
	g_return_val_if_fail (ACCOUNTS_IS_MANAGER (self), 0);
#line 167 "../src/client/accounts/accounts-manager.vala"
	g_return_val_if_fail (GEARY_IS_ACCOUNT_INFORMATION (account), 0);
#line 168 "../src/client/accounts/accounts-manager.vala"
	_tmp0_ = self->priv->accounts;
#line 168 "../src/client/accounts/accounts-manager.vala"
	_tmp1_ = geary_account_information_get_id (account);
#line 168 "../src/client/accounts/accounts-manager.vala"
	_tmp2_ = _tmp1_;
#line 168 "../src/client/accounts/accounts-manager.vala"
	_tmp3_ = gee_map_get (_tmp0_, _tmp2_);
#line 168 "../src/client/accounts/accounts-manager.vala"
	state = (AccountsManagerAccountState*) _tmp3_;
#line 169 "../src/client/accounts/accounts-manager.vala"
	_tmp5_ = state;
#line 169 "../src/client/accounts/accounts-manager.vala"
	if (_tmp5_ != NULL) {
#line 2049 "accounts-manager.c"
		AccountsManagerAccountState* _tmp6_;
		AccountsManagerStatus _tmp7_;
		AccountsManagerStatus _tmp8_;
#line 169 "../src/client/accounts/accounts-manager.vala"
		_tmp6_ = state;
#line 169 "../src/client/accounts/accounts-manager.vala"
		_tmp7_ = accounts_manager_account_state_get_status (_tmp6_);
#line 169 "../src/client/accounts/accounts-manager.vala"
		_tmp8_ = _tmp7_;
#line 169 "../src/client/accounts/accounts-manager.vala"
		_tmp4_ = _tmp8_;
#line 2061 "accounts-manager.c"
	} else {
#line 169 "../src/client/accounts/accounts-manager.vala"
		_tmp4_ = ACCOUNTS_MANAGER_STATUS_UNAVAILABLE;
#line 2065 "accounts-manager.c"
	}
#line 169 "../src/client/accounts/accounts-manager.vala"
	result = _tmp4_;
#line 169 "../src/client/accounts/accounts-manager.vala"
	_accounts_manager_account_state_unref0 (state);
#line 169 "../src/client/accounts/accounts-manager.vala"
	return result;
#line 2073 "accounts-manager.c"
}


/** Returns a read-only iterable of all currently known accounts. */
static GearyAccountInformation*
__lambda9_ (AccountsManager* self,
            AccountsManagerAccountState* state)
{
	GearyAccountInformation* result = NULL;
	GearyAccountInformation* _tmp0_;
	GearyAccountInformation* _tmp1_;
	GearyAccountInformation* _tmp2_;
#line 177 "../src/client/accounts/accounts-manager.vala"
	g_return_val_if_fail (ACCOUNTS_MANAGER_IS_ACCOUNT_STATE (state), NULL);
#line 177 "../src/client/accounts/accounts-manager.vala"
	_tmp0_ = accounts_manager_account_state_get_account (state);
#line 177 "../src/client/accounts/accounts-manager.vala"
	_tmp1_ = _tmp0_;
#line 177 "../src/client/accounts/accounts-manager.vala"
	_tmp2_ = _g_object_ref0 (_tmp1_);
#line 177 "../src/client/accounts/accounts-manager.vala"
	result = _tmp2_;
#line 177 "../src/client/accounts/accounts-manager.vala"
	_accounts_manager_account_state_unref0 (state);
#line 177 "../src/client/accounts/accounts-manager.vala"
	return result;
#line 2100 "accounts-manager.c"
}


static gpointer
___lambda9__gee_map_func (gpointer g,
                          gpointer self)
{
	gpointer result;
	result = __lambda9_ ((AccountsManager*) self, (AccountsManagerAccountState*) g);
#line 174 "../src/client/accounts/accounts-manager.vala"
	return result;
#line 2112 "accounts-manager.c"
}


GearyIterable*
accounts_manager_iterable (AccountsManager* self)
{
	GearyIterable* result = NULL;
	GeeMap* _tmp0_;
	GeeCollection* _tmp1_;
	GeeCollection* _tmp2_;
	GeeCollection* _tmp3_;
	GearyIterable* _tmp4_;
	GearyIterable* _tmp5_;
	GearyIterable* _tmp6_;
	GearyIterable* _tmp7_;
#line 173 "../src/client/accounts/accounts-manager.vala"
	g_return_val_if_fail (ACCOUNTS_IS_MANAGER (self), NULL);
#line 174 "../src/client/accounts/accounts-manager.vala"
	_tmp0_ = self->priv->accounts;
#line 174 "../src/client/accounts/accounts-manager.vala"
	_tmp1_ = gee_map_get_values (_tmp0_);
#line 174 "../src/client/accounts/accounts-manager.vala"
	_tmp2_ = _tmp1_;
#line 174 "../src/client/accounts/accounts-manager.vala"
	_tmp3_ = _tmp2_;
#line 174 "../src/client/accounts/accounts-manager.vala"
	_tmp4_ = geary_traverse (ACCOUNTS_MANAGER_TYPE_ACCOUNT_STATE, (GBoxedCopyFunc) accounts_manager_account_state_ref, (GDestroyNotify) accounts_manager_account_state_unref, G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_ITERABLE, GeeIterable));
#line 174 "../src/client/accounts/accounts-manager.vala"
	_tmp5_ = _tmp4_;
#line 174 "../src/client/accounts/accounts-manager.vala"
	_tmp6_ = geary_iterable_map (_tmp5_, GEARY_TYPE_ACCOUNT_INFORMATION, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, ___lambda9__gee_map_func, self);
#line 174 "../src/client/accounts/accounts-manager.vala"
	_tmp7_ = _tmp6_;
#line 174 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_tmp5_);
#line 174 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_tmp3_);
#line 174 "../src/client/accounts/accounts-manager.vala"
	result = _tmp7_;
#line 174 "../src/client/accounts/accounts-manager.vala"
	return result;
#line 2154 "accounts-manager.c"
}


/**
     * Returns the display name for the current desktop login session.
     */
gchar*
accounts_manager_get_account_name (AccountsManager* self)
{
	gchar* result = NULL;
	gchar* name = NULL;
	const gchar* _tmp0_;
	gchar* _tmp1_;
	gboolean _tmp2_ = FALSE;
	const gchar* _tmp3_;
#line 184 "../src/client/accounts/accounts-manager.vala"
	g_return_val_if_fail (ACCOUNTS_IS_MANAGER (self), NULL);
#line 185 "../src/client/accounts/accounts-manager.vala"
	_tmp0_ = g_get_real_name ();
#line 185 "../src/client/accounts/accounts-manager.vala"
	_tmp1_ = g_strdup (_tmp0_);
#line 185 "../src/client/accounts/accounts-manager.vala"
	name = _tmp1_;
#line 186 "../src/client/accounts/accounts-manager.vala"
	_tmp3_ = name;
#line 186 "../src/client/accounts/accounts-manager.vala"
	if (geary_string_is_empty (_tmp3_)) {
#line 186 "../src/client/accounts/accounts-manager.vala"
		_tmp2_ = TRUE;
#line 2184 "accounts-manager.c"
	} else {
		const gchar* _tmp4_;
#line 186 "../src/client/accounts/accounts-manager.vala"
		_tmp4_ = name;
#line 186 "../src/client/accounts/accounts-manager.vala"
		_tmp2_ = g_strcmp0 (_tmp4_, "Unknown") == 0;
#line 2191 "accounts-manager.c"
	}
#line 186 "../src/client/accounts/accounts-manager.vala"
	if (_tmp2_) {
#line 187 "../src/client/accounts/accounts-manager.vala"
		_g_free0 (name);
#line 187 "../src/client/accounts/accounts-manager.vala"
		name = NULL;
#line 2199 "accounts-manager.c"
	}
#line 189 "../src/client/accounts/accounts-manager.vala"
	result = name;
#line 189 "../src/client/accounts/accounts-manager.vala"
	return result;
#line 2205 "accounts-manager.c"
}


static void
accounts_manager_new_orphan_account_data_free (gpointer _data)
{
	AccountsManagerNewOrphanAccountData* _data_;
	_data_ = _data;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->primary_mailbox);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->cancellable);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->result);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->self);
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_slice_free (AccountsManagerNewOrphanAccountData, _data_);
#line 2224 "accounts-manager.c"
}


void
accounts_manager_new_orphan_account (AccountsManager* self,
                                     GearyServiceProvider provider,
                                     GearyRFC822MailboxAddress* primary_mailbox,
                                     GCancellable* cancellable,
                                     GAsyncReadyCallback _callback_,
                                     gpointer _user_data_)
{
	AccountsManagerNewOrphanAccountData* _data_;
	AccountsManager* _tmp0_;
	GearyRFC822MailboxAddress* _tmp1_;
	GCancellable* _tmp2_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_ = g_slice_new0 (AccountsManagerNewOrphanAccountData);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_task_set_task_data (_data_->_async_result, _data_, accounts_manager_new_orphan_account_data_free);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->self = _tmp0_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->provider = provider;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_tmp1_ = _g_object_ref0 (primary_mailbox);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->primary_mailbox);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->primary_mailbox = _tmp1_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_tmp2_ = _g_object_ref0 (cancellable);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->cancellable);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->cancellable = _tmp2_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_new_orphan_account_co (_data_);
#line 2266 "accounts-manager.c"
}


GearyAccountInformation*
accounts_manager_new_orphan_account_finish (AccountsManager* self,
                                            GAsyncResult* _res_)
{
	GearyAccountInformation* result;
	AccountsManagerNewOrphanAccountData* _data_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 24 "../src/client/accounts/accounts-manager.vala"
	if (NULL == _data_) {
#line 24 "../src/client/accounts/accounts-manager.vala"
		return NULL;
#line 2282 "accounts-manager.c"
	}
#line 24 "../src/client/accounts/accounts-manager.vala"
	result = _data_->result;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->result = NULL;
#line 24 "../src/client/accounts/accounts-manager.vala"
	return result;
#line 2290 "accounts-manager.c"
}


/**
     * Returns a new account, not yet stored on disk.
     */
static void
accounts_manager_new_orphan_account_ready (GObject* source_object,
                                           GAsyncResult* _res_,
                                           gpointer _user_data_)
{
	AccountsManagerNewOrphanAccountData* _data_;
#line 199 "../src/client/accounts/accounts-manager.vala"
	_data_ = _user_data_;
#line 199 "../src/client/accounts/accounts-manager.vala"
	_data_->_source_object_ = source_object;
#line 199 "../src/client/accounts/accounts-manager.vala"
	_data_->_res_ = _res_;
#line 199 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_new_orphan_account_co (_data_);
#line 2311 "accounts-manager.c"
}


static gboolean
accounts_manager_new_orphan_account_co (AccountsManagerNewOrphanAccountData* _data_)
{
#line 195 "../src/client/accounts/accounts-manager.vala"
	switch (_data_->_state_) {
#line 195 "../src/client/accounts/accounts-manager.vala"
		case 0:
#line 2322 "accounts-manager.c"
		goto _state_0;
#line 195 "../src/client/accounts/accounts-manager.vala"
		case 1:
#line 2326 "accounts-manager.c"
		goto _state_1;
		default:
#line 195 "../src/client/accounts/accounts-manager.vala"
		g_assert_not_reached ();
#line 2331 "accounts-manager.c"
	}
	_state_0:
#line 199 "../src/client/accounts/accounts-manager.vala"
	_data_->_state_ = 1;
#line 199 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_next_id (_data_->self, _data_->cancellable, accounts_manager_new_orphan_account_ready, _data_);
#line 199 "../src/client/accounts/accounts-manager.vala"
	return FALSE;
#line 2340 "accounts-manager.c"
	_state_1:
#line 199 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp0_ = accounts_manager_next_id_finish (_data_->self, _data_->_res_);
#line 199 "../src/client/accounts/accounts-manager.vala"
	_data_->id = _data_->_tmp0_;
#line 200 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp1_ = _data_->self->priv->local_mediator;
#line 200 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp2_ = geary_account_information_new (_data_->id, _data_->provider, _data_->_tmp1_, _data_->primary_mailbox);
#line 200 "../src/client/accounts/accounts-manager.vala"
	_data_->result = _data_->_tmp2_;
#line 200 "../src/client/accounts/accounts-manager.vala"
	_g_free0 (_data_->id);
#line 200 "../src/client/accounts/accounts-manager.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 200 "../src/client/accounts/accounts-manager.vala"
	if (_data_->_state_ != 0) {
#line 200 "../src/client/accounts/accounts-manager.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 200 "../src/client/accounts/accounts-manager.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2362 "accounts-manager.c"
		}
	}
#line 200 "../src/client/accounts/accounts-manager.vala"
	g_object_unref (_data_->_async_result);
#line 200 "../src/client/accounts/accounts-manager.vala"
	return FALSE;
#line 2369 "accounts-manager.c"
}


static void
accounts_manager_create_account_data_free (gpointer _data)
{
	AccountsManagerCreateAccountData* _data_;
	_data_ = _data;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->account);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->cancellable);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->self);
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_slice_free (AccountsManagerCreateAccountData, _data_);
#line 2386 "accounts-manager.c"
}


void
accounts_manager_create_account (AccountsManager* self,
                                 GearyAccountInformation* account,
                                 GCancellable* cancellable,
                                 GAsyncReadyCallback _callback_,
                                 gpointer _user_data_)
{
	AccountsManagerCreateAccountData* _data_;
	AccountsManager* _tmp0_;
	GearyAccountInformation* _tmp1_;
	GCancellable* _tmp2_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_ = g_slice_new0 (AccountsManagerCreateAccountData);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_task_set_task_data (_data_->_async_result, _data_, accounts_manager_create_account_data_free);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->self = _tmp0_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_tmp1_ = _g_object_ref0 (account);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->account);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->account = _tmp1_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_tmp2_ = _g_object_ref0 (cancellable);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->cancellable);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->cancellable = _tmp2_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_create_account_co (_data_);
#line 2425 "accounts-manager.c"
}


void
accounts_manager_create_account_finish (AccountsManager* self,
                                        GAsyncResult* _res_,
                                        GError** error)
{
	AccountsManagerCreateAccountData* _data_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 24 "../src/client/accounts/accounts-manager.vala"
	if (NULL == _data_) {
#line 24 "../src/client/accounts/accounts-manager.vala"
		return;
#line 2441 "accounts-manager.c"
	}
}


/**
     * Creates new account's disk and credential storage as needed.
     */
static void
accounts_manager_create_account_ready (GObject* source_object,
                                       GAsyncResult* _res_,
                                       gpointer _user_data_)
{
	AccountsManagerCreateAccountData* _data_;
#line 211 "../src/client/accounts/accounts-manager.vala"
	_data_ = _user_data_;
#line 211 "../src/client/accounts/accounts-manager.vala"
	_data_->_source_object_ = source_object;
#line 211 "../src/client/accounts/accounts-manager.vala"
	_data_->_res_ = _res_;
#line 211 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_create_account_co (_data_);
#line 2463 "accounts-manager.c"
}


static gboolean
accounts_manager_create_account_co (AccountsManagerCreateAccountData* _data_)
{
#line 208 "../src/client/accounts/accounts-manager.vala"
	switch (_data_->_state_) {
#line 208 "../src/client/accounts/accounts-manager.vala"
		case 0:
#line 2474 "accounts-manager.c"
		goto _state_0;
#line 208 "../src/client/accounts/accounts-manager.vala"
		case 1:
#line 2478 "accounts-manager.c"
		goto _state_1;
#line 208 "../src/client/accounts/accounts-manager.vala"
		case 2:
#line 2482 "accounts-manager.c"
		goto _state_2;
#line 208 "../src/client/accounts/accounts-manager.vala"
		case 3:
#line 2486 "accounts-manager.c"
		goto _state_3;
#line 208 "../src/client/accounts/accounts-manager.vala"
		case 4:
#line 2490 "accounts-manager.c"
		goto _state_4;
		default:
#line 208 "../src/client/accounts/accounts-manager.vala"
		g_assert_not_reached ();
#line 2495 "accounts-manager.c"
	}
	_state_0:
#line 211 "../src/client/accounts/accounts-manager.vala"
	_data_->_state_ = 1;
#line 211 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_create_account_dirs (_data_->self, _data_->account, _data_->cancellable, accounts_manager_create_account_ready, _data_);
#line 211 "../src/client/accounts/accounts-manager.vala"
	return FALSE;
#line 2504 "accounts-manager.c"
	_state_1:
#line 211 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_create_account_dirs_finish (_data_->self, _data_->_res_, &_data_->_inner_error_);
#line 211 "../src/client/accounts/accounts-manager.vala"
	if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 211 "../src/client/accounts/accounts-manager.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error_);
#line 211 "../src/client/accounts/accounts-manager.vala"
		g_object_unref (_data_->_async_result);
#line 211 "../src/client/accounts/accounts-manager.vala"
		return FALSE;
#line 2516 "accounts-manager.c"
	}
#line 212 "../src/client/accounts/accounts-manager.vala"
	_data_->_state_ = 2;
#line 212 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_save_account (_data_->self, _data_->account, _data_->cancellable, accounts_manager_create_account_ready, _data_);
#line 212 "../src/client/accounts/accounts-manager.vala"
	return FALSE;
#line 2524 "accounts-manager.c"
	_state_2:
#line 212 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_save_account_finish (_data_->self, _data_->_res_, &_data_->_inner_error_);
#line 212 "../src/client/accounts/accounts-manager.vala"
	if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 212 "../src/client/accounts/accounts-manager.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error_);
#line 212 "../src/client/accounts/accounts-manager.vala"
		g_object_unref (_data_->_async_result);
#line 212 "../src/client/accounts/accounts-manager.vala"
		return FALSE;
#line 2536 "accounts-manager.c"
	}
#line 213 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_set_enabled (_data_->self, _data_->account, TRUE);
#line 216 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp0_ = geary_account_information_get_mediator (_data_->account);
#line 216 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp1_ = _data_->_tmp0_;
#line 216 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp2_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_data_->_tmp1_, TYPE_SECRET_MEDIATOR) ? ((SecretMediator*) _data_->_tmp1_) : NULL);
#line 216 "../src/client/accounts/accounts-manager.vala"
	_data_->mediator = _data_->_tmp2_;
#line 217 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp3_ = _data_->mediator;
#line 217 "../src/client/accounts/accounts-manager.vala"
	if (_data_->_tmp3_ != NULL) {
#line 218 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp4_ = _data_->mediator;
#line 218 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp5_ = geary_account_information_get_incoming (_data_->account);
#line 218 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp6_ = _data_->_tmp5_;
#line 218 "../src/client/accounts/accounts-manager.vala"
		_data_->_state_ = 3;
#line 218 "../src/client/accounts/accounts-manager.vala"
		secret_mediator_update_token (_data_->_tmp4_, _data_->account, _data_->_tmp6_, _data_->cancellable, accounts_manager_create_account_ready, _data_);
#line 218 "../src/client/accounts/accounts-manager.vala"
		return FALSE;
#line 2564 "accounts-manager.c"
		_state_3:
#line 218 "../src/client/accounts/accounts-manager.vala"
		secret_mediator_update_token_finish (_data_->_tmp4_, _data_->_res_, &_data_->_inner_error_);
#line 218 "../src/client/accounts/accounts-manager.vala"
		if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 218 "../src/client/accounts/accounts-manager.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error_);
#line 218 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->mediator);
#line 218 "../src/client/accounts/accounts-manager.vala"
			g_object_unref (_data_->_async_result);
#line 218 "../src/client/accounts/accounts-manager.vala"
			return FALSE;
#line 2578 "accounts-manager.c"
		}
#line 219 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp7_ = _data_->mediator;
#line 219 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp8_ = geary_account_information_get_outgoing (_data_->account);
#line 219 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp9_ = _data_->_tmp8_;
#line 219 "../src/client/accounts/accounts-manager.vala"
		_data_->_state_ = 4;
#line 219 "../src/client/accounts/accounts-manager.vala"
		secret_mediator_update_token (_data_->_tmp7_, _data_->account, _data_->_tmp9_, _data_->cancellable, accounts_manager_create_account_ready, _data_);
#line 219 "../src/client/accounts/accounts-manager.vala"
		return FALSE;
#line 2592 "accounts-manager.c"
		_state_4:
#line 219 "../src/client/accounts/accounts-manager.vala"
		secret_mediator_update_token_finish (_data_->_tmp7_, _data_->_res_, &_data_->_inner_error_);
#line 219 "../src/client/accounts/accounts-manager.vala"
		if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 219 "../src/client/accounts/accounts-manager.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error_);
#line 219 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->mediator);
#line 219 "../src/client/accounts/accounts-manager.vala"
			g_object_unref (_data_->_async_result);
#line 219 "../src/client/accounts/accounts-manager.vala"
			return FALSE;
#line 2606 "accounts-manager.c"
		}
	}
#line 208 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->mediator);
#line 208 "../src/client/accounts/accounts-manager.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 208 "../src/client/accounts/accounts-manager.vala"
	if (_data_->_state_ != 0) {
#line 208 "../src/client/accounts/accounts-manager.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 208 "../src/client/accounts/accounts-manager.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 2619 "accounts-manager.c"
		}
	}
#line 208 "../src/client/accounts/accounts-manager.vala"
	g_object_unref (_data_->_async_result);
#line 208 "../src/client/accounts/accounts-manager.vala"
	return FALSE;
#line 2626 "accounts-manager.c"
}


static void
accounts_manager_load_accounts_data_free (gpointer _data)
{
	AccountsManagerLoadAccountsData* _data_;
	_data_ = _data;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->cancellable);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->self);
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_slice_free (AccountsManagerLoadAccountsData, _data_);
#line 2641 "accounts-manager.c"
}


void
accounts_manager_load_accounts (AccountsManager* self,
                                GCancellable* cancellable,
                                GAsyncReadyCallback _callback_,
                                gpointer _user_data_)
{
	AccountsManagerLoadAccountsData* _data_;
	AccountsManager* _tmp0_;
	GCancellable* _tmp1_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_ = g_slice_new0 (AccountsManagerLoadAccountsData);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_task_set_task_data (_data_->_async_result, _data_, accounts_manager_load_accounts_data_free);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->self = _tmp0_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_tmp1_ = _g_object_ref0 (cancellable);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->cancellable);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->cancellable = _tmp1_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_load_accounts_co (_data_);
#line 2672 "accounts-manager.c"
}


void
accounts_manager_load_accounts_finish (AccountsManager* self,
                                       GAsyncResult* _res_,
                                       GError** error)
{
	AccountsManagerLoadAccountsData* _data_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 24 "../src/client/accounts/accounts-manager.vala"
	if (NULL == _data_) {
#line 24 "../src/client/accounts/accounts-manager.vala"
		return;
#line 2688 "accounts-manager.c"
	}
}


static void
accounts_manager_load_accounts_ready (GObject* source_object,
                                      GAsyncResult* _res_,
                                      gpointer _user_data_)
{
	AccountsManagerLoadAccountsData* _data_;
#line 228 "../src/client/accounts/accounts-manager.vala"
	_data_ = _user_data_;
#line 228 "../src/client/accounts/accounts-manager.vala"
	_data_->_source_object_ = source_object;
#line 228 "../src/client/accounts/accounts-manager.vala"
	_data_->_res_ = _res_;
#line 228 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_load_accounts_co (_data_);
#line 2707 "accounts-manager.c"
}


static void
_g_object_unref0_ (gpointer var)
{
#line 250 "../src/client/accounts/accounts-manager.vala"
	(var == NULL) ? NULL : (var = (g_object_unref (var), NULL));
#line 2716 "accounts-manager.c"
}


static inline void
_g_list_free__g_object_unref0_ (GList* self)
{
#line 250 "../src/client/accounts/accounts-manager.vala"
	g_list_free_full (self, (GDestroyNotify) _g_object_unref0_);
#line 2725 "accounts-manager.c"
}


static gboolean
accounts_manager_load_accounts_co (AccountsManagerLoadAccountsData* _data_)
{
#line 223 "../src/client/accounts/accounts-manager.vala"
	switch (_data_->_state_) {
#line 223 "../src/client/accounts/accounts-manager.vala"
		case 0:
#line 2736 "accounts-manager.c"
		goto _state_0;
#line 223 "../src/client/accounts/accounts-manager.vala"
		case 1:
#line 2740 "accounts-manager.c"
		goto _state_1;
#line 223 "../src/client/accounts/accounts-manager.vala"
		case 2:
#line 2744 "accounts-manager.c"
		goto _state_2;
#line 223 "../src/client/accounts/accounts-manager.vala"
		case 3:
#line 2748 "accounts-manager.c"
		goto _state_3;
#line 223 "../src/client/accounts/accounts-manager.vala"
		case 4:
#line 2752 "accounts-manager.c"
		goto _state_4;
		default:
#line 223 "../src/client/accounts/accounts-manager.vala"
		g_assert_not_reached ();
#line 2757 "accounts-manager.c"
	}
	_state_0:
#line 226 "../src/client/accounts/accounts-manager.vala"
	_data_->enumerator = NULL;
#line 2762 "accounts-manager.c"
	{
#line 228 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp1_ = _data_->self->priv->_config_dir;
#line 228 "../src/client/accounts/accounts-manager.vala"
		_data_->_state_ = 1;
#line 228 "../src/client/accounts/accounts-manager.vala"
		g_file_enumerate_children_async (_data_->_tmp1_, "standard::*", G_FILE_QUERY_INFO_NONE, G_PRIORITY_DEFAULT, _data_->cancellable, accounts_manager_load_accounts_ready, _data_);
#line 228 "../src/client/accounts/accounts-manager.vala"
		return FALSE;
#line 2772 "accounts-manager.c"
		_state_1:
#line 228 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp2_ = g_file_enumerate_children_finish (_data_->_tmp1_, _data_->_res_, &_data_->_inner_error_);
#line 228 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp0_ = _data_->_tmp2_;
#line 228 "../src/client/accounts/accounts-manager.vala"
		if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 228 "../src/client/accounts/accounts-manager.vala"
			if (g_error_matches (_data_->_inner_error_, G_IO_ERROR, G_IO_ERROR_NOT_FOUND)) {
#line 2782 "accounts-manager.c"
				goto __catch83_g_io_error_not_found;
			}
			goto __finally83;
		}
#line 228 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp3_ = _data_->_tmp0_;
#line 228 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp0_ = NULL;
#line 228 "../src/client/accounts/accounts-manager.vala"
		_g_object_unref0 (_data_->enumerator);
#line 228 "../src/client/accounts/accounts-manager.vala"
		_data_->enumerator = _data_->_tmp3_;
#line 227 "../src/client/accounts/accounts-manager.vala"
		_g_object_unref0 (_data_->_tmp0_);
#line 2797 "accounts-manager.c"
	}
	goto __finally83;
	__catch83_g_io_error_not_found:
	{
#line 227 "../src/client/accounts/accounts-manager.vala"
		_data_->err = _data_->_inner_error_;
#line 227 "../src/client/accounts/accounts-manager.vala"
		_data_->_inner_error_ = NULL;
#line 227 "../src/client/accounts/accounts-manager.vala"
		_g_error_free0 (_data_->err);
#line 2808 "accounts-manager.c"
	}
	__finally83:
#line 227 "../src/client/accounts/accounts-manager.vala"
	if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 227 "../src/client/accounts/accounts-manager.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error_);
#line 227 "../src/client/accounts/accounts-manager.vala"
		_g_object_unref0 (_data_->enumerator);
#line 227 "../src/client/accounts/accounts-manager.vala"
		g_object_unref (_data_->_async_result);
#line 227 "../src/client/accounts/accounts-manager.vala"
		return FALSE;
#line 2821 "accounts-manager.c"
	}
#line 239 "../src/client/accounts/accounts-manager.vala"
	while (TRUE) {
#line 239 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp5_ = _data_->enumerator;
#line 239 "../src/client/accounts/accounts-manager.vala"
		if (_data_->_tmp5_ != NULL) {
#line 239 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp4_ = !g_cancellable_is_cancelled (_data_->cancellable);
#line 2831 "accounts-manager.c"
		} else {
#line 239 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp4_ = FALSE;
#line 2835 "accounts-manager.c"
		}
#line 239 "../src/client/accounts/accounts-manager.vala"
		if (!_data_->_tmp4_) {
#line 239 "../src/client/accounts/accounts-manager.vala"
			break;
#line 2841 "accounts-manager.c"
		}
#line 241 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp6_ = _data_->enumerator;
#line 241 "../src/client/accounts/accounts-manager.vala"
		_data_->_state_ = 2;
#line 241 "../src/client/accounts/accounts-manager.vala"
		g_file_enumerator_next_files_async (_data_->_tmp6_, 10, G_PRIORITY_DEFAULT, _data_->cancellable, accounts_manager_load_accounts_ready, _data_);
#line 241 "../src/client/accounts/accounts-manager.vala"
		return FALSE;
#line 2851 "accounts-manager.c"
		_state_2:
#line 241 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp7_ = g_file_enumerator_next_files_finish (_data_->_tmp6_, _data_->_res_, &_data_->_inner_error_);
#line 241 "../src/client/accounts/accounts-manager.vala"
		_data_->info_list = _data_->_tmp7_;
#line 241 "../src/client/accounts/accounts-manager.vala"
		if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 241 "../src/client/accounts/accounts-manager.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error_);
#line 241 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->enumerator);
#line 241 "../src/client/accounts/accounts-manager.vala"
			g_object_unref (_data_->_async_result);
#line 241 "../src/client/accounts/accounts-manager.vala"
			return FALSE;
#line 2867 "accounts-manager.c"
		}
#line 245 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp8_ = _data_->info_list;
#line 245 "../src/client/accounts/accounts-manager.vala"
		_data_->len = g_list_length (_data_->_tmp8_);
#line 2873 "accounts-manager.c"
		{
#line 246 "../src/client/accounts/accounts-manager.vala"
			_data_->i = (guint) 0;
#line 2877 "accounts-manager.c"
			{
#line 246 "../src/client/accounts/accounts-manager.vala"
				_data_->_tmp9_ = TRUE;
#line 246 "../src/client/accounts/accounts-manager.vala"
				while (TRUE) {
#line 246 "../src/client/accounts/accounts-manager.vala"
					if (!_data_->_tmp9_) {
#line 246 "../src/client/accounts/accounts-manager.vala"
						_data_->_tmp10_ = _data_->i;
#line 246 "../src/client/accounts/accounts-manager.vala"
						_data_->i = _data_->_tmp10_ + 1;
#line 2889 "accounts-manager.c"
					}
#line 246 "../src/client/accounts/accounts-manager.vala"
					_data_->_tmp9_ = FALSE;
#line 246 "../src/client/accounts/accounts-manager.vala"
					_data_->_tmp12_ = _data_->i;
#line 246 "../src/client/accounts/accounts-manager.vala"
					_data_->_tmp13_ = _data_->len;
#line 246 "../src/client/accounts/accounts-manager.vala"
					if (_data_->_tmp12_ < _data_->_tmp13_) {
#line 246 "../src/client/accounts/accounts-manager.vala"
						_data_->_tmp11_ = !g_cancellable_is_cancelled (_data_->cancellable);
#line 2901 "accounts-manager.c"
					} else {
#line 246 "../src/client/accounts/accounts-manager.vala"
						_data_->_tmp11_ = FALSE;
#line 2905 "accounts-manager.c"
					}
#line 246 "../src/client/accounts/accounts-manager.vala"
					if (!_data_->_tmp11_) {
#line 246 "../src/client/accounts/accounts-manager.vala"
						break;
#line 2911 "accounts-manager.c"
					}
#line 247 "../src/client/accounts/accounts-manager.vala"
					_data_->_tmp14_ = _data_->info_list;
#line 247 "../src/client/accounts/accounts-manager.vala"
					_data_->_tmp15_ = _data_->i;
#line 247 "../src/client/accounts/accounts-manager.vala"
					_data_->_tmp16_ = g_list_nth_data (_data_->_tmp14_, _data_->_tmp15_);
#line 247 "../src/client/accounts/accounts-manager.vala"
					_data_->_tmp17_ = _g_object_ref0 ((GFileInfo*) _data_->_tmp16_);
#line 247 "../src/client/accounts/accounts-manager.vala"
					_data_->file = _data_->_tmp17_;
#line 248 "../src/client/accounts/accounts-manager.vala"
					_data_->_tmp18_ = _data_->file;
#line 248 "../src/client/accounts/accounts-manager.vala"
					if (g_file_info_get_file_type (_data_->_tmp18_) == G_FILE_TYPE_DIRECTORY) {
#line 249 "../src/client/accounts/accounts-manager.vala"
						_data_->_tmp19_ = _data_->file;
#line 249 "../src/client/accounts/accounts-manager.vala"
						_data_->_tmp20_ = g_file_info_get_name (_data_->_tmp19_);
#line 249 "../src/client/accounts/accounts-manager.vala"
						_data_->_tmp21_ = g_strdup (_data_->_tmp20_);
#line 249 "../src/client/accounts/accounts-manager.vala"
						_data_->id = _data_->_tmp21_;
#line 2935 "accounts-manager.c"
						{
#line 251 "../src/client/accounts/accounts-manager.vala"
							_data_->_tmp22_ = _data_->id;
#line 251 "../src/client/accounts/accounts-manager.vala"
							_data_->_state_ = 3;
#line 251 "../src/client/accounts/accounts-manager.vala"
							accounts_manager_load_account (_data_->self, _data_->_tmp22_, _data_->cancellable, accounts_manager_load_accounts_ready, _data_);
#line 251 "../src/client/accounts/accounts-manager.vala"
							return FALSE;
#line 2945 "accounts-manager.c"
							_state_3:
#line 251 "../src/client/accounts/accounts-manager.vala"
							_data_->_tmp23_ = accounts_manager_load_account_finish (_data_->self, _data_->_res_, &_data_->_inner_error_);
#line 251 "../src/client/accounts/accounts-manager.vala"
							_data_->info = _data_->_tmp23_;
#line 251 "../src/client/accounts/accounts-manager.vala"
							if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 251 "../src/client/accounts/accounts-manager.vala"
								if (g_error_matches (_data_->_inner_error_, ACCOUNTS_CONFIG_ERROR, ACCOUNTS_CONFIG_ERROR_UNAVAILABLE)) {
#line 2955 "accounts-manager.c"
									goto __catch84_accounts_config_error_unavailable;
								}
#line 251 "../src/client/accounts/accounts-manager.vala"
								if (g_error_matches (_data_->_inner_error_, ACCOUNTS_CONFIG_ERROR, ACCOUNTS_CONFIG_ERROR_REMOVED)) {
#line 2960 "accounts-manager.c"
									goto __catch84_accounts_config_error_removed;
								}
								goto __catch84_g_error;
							}
#line 254 "../src/client/accounts/accounts-manager.vala"
							_data_->_tmp24_ = _data_->info;
#line 254 "../src/client/accounts/accounts-manager.vala"
							accounts_manager_set_enabled (_data_->self, _data_->_tmp24_, TRUE);
#line 250 "../src/client/accounts/accounts-manager.vala"
							_g_object_unref0 (_data_->info);
#line 2971 "accounts-manager.c"
						}
						goto __finally84;
						__catch84_accounts_config_error_unavailable:
						{
#line 250 "../src/client/accounts/accounts-manager.vala"
							_data_->_vala1_err = _data_->_inner_error_;
#line 250 "../src/client/accounts/accounts-manager.vala"
							_data_->_inner_error_ = NULL;
#line 250 "../src/client/accounts/accounts-manager.vala"
							_g_error_free0 (_data_->_vala1_err);
#line 2982 "accounts-manager.c"
						}
						goto __finally84;
						__catch84_accounts_config_error_removed:
						{
#line 250 "../src/client/accounts/accounts-manager.vala"
							_data_->_vala2_err = _data_->_inner_error_;
#line 250 "../src/client/accounts/accounts-manager.vala"
							_data_->_inner_error_ = NULL;
#line 250 "../src/client/accounts/accounts-manager.vala"
							_g_error_free0 (_data_->_vala2_err);
#line 2993 "accounts-manager.c"
						}
						goto __finally84;
						__catch84_g_error:
						{
#line 250 "../src/client/accounts/accounts-manager.vala"
							_data_->_vala3_err = _data_->_inner_error_;
#line 250 "../src/client/accounts/accounts-manager.vala"
							_data_->_inner_error_ = NULL;
#line 262 "../src/client/accounts/accounts-manager.vala"
							_data_->_tmp25_ = _data_->id;
#line 262 "../src/client/accounts/accounts-manager.vala"
							g_debug ("accounts-manager.vala:262: Error loading account %s", _data_->_tmp25_);
#line 263 "../src/client/accounts/accounts-manager.vala"
							_data_->_tmp26_ = _data_->_vala3_err;
#line 263 "../src/client/accounts/accounts-manager.vala"
							_data_->_tmp27_ = geary_problem_report_new (GEARY_PROBLEM_TYPE_GENERIC_ERROR, _data_->_tmp26_);
#line 263 "../src/client/accounts/accounts-manager.vala"
							_data_->_tmp28_ = _data_->_tmp27_;
#line 263 "../src/client/accounts/accounts-manager.vala"
							g_signal_emit (_data_->self, accounts_manager_signals[ACCOUNTS_MANAGER_REPORT_PROBLEM_SIGNAL], 0, _data_->_tmp28_);
#line 263 "../src/client/accounts/accounts-manager.vala"
							_g_object_unref0 (_data_->_tmp28_);
#line 250 "../src/client/accounts/accounts-manager.vala"
							_g_error_free0 (_data_->_vala3_err);
#line 3018 "accounts-manager.c"
						}
						__finally84:
#line 250 "../src/client/accounts/accounts-manager.vala"
						if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 250 "../src/client/accounts/accounts-manager.vala"
							g_task_return_error (_data_->_async_result, _data_->_inner_error_);
#line 250 "../src/client/accounts/accounts-manager.vala"
							_g_free0 (_data_->id);
#line 250 "../src/client/accounts/accounts-manager.vala"
							_g_object_unref0 (_data_->file);
#line 250 "../src/client/accounts/accounts-manager.vala"
							(_data_->info_list == NULL) ? NULL : (_data_->info_list = (_g_list_free__g_object_unref0_ (_data_->info_list), NULL));
#line 250 "../src/client/accounts/accounts-manager.vala"
							_g_object_unref0 (_data_->enumerator);
#line 250 "../src/client/accounts/accounts-manager.vala"
							g_object_unref (_data_->_async_result);
#line 250 "../src/client/accounts/accounts-manager.vala"
							return FALSE;
#line 3037 "accounts-manager.c"
						}
#line 248 "../src/client/accounts/accounts-manager.vala"
						_g_free0 (_data_->id);
#line 3041 "accounts-manager.c"
					}
#line 246 "../src/client/accounts/accounts-manager.vala"
					_g_object_unref0 (_data_->file);
#line 3045 "accounts-manager.c"
				}
			}
		}
#line 272 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp29_ = _data_->len;
#line 272 "../src/client/accounts/accounts-manager.vala"
		if (_data_->_tmp29_ == ((guint) 0)) {
#line 274 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->enumerator);
#line 274 "../src/client/accounts/accounts-manager.vala"
			_data_->enumerator = NULL;
#line 3057 "accounts-manager.c"
		}
#line 239 "../src/client/accounts/accounts-manager.vala"
		(_data_->info_list == NULL) ? NULL : (_data_->info_list = (_g_list_free__g_object_unref0_ (_data_->info_list), NULL));
#line 3061 "accounts-manager.c"
	}
#line 279 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp30_ = _data_->self->priv->goa_service;
#line 279 "../src/client/accounts/accounts-manager.vala"
	if (_data_->_tmp30_ != NULL) {
#line 280 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp31_ = _data_->self->priv->goa_service;
#line 280 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp32_ = goa_client_get_accounts (_data_->_tmp31_);
#line 280 "../src/client/accounts/accounts-manager.vala"
		_data_->list = _data_->_tmp32_;
#line 3073 "accounts-manager.c"
		{
#line 281 "../src/client/accounts/accounts-manager.vala"
			_data_->_vala1_i = 0;
#line 3077 "accounts-manager.c"
			{
#line 281 "../src/client/accounts/accounts-manager.vala"
				_data_->_tmp33_ = TRUE;
#line 281 "../src/client/accounts/accounts-manager.vala"
				while (TRUE) {
#line 281 "../src/client/accounts/accounts-manager.vala"
					if (!_data_->_tmp33_) {
#line 281 "../src/client/accounts/accounts-manager.vala"
						_data_->_tmp34_ = _data_->_vala1_i;
#line 281 "../src/client/accounts/accounts-manager.vala"
						_data_->_vala1_i = _data_->_tmp34_ + 1;
#line 3089 "accounts-manager.c"
					}
#line 281 "../src/client/accounts/accounts-manager.vala"
					_data_->_tmp33_ = FALSE;
#line 281 "../src/client/accounts/accounts-manager.vala"
					_data_->_tmp36_ = _data_->_vala1_i;
#line 281 "../src/client/accounts/accounts-manager.vala"
					_data_->_tmp37_ = _data_->list;
#line 281 "../src/client/accounts/accounts-manager.vala"
					if (((guint) _data_->_tmp36_) < g_list_length (_data_->_tmp37_)) {
#line 281 "../src/client/accounts/accounts-manager.vala"
						_data_->_tmp35_ = !g_cancellable_is_cancelled (_data_->cancellable);
#line 3101 "accounts-manager.c"
					} else {
#line 281 "../src/client/accounts/accounts-manager.vala"
						_data_->_tmp35_ = FALSE;
#line 3105 "accounts-manager.c"
					}
#line 281 "../src/client/accounts/accounts-manager.vala"
					if (!_data_->_tmp35_) {
#line 281 "../src/client/accounts/accounts-manager.vala"
						break;
#line 3111 "accounts-manager.c"
					}
#line 282 "../src/client/accounts/accounts-manager.vala"
					_data_->_tmp38_ = _data_->list;
#line 282 "../src/client/accounts/accounts-manager.vala"
					_data_->_tmp39_ = _data_->_vala1_i;
#line 282 "../src/client/accounts/accounts-manager.vala"
					_data_->_tmp40_ = g_list_nth_data (_data_->_tmp38_, (guint) _data_->_tmp39_);
#line 282 "../src/client/accounts/accounts-manager.vala"
					_data_->_tmp41_ = _g_object_ref0 ((GoaObject*) _data_->_tmp40_);
#line 282 "../src/client/accounts/accounts-manager.vala"
					_data_->account = _data_->_tmp41_;
#line 283 "../src/client/accounts/accounts-manager.vala"
					_data_->_tmp42_ = _data_->account;
#line 283 "../src/client/accounts/accounts-manager.vala"
					_data_->_tmp43_ = accounts_manager_to_geary_id (_data_->self, _data_->_tmp42_);
#line 283 "../src/client/accounts/accounts-manager.vala"
					_data_->_vala1_id = _data_->_tmp43_;
#line 284 "../src/client/accounts/accounts-manager.vala"
					_data_->_tmp44_ = _data_->self->priv->accounts;
#line 284 "../src/client/accounts/accounts-manager.vala"
					_data_->_tmp45_ = _data_->_vala1_id;
#line 284 "../src/client/accounts/accounts-manager.vala"
					if (!gee_map_has_key (_data_->_tmp44_, _data_->_tmp45_)) {
#line 285 "../src/client/accounts/accounts-manager.vala"
						_data_->_tmp46_ = _data_->account;
#line 285 "../src/client/accounts/accounts-manager.vala"
						_data_->_state_ = 4;
#line 285 "../src/client/accounts/accounts-manager.vala"
						accounts_manager_create_goa_account (_data_->self, _data_->_tmp46_, _data_->cancellable, accounts_manager_load_accounts_ready, _data_);
#line 285 "../src/client/accounts/accounts-manager.vala"
						return FALSE;
#line 3143 "accounts-manager.c"
						_state_4:
#line 285 "../src/client/accounts/accounts-manager.vala"
						accounts_manager_create_goa_account_finish (_data_->self, _data_->_res_);
#line 3147 "accounts-manager.c"
					}
#line 281 "../src/client/accounts/accounts-manager.vala"
					_g_free0 (_data_->_vala1_id);
#line 281 "../src/client/accounts/accounts-manager.vala"
					_g_object_unref0 (_data_->account);
#line 3153 "accounts-manager.c"
				}
			}
		}
#line 279 "../src/client/accounts/accounts-manager.vala"
		(_data_->list == NULL) ? NULL : (_data_->list = (_g_list_free__g_object_unref0_ (_data_->list), NULL));
#line 3159 "accounts-manager.c"
	}
#line 223 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->enumerator);
#line 223 "../src/client/accounts/accounts-manager.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 223 "../src/client/accounts/accounts-manager.vala"
	if (_data_->_state_ != 0) {
#line 223 "../src/client/accounts/accounts-manager.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 223 "../src/client/accounts/accounts-manager.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3171 "accounts-manager.c"
		}
	}
#line 223 "../src/client/accounts/accounts-manager.vala"
	g_object_unref (_data_->_async_result);
#line 223 "../src/client/accounts/accounts-manager.vala"
	return FALSE;
#line 3178 "accounts-manager.c"
}


/**
     * Marks an existing account as being unavailable.
     *
     * This keeps the account in the known set, but marks it as being
     * unavailable.
     */
void
accounts_manager_disable_account (AccountsManager* self,
                                  GearyAccountInformation* account)
{
	GeeMap* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
#line 297 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail (ACCOUNTS_IS_MANAGER (self));
#line 297 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail (GEARY_IS_ACCOUNT_INFORMATION (account));
#line 298 "../src/client/accounts/accounts-manager.vala"
	_tmp0_ = self->priv->accounts;
#line 298 "../src/client/accounts/accounts-manager.vala"
	_tmp1_ = geary_account_information_get_id (account);
#line 298 "../src/client/accounts/accounts-manager.vala"
	_tmp2_ = _tmp1_;
#line 298 "../src/client/accounts/accounts-manager.vala"
	if (gee_map_has_key (_tmp0_, _tmp2_)) {
#line 299 "../src/client/accounts/accounts-manager.vala"
		accounts_manager_set_available (self, account, FALSE);
#line 3209 "accounts-manager.c"
	}
}


static void
accounts_manager_remove_account_data_free (gpointer _data)
{
	AccountsManagerRemoveAccountData* _data_;
	_data_ = _data;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->account);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->cancellable);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->self);
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_slice_free (AccountsManagerRemoveAccountData, _data_);
#line 3227 "accounts-manager.c"
}


void
accounts_manager_remove_account (AccountsManager* self,
                                 GearyAccountInformation* account,
                                 GCancellable* cancellable,
                                 GAsyncReadyCallback _callback_,
                                 gpointer _user_data_)
{
	AccountsManagerRemoveAccountData* _data_;
	AccountsManager* _tmp0_;
	GearyAccountInformation* _tmp1_;
	GCancellable* _tmp2_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_ = g_slice_new0 (AccountsManagerRemoveAccountData);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_task_set_task_data (_data_->_async_result, _data_, accounts_manager_remove_account_data_free);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->self = _tmp0_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_tmp1_ = _g_object_ref0 (account);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->account);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->account = _tmp1_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_tmp2_ = _g_object_ref0 (cancellable);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->cancellable);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->cancellable = _tmp2_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_remove_account_co (_data_);
#line 3266 "accounts-manager.c"
}


void
accounts_manager_remove_account_finish (AccountsManager* self,
                                        GAsyncResult* _res_,
                                        GError** error)
{
	AccountsManagerRemoveAccountData* _data_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 24 "../src/client/accounts/accounts-manager.vala"
	if (NULL == _data_) {
#line 24 "../src/client/accounts/accounts-manager.vala"
		return;
#line 3282 "accounts-manager.c"
	}
}


/**
     * Removes an account from the manager's set of known accounts.
     *
     * This removes the account from the known set, marks the account
     * as deleted, and queues it for deletion. The account will not
     * actually be deleted until {@link expunge_accounts} is called,
     * and until then the account can be re-added using {@link
     * restore_account}.
     */
static void
_accounts_manager_on_account_changed_geary_account_information_changed (GearyAccountInformation* _sender,
                                                                        gpointer self)
{
#line 317 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_on_account_changed ((AccountsManager*) self, _sender);
#line 3302 "accounts-manager.c"
}


static void
accounts_manager_remove_account_ready (GObject* source_object,
                                       GAsyncResult* _res_,
                                       gpointer _user_data_)
{
	AccountsManagerRemoveAccountData* _data_;
#line 318 "../src/client/accounts/accounts-manager.vala"
	_data_ = _user_data_;
#line 318 "../src/client/accounts/accounts-manager.vala"
	_data_->_source_object_ = source_object;
#line 318 "../src/client/accounts/accounts-manager.vala"
	_data_->_res_ = _res_;
#line 318 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_remove_account_co (_data_);
#line 3320 "accounts-manager.c"
}


static gboolean
accounts_manager_remove_account_co (AccountsManagerRemoveAccountData* _data_)
{
#line 312 "../src/client/accounts/accounts-manager.vala"
	switch (_data_->_state_) {
#line 312 "../src/client/accounts/accounts-manager.vala"
		case 0:
#line 3331 "accounts-manager.c"
		goto _state_0;
#line 312 "../src/client/accounts/accounts-manager.vala"
		case 1:
#line 3335 "accounts-manager.c"
		goto _state_1;
		default:
#line 312 "../src/client/accounts/accounts-manager.vala"
		g_assert_not_reached ();
#line 3340 "accounts-manager.c"
	}
	_state_0:
#line 315 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp0_ = _data_->self->priv->accounts;
#line 315 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp1_ = geary_account_information_get_id (_data_->account);
#line 315 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp2_ = _data_->_tmp1_;
#line 315 "../src/client/accounts/accounts-manager.vala"
	gee_map_unset (_data_->_tmp0_, _data_->_tmp2_, NULL);
#line 316 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp3_ = _data_->self->priv->removed;
#line 316 "../src/client/accounts/accounts-manager.vala"
	gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp3_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _data_->account);
#line 317 "../src/client/accounts/accounts-manager.vala"
	g_signal_parse_name ("changed", GEARY_TYPE_ACCOUNT_INFORMATION, &_data_->_tmp4_, NULL, FALSE);
#line 317 "../src/client/accounts/accounts-manager.vala"
	g_signal_handlers_disconnect_matched (_data_->account, G_SIGNAL_MATCH_ID | G_SIGNAL_MATCH_FUNC | G_SIGNAL_MATCH_DATA, _data_->_tmp4_, 0, NULL, (GCallback) _accounts_manager_on_account_changed_geary_account_information_changed, _data_->self);
#line 318 "../src/client/accounts/accounts-manager.vala"
	_data_->_state_ = 1;
#line 318 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_save_account (_data_->self, _data_->account, _data_->cancellable, accounts_manager_remove_account_ready, _data_);
#line 318 "../src/client/accounts/accounts-manager.vala"
	return FALSE;
#line 3365 "accounts-manager.c"
	_state_1:
#line 318 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_save_account_finish (_data_->self, _data_->_res_, &_data_->_inner_error_);
#line 318 "../src/client/accounts/accounts-manager.vala"
	if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 318 "../src/client/accounts/accounts-manager.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error_);
#line 318 "../src/client/accounts/accounts-manager.vala"
		g_object_unref (_data_->_async_result);
#line 318 "../src/client/accounts/accounts-manager.vala"
		return FALSE;
#line 3377 "accounts-manager.c"
	}
#line 319 "../src/client/accounts/accounts-manager.vala"
	g_signal_emit (_data_->self, accounts_manager_signals[ACCOUNTS_MANAGER_ACCOUNT_REMOVED_SIGNAL], 0, _data_->account);
#line 312 "../src/client/accounts/accounts-manager.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 312 "../src/client/accounts/accounts-manager.vala"
	if (_data_->_state_ != 0) {
#line 312 "../src/client/accounts/accounts-manager.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 312 "../src/client/accounts/accounts-manager.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3389 "accounts-manager.c"
		}
	}
#line 312 "../src/client/accounts/accounts-manager.vala"
	g_object_unref (_data_->_async_result);
#line 312 "../src/client/accounts/accounts-manager.vala"
	return FALSE;
#line 3396 "accounts-manager.c"
}


static void
accounts_manager_restore_account_data_free (gpointer _data)
{
	AccountsManagerRestoreAccountData* _data_;
	_data_ = _data;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->account);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->cancellable);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->self);
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_slice_free (AccountsManagerRestoreAccountData, _data_);
#line 3413 "accounts-manager.c"
}


void
accounts_manager_restore_account (AccountsManager* self,
                                  GearyAccountInformation* account,
                                  GCancellable* cancellable,
                                  GAsyncReadyCallback _callback_,
                                  gpointer _user_data_)
{
	AccountsManagerRestoreAccountData* _data_;
	AccountsManager* _tmp0_;
	GearyAccountInformation* _tmp1_;
	GCancellable* _tmp2_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_ = g_slice_new0 (AccountsManagerRestoreAccountData);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_task_set_task_data (_data_->_async_result, _data_, accounts_manager_restore_account_data_free);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->self = _tmp0_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_tmp1_ = _g_object_ref0 (account);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->account);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->account = _tmp1_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_tmp2_ = _g_object_ref0 (cancellable);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->cancellable);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->cancellable = _tmp2_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_restore_account_co (_data_);
#line 3452 "accounts-manager.c"
}


void
accounts_manager_restore_account_finish (AccountsManager* self,
                                         GAsyncResult* _res_,
                                         GError** error)
{
	AccountsManagerRestoreAccountData* _data_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 24 "../src/client/accounts/accounts-manager.vala"
	if (NULL == _data_) {
#line 24 "../src/client/accounts/accounts-manager.vala"
		return;
#line 3468 "accounts-manager.c"
	}
}


/**
     * Restores an account that has previously been removed.
     *
     * This restores an account previously removed via a call to
     * {@link remove_account}, adding it back to the known set, as
     * long as {@link expunge_accounts} has not been called since
     * he account was removed.
     */
static void
accounts_manager_restore_account_ready (GObject* source_object,
                                        GAsyncResult* _res_,
                                        gpointer _user_data_)
{
	AccountsManagerRestoreAccountData* _data_;
#line 334 "../src/client/accounts/accounts-manager.vala"
	_data_ = _user_data_;
#line 334 "../src/client/accounts/accounts-manager.vala"
	_data_->_source_object_ = source_object;
#line 334 "../src/client/accounts/accounts-manager.vala"
	_data_->_res_ = _res_;
#line 334 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_restore_account_co (_data_);
#line 3495 "accounts-manager.c"
}


static gboolean
accounts_manager_restore_account_co (AccountsManagerRestoreAccountData* _data_)
{
#line 330 "../src/client/accounts/accounts-manager.vala"
	switch (_data_->_state_) {
#line 330 "../src/client/accounts/accounts-manager.vala"
		case 0:
#line 3506 "accounts-manager.c"
		goto _state_0;
#line 330 "../src/client/accounts/accounts-manager.vala"
		case 1:
#line 3510 "accounts-manager.c"
		goto _state_1;
		default:
#line 330 "../src/client/accounts/accounts-manager.vala"
		g_assert_not_reached ();
#line 3515 "accounts-manager.c"
	}
	_state_0:
#line 333 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp0_ = _data_->self->priv->removed;
#line 333 "../src/client/accounts/accounts-manager.vala"
	if (gee_abstract_collection_remove (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp0_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _data_->account)) {
#line 334 "../src/client/accounts/accounts-manager.vala"
		_data_->_state_ = 1;
#line 334 "../src/client/accounts/accounts-manager.vala"
		accounts_manager_save_account (_data_->self, _data_->account, _data_->cancellable, accounts_manager_restore_account_ready, _data_);
#line 334 "../src/client/accounts/accounts-manager.vala"
		return FALSE;
#line 3528 "accounts-manager.c"
		_state_1:
#line 334 "../src/client/accounts/accounts-manager.vala"
		accounts_manager_save_account_finish (_data_->self, _data_->_res_, &_data_->_inner_error_);
#line 334 "../src/client/accounts/accounts-manager.vala"
		if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 334 "../src/client/accounts/accounts-manager.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error_);
#line 334 "../src/client/accounts/accounts-manager.vala"
			g_object_unref (_data_->_async_result);
#line 334 "../src/client/accounts/accounts-manager.vala"
			return FALSE;
#line 3540 "accounts-manager.c"
		}
#line 335 "../src/client/accounts/accounts-manager.vala"
		accounts_manager_set_enabled (_data_->self, _data_->account, TRUE);
#line 3544 "accounts-manager.c"
	}
#line 330 "../src/client/accounts/accounts-manager.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 330 "../src/client/accounts/accounts-manager.vala"
	if (_data_->_state_ != 0) {
#line 330 "../src/client/accounts/accounts-manager.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 330 "../src/client/accounts/accounts-manager.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3554 "accounts-manager.c"
		}
	}
#line 330 "../src/client/accounts/accounts-manager.vala"
	g_object_unref (_data_->_async_result);
#line 330 "../src/client/accounts/accounts-manager.vala"
	return FALSE;
#line 3561 "accounts-manager.c"
}


static void
accounts_manager_expunge_accounts_data_free (gpointer _data)
{
	AccountsManagerExpungeAccountsData* _data_;
	_data_ = _data;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->cancellable);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->self);
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_slice_free (AccountsManagerExpungeAccountsData, _data_);
#line 3576 "accounts-manager.c"
}


void
accounts_manager_expunge_accounts (AccountsManager* self,
                                   GCancellable* cancellable,
                                   GAsyncReadyCallback _callback_,
                                   gpointer _user_data_)
{
	AccountsManagerExpungeAccountsData* _data_;
	AccountsManager* _tmp0_;
	GCancellable* _tmp1_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_ = g_slice_new0 (AccountsManagerExpungeAccountsData);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_task_set_task_data (_data_->_async_result, _data_, accounts_manager_expunge_accounts_data_free);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->self = _tmp0_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_tmp1_ = _g_object_ref0 (cancellable);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->cancellable);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->cancellable = _tmp1_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_expunge_accounts_co (_data_);
#line 3607 "accounts-manager.c"
}


void
accounts_manager_expunge_accounts_finish (AccountsManager* self,
                                          GAsyncResult* _res_,
                                          GError** error)
{
	AccountsManagerExpungeAccountsData* _data_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 24 "../src/client/accounts/accounts-manager.vala"
	if (NULL == _data_) {
#line 24 "../src/client/accounts/accounts-manager.vala"
		return;
#line 3623 "accounts-manager.c"
	}
}


/**
     * Deletes all local data for all accounts that have been removed.
     */
static void
accounts_manager_expunge_accounts_ready (GObject* source_object,
                                         GAsyncResult* _res_,
                                         gpointer _user_data_)
{
	AccountsManagerExpungeAccountsData* _data_;
#line 345 "../src/client/accounts/accounts-manager.vala"
	_data_ = _user_data_;
#line 345 "../src/client/accounts/accounts-manager.vala"
	_data_->_source_object_ = source_object;
#line 345 "../src/client/accounts/accounts-manager.vala"
	_data_->_res_ = _res_;
#line 345 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_expunge_accounts_co (_data_);
#line 3645 "accounts-manager.c"
}


static gboolean
accounts_manager_expunge_accounts_co (AccountsManagerExpungeAccountsData* _data_)
{
#line 342 "../src/client/accounts/accounts-manager.vala"
	switch (_data_->_state_) {
#line 342 "../src/client/accounts/accounts-manager.vala"
		case 0:
#line 3656 "accounts-manager.c"
		goto _state_0;
#line 342 "../src/client/accounts/accounts-manager.vala"
		case 1:
#line 3660 "accounts-manager.c"
		goto _state_1;
		default:
#line 342 "../src/client/accounts/accounts-manager.vala"
		g_assert_not_reached ();
#line 3665 "accounts-manager.c"
	}
	_state_0:
#line 344 "../src/client/accounts/accounts-manager.vala"
	while (TRUE) {
#line 344 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp1_ = _data_->self->priv->removed;
#line 344 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp2_ = gee_collection_get_is_empty (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp1_, GEE_TYPE_COLLECTION, GeeCollection));
#line 344 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp3_ = _data_->_tmp2_;
#line 344 "../src/client/accounts/accounts-manager.vala"
		if (!_data_->_tmp3_) {
#line 344 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp0_ = !g_cancellable_is_cancelled (_data_->cancellable);
#line 3680 "accounts-manager.c"
		} else {
#line 344 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp0_ = FALSE;
#line 3684 "accounts-manager.c"
		}
#line 344 "../src/client/accounts/accounts-manager.vala"
		if (!_data_->_tmp0_) {
#line 344 "../src/client/accounts/accounts-manager.vala"
			break;
#line 3690 "accounts-manager.c"
		}
#line 345 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp4_ = _data_->self->priv->removed;
#line 345 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp5_ = gee_abstract_list_remove_at (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp4_, GEE_TYPE_ABSTRACT_LIST, GeeAbstractList), 0);
#line 345 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp6_ = (GearyAccountInformation*) _data_->_tmp5_;
#line 345 "../src/client/accounts/accounts-manager.vala"
		_data_->_state_ = 1;
#line 345 "../src/client/accounts/accounts-manager.vala"
		accounts_manager_delete_account (_data_->self, _data_->_tmp6_, _data_->cancellable, accounts_manager_expunge_accounts_ready, _data_);
#line 345 "../src/client/accounts/accounts-manager.vala"
		return FALSE;
#line 3704 "accounts-manager.c"
		_state_1:
#line 345 "../src/client/accounts/accounts-manager.vala"
		accounts_manager_delete_account_finish (_data_->self, _data_->_res_, &_data_->_inner_error_);
#line 345 "../src/client/accounts/accounts-manager.vala"
		_g_object_unref0 (_data_->_tmp6_);
#line 345 "../src/client/accounts/accounts-manager.vala"
		if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 345 "../src/client/accounts/accounts-manager.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error_);
#line 345 "../src/client/accounts/accounts-manager.vala"
			g_object_unref (_data_->_async_result);
#line 345 "../src/client/accounts/accounts-manager.vala"
			return FALSE;
#line 3718 "accounts-manager.c"
		}
	}
#line 342 "../src/client/accounts/accounts-manager.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 342 "../src/client/accounts/accounts-manager.vala"
	if (_data_->_state_ != 0) {
#line 342 "../src/client/accounts/accounts-manager.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 342 "../src/client/accounts/accounts-manager.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3729 "accounts-manager.c"
		}
	}
#line 342 "../src/client/accounts/accounts-manager.vala"
	g_object_unref (_data_->_async_result);
#line 342 "../src/client/accounts/accounts-manager.vala"
	return FALSE;
#line 3736 "accounts-manager.c"
}


static void
accounts_manager_save_account_data_free (gpointer _data)
{
	AccountsManagerSaveAccountData* _data_;
	_data_ = _data;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->info);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->cancellable);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->self);
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_slice_free (AccountsManagerSaveAccountData, _data_);
#line 3753 "accounts-manager.c"
}


void
accounts_manager_save_account (AccountsManager* self,
                               GearyAccountInformation* info,
                               GCancellable* cancellable,
                               GAsyncReadyCallback _callback_,
                               gpointer _user_data_)
{
	AccountsManagerSaveAccountData* _data_;
	AccountsManager* _tmp0_;
	GearyAccountInformation* _tmp1_;
	GCancellable* _tmp2_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_ = g_slice_new0 (AccountsManagerSaveAccountData);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_task_set_task_data (_data_->_async_result, _data_, accounts_manager_save_account_data_free);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->self = _tmp0_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_tmp1_ = _g_object_ref0 (info);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->info);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->info = _tmp1_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_tmp2_ = _g_object_ref0 (cancellable);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->cancellable);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->cancellable = _tmp2_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_save_account_co (_data_);
#line 3792 "accounts-manager.c"
}


void
accounts_manager_save_account_finish (AccountsManager* self,
                                      GAsyncResult* _res_,
                                      GError** error)
{
	AccountsManagerSaveAccountData* _data_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 24 "../src/client/accounts/accounts-manager.vala"
	if (NULL == _data_) {
#line 24 "../src/client/accounts/accounts-manager.vala"
		return;
#line 3808 "accounts-manager.c"
	}
}


/**
     * Saves an account's configuration data to disk.
     */
static void
accounts_manager_save_account_ready (GObject* source_object,
                                     GAsyncResult* _res_,
                                     gpointer _user_data_)
{
	AccountsManagerSaveAccountData* _data_;
#line 358 "../src/client/accounts/accounts-manager.vala"
	_data_ = _user_data_;
#line 358 "../src/client/accounts/accounts-manager.vala"
	_data_->_source_object_ = source_object;
#line 358 "../src/client/accounts/accounts-manager.vala"
	_data_->_res_ = _res_;
#line 358 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_save_account_co (_data_);
#line 3830 "accounts-manager.c"
}


static gpointer
_g_error_copy0 (gpointer self)
{
#line 364 "../src/client/accounts/accounts-manager.vala"
	return self ? g_error_copy (self) : NULL;
#line 3839 "accounts-manager.c"
}


static gboolean
accounts_manager_save_account_co (AccountsManagerSaveAccountData* _data_)
{
#line 352 "../src/client/accounts/accounts-manager.vala"
	switch (_data_->_state_) {
#line 352 "../src/client/accounts/accounts-manager.vala"
		case 0:
#line 3850 "accounts-manager.c"
		goto _state_0;
#line 352 "../src/client/accounts/accounts-manager.vala"
		case 1:
#line 3854 "accounts-manager.c"
		goto _state_1;
#line 352 "../src/client/accounts/accounts-manager.vala"
		case 2:
#line 3858 "accounts-manager.c"
		goto _state_2;
		default:
#line 352 "../src/client/accounts/accounts-manager.vala"
		g_assert_not_reached ();
#line 3863 "accounts-manager.c"
	}
	_state_0:
#line 358 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp0_ = geary_account_information_get_write_lock (_data_->info);
#line 358 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp1_ = _data_->_tmp0_;
#line 358 "../src/client/accounts/accounts-manager.vala"
	_data_->_state_ = 1;
#line 358 "../src/client/accounts/accounts-manager.vala"
	geary_nonblocking_mutex_claim_async (_data_->_tmp1_, _data_->cancellable, accounts_manager_save_account_ready, _data_);
#line 358 "../src/client/accounts/accounts-manager.vala"
	return FALSE;
#line 3876 "accounts-manager.c"
	_state_1:
#line 358 "../src/client/accounts/accounts-manager.vala"
	_data_->token = geary_nonblocking_mutex_claim_finish (_data_->_tmp1_, _data_->_res_, &_data_->_inner_error_);
#line 358 "../src/client/accounts/accounts-manager.vala"
	if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 358 "../src/client/accounts/accounts-manager.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error_);
#line 358 "../src/client/accounts/accounts-manager.vala"
		g_object_unref (_data_->_async_result);
#line 358 "../src/client/accounts/accounts-manager.vala"
		return FALSE;
#line 3888 "accounts-manager.c"
	}
#line 360 "../src/client/accounts/accounts-manager.vala"
	_data_->thrown = NULL;
#line 3892 "accounts-manager.c"
	{
#line 362 "../src/client/accounts/accounts-manager.vala"
		_data_->_state_ = 2;
#line 362 "../src/client/accounts/accounts-manager.vala"
		accounts_manager_save_account_locked (_data_->self, _data_->info, _data_->cancellable, accounts_manager_save_account_ready, _data_);
#line 362 "../src/client/accounts/accounts-manager.vala"
		return FALSE;
#line 3900 "accounts-manager.c"
		_state_2:
#line 362 "../src/client/accounts/accounts-manager.vala"
		accounts_manager_save_account_locked_finish (_data_->self, _data_->_res_, &_data_->_inner_error_);
#line 362 "../src/client/accounts/accounts-manager.vala"
		if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 3906 "accounts-manager.c"
			goto __catch85_g_error;
		}
	}
	goto __finally85;
	__catch85_g_error:
	{
#line 361 "../src/client/accounts/accounts-manager.vala"
		_data_->err = _data_->_inner_error_;
#line 361 "../src/client/accounts/accounts-manager.vala"
		_data_->_inner_error_ = NULL;
#line 364 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp2_ = _data_->err;
#line 364 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp3_ = _g_error_copy0 (_data_->_tmp2_);
#line 364 "../src/client/accounts/accounts-manager.vala"
		_g_error_free0 (_data_->thrown);
#line 364 "../src/client/accounts/accounts-manager.vala"
		_data_->thrown = _data_->_tmp3_;
#line 361 "../src/client/accounts/accounts-manager.vala"
		_g_error_free0 (_data_->err);
#line 3927 "accounts-manager.c"
	}
	__finally85:
#line 361 "../src/client/accounts/accounts-manager.vala"
	if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 361 "../src/client/accounts/accounts-manager.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error_);
#line 361 "../src/client/accounts/accounts-manager.vala"
		_g_error_free0 (_data_->thrown);
#line 361 "../src/client/accounts/accounts-manager.vala"
		g_object_unref (_data_->_async_result);
#line 361 "../src/client/accounts/accounts-manager.vala"
		return FALSE;
#line 3940 "accounts-manager.c"
	}
#line 367 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp4_ = geary_account_information_get_write_lock (_data_->info);
#line 367 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp5_ = _data_->_tmp4_;
#line 367 "../src/client/accounts/accounts-manager.vala"
	geary_nonblocking_mutex_release (_data_->_tmp5_, &_data_->token, &_data_->_inner_error_);
#line 367 "../src/client/accounts/accounts-manager.vala"
	if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 367 "../src/client/accounts/accounts-manager.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error_);
#line 367 "../src/client/accounts/accounts-manager.vala"
		_g_error_free0 (_data_->thrown);
#line 367 "../src/client/accounts/accounts-manager.vala"
		g_object_unref (_data_->_async_result);
#line 367 "../src/client/accounts/accounts-manager.vala"
		return FALSE;
#line 3958 "accounts-manager.c"
	}
#line 369 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp6_ = _data_->thrown;
#line 369 "../src/client/accounts/accounts-manager.vala"
	if (_data_->_tmp6_ != NULL) {
#line 370 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp7_ = _data_->thrown;
#line 370 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp8_ = _g_error_copy0 (_data_->_tmp7_);
#line 370 "../src/client/accounts/accounts-manager.vala"
		_data_->_inner_error_ = _data_->_tmp8_;
#line 370 "../src/client/accounts/accounts-manager.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error_);
#line 370 "../src/client/accounts/accounts-manager.vala"
		_g_error_free0 (_data_->thrown);
#line 370 "../src/client/accounts/accounts-manager.vala"
		g_object_unref (_data_->_async_result);
#line 370 "../src/client/accounts/accounts-manager.vala"
		return FALSE;
#line 3978 "accounts-manager.c"
	}
#line 352 "../src/client/accounts/accounts-manager.vala"
	_g_error_free0 (_data_->thrown);
#line 352 "../src/client/accounts/accounts-manager.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 352 "../src/client/accounts/accounts-manager.vala"
	if (_data_->_state_ != 0) {
#line 352 "../src/client/accounts/accounts-manager.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 352 "../src/client/accounts/accounts-manager.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 3990 "accounts-manager.c"
		}
	}
#line 352 "../src/client/accounts/accounts-manager.vala"
	g_object_unref (_data_->_async_result);
#line 352 "../src/client/accounts/accounts-manager.vala"
	return FALSE;
#line 3997 "accounts-manager.c"
}


static void
accounts_manager_update_local_credentials_data_free (gpointer _data)
{
	AccountsManagerUpdateLocalCredentialsData* _data_;
	_data_ = _data;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->account);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->old_service);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->new_service);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->cancellable);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->self);
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_slice_free (AccountsManagerUpdateLocalCredentialsData, _data_);
#line 4018 "accounts-manager.c"
}


void
accounts_manager_update_local_credentials (AccountsManager* self,
                                           GearyAccountInformation* account,
                                           GearyServiceInformation* old_service,
                                           GearyServiceInformation* new_service,
                                           GCancellable* cancellable,
                                           GAsyncReadyCallback _callback_,
                                           gpointer _user_data_)
{
	AccountsManagerUpdateLocalCredentialsData* _data_;
	AccountsManager* _tmp0_;
	GearyAccountInformation* _tmp1_;
	GearyServiceInformation* _tmp2_;
	GearyServiceInformation* _tmp3_;
	GCancellable* _tmp4_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_ = g_slice_new0 (AccountsManagerUpdateLocalCredentialsData);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_task_set_task_data (_data_->_async_result, _data_, accounts_manager_update_local_credentials_data_free);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->self = _tmp0_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_tmp1_ = _g_object_ref0 (account);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->account);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->account = _tmp1_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_tmp2_ = _g_object_ref0 (old_service);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->old_service);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->old_service = _tmp2_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_tmp3_ = _g_object_ref0 (new_service);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->new_service);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->new_service = _tmp3_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_tmp4_ = _g_object_ref0 (cancellable);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->cancellable);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->cancellable = _tmp4_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_update_local_credentials_co (_data_);
#line 4073 "accounts-manager.c"
}


void
accounts_manager_update_local_credentials_finish (AccountsManager* self,
                                                  GAsyncResult* _res_,
                                                  GError** error)
{
	AccountsManagerUpdateLocalCredentialsData* _data_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 24 "../src/client/accounts/accounts-manager.vala"
	if (NULL == _data_) {
#line 24 "../src/client/accounts/accounts-manager.vala"
		return;
#line 4089 "accounts-manager.c"
	}
}


/** Updates a local account service's credentials. */
static void
accounts_manager_update_local_credentials_ready (GObject* source_object,
                                                 GAsyncResult* _res_,
                                                 gpointer _user_data_)
{
	AccountsManagerUpdateLocalCredentialsData* _data_;
#line 383 "../src/client/accounts/accounts-manager.vala"
	_data_ = _user_data_;
#line 383 "../src/client/accounts/accounts-manager.vala"
	_data_->_source_object_ = source_object;
#line 383 "../src/client/accounts/accounts-manager.vala"
	_data_->_res_ = _res_;
#line 383 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_update_local_credentials_co (_data_);
#line 4109 "accounts-manager.c"
}


static gboolean
accounts_manager_update_local_credentials_co (AccountsManagerUpdateLocalCredentialsData* _data_)
{
#line 375 "../src/client/accounts/accounts-manager.vala"
	switch (_data_->_state_) {
#line 375 "../src/client/accounts/accounts-manager.vala"
		case 0:
#line 4120 "accounts-manager.c"
		goto _state_0;
#line 375 "../src/client/accounts/accounts-manager.vala"
		case 1:
#line 4124 "accounts-manager.c"
		goto _state_1;
#line 375 "../src/client/accounts/accounts-manager.vala"
		case 2:
#line 4128 "accounts-manager.c"
		goto _state_2;
		default:
#line 375 "../src/client/accounts/accounts-manager.vala"
		g_assert_not_reached ();
#line 4133 "accounts-manager.c"
	}
	_state_0:
#line 380 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp0_ = geary_account_information_get_mediator (_data_->account);
#line 380 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp1_ = _data_->_tmp0_;
#line 380 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp2_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_data_->_tmp1_, TYPE_SECRET_MEDIATOR) ? ((SecretMediator*) _data_->_tmp1_) : NULL);
#line 380 "../src/client/accounts/accounts-manager.vala"
	_data_->mediator = _data_->_tmp2_;
#line 381 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp3_ = _data_->mediator;
#line 381 "../src/client/accounts/accounts-manager.vala"
	if (_data_->_tmp3_ != NULL) {
#line 382 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp4_ = geary_service_information_get_credentials (_data_->new_service);
#line 382 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp5_ = _data_->_tmp4_;
#line 382 "../src/client/accounts/accounts-manager.vala"
		if (_data_->_tmp5_ != NULL) {
#line 383 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp6_ = _data_->mediator;
#line 383 "../src/client/accounts/accounts-manager.vala"
			_data_->_state_ = 1;
#line 383 "../src/client/accounts/accounts-manager.vala"
			secret_mediator_update_token (_data_->_tmp6_, _data_->account, _data_->new_service, _data_->cancellable, accounts_manager_update_local_credentials_ready, _data_);
#line 383 "../src/client/accounts/accounts-manager.vala"
			return FALSE;
#line 4162 "accounts-manager.c"
			_state_1:
#line 383 "../src/client/accounts/accounts-manager.vala"
			secret_mediator_update_token_finish (_data_->_tmp6_, _data_->_res_, &_data_->_inner_error_);
#line 383 "../src/client/accounts/accounts-manager.vala"
			if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 383 "../src/client/accounts/accounts-manager.vala"
				g_task_return_error (_data_->_async_result, _data_->_inner_error_);
#line 383 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->mediator);
#line 383 "../src/client/accounts/accounts-manager.vala"
				g_object_unref (_data_->_async_result);
#line 383 "../src/client/accounts/accounts-manager.vala"
				return FALSE;
#line 4176 "accounts-manager.c"
			}
		}
#line 386 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp8_ = geary_service_information_get_credentials (_data_->old_service);
#line 386 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp9_ = _data_->_tmp8_;
#line 386 "../src/client/accounts/accounts-manager.vala"
		if (_data_->_tmp9_ != NULL) {
#line 387 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp11_ = geary_service_information_get_credentials (_data_->new_service);
#line 387 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp12_ = _data_->_tmp11_;
#line 387 "../src/client/accounts/accounts-manager.vala"
			if (_data_->_tmp12_ == NULL) {
#line 387 "../src/client/accounts/accounts-manager.vala"
				_data_->_tmp10_ = TRUE;
#line 4193 "accounts-manager.c"
			} else {
#line 388 "../src/client/accounts/accounts-manager.vala"
				_data_->_tmp14_ = geary_service_information_get_credentials (_data_->new_service);
#line 388 "../src/client/accounts/accounts-manager.vala"
				_data_->_tmp15_ = _data_->_tmp14_;
#line 388 "../src/client/accounts/accounts-manager.vala"
				if (_data_->_tmp15_ != NULL) {
#line 389 "../src/client/accounts/accounts-manager.vala"
					_data_->_tmp16_ = geary_service_information_get_credentials (_data_->old_service);
#line 389 "../src/client/accounts/accounts-manager.vala"
					_data_->_tmp17_ = _data_->_tmp16_;
#line 389 "../src/client/accounts/accounts-manager.vala"
					_data_->_tmp18_ = geary_credentials_get_user (_data_->_tmp17_);
#line 389 "../src/client/accounts/accounts-manager.vala"
					_data_->_tmp19_ = _data_->_tmp18_;
#line 389 "../src/client/accounts/accounts-manager.vala"
					_data_->_tmp20_ = geary_service_information_get_credentials (_data_->old_service);
#line 389 "../src/client/accounts/accounts-manager.vala"
					_data_->_tmp21_ = _data_->_tmp20_;
#line 389 "../src/client/accounts/accounts-manager.vala"
					_data_->_tmp22_ = geary_credentials_get_user (_data_->_tmp21_);
#line 389 "../src/client/accounts/accounts-manager.vala"
					_data_->_tmp23_ = _data_->_tmp22_;
#line 389 "../src/client/accounts/accounts-manager.vala"
					_data_->_tmp13_ = g_strcmp0 (_data_->_tmp19_, _data_->_tmp23_) != 0;
#line 4219 "accounts-manager.c"
				} else {
#line 388 "../src/client/accounts/accounts-manager.vala"
					_data_->_tmp13_ = FALSE;
#line 4223 "accounts-manager.c"
				}
#line 388 "../src/client/accounts/accounts-manager.vala"
				_data_->_tmp10_ = _data_->_tmp13_;
#line 4227 "accounts-manager.c"
			}
#line 387 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp7_ = _data_->_tmp10_;
#line 4231 "accounts-manager.c"
		} else {
#line 386 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp7_ = FALSE;
#line 4235 "accounts-manager.c"
		}
#line 386 "../src/client/accounts/accounts-manager.vala"
		if (_data_->_tmp7_) {
#line 390 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp24_ = _data_->mediator;
#line 390 "../src/client/accounts/accounts-manager.vala"
			_data_->_state_ = 2;
#line 390 "../src/client/accounts/accounts-manager.vala"
			secret_mediator_clear_token (_data_->_tmp24_, _data_->account, _data_->old_service, _data_->cancellable, accounts_manager_update_local_credentials_ready, _data_);
#line 390 "../src/client/accounts/accounts-manager.vala"
			return FALSE;
#line 4247 "accounts-manager.c"
			_state_2:
#line 390 "../src/client/accounts/accounts-manager.vala"
			secret_mediator_clear_token_finish (_data_->_tmp24_, _data_->_res_, &_data_->_inner_error_);
#line 390 "../src/client/accounts/accounts-manager.vala"
			if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 390 "../src/client/accounts/accounts-manager.vala"
				g_task_return_error (_data_->_async_result, _data_->_inner_error_);
#line 390 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->mediator);
#line 390 "../src/client/accounts/accounts-manager.vala"
				g_object_unref (_data_->_async_result);
#line 390 "../src/client/accounts/accounts-manager.vala"
				return FALSE;
#line 4261 "accounts-manager.c"
			}
		}
	}
#line 375 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->mediator);
#line 375 "../src/client/accounts/accounts-manager.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 375 "../src/client/accounts/accounts-manager.vala"
	if (_data_->_state_ != 0) {
#line 375 "../src/client/accounts/accounts-manager.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 375 "../src/client/accounts/accounts-manager.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 4275 "accounts-manager.c"
		}
	}
#line 375 "../src/client/accounts/accounts-manager.vala"
	g_object_unref (_data_->_async_result);
#line 375 "../src/client/accounts/accounts-manager.vala"
	return FALSE;
#line 4282 "accounts-manager.c"
}


/**
     * Determines if an account is a GOA account or not.
     */
gboolean
accounts_manager_is_goa_account (AccountsManager* self,
                                 GearyAccountInformation* account)
{
	gboolean result = FALSE;
	GearyCredentialsMediator* _tmp0_;
	GearyCredentialsMediator* _tmp1_;
#line 398 "../src/client/accounts/accounts-manager.vala"
	g_return_val_if_fail (ACCOUNTS_IS_MANAGER (self), FALSE);
#line 398 "../src/client/accounts/accounts-manager.vala"
	g_return_val_if_fail (GEARY_IS_ACCOUNT_INFORMATION (account), FALSE);
#line 399 "../src/client/accounts/accounts-manager.vala"
	_tmp0_ = geary_account_information_get_mediator (account);
#line 399 "../src/client/accounts/accounts-manager.vala"
	_tmp1_ = _tmp0_;
#line 399 "../src/client/accounts/accounts-manager.vala"
	result = G_TYPE_CHECK_INSTANCE_TYPE (_tmp1_, TYPE_GOA_MEDIATOR);
#line 399 "../src/client/accounts/accounts-manager.vala"
	return result;
#line 4308 "accounts-manager.c"
}


static void
accounts_manager_add_goa_account_data_free (gpointer _data)
{
	AccountsManagerAddGoaAccountData* _data_;
	_data_ = _data;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->cancellable);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->self);
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_slice_free (AccountsManagerAddGoaAccountData, _data_);
#line 4323 "accounts-manager.c"
}


void
accounts_manager_add_goa_account (AccountsManager* self,
                                  GearyServiceProvider type,
                                  GCancellable* cancellable,
                                  GAsyncReadyCallback _callback_,
                                  gpointer _user_data_)
{
	AccountsManagerAddGoaAccountData* _data_;
	AccountsManager* _tmp0_;
	GCancellable* _tmp1_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_ = g_slice_new0 (AccountsManagerAddGoaAccountData);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_task_set_task_data (_data_->_async_result, _data_, accounts_manager_add_goa_account_data_free);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->self = _tmp0_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->type = type;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_tmp1_ = _g_object_ref0 (cancellable);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->cancellable);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->cancellable = _tmp1_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_add_goa_account_co (_data_);
#line 4357 "accounts-manager.c"
}


void
accounts_manager_add_goa_account_finish (AccountsManager* self,
                                         GAsyncResult* _res_,
                                         GError** error)
{
	AccountsManagerAddGoaAccountData* _data_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 24 "../src/client/accounts/accounts-manager.vala"
	if (NULL == _data_) {
#line 24 "../src/client/accounts/accounts-manager.vala"
		return;
#line 4373 "accounts-manager.c"
	}
}


/**
     * Opens GNOME Settings to add an account of a particular type.
     *
     * Throws an error if it was not possible to open GNOME Settings,
     * or if the given type is not supported for by GOA.
     */
static void
accounts_manager_add_goa_account_ready (GObject* source_object,
                                        GAsyncResult* _res_,
                                        gpointer _user_data_)
{
	AccountsManagerAddGoaAccountData* _data_;
#line 413 "../src/client/accounts/accounts-manager.vala"
	_data_ = _user_data_;
#line 413 "../src/client/accounts/accounts-manager.vala"
	_data_->_source_object_ = source_object;
#line 413 "../src/client/accounts/accounts-manager.vala"
	_data_->_res_ = _res_;
#line 413 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_add_goa_account_co (_data_);
#line 4398 "accounts-manager.c"
}


static gboolean
accounts_manager_add_goa_account_co (AccountsManagerAddGoaAccountData* _data_)
{
#line 408 "../src/client/accounts/accounts-manager.vala"
	switch (_data_->_state_) {
#line 408 "../src/client/accounts/accounts-manager.vala"
		case 0:
#line 4409 "accounts-manager.c"
		goto _state_0;
#line 408 "../src/client/accounts/accounts-manager.vala"
		case 1:
#line 4413 "accounts-manager.c"
		goto _state_1;
#line 408 "../src/client/accounts/accounts-manager.vala"
		case 2:
#line 4417 "accounts-manager.c"
		goto _state_2;
		default:
#line 408 "../src/client/accounts/accounts-manager.vala"
		g_assert_not_reached ();
#line 4422 "accounts-manager.c"
	}
	_state_0:
#line 411 "../src/client/accounts/accounts-manager.vala"
	switch (_data_->type) {
#line 411 "../src/client/accounts/accounts-manager.vala"
		case GEARY_SERVICE_PROVIDER_GMAIL:
#line 4429 "accounts-manager.c"
		{
#line 413 "../src/client/accounts/accounts-manager.vala"
			_data_->_state_ = 1;
#line 413 "../src/client/accounts/accounts-manager.vala"
			accounts_manager_open_goa_settings (_data_->self, "add", "google", _data_->cancellable, accounts_manager_add_goa_account_ready, _data_);
#line 413 "../src/client/accounts/accounts-manager.vala"
			return FALSE;
#line 4437 "accounts-manager.c"
			_state_1:
#line 413 "../src/client/accounts/accounts-manager.vala"
			accounts_manager_open_goa_settings_finish (_data_->self, _data_->_res_, &_data_->_inner_error_);
#line 413 "../src/client/accounts/accounts-manager.vala"
			if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 413 "../src/client/accounts/accounts-manager.vala"
				g_task_return_error (_data_->_async_result, _data_->_inner_error_);
#line 413 "../src/client/accounts/accounts-manager.vala"
				g_object_unref (_data_->_async_result);
#line 413 "../src/client/accounts/accounts-manager.vala"
				return FALSE;
#line 4449 "accounts-manager.c"
			}
#line 414 "../src/client/accounts/accounts-manager.vala"
			break;
#line 4453 "accounts-manager.c"
		}
#line 411 "../src/client/accounts/accounts-manager.vala"
		case GEARY_SERVICE_PROVIDER_OUTLOOK:
#line 4457 "accounts-manager.c"
		{
#line 417 "../src/client/accounts/accounts-manager.vala"
			_data_->_state_ = 2;
#line 417 "../src/client/accounts/accounts-manager.vala"
			accounts_manager_open_goa_settings (_data_->self, "add", "windows_live", _data_->cancellable, accounts_manager_add_goa_account_ready, _data_);
#line 417 "../src/client/accounts/accounts-manager.vala"
			return FALSE;
#line 4465 "accounts-manager.c"
			_state_2:
#line 417 "../src/client/accounts/accounts-manager.vala"
			accounts_manager_open_goa_settings_finish (_data_->self, _data_->_res_, &_data_->_inner_error_);
#line 417 "../src/client/accounts/accounts-manager.vala"
			if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 417 "../src/client/accounts/accounts-manager.vala"
				g_task_return_error (_data_->_async_result, _data_->_inner_error_);
#line 417 "../src/client/accounts/accounts-manager.vala"
				g_object_unref (_data_->_async_result);
#line 417 "../src/client/accounts/accounts-manager.vala"
				return FALSE;
#line 4477 "accounts-manager.c"
			}
#line 418 "../src/client/accounts/accounts-manager.vala"
			break;
#line 4481 "accounts-manager.c"
		}
		default:
		{
#line 421 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp0_ = g_error_new_literal (G_IO_ERROR, G_IO_ERROR_NOT_SUPPORTED, "Not supported for GOA");
#line 421 "../src/client/accounts/accounts-manager.vala"
			_data_->_inner_error_ = _data_->_tmp0_;
#line 421 "../src/client/accounts/accounts-manager.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error_);
#line 421 "../src/client/accounts/accounts-manager.vala"
			g_object_unref (_data_->_async_result);
#line 421 "../src/client/accounts/accounts-manager.vala"
			return FALSE;
#line 4495 "accounts-manager.c"
		}
	}
#line 408 "../src/client/accounts/accounts-manager.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 408 "../src/client/accounts/accounts-manager.vala"
	if (_data_->_state_ != 0) {
#line 408 "../src/client/accounts/accounts-manager.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 408 "../src/client/accounts/accounts-manager.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 4506 "accounts-manager.c"
		}
	}
#line 408 "../src/client/accounts/accounts-manager.vala"
	g_object_unref (_data_->_async_result);
#line 408 "../src/client/accounts/accounts-manager.vala"
	return FALSE;
#line 4513 "accounts-manager.c"
}


static void
accounts_manager_show_goa_account_data_free (gpointer _data)
{
	AccountsManagerShowGoaAccountData* _data_;
	_data_ = _data;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->account);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->cancellable);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->self);
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_slice_free (AccountsManagerShowGoaAccountData, _data_);
#line 4530 "accounts-manager.c"
}


void
accounts_manager_show_goa_account (AccountsManager* self,
                                   GearyAccountInformation* account,
                                   GCancellable* cancellable,
                                   GAsyncReadyCallback _callback_,
                                   gpointer _user_data_)
{
	AccountsManagerShowGoaAccountData* _data_;
	AccountsManager* _tmp0_;
	GearyAccountInformation* _tmp1_;
	GCancellable* _tmp2_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_ = g_slice_new0 (AccountsManagerShowGoaAccountData);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_task_set_task_data (_data_->_async_result, _data_, accounts_manager_show_goa_account_data_free);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->self = _tmp0_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_tmp1_ = _g_object_ref0 (account);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->account);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->account = _tmp1_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_tmp2_ = _g_object_ref0 (cancellable);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->cancellable);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->cancellable = _tmp2_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_show_goa_account_co (_data_);
#line 4569 "accounts-manager.c"
}


void
accounts_manager_show_goa_account_finish (AccountsManager* self,
                                          GAsyncResult* _res_,
                                          GError** error)
{
	AccountsManagerShowGoaAccountData* _data_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 24 "../src/client/accounts/accounts-manager.vala"
	if (NULL == _data_) {
#line 24 "../src/client/accounts/accounts-manager.vala"
		return;
#line 4585 "accounts-manager.c"
	}
}


/**
     * Opens GOA settings for the given account in GNOME Settings.
     *
     * Throws an error if it was not possible to open GNOME Settings,
     * or if the given account is not backed by GOA.
     */
static void
accounts_manager_show_goa_account_ready (GObject* source_object,
                                         GAsyncResult* _res_,
                                         gpointer _user_data_)
{
	AccountsManagerShowGoaAccountData* _data_;
#line 438 "../src/client/accounts/accounts-manager.vala"
	_data_ = _user_data_;
#line 438 "../src/client/accounts/accounts-manager.vala"
	_data_->_source_object_ = source_object;
#line 438 "../src/client/accounts/accounts-manager.vala"
	_data_->_res_ = _res_;
#line 438 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_show_goa_account_co (_data_);
#line 4610 "accounts-manager.c"
}


static gboolean
accounts_manager_show_goa_account_co (AccountsManagerShowGoaAccountData* _data_)
{
#line 431 "../src/client/accounts/accounts-manager.vala"
	switch (_data_->_state_) {
#line 431 "../src/client/accounts/accounts-manager.vala"
		case 0:
#line 4621 "accounts-manager.c"
		goto _state_0;
#line 431 "../src/client/accounts/accounts-manager.vala"
		case 1:
#line 4625 "accounts-manager.c"
		goto _state_1;
		default:
#line 431 "../src/client/accounts/accounts-manager.vala"
		g_assert_not_reached ();
#line 4630 "accounts-manager.c"
	}
	_state_0:
#line 434 "../src/client/accounts/accounts-manager.vala"
	if (!accounts_manager_is_goa_account (_data_->self, _data_->account)) {
#line 435 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp0_ = g_error_new_literal (G_IO_ERROR, G_IO_ERROR_NOT_SUPPORTED, "Not a GOA Account");
#line 435 "../src/client/accounts/accounts-manager.vala"
		_data_->_inner_error_ = _data_->_tmp0_;
#line 435 "../src/client/accounts/accounts-manager.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error_);
#line 435 "../src/client/accounts/accounts-manager.vala"
		g_object_unref (_data_->_async_result);
#line 435 "../src/client/accounts/accounts-manager.vala"
		return FALSE;
#line 4645 "accounts-manager.c"
	}
#line 438 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp1_ = geary_account_information_get_id (_data_->account);
#line 438 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp2_ = _data_->_tmp1_;
#line 438 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp3_ = accounts_manager_to_goa_id (_data_->self, _data_->_tmp2_);
#line 438 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp4_ = _data_->_tmp3_;
#line 438 "../src/client/accounts/accounts-manager.vala"
	_data_->_state_ = 1;
#line 438 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_open_goa_settings (_data_->self, _data_->_tmp4_, NULL, _data_->cancellable, accounts_manager_show_goa_account_ready, _data_);
#line 438 "../src/client/accounts/accounts-manager.vala"
	return FALSE;
#line 4661 "accounts-manager.c"
	_state_1:
#line 438 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_open_goa_settings_finish (_data_->self, _data_->_res_, &_data_->_inner_error_);
#line 438 "../src/client/accounts/accounts-manager.vala"
	_g_free0 (_data_->_tmp4_);
#line 438 "../src/client/accounts/accounts-manager.vala"
	if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 438 "../src/client/accounts/accounts-manager.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error_);
#line 438 "../src/client/accounts/accounts-manager.vala"
		g_object_unref (_data_->_async_result);
#line 438 "../src/client/accounts/accounts-manager.vala"
		return FALSE;
#line 4675 "accounts-manager.c"
	}
#line 431 "../src/client/accounts/accounts-manager.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 431 "../src/client/accounts/accounts-manager.vala"
	if (_data_->_state_ != 0) {
#line 431 "../src/client/accounts/accounts-manager.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 431 "../src/client/accounts/accounts-manager.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 4685 "accounts-manager.c"
		}
	}
#line 431 "../src/client/accounts/accounts-manager.vala"
	g_object_unref (_data_->_async_result);
#line 431 "../src/client/accounts/accounts-manager.vala"
	return FALSE;
#line 4692 "accounts-manager.c"
}


static void
accounts_manager_next_id_data_free (gpointer _data)
{
	AccountsManagerNextIdData* _data_;
	_data_ = _data;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->cancellable);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_free0 (_data_->result);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->self);
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_slice_free (AccountsManagerNextIdData, _data_);
#line 4709 "accounts-manager.c"
}


static void
accounts_manager_next_id (AccountsManager* self,
                          GCancellable* cancellable,
                          GAsyncReadyCallback _callback_,
                          gpointer _user_data_)
{
	AccountsManagerNextIdData* _data_;
	AccountsManager* _tmp0_;
	GCancellable* _tmp1_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_ = g_slice_new0 (AccountsManagerNextIdData);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_task_set_task_data (_data_->_async_result, _data_, accounts_manager_next_id_data_free);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->self = _tmp0_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_tmp1_ = _g_object_ref0 (cancellable);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->cancellable);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->cancellable = _tmp1_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_next_id_co (_data_);
#line 4740 "accounts-manager.c"
}


static gchar*
accounts_manager_next_id_finish (AccountsManager* self,
                                 GAsyncResult* _res_)
{
	gchar* result;
	AccountsManagerNextIdData* _data_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 24 "../src/client/accounts/accounts-manager.vala"
	if (NULL == _data_) {
#line 24 "../src/client/accounts/accounts-manager.vala"
		return NULL;
#line 4756 "accounts-manager.c"
	}
#line 24 "../src/client/accounts/accounts-manager.vala"
	result = _data_->result;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->result = NULL;
#line 24 "../src/client/accounts/accounts-manager.vala"
	return result;
#line 4764 "accounts-manager.c"
}


/** Returns the next id for a new local account. */
static gchar*
__lambda10_ (AccountsManager* self,
             gchar* next,
             gchar* last)
{
	gchar* result = NULL;
	gchar* _result_ = NULL;
	gchar* _tmp0_;
#line 446 "../src/client/accounts/accounts-manager.vala"
	g_return_val_if_fail (next != NULL, NULL);
#line 447 "../src/client/accounts/accounts-manager.vala"
	_tmp0_ = g_strdup (last);
#line 447 "../src/client/accounts/accounts-manager.vala"
	_result_ = _tmp0_;
#line 448 "../src/client/accounts/accounts-manager.vala"
	if (g_str_has_prefix (next, ACCOUNTS_MANAGER_LOCAL_ID_PREFIX)) {
#line 4785 "accounts-manager.c"
		const gchar* _tmp1_ = NULL;
		gboolean _tmp2_ = FALSE;
		gchar* _tmp4_;
#line 449 "../src/client/accounts/accounts-manager.vala"
		if (last == NULL) {
#line 449 "../src/client/accounts/accounts-manager.vala"
			_tmp2_ = TRUE;
#line 4793 "accounts-manager.c"
		} else {
			GCompareFunc _tmp3_;
#line 449 "../src/client/accounts/accounts-manager.vala"
			_tmp3_ = ((GCompareFunc) g_strcmp0);
#line 449 "../src/client/accounts/accounts-manager.vala"
			_tmp2_ = _tmp3_ (last, next) < 0;
#line 4800 "accounts-manager.c"
		}
#line 449 "../src/client/accounts/accounts-manager.vala"
		if (_tmp2_) {
#line 449 "../src/client/accounts/accounts-manager.vala"
			_tmp1_ = next;
#line 4806 "accounts-manager.c"
		} else {
#line 449 "../src/client/accounts/accounts-manager.vala"
			_tmp1_ = last;
#line 4810 "accounts-manager.c"
		}
#line 449 "../src/client/accounts/accounts-manager.vala"
		_tmp4_ = g_strdup (_tmp1_);
#line 449 "../src/client/accounts/accounts-manager.vala"
		_g_free0 (_result_);
#line 449 "../src/client/accounts/accounts-manager.vala"
		_result_ = _tmp4_;
#line 4818 "accounts-manager.c"
	}
#line 451 "../src/client/accounts/accounts-manager.vala"
	result = _result_;
#line 451 "../src/client/accounts/accounts-manager.vala"
	_g_free0 (next);
#line 451 "../src/client/accounts/accounts-manager.vala"
	_g_free0 (last);
#line 451 "../src/client/accounts/accounts-manager.vala"
	return result;
#line 4828 "accounts-manager.c"
}


static gpointer
___lambda10__gee_fold_func (gpointer g,
                            gpointer a,
                            gpointer self)
{
	gpointer result;
	result = __lambda10_ ((AccountsManager*) self, (gchar*) g, (gchar*) a);
#line 446 "../src/client/accounts/accounts-manager.vala"
	return result;
#line 4841 "accounts-manager.c"
}


static glong
string_strnlen (gchar* str,
                glong maxlen)
{
	glong result = 0L;
	gchar* end = NULL;
	gchar* _tmp0_;
	gchar* _tmp1_;
#line 1392 "glib-2.0.vapi"
	_tmp0_ = memchr (str, 0, (gsize) maxlen);
#line 1392 "glib-2.0.vapi"
	end = _tmp0_;
#line 1393 "glib-2.0.vapi"
	_tmp1_ = end;
#line 1393 "glib-2.0.vapi"
	if (_tmp1_ == NULL) {
#line 1394 "glib-2.0.vapi"
		result = maxlen;
#line 1394 "glib-2.0.vapi"
		return result;
#line 4865 "accounts-manager.c"
	} else {
		gchar* _tmp2_;
#line 1396 "glib-2.0.vapi"
		_tmp2_ = end;
#line 1396 "glib-2.0.vapi"
		result = (glong) (_tmp2_ - str);
#line 1396 "glib-2.0.vapi"
		return result;
#line 4874 "accounts-manager.c"
	}
}


static gchar*
string_substring (const gchar* self,
                  glong offset,
                  glong len)
{
	gchar* result = NULL;
	glong string_length = 0L;
	gboolean _tmp0_ = FALSE;
	glong _tmp6_;
	gchar* _tmp7_;
#line 1403 "glib-2.0.vapi"
	g_return_val_if_fail (self != NULL, NULL);
#line 1405 "glib-2.0.vapi"
	if (offset >= ((glong) 0)) {
#line 1405 "glib-2.0.vapi"
		_tmp0_ = len >= ((glong) 0);
#line 4895 "accounts-manager.c"
	} else {
#line 1405 "glib-2.0.vapi"
		_tmp0_ = FALSE;
#line 4899 "accounts-manager.c"
	}
#line 1405 "glib-2.0.vapi"
	if (_tmp0_) {
#line 1407 "glib-2.0.vapi"
		string_length = string_strnlen ((gchar*) self, offset + len);
#line 4905 "accounts-manager.c"
	} else {
		gint _tmp1_;
		gint _tmp2_;
#line 1409 "glib-2.0.vapi"
		_tmp1_ = strlen (self);
#line 1409 "glib-2.0.vapi"
		_tmp2_ = _tmp1_;
#line 1409 "glib-2.0.vapi"
		string_length = (glong) _tmp2_;
#line 4915 "accounts-manager.c"
	}
#line 1412 "glib-2.0.vapi"
	if (offset < ((glong) 0)) {
#line 4919 "accounts-manager.c"
		glong _tmp3_;
#line 1413 "glib-2.0.vapi"
		_tmp3_ = string_length;
#line 1413 "glib-2.0.vapi"
		offset = _tmp3_ + offset;
#line 1414 "glib-2.0.vapi"
		g_return_val_if_fail (offset >= ((glong) 0), NULL);
#line 4927 "accounts-manager.c"
	} else {
		glong _tmp4_;
#line 1416 "glib-2.0.vapi"
		_tmp4_ = string_length;
#line 1416 "glib-2.0.vapi"
		g_return_val_if_fail (offset <= _tmp4_, NULL);
#line 4934 "accounts-manager.c"
	}
#line 1418 "glib-2.0.vapi"
	if (len < ((glong) 0)) {
#line 4938 "accounts-manager.c"
		glong _tmp5_;
#line 1419 "glib-2.0.vapi"
		_tmp5_ = string_length;
#line 1419 "glib-2.0.vapi"
		len = _tmp5_ - offset;
#line 4944 "accounts-manager.c"
	}
#line 1421 "glib-2.0.vapi"
	_tmp6_ = string_length;
#line 1421 "glib-2.0.vapi"
	g_return_val_if_fail ((offset + len) <= _tmp6_, NULL);
#line 1422 "glib-2.0.vapi"
	_tmp7_ = g_strndup (((gchar*) self) + offset, (gsize) len);
#line 1422 "glib-2.0.vapi"
	result = _tmp7_;
#line 1422 "glib-2.0.vapi"
	return result;
#line 4956 "accounts-manager.c"
}


static void
accounts_manager_next_id_ready (GObject* source_object,
                                GAsyncResult* _res_,
                                gpointer _user_data_)
{
	AccountsManagerNextIdData* _data_;
#line 465 "../src/client/accounts/accounts-manager.vala"
	_data_ = _user_data_;
#line 465 "../src/client/accounts/accounts-manager.vala"
	_data_->_source_object_ = source_object;
#line 465 "../src/client/accounts/accounts-manager.vala"
	_data_->_res_ = _res_;
#line 465 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_next_id_co (_data_);
#line 4974 "accounts-manager.c"
}


static gboolean
accounts_manager_next_id_co (AccountsManagerNextIdData* _data_)
{
#line 444 "../src/client/accounts/accounts-manager.vala"
	switch (_data_->_state_) {
#line 444 "../src/client/accounts/accounts-manager.vala"
		case 0:
#line 4985 "accounts-manager.c"
		goto _state_0;
#line 444 "../src/client/accounts/accounts-manager.vala"
		case 1:
#line 4989 "accounts-manager.c"
		goto _state_1;
#line 444 "../src/client/accounts/accounts-manager.vala"
		case 2:
#line 4993 "accounts-manager.c"
		goto _state_2;
		default:
#line 444 "../src/client/accounts/accounts-manager.vala"
		g_assert_not_reached ();
#line 4998 "accounts-manager.c"
	}
	_state_0:
#line 446 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp0_ = _data_->self->priv->accounts;
#line 446 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp1_ = gee_map_get_keys (_data_->_tmp0_);
#line 446 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp2_ = _data_->_tmp1_;
#line 446 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp3_ = _data_->_tmp2_;
#line 446 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp4_ = gee_traversable_fold (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp3_, GEE_TYPE_TRAVERSABLE, GeeTraversable), G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, ___lambda10__gee_fold_func, _data_->self, NULL);
#line 446 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp5_ = (gchar*) _data_->_tmp4_;
#line 446 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->_tmp3_);
#line 446 "../src/client/accounts/accounts-manager.vala"
	_data_->last_account = _data_->_tmp5_;
#line 455 "../src/client/accounts/accounts-manager.vala"
	_data_->next_id = (guint) 1;
#line 456 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp6_ = _data_->last_account;
#line 456 "../src/client/accounts/accounts-manager.vala"
	if (_data_->_tmp6_ != NULL) {
#line 457 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp7_ = _data_->last_account;
#line 457 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp8_ = strlen (ACCOUNTS_MANAGER_LOCAL_ID_PREFIX);
#line 457 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp9_ = _data_->_tmp8_;
#line 457 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp10_ = string_substring (_data_->_tmp7_, (glong) _data_->_tmp9_, (glong) -1);
#line 457 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp11_ = _data_->_tmp10_;
#line 457 "../src/client/accounts/accounts-manager.vala"
		_data_->next_id = (guint) (atoi (_data_->_tmp11_) + 1);
#line 457 "../src/client/accounts/accounts-manager.vala"
		_g_free0 (_data_->_tmp11_);
#line 5037 "accounts-manager.c"
	}
#line 463 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp12_ = _data_->next_id;
#line 463 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp13_ = g_strdup_printf (ACCOUNTS_MANAGER_LOCAL_ID_FORMAT, _data_->_tmp12_);
#line 463 "../src/client/accounts/accounts-manager.vala"
	_data_->id = _data_->_tmp13_;
#line 5045 "accounts-manager.c"
	{
#line 465 "../src/client/accounts/accounts-manager.vala"
		while (TRUE) {
#line 465 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp16_ = _data_->self->priv->_config_dir;
#line 465 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp17_ = _data_->id;
#line 465 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp18_ = g_file_get_child (_data_->_tmp16_, _data_->_tmp17_);
#line 465 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp19_ = _data_->_tmp18_;
#line 465 "../src/client/accounts/accounts-manager.vala"
			_data_->_state_ = 1;
#line 465 "../src/client/accounts/accounts-manager.vala"
			geary_files_query_exists_async (_data_->_tmp19_, _data_->cancellable, accounts_manager_next_id_ready, _data_);
#line 465 "../src/client/accounts/accounts-manager.vala"
			return FALSE;
#line 5063 "accounts-manager.c"
			_state_1:
#line 465 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp20_ = geary_files_query_exists_finish (_data_->_res_, &_data_->_inner_error_);
#line 465 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->_tmp19_);
#line 465 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp15_ = _data_->_tmp20_;
#line 465 "../src/client/accounts/accounts-manager.vala"
			if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 5073 "accounts-manager.c"
				goto __catch86_g_error;
			}
#line 465 "../src/client/accounts/accounts-manager.vala"
			if (_data_->_tmp15_) {
#line 465 "../src/client/accounts/accounts-manager.vala"
				_data_->_tmp14_ = TRUE;
#line 5080 "accounts-manager.c"
			} else {
#line 467 "../src/client/accounts/accounts-manager.vala"
				_data_->_tmp22_ = _data_->self->priv->_data_dir;
#line 467 "../src/client/accounts/accounts-manager.vala"
				_data_->_tmp23_ = _data_->id;
#line 467 "../src/client/accounts/accounts-manager.vala"
				_data_->_tmp24_ = g_file_get_child (_data_->_tmp22_, _data_->_tmp23_);
#line 467 "../src/client/accounts/accounts-manager.vala"
				_data_->_tmp25_ = _data_->_tmp24_;
#line 467 "../src/client/accounts/accounts-manager.vala"
				_data_->_state_ = 2;
#line 467 "../src/client/accounts/accounts-manager.vala"
				geary_files_query_exists_async (_data_->_tmp25_, _data_->cancellable, accounts_manager_next_id_ready, _data_);
#line 467 "../src/client/accounts/accounts-manager.vala"
				return FALSE;
#line 5096 "accounts-manager.c"
				_state_2:
#line 467 "../src/client/accounts/accounts-manager.vala"
				_data_->_tmp26_ = geary_files_query_exists_finish (_data_->_res_, &_data_->_inner_error_);
#line 467 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->_tmp25_);
#line 467 "../src/client/accounts/accounts-manager.vala"
				_data_->_tmp21_ = _data_->_tmp26_;
#line 467 "../src/client/accounts/accounts-manager.vala"
				if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 5106 "accounts-manager.c"
					goto __catch86_g_error;
				}
#line 467 "../src/client/accounts/accounts-manager.vala"
				_data_->_tmp14_ = _data_->_tmp21_;
#line 5111 "accounts-manager.c"
			}
#line 465 "../src/client/accounts/accounts-manager.vala"
			if (!_data_->_tmp14_) {
#line 465 "../src/client/accounts/accounts-manager.vala"
				break;
#line 5117 "accounts-manager.c"
			}
#line 469 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp27_ = _data_->next_id;
#line 469 "../src/client/accounts/accounts-manager.vala"
			_data_->next_id = _data_->_tmp27_ + 1;
#line 470 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp28_ = _data_->next_id;
#line 470 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp29_ = g_strdup_printf (ACCOUNTS_MANAGER_LOCAL_ID_FORMAT, _data_->_tmp28_);
#line 470 "../src/client/accounts/accounts-manager.vala"
			_g_free0 (_data_->id);
#line 470 "../src/client/accounts/accounts-manager.vala"
			_data_->id = _data_->_tmp29_;
#line 5131 "accounts-manager.c"
		}
	}
	goto __finally86;
	__catch86_g_error:
	{
#line 464 "../src/client/accounts/accounts-manager.vala"
		_data_->err = _data_->_inner_error_;
#line 464 "../src/client/accounts/accounts-manager.vala"
		_data_->_inner_error_ = NULL;
#line 474 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp30_ = _data_->err;
#line 474 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp31_ = _data_->_tmp30_->message;
#line 474 "../src/client/accounts/accounts-manager.vala"
		g_debug ("accounts-manager.vala:474: Error checking for a free id on disk: %s", _data_->_tmp31_);
#line 464 "../src/client/accounts/accounts-manager.vala"
		_g_error_free0 (_data_->err);
#line 5149 "accounts-manager.c"
	}
	__finally86:
#line 464 "../src/client/accounts/accounts-manager.vala"
	if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 464 "../src/client/accounts/accounts-manager.vala"
		_g_free0 (_data_->id);
#line 464 "../src/client/accounts/accounts-manager.vala"
		_g_free0 (_data_->last_account);
#line 464 "../src/client/accounts/accounts-manager.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error_->message, g_quark_to_string (_data_->_inner_error_->domain), _data_->_inner_error_->code);
#line 464 "../src/client/accounts/accounts-manager.vala"
		g_clear_error (&_data_->_inner_error_);
#line 464 "../src/client/accounts/accounts-manager.vala"
		g_object_unref (_data_->_async_result);
#line 464 "../src/client/accounts/accounts-manager.vala"
		return FALSE;
#line 5166 "accounts-manager.c"
	}
#line 477 "../src/client/accounts/accounts-manager.vala"
	_data_->result = _data_->id;
#line 477 "../src/client/accounts/accounts-manager.vala"
	_g_free0 (_data_->last_account);
#line 477 "../src/client/accounts/accounts-manager.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 477 "../src/client/accounts/accounts-manager.vala"
	if (_data_->_state_ != 0) {
#line 477 "../src/client/accounts/accounts-manager.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 477 "../src/client/accounts/accounts-manager.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 5180 "accounts-manager.c"
		}
	}
#line 477 "../src/client/accounts/accounts-manager.vala"
	g_object_unref (_data_->_async_result);
#line 477 "../src/client/accounts/accounts-manager.vala"
	return FALSE;
#line 5187 "accounts-manager.c"
}


static void
accounts_manager_load_account_data_free (gpointer _data)
{
	AccountsManagerLoadAccountData* _data_;
	_data_ = _data;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_free0 (_data_->id);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->cancellable);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->result);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->self);
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_slice_free (AccountsManagerLoadAccountData, _data_);
#line 5206 "accounts-manager.c"
}


static void
accounts_manager_load_account (AccountsManager* self,
                               const gchar* id,
                               GCancellable* cancellable,
                               GAsyncReadyCallback _callback_,
                               gpointer _user_data_)
{
	AccountsManagerLoadAccountData* _data_;
	AccountsManager* _tmp0_;
	gchar* _tmp1_;
	GCancellable* _tmp2_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_ = g_slice_new0 (AccountsManagerLoadAccountData);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_task_set_task_data (_data_->_async_result, _data_, accounts_manager_load_account_data_free);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->self = _tmp0_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_tmp1_ = g_strdup (id);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_free0 (_data_->id);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->id = _tmp1_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_tmp2_ = _g_object_ref0 (cancellable);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->cancellable);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->cancellable = _tmp2_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_load_account_co (_data_);
#line 5245 "accounts-manager.c"
}


static GearyAccountInformation*
accounts_manager_load_account_finish (AccountsManager* self,
                                      GAsyncResult* _res_,
                                      GError** error)
{
	GearyAccountInformation* result;
	AccountsManagerLoadAccountData* _data_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 24 "../src/client/accounts/accounts-manager.vala"
	if (NULL == _data_) {
#line 24 "../src/client/accounts/accounts-manager.vala"
		return NULL;
#line 5262 "accounts-manager.c"
	}
#line 24 "../src/client/accounts/accounts-manager.vala"
	result = _data_->result;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->result = NULL;
#line 24 "../src/client/accounts/accounts-manager.vala"
	return result;
#line 5270 "accounts-manager.c"
}


/**
     * Loads an account info from a config directory.
     *
     * Throws an error if the config file was not found, could not be
     * parsed, or doesn't have all required fields.
     */
static void
accounts_manager_load_account_ready (GObject* source_object,
                                     GAsyncResult* _res_,
                                     gpointer _user_data_)
{
	AccountsManagerLoadAccountData* _data_;
#line 497 "../src/client/accounts/accounts-manager.vala"
	_data_ = _user_data_;
#line 497 "../src/client/accounts/accounts-manager.vala"
	_data_->_source_object_ = source_object;
#line 497 "../src/client/accounts/accounts-manager.vala"
	_data_->_res_ = _res_;
#line 497 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_load_account_co (_data_);
#line 5294 "accounts-manager.c"
}


static GearyServiceProvider*
_geary_service_provider_dup (GearyServiceProvider* self)
{
	GearyServiceProvider* dup;
#line 541 "../src/client/accounts/accounts-manager.vala"
	dup = g_new0 (GearyServiceProvider, 1);
#line 541 "../src/client/accounts/accounts-manager.vala"
	memcpy (dup, self, sizeof (GearyServiceProvider));
#line 541 "../src/client/accounts/accounts-manager.vala"
	return dup;
#line 5308 "accounts-manager.c"
}


static gpointer
__geary_service_provider_dup0 (gpointer self)
{
#line 541 "../src/client/accounts/accounts-manager.vala"
	return self ? _geary_service_provider_dup (self) : NULL;
#line 5317 "accounts-manager.c"
}


static gboolean
accounts_manager_load_account_co (AccountsManagerLoadAccountData* _data_)
{
#line 486 "../src/client/accounts/accounts-manager.vala"
	switch (_data_->_state_) {
#line 486 "../src/client/accounts/accounts-manager.vala"
		case 0:
#line 5328 "accounts-manager.c"
		goto _state_0;
#line 486 "../src/client/accounts/accounts-manager.vala"
		case 1:
#line 5332 "accounts-manager.c"
		goto _state_1;
#line 486 "../src/client/accounts/accounts-manager.vala"
		case 2:
#line 5336 "accounts-manager.c"
		goto _state_2;
		default:
#line 486 "../src/client/accounts/accounts-manager.vala"
		g_assert_not_reached ();
#line 5341 "accounts-manager.c"
	}
	_state_0:
#line 489 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp0_ = _data_->self->priv->_config_dir;
#line 489 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp1_ = g_file_get_child (_data_->_tmp0_, _data_->id);
#line 489 "../src/client/accounts/accounts-manager.vala"
	_data_->config_dir = _data_->_tmp1_;
#line 490 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp2_ = _data_->self->priv->_data_dir;
#line 490 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp3_ = g_file_get_child (_data_->_tmp2_, _data_->id);
#line 490 "../src/client/accounts/accounts-manager.vala"
	_data_->data_dir = _data_->_tmp3_;
#line 492 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp4_ = _data_->config_dir;
#line 492 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp5_ = g_file_get_child (_data_->_tmp4_, ACCOUNTS_MANAGER_SETTINGS_FILENAME);
#line 492 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp6_ = _data_->_tmp5_;
#line 492 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp7_ = geary_config_file_new (_data_->_tmp6_);
#line 492 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp8_ = _data_->_tmp7_;
#line 492 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->_tmp6_);
#line 492 "../src/client/accounts/accounts-manager.vala"
	_data_->config = _data_->_tmp8_;
#line 5370 "accounts-manager.c"
	{
#line 497 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp9_ = _data_->config;
#line 497 "../src/client/accounts/accounts-manager.vala"
		_data_->_state_ = 1;
#line 497 "../src/client/accounts/accounts-manager.vala"
		geary_config_file_load (_data_->_tmp9_, _data_->cancellable, accounts_manager_load_account_ready, _data_);
#line 497 "../src/client/accounts/accounts-manager.vala"
		return FALSE;
#line 5380 "accounts-manager.c"
		_state_1:
#line 497 "../src/client/accounts/accounts-manager.vala"
		geary_config_file_load_finish (_data_->_tmp9_, _data_->_res_, &_data_->_inner_error_);
#line 497 "../src/client/accounts/accounts-manager.vala"
		if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 497 "../src/client/accounts/accounts-manager.vala"
			if (_data_->_inner_error_->domain == G_KEY_FILE_ERROR) {
#line 5388 "accounts-manager.c"
				goto __catch87_g_key_file_error;
			}
			goto __catch87_g_error;
		}
	}
	goto __finally87;
	__catch87_g_key_file_error:
	{
#line 496 "../src/client/accounts/accounts-manager.vala"
		_data_->err = _data_->_inner_error_;
#line 496 "../src/client/accounts/accounts-manager.vala"
		_data_->_inner_error_ = NULL;
#line 499 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp10_ = _data_->err;
#line 499 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp11_ = _data_->_tmp10_->message;
#line 499 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp12_ = g_error_new_literal (ACCOUNTS_CONFIG_ERROR, ACCOUNTS_CONFIG_ERROR_SYNTAX, _data_->_tmp11_);
#line 499 "../src/client/accounts/accounts-manager.vala"
		_data_->_inner_error_ = _data_->_tmp12_;
#line 499 "../src/client/accounts/accounts-manager.vala"
		_g_error_free0 (_data_->err);
#line 5411 "accounts-manager.c"
		goto __finally87;
	}
	goto __finally87;
	__catch87_g_error:
	{
#line 496 "../src/client/accounts/accounts-manager.vala"
		_data_->_vala1_err = _data_->_inner_error_;
#line 496 "../src/client/accounts/accounts-manager.vala"
		_data_->_inner_error_ = NULL;
#line 501 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp13_ = _data_->_vala1_err;
#line 501 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp14_ = _data_->_tmp13_->message;
#line 501 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp15_ = g_error_new_literal (ACCOUNTS_CONFIG_ERROR, ACCOUNTS_CONFIG_ERROR_IO, _data_->_tmp14_);
#line 501 "../src/client/accounts/accounts-manager.vala"
		_data_->_inner_error_ = _data_->_tmp15_;
#line 501 "../src/client/accounts/accounts-manager.vala"
		_g_error_free0 (_data_->_vala1_err);
#line 5431 "accounts-manager.c"
		goto __finally87;
	}
	__finally87:
#line 496 "../src/client/accounts/accounts-manager.vala"
	if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 496 "../src/client/accounts/accounts-manager.vala"
		if (_data_->_inner_error_->domain == ACCOUNTS_CONFIG_ERROR) {
#line 496 "../src/client/accounts/accounts-manager.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error_);
#line 496 "../src/client/accounts/accounts-manager.vala"
			_geary_config_file_unref0 (_data_->config);
#line 496 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->data_dir);
#line 496 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->config_dir);
#line 496 "../src/client/accounts/accounts-manager.vala"
			g_object_unref (_data_->_async_result);
#line 496 "../src/client/accounts/accounts-manager.vala"
			return FALSE;
#line 5451 "accounts-manager.c"
		} else {
#line 496 "../src/client/accounts/accounts-manager.vala"
			_geary_config_file_unref0 (_data_->config);
#line 496 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->data_dir);
#line 496 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->config_dir);
#line 496 "../src/client/accounts/accounts-manager.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error_->message, g_quark_to_string (_data_->_inner_error_->domain), _data_->_inner_error_->code);
#line 496 "../src/client/accounts/accounts-manager.vala"
			g_clear_error (&_data_->_inner_error_);
#line 496 "../src/client/accounts/accounts-manager.vala"
			g_object_unref (_data_->_async_result);
#line 496 "../src/client/accounts/accounts-manager.vala"
			return FALSE;
#line 5467 "accounts-manager.c"
		}
	}
#line 504 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp16_ = _data_->config;
#line 504 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp17_ = geary_config_file_get_group (_data_->_tmp16_, ACCOUNTS_MANAGER_GROUP_METADATA);
#line 504 "../src/client/accounts/accounts-manager.vala"
	_data_->metadata_config = _data_->_tmp17_;
#line 506 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp18_ = _data_->metadata_config;
#line 506 "../src/client/accounts/accounts-manager.vala"
	_data_->version = geary_config_file_group_get_int (_data_->_tmp18_, ACCOUNTS_MANAGER_METADATA_VERSION, 0);
#line 507 "../src/client/accounts/accounts-manager.vala"
	_data_->status = ACCOUNTS_MANAGER_STATUS_ENABLED;
#line 5482 "accounts-manager.c"
	{
#line 509 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp20_ = _data_->metadata_config;
#line 509 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp21_ = _data_->status;
#line 509 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp22_ = accounts_manager_status_to_value (_data_->_tmp21_);
#line 509 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp23_ = _data_->_tmp22_;
#line 509 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp24_ = geary_config_file_group_get_string (_data_->_tmp20_, ACCOUNTS_MANAGER_METADATA_STATUS, _data_->_tmp23_);
#line 509 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp25_ = _data_->_tmp24_;
#line 509 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp26_ = accounts_manager_status_for_value (_data_->_tmp25_, &_data_->_inner_error_);
#line 509 "../src/client/accounts/accounts-manager.vala"
		_g_free0 (_data_->_tmp25_);
#line 509 "../src/client/accounts/accounts-manager.vala"
		_g_free0 (_data_->_tmp23_);
#line 509 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp19_ = _data_->_tmp26_;
#line 509 "../src/client/accounts/accounts-manager.vala"
		if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 509 "../src/client/accounts/accounts-manager.vala"
			if (_data_->_inner_error_->domain == GEARY_ENGINE_ERROR) {
#line 5508 "accounts-manager.c"
				goto __catch88_geary_engine_error;
			}
#line 509 "../src/client/accounts/accounts-manager.vala"
			_geary_config_file_group_unref0 (_data_->metadata_config);
#line 509 "../src/client/accounts/accounts-manager.vala"
			_geary_config_file_unref0 (_data_->config);
#line 509 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->data_dir);
#line 509 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->config_dir);
#line 509 "../src/client/accounts/accounts-manager.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error_->message, g_quark_to_string (_data_->_inner_error_->domain), _data_->_inner_error_->code);
#line 509 "../src/client/accounts/accounts-manager.vala"
			g_clear_error (&_data_->_inner_error_);
#line 509 "../src/client/accounts/accounts-manager.vala"
			g_object_unref (_data_->_async_result);
#line 509 "../src/client/accounts/accounts-manager.vala"
			return FALSE;
#line 5527 "accounts-manager.c"
		}
#line 509 "../src/client/accounts/accounts-manager.vala"
		_data_->status = _data_->_tmp19_;
#line 5531 "accounts-manager.c"
	}
	goto __finally88;
	__catch88_geary_engine_error:
	{
#line 508 "../src/client/accounts/accounts-manager.vala"
		_data_->_vala2_err = _data_->_inner_error_;
#line 508 "../src/client/accounts/accounts-manager.vala"
		_data_->_inner_error_ = NULL;
#line 514 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp27_ = g_error_new (ACCOUNTS_CONFIG_ERROR, ACCOUNTS_CONFIG_ERROR_SYNTAX, "%s: Invalid status value", _data_->id);
#line 514 "../src/client/accounts/accounts-manager.vala"
		_data_->_inner_error_ = _data_->_tmp27_;
#line 514 "../src/client/accounts/accounts-manager.vala"
		_g_error_free0 (_data_->_vala2_err);
#line 5546 "accounts-manager.c"
		goto __finally88;
	}
	__finally88:
#line 508 "../src/client/accounts/accounts-manager.vala"
	if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 508 "../src/client/accounts/accounts-manager.vala"
		if (_data_->_inner_error_->domain == ACCOUNTS_CONFIG_ERROR) {
#line 508 "../src/client/accounts/accounts-manager.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error_);
#line 508 "../src/client/accounts/accounts-manager.vala"
			_geary_config_file_group_unref0 (_data_->metadata_config);
#line 508 "../src/client/accounts/accounts-manager.vala"
			_geary_config_file_unref0 (_data_->config);
#line 508 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->data_dir);
#line 508 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->config_dir);
#line 508 "../src/client/accounts/accounts-manager.vala"
			g_object_unref (_data_->_async_result);
#line 508 "../src/client/accounts/accounts-manager.vala"
			return FALSE;
#line 5568 "accounts-manager.c"
		} else {
#line 508 "../src/client/accounts/accounts-manager.vala"
			_geary_config_file_group_unref0 (_data_->metadata_config);
#line 508 "../src/client/accounts/accounts-manager.vala"
			_geary_config_file_unref0 (_data_->config);
#line 508 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->data_dir);
#line 508 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->config_dir);
#line 508 "../src/client/accounts/accounts-manager.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error_->message, g_quark_to_string (_data_->_inner_error_->domain), _data_->_inner_error_->code);
#line 508 "../src/client/accounts/accounts-manager.vala"
			g_clear_error (&_data_->_inner_error_);
#line 508 "../src/client/accounts/accounts-manager.vala"
			g_object_unref (_data_->_async_result);
#line 508 "../src/client/accounts/accounts-manager.vala"
			return FALSE;
#line 5586 "accounts-manager.c"
		}
	}
#line 517 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp28_ = _data_->metadata_config;
#line 517 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp29_ = geary_config_file_group_get_string (_data_->_tmp28_, ACCOUNTS_MANAGER_METADATA_GOA, NULL);
#line 517 "../src/client/accounts/accounts-manager.vala"
	_data_->goa_id = _data_->_tmp29_;
#line 518 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp30_ = _data_->goa_id;
#line 518 "../src/client/accounts/accounts-manager.vala"
	_data_->is_goa = _data_->_tmp30_ != NULL;
#line 523 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp32_ = _data_->goa_id;
#line 523 "../src/client/accounts/accounts-manager.vala"
	if (_data_->_tmp32_ == NULL) {
#line 523 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp31_ = g_str_has_prefix (_data_->id, ACCOUNTS_MANAGER_GOA_ID_PREFIX);
#line 5605 "accounts-manager.c"
	} else {
#line 523 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp31_ = FALSE;
#line 5609 "accounts-manager.c"
	}
#line 523 "../src/client/accounts/accounts-manager.vala"
	if (_data_->_tmp31_) {
#line 524 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp33_ = accounts_manager_to_goa_id (_data_->self, _data_->id);
#line 524 "../src/client/accounts/accounts-manager.vala"
		_g_free0 (_data_->goa_id);
#line 524 "../src/client/accounts/accounts-manager.vala"
		_data_->goa_id = _data_->_tmp33_;
#line 525 "../src/client/accounts/accounts-manager.vala"
		_data_->is_goa = TRUE;
#line 5621 "accounts-manager.c"
	}
#line 528 "../src/client/accounts/accounts-manager.vala"
	_data_->goa_handle = NULL;
#line 529 "../src/client/accounts/accounts-manager.vala"
	_data_->goa_mediator = NULL;
#line 530 "../src/client/accounts/accounts-manager.vala"
	_data_->default_provider = NULL;
#line 531 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp34_ = _data_->self->priv->local_mediator;
#line 531 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp35_ = _g_object_ref0 (_data_->_tmp34_);
#line 531 "../src/client/accounts/accounts-manager.vala"
	_data_->mediator = _data_->_tmp35_;
#line 533 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp36_ = _data_->is_goa;
#line 533 "../src/client/accounts/accounts-manager.vala"
	if (_data_->_tmp36_) {
#line 534 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp37_ = _data_->self->priv->goa_service;
#line 534 "../src/client/accounts/accounts-manager.vala"
		if (_data_->_tmp37_ == NULL) {
#line 535 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp38_ = g_error_new_literal (ACCOUNTS_CONFIG_ERROR, ACCOUNTS_CONFIG_ERROR_MANAGEMENT, "GOA service not available");
#line 535 "../src/client/accounts/accounts-manager.vala"
			_data_->_inner_error_ = _data_->_tmp38_;
#line 535 "../src/client/accounts/accounts-manager.vala"
			if (_data_->_inner_error_->domain == ACCOUNTS_CONFIG_ERROR) {
#line 535 "../src/client/accounts/accounts-manager.vala"
				g_task_return_error (_data_->_async_result, _data_->_inner_error_);
#line 535 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->mediator);
#line 535 "../src/client/accounts/accounts-manager.vala"
				_g_free0 (_data_->default_provider);
#line 535 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->goa_mediator);
#line 535 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->goa_handle);
#line 535 "../src/client/accounts/accounts-manager.vala"
				_g_free0 (_data_->goa_id);
#line 535 "../src/client/accounts/accounts-manager.vala"
				_geary_config_file_group_unref0 (_data_->metadata_config);
#line 535 "../src/client/accounts/accounts-manager.vala"
				_geary_config_file_unref0 (_data_->config);
#line 535 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->data_dir);
#line 535 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->config_dir);
#line 535 "../src/client/accounts/accounts-manager.vala"
				g_object_unref (_data_->_async_result);
#line 535 "../src/client/accounts/accounts-manager.vala"
				return FALSE;
#line 5673 "accounts-manager.c"
			} else {
#line 535 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->mediator);
#line 535 "../src/client/accounts/accounts-manager.vala"
				_g_free0 (_data_->default_provider);
#line 535 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->goa_mediator);
#line 535 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->goa_handle);
#line 535 "../src/client/accounts/accounts-manager.vala"
				_g_free0 (_data_->goa_id);
#line 535 "../src/client/accounts/accounts-manager.vala"
				_geary_config_file_group_unref0 (_data_->metadata_config);
#line 535 "../src/client/accounts/accounts-manager.vala"
				_geary_config_file_unref0 (_data_->config);
#line 535 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->data_dir);
#line 535 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->config_dir);
#line 535 "../src/client/accounts/accounts-manager.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error_->message, g_quark_to_string (_data_->_inner_error_->domain), _data_->_inner_error_->code);
#line 535 "../src/client/accounts/accounts-manager.vala"
				g_clear_error (&_data_->_inner_error_);
#line 535 "../src/client/accounts/accounts-manager.vala"
				g_object_unref (_data_->_async_result);
#line 535 "../src/client/accounts/accounts-manager.vala"
				return FALSE;
#line 5701 "accounts-manager.c"
			}
		}
#line 538 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp39_ = _data_->self->priv->goa_service;
#line 538 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp40_ = _data_->goa_id;
#line 538 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp41_ = goa_client_lookup_by_id (_data_->_tmp39_, _data_->_tmp40_);
#line 538 "../src/client/accounts/accounts-manager.vala"
		_g_object_unref0 (_data_->goa_handle);
#line 538 "../src/client/accounts/accounts-manager.vala"
		_data_->goa_handle = _data_->_tmp41_;
#line 539 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp42_ = _data_->goa_handle;
#line 539 "../src/client/accounts/accounts-manager.vala"
		if (_data_->_tmp42_ != NULL) {
#line 540 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp43_ = _data_->goa_handle;
#line 540 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp44_ = goa_mediator_new (_data_->_tmp43_);
#line 540 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->goa_mediator);
#line 540 "../src/client/accounts/accounts-manager.vala"
			_data_->goa_mediator = _data_->_tmp44_;
#line 540 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp45_ = _data_->goa_mediator;
#line 540 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp46_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp45_, GEARY_TYPE_CREDENTIALS_MEDIATOR, GearyCredentialsMediator));
#line 540 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->mediator);
#line 540 "../src/client/accounts/accounts-manager.vala"
			_data_->mediator = _data_->_tmp46_;
#line 541 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp47_ = _data_->goa_mediator;
#line 541 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp48_ = goa_mediator_get_service_provider (_data_->_tmp47_);
#line 541 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp49_ = __geary_service_provider_dup0 (&_data_->_tmp48_);
#line 541 "../src/client/accounts/accounts-manager.vala"
			_g_free0 (_data_->default_provider);
#line 541 "../src/client/accounts/accounts-manager.vala"
			_data_->default_provider = _data_->_tmp49_;
#line 5744 "accounts-manager.c"
		} else {
#line 545 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp50_ = _data_->goa_id;
#line 545 "../src/client/accounts/accounts-manager.vala"
			g_info ("accounts-manager.vala:545: %s: GOA account %s has been removed, removi" \
"ng local data", _data_->id, _data_->_tmp50_);
#line 549 "../src/client/accounts/accounts-manager.vala"
			_data_->status = ACCOUNTS_MANAGER_STATUS_REMOVED;
#line 553 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp51_ = GEARY_SERVICE_PROVIDER_OTHER;
#line 553 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp52_ = __geary_service_provider_dup0 (&_data_->_tmp51_);
#line 553 "../src/client/accounts/accounts-manager.vala"
			_g_free0 (_data_->default_provider);
#line 553 "../src/client/accounts/accounts-manager.vala"
			_data_->default_provider = _data_->_tmp52_;
#line 5760 "accounts-manager.c"
		}
	}
#line 557 "../src/client/accounts/accounts-manager.vala"
	_data_->accounts = NULL;
#line 558 "../src/client/accounts/accounts-manager.vala"
	_data_->services = NULL;
#line 559 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp53_ = _data_->version;
#line 559 "../src/client/accounts/accounts-manager.vala"
	switch (_data_->_tmp53_) {
#line 559 "../src/client/accounts/accounts-manager.vala"
		case 0:
#line 5773 "accounts-manager.c"
		{
#line 561 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp54_ = accounts_account_config_legacy_new ();
#line 561 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->accounts);
#line 561 "../src/client/accounts/accounts-manager.vala"
			_data_->accounts = G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp54_, ACCOUNTS_TYPE_ACCOUNT_CONFIG, AccountsAccountConfig);
#line 562 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp55_ = accounts_service_config_legacy_new ();
#line 562 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->services);
#line 562 "../src/client/accounts/accounts-manager.vala"
			_data_->services = G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp55_, ACCOUNTS_TYPE_SERVICE_CONFIG, AccountsServiceConfig);
#line 563 "../src/client/accounts/accounts-manager.vala"
			break;
#line 5789 "accounts-manager.c"
		}
#line 559 "../src/client/accounts/accounts-manager.vala"
		case 1:
#line 5793 "accounts-manager.c"
		{
#line 566 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp56_ = _data_->is_goa;
#line 566 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp57_ = accounts_account_config_v1_new (_data_->_tmp56_);
#line 566 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->accounts);
#line 566 "../src/client/accounts/accounts-manager.vala"
			_data_->accounts = G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp57_, ACCOUNTS_TYPE_ACCOUNT_CONFIG, AccountsAccountConfig);
#line 567 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp58_ = accounts_service_config_v1_new ();
#line 567 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->services);
#line 567 "../src/client/accounts/accounts-manager.vala"
			_data_->services = G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp58_, ACCOUNTS_TYPE_SERVICE_CONFIG, AccountsServiceConfig);
#line 568 "../src/client/accounts/accounts-manager.vala"
			break;
#line 5811 "accounts-manager.c"
		}
		default:
		{
#line 571 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp59_ = _data_->version;
#line 571 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp60_ = g_error_new (ACCOUNTS_CONFIG_ERROR, ACCOUNTS_CONFIG_ERROR_VERSION, "Unsupported config version: %d", _data_->_tmp59_);
#line 571 "../src/client/accounts/accounts-manager.vala"
			_data_->_inner_error_ = _data_->_tmp60_;
#line 571 "../src/client/accounts/accounts-manager.vala"
			if (_data_->_inner_error_->domain == ACCOUNTS_CONFIG_ERROR) {
#line 571 "../src/client/accounts/accounts-manager.vala"
				g_task_return_error (_data_->_async_result, _data_->_inner_error_);
#line 571 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->services);
#line 571 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->accounts);
#line 571 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->mediator);
#line 571 "../src/client/accounts/accounts-manager.vala"
				_g_free0 (_data_->default_provider);
#line 571 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->goa_mediator);
#line 571 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->goa_handle);
#line 571 "../src/client/accounts/accounts-manager.vala"
				_g_free0 (_data_->goa_id);
#line 571 "../src/client/accounts/accounts-manager.vala"
				_geary_config_file_group_unref0 (_data_->metadata_config);
#line 571 "../src/client/accounts/accounts-manager.vala"
				_geary_config_file_unref0 (_data_->config);
#line 571 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->data_dir);
#line 571 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->config_dir);
#line 571 "../src/client/accounts/accounts-manager.vala"
				g_object_unref (_data_->_async_result);
#line 571 "../src/client/accounts/accounts-manager.vala"
				return FALSE;
#line 5851 "accounts-manager.c"
			} else {
#line 571 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->services);
#line 571 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->accounts);
#line 571 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->mediator);
#line 571 "../src/client/accounts/accounts-manager.vala"
				_g_free0 (_data_->default_provider);
#line 571 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->goa_mediator);
#line 571 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->goa_handle);
#line 571 "../src/client/accounts/accounts-manager.vala"
				_g_free0 (_data_->goa_id);
#line 571 "../src/client/accounts/accounts-manager.vala"
				_geary_config_file_group_unref0 (_data_->metadata_config);
#line 571 "../src/client/accounts/accounts-manager.vala"
				_geary_config_file_unref0 (_data_->config);
#line 571 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->data_dir);
#line 571 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->config_dir);
#line 571 "../src/client/accounts/accounts-manager.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error_->message, g_quark_to_string (_data_->_inner_error_->domain), _data_->_inner_error_->code);
#line 571 "../src/client/accounts/accounts-manager.vala"
				g_clear_error (&_data_->_inner_error_);
#line 571 "../src/client/accounts/accounts-manager.vala"
				g_object_unref (_data_->_async_result);
#line 571 "../src/client/accounts/accounts-manager.vala"
				return FALSE;
#line 5883 "accounts-manager.c"
			}
		}
	}
#line 576 "../src/client/accounts/accounts-manager.vala"
	_data_->account = NULL;
#line 5889 "accounts-manager.c"
	{
#line 578 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp62_ = _data_->accounts;
#line 578 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp63_ = _data_->config;
#line 578 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp64_ = _data_->mediator;
#line 578 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp65_ = _data_->default_provider;
#line 578 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp66_ = accounts_manager_get_account_name (_data_->self);
#line 578 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp67_ = _data_->_tmp66_;
#line 578 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp68_ = accounts_account_config_load (_data_->_tmp62_, _data_->_tmp63_, _data_->id, _data_->_tmp64_, _data_->_tmp65_, _data_->_tmp67_, &_data_->_inner_error_);
#line 578 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp69_ = _data_->_tmp68_;
#line 578 "../src/client/accounts/accounts-manager.vala"
		_g_free0 (_data_->_tmp67_);
#line 578 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp61_ = _data_->_tmp69_;
#line 578 "../src/client/accounts/accounts-manager.vala"
		if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 578 "../src/client/accounts/accounts-manager.vala"
			if (_data_->_inner_error_->domain == G_KEY_FILE_ERROR) {
#line 5915 "accounts-manager.c"
				goto __catch89_g_key_file_error;
			}
			goto __finally89;
		}
#line 578 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp70_ = _data_->_tmp61_;
#line 578 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp61_ = NULL;
#line 578 "../src/client/accounts/accounts-manager.vala"
		_g_object_unref0 (_data_->account);
#line 578 "../src/client/accounts/accounts-manager.vala"
		_data_->account = _data_->_tmp70_;
#line 585 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp71_ = _data_->account;
#line 585 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp72_ = _data_->config_dir;
#line 585 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp73_ = _data_->data_dir;
#line 585 "../src/client/accounts/accounts-manager.vala"
		geary_account_information_set_account_directories (_data_->_tmp71_, _data_->_tmp72_, _data_->_tmp73_);
#line 577 "../src/client/accounts/accounts-manager.vala"
		_g_object_unref0 (_data_->_tmp61_);
#line 5938 "accounts-manager.c"
	}
	goto __finally89;
	__catch89_g_key_file_error:
	{
#line 577 "../src/client/accounts/accounts-manager.vala"
		_data_->_vala3_err = _data_->_inner_error_;
#line 577 "../src/client/accounts/accounts-manager.vala"
		_data_->_inner_error_ = NULL;
#line 587 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp74_ = _data_->_vala3_err;
#line 587 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp75_ = _data_->_tmp74_->message;
#line 587 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp76_ = g_error_new_literal (ACCOUNTS_CONFIG_ERROR, ACCOUNTS_CONFIG_ERROR_SYNTAX, _data_->_tmp75_);
#line 587 "../src/client/accounts/accounts-manager.vala"
		_data_->_inner_error_ = _data_->_tmp76_;
#line 587 "../src/client/accounts/accounts-manager.vala"
		_g_error_free0 (_data_->_vala3_err);
#line 5957 "accounts-manager.c"
		goto __finally89;
	}
	__finally89:
#line 577 "../src/client/accounts/accounts-manager.vala"
	if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 577 "../src/client/accounts/accounts-manager.vala"
		if (_data_->_inner_error_->domain == ACCOUNTS_CONFIG_ERROR) {
#line 577 "../src/client/accounts/accounts-manager.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error_);
#line 577 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->account);
#line 577 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->services);
#line 577 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->accounts);
#line 577 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->mediator);
#line 577 "../src/client/accounts/accounts-manager.vala"
			_g_free0 (_data_->default_provider);
#line 577 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->goa_mediator);
#line 577 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->goa_handle);
#line 577 "../src/client/accounts/accounts-manager.vala"
			_g_free0 (_data_->goa_id);
#line 577 "../src/client/accounts/accounts-manager.vala"
			_geary_config_file_group_unref0 (_data_->metadata_config);
#line 577 "../src/client/accounts/accounts-manager.vala"
			_geary_config_file_unref0 (_data_->config);
#line 577 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->data_dir);
#line 577 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->config_dir);
#line 577 "../src/client/accounts/accounts-manager.vala"
			g_object_unref (_data_->_async_result);
#line 577 "../src/client/accounts/accounts-manager.vala"
			return FALSE;
#line 5995 "accounts-manager.c"
		} else {
#line 577 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->account);
#line 577 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->services);
#line 577 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->accounts);
#line 577 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->mediator);
#line 577 "../src/client/accounts/accounts-manager.vala"
			_g_free0 (_data_->default_provider);
#line 577 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->goa_mediator);
#line 577 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->goa_handle);
#line 577 "../src/client/accounts/accounts-manager.vala"
			_g_free0 (_data_->goa_id);
#line 577 "../src/client/accounts/accounts-manager.vala"
			_geary_config_file_group_unref0 (_data_->metadata_config);
#line 577 "../src/client/accounts/accounts-manager.vala"
			_geary_config_file_unref0 (_data_->config);
#line 577 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->data_dir);
#line 577 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->config_dir);
#line 577 "../src/client/accounts/accounts-manager.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error_->message, g_quark_to_string (_data_->_inner_error_->domain), _data_->_inner_error_->code);
#line 577 "../src/client/accounts/accounts-manager.vala"
			g_clear_error (&_data_->_inner_error_);
#line 577 "../src/client/accounts/accounts-manager.vala"
			g_object_unref (_data_->_async_result);
#line 577 "../src/client/accounts/accounts-manager.vala"
			return FALSE;
#line 6029 "accounts-manager.c"
		}
	}
#line 593 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp77_ = _data_->status;
#line 593 "../src/client/accounts/accounts-manager.vala"
	if (_data_->_tmp77_ == ACCOUNTS_MANAGER_STATUS_REMOVED) {
#line 594 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp78_ = _data_->self->priv->removed;
#line 594 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp79_ = _data_->account;
#line 594 "../src/client/accounts/accounts-manager.vala"
		gee_abstract_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp78_, GEE_TYPE_ABSTRACT_COLLECTION, GeeAbstractCollection), _data_->_tmp79_);
#line 595 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp80_ = g_error_new_literal (ACCOUNTS_CONFIG_ERROR, ACCOUNTS_CONFIG_ERROR_REMOVED, "Account marked for removal");
#line 595 "../src/client/accounts/accounts-manager.vala"
		_data_->_inner_error_ = _data_->_tmp80_;
#line 595 "../src/client/accounts/accounts-manager.vala"
		if (_data_->_inner_error_->domain == ACCOUNTS_CONFIG_ERROR) {
#line 595 "../src/client/accounts/accounts-manager.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error_);
#line 595 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->account);
#line 595 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->services);
#line 595 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->accounts);
#line 595 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->mediator);
#line 595 "../src/client/accounts/accounts-manager.vala"
			_g_free0 (_data_->default_provider);
#line 595 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->goa_mediator);
#line 595 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->goa_handle);
#line 595 "../src/client/accounts/accounts-manager.vala"
			_g_free0 (_data_->goa_id);
#line 595 "../src/client/accounts/accounts-manager.vala"
			_geary_config_file_group_unref0 (_data_->metadata_config);
#line 595 "../src/client/accounts/accounts-manager.vala"
			_geary_config_file_unref0 (_data_->config);
#line 595 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->data_dir);
#line 595 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->config_dir);
#line 595 "../src/client/accounts/accounts-manager.vala"
			g_object_unref (_data_->_async_result);
#line 595 "../src/client/accounts/accounts-manager.vala"
			return FALSE;
#line 6078 "accounts-manager.c"
		} else {
#line 595 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->account);
#line 595 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->services);
#line 595 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->accounts);
#line 595 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->mediator);
#line 595 "../src/client/accounts/accounts-manager.vala"
			_g_free0 (_data_->default_provider);
#line 595 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->goa_mediator);
#line 595 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->goa_handle);
#line 595 "../src/client/accounts/accounts-manager.vala"
			_g_free0 (_data_->goa_id);
#line 595 "../src/client/accounts/accounts-manager.vala"
			_geary_config_file_group_unref0 (_data_->metadata_config);
#line 595 "../src/client/accounts/accounts-manager.vala"
			_geary_config_file_unref0 (_data_->config);
#line 595 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->data_dir);
#line 595 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->config_dir);
#line 595 "../src/client/accounts/accounts-manager.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error_->message, g_quark_to_string (_data_->_inner_error_->domain), _data_->_inner_error_->code);
#line 595 "../src/client/accounts/accounts-manager.vala"
			g_clear_error (&_data_->_inner_error_);
#line 595 "../src/client/accounts/accounts-manager.vala"
			g_object_unref (_data_->_async_result);
#line 595 "../src/client/accounts/accounts-manager.vala"
			return FALSE;
#line 6112 "accounts-manager.c"
		}
	}
#line 598 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp81_ = _data_->is_goa;
#line 598 "../src/client/accounts/accounts-manager.vala"
	if (!_data_->_tmp81_) {
#line 6119 "accounts-manager.c"
		{
#line 600 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp82_ = _data_->services;
#line 600 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp83_ = _data_->config;
#line 600 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp84_ = _data_->account;
#line 600 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp85_ = _data_->account;
#line 600 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp86_ = geary_account_information_get_incoming (_data_->_tmp85_);
#line 600 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp87_ = _data_->_tmp86_;
#line 600 "../src/client/accounts/accounts-manager.vala"
			accounts_service_config_load (_data_->_tmp82_, _data_->_tmp83_, _data_->_tmp84_, _data_->_tmp87_, &_data_->_inner_error_);
#line 600 "../src/client/accounts/accounts-manager.vala"
			if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 600 "../src/client/accounts/accounts-manager.vala"
				if (_data_->_inner_error_->domain == G_KEY_FILE_ERROR) {
#line 6139 "accounts-manager.c"
					goto __catch90_g_key_file_error;
				}
				goto __finally90;
			}
#line 601 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp88_ = _data_->services;
#line 601 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp89_ = _data_->config;
#line 601 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp90_ = _data_->account;
#line 601 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp91_ = _data_->account;
#line 601 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp92_ = geary_account_information_get_outgoing (_data_->_tmp91_);
#line 601 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp93_ = _data_->_tmp92_;
#line 601 "../src/client/accounts/accounts-manager.vala"
			accounts_service_config_load (_data_->_tmp88_, _data_->_tmp89_, _data_->_tmp90_, _data_->_tmp93_, &_data_->_inner_error_);
#line 601 "../src/client/accounts/accounts-manager.vala"
			if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 601 "../src/client/accounts/accounts-manager.vala"
				if (_data_->_inner_error_->domain == G_KEY_FILE_ERROR) {
#line 6162 "accounts-manager.c"
					goto __catch90_g_key_file_error;
				}
				goto __finally90;
			}
		}
		goto __finally90;
		__catch90_g_key_file_error:
		{
#line 599 "../src/client/accounts/accounts-manager.vala"
			_data_->_vala4_err = _data_->_inner_error_;
#line 599 "../src/client/accounts/accounts-manager.vala"
			_data_->_inner_error_ = NULL;
#line 603 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp94_ = _data_->_vala4_err;
#line 603 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp95_ = _data_->_tmp94_->message;
#line 603 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp96_ = g_error_new_literal (ACCOUNTS_CONFIG_ERROR, ACCOUNTS_CONFIG_ERROR_SYNTAX, _data_->_tmp95_);
#line 603 "../src/client/accounts/accounts-manager.vala"
			_data_->_inner_error_ = _data_->_tmp96_;
#line 603 "../src/client/accounts/accounts-manager.vala"
			_g_error_free0 (_data_->_vala4_err);
#line 6185 "accounts-manager.c"
			goto __finally90;
		}
		__finally90:
#line 599 "../src/client/accounts/accounts-manager.vala"
		if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 599 "../src/client/accounts/accounts-manager.vala"
			if (_data_->_inner_error_->domain == ACCOUNTS_CONFIG_ERROR) {
#line 599 "../src/client/accounts/accounts-manager.vala"
				g_task_return_error (_data_->_async_result, _data_->_inner_error_);
#line 599 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->account);
#line 599 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->services);
#line 599 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->accounts);
#line 599 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->mediator);
#line 599 "../src/client/accounts/accounts-manager.vala"
				_g_free0 (_data_->default_provider);
#line 599 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->goa_mediator);
#line 599 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->goa_handle);
#line 599 "../src/client/accounts/accounts-manager.vala"
				_g_free0 (_data_->goa_id);
#line 599 "../src/client/accounts/accounts-manager.vala"
				_geary_config_file_group_unref0 (_data_->metadata_config);
#line 599 "../src/client/accounts/accounts-manager.vala"
				_geary_config_file_unref0 (_data_->config);
#line 599 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->data_dir);
#line 599 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->config_dir);
#line 599 "../src/client/accounts/accounts-manager.vala"
				g_object_unref (_data_->_async_result);
#line 599 "../src/client/accounts/accounts-manager.vala"
				return FALSE;
#line 6223 "accounts-manager.c"
			} else {
#line 599 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->account);
#line 599 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->services);
#line 599 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->accounts);
#line 599 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->mediator);
#line 599 "../src/client/accounts/accounts-manager.vala"
				_g_free0 (_data_->default_provider);
#line 599 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->goa_mediator);
#line 599 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->goa_handle);
#line 599 "../src/client/accounts/accounts-manager.vala"
				_g_free0 (_data_->goa_id);
#line 599 "../src/client/accounts/accounts-manager.vala"
				_geary_config_file_group_unref0 (_data_->metadata_config);
#line 599 "../src/client/accounts/accounts-manager.vala"
				_geary_config_file_unref0 (_data_->config);
#line 599 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->data_dir);
#line 599 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->config_dir);
#line 599 "../src/client/accounts/accounts-manager.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error_->message, g_quark_to_string (_data_->_inner_error_->domain), _data_->_inner_error_->code);
#line 599 "../src/client/accounts/accounts-manager.vala"
				g_clear_error (&_data_->_inner_error_);
#line 599 "../src/client/accounts/accounts-manager.vala"
				g_object_unref (_data_->_async_result);
#line 599 "../src/client/accounts/accounts-manager.vala"
				return FALSE;
#line 6257 "accounts-manager.c"
			}
		}
	} else {
#line 606 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp97_ = _data_->account;
#line 606 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp98_ = _data_->goa_mediator;
#line 606 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp99_ = goa_mediator_get_service_label (_data_->_tmp98_);
#line 606 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp100_ = _data_->_tmp99_;
#line 606 "../src/client/accounts/accounts-manager.vala"
		geary_account_information_set_service_label (_data_->_tmp97_, _data_->_tmp100_);
#line 606 "../src/client/accounts/accounts-manager.vala"
		_g_free0 (_data_->_tmp100_);
#line 6273 "accounts-manager.c"
		{
#line 608 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp101_ = _data_->goa_mediator;
#line 608 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp102_ = _data_->account;
#line 608 "../src/client/accounts/accounts-manager.vala"
			_data_->_state_ = 2;
#line 608 "../src/client/accounts/accounts-manager.vala"
			goa_mediator_update (_data_->_tmp101_, _data_->_tmp102_, _data_->cancellable, accounts_manager_load_account_ready, _data_);
#line 608 "../src/client/accounts/accounts-manager.vala"
			return FALSE;
#line 6285 "accounts-manager.c"
			_state_2:
#line 608 "../src/client/accounts/accounts-manager.vala"
			goa_mediator_update_finish (_data_->_tmp101_, _data_->_res_, &_data_->_inner_error_);
#line 608 "../src/client/accounts/accounts-manager.vala"
			if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 6291 "accounts-manager.c"
				goto __catch91_g_error;
			}
		}
		goto __finally91;
		__catch91_g_error:
		{
#line 607 "../src/client/accounts/accounts-manager.vala"
			_data_->_vala5_err = _data_->_inner_error_;
#line 607 "../src/client/accounts/accounts-manager.vala"
			_data_->_inner_error_ = NULL;
#line 610 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp103_ = _data_->_vala5_err;
#line 610 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp104_ = _data_->_tmp103_->message;
#line 610 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp105_ = g_error_new_literal (ACCOUNTS_CONFIG_ERROR, ACCOUNTS_CONFIG_ERROR_MANAGEMENT, _data_->_tmp104_);
#line 610 "../src/client/accounts/accounts-manager.vala"
			_data_->_inner_error_ = _data_->_tmp105_;
#line 610 "../src/client/accounts/accounts-manager.vala"
			_g_error_free0 (_data_->_vala5_err);
#line 6312 "accounts-manager.c"
			goto __finally91;
		}
		__finally91:
#line 607 "../src/client/accounts/accounts-manager.vala"
		if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 607 "../src/client/accounts/accounts-manager.vala"
			if (_data_->_inner_error_->domain == ACCOUNTS_CONFIG_ERROR) {
#line 607 "../src/client/accounts/accounts-manager.vala"
				g_task_return_error (_data_->_async_result, _data_->_inner_error_);
#line 607 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->account);
#line 607 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->services);
#line 607 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->accounts);
#line 607 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->mediator);
#line 607 "../src/client/accounts/accounts-manager.vala"
				_g_free0 (_data_->default_provider);
#line 607 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->goa_mediator);
#line 607 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->goa_handle);
#line 607 "../src/client/accounts/accounts-manager.vala"
				_g_free0 (_data_->goa_id);
#line 607 "../src/client/accounts/accounts-manager.vala"
				_geary_config_file_group_unref0 (_data_->metadata_config);
#line 607 "../src/client/accounts/accounts-manager.vala"
				_geary_config_file_unref0 (_data_->config);
#line 607 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->data_dir);
#line 607 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->config_dir);
#line 607 "../src/client/accounts/accounts-manager.vala"
				g_object_unref (_data_->_async_result);
#line 607 "../src/client/accounts/accounts-manager.vala"
				return FALSE;
#line 6350 "accounts-manager.c"
			} else {
#line 607 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->account);
#line 607 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->services);
#line 607 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->accounts);
#line 607 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->mediator);
#line 607 "../src/client/accounts/accounts-manager.vala"
				_g_free0 (_data_->default_provider);
#line 607 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->goa_mediator);
#line 607 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->goa_handle);
#line 607 "../src/client/accounts/accounts-manager.vala"
				_g_free0 (_data_->goa_id);
#line 607 "../src/client/accounts/accounts-manager.vala"
				_geary_config_file_group_unref0 (_data_->metadata_config);
#line 607 "../src/client/accounts/accounts-manager.vala"
				_geary_config_file_unref0 (_data_->config);
#line 607 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->data_dir);
#line 607 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->config_dir);
#line 607 "../src/client/accounts/accounts-manager.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error_->message, g_quark_to_string (_data_->_inner_error_->domain), _data_->_inner_error_->code);
#line 607 "../src/client/accounts/accounts-manager.vala"
				g_clear_error (&_data_->_inner_error_);
#line 607 "../src/client/accounts/accounts-manager.vala"
				g_object_unref (_data_->_async_result);
#line 607 "../src/client/accounts/accounts-manager.vala"
				return FALSE;
#line 6384 "accounts-manager.c"
			}
		}
#line 613 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp106_ = _data_->goa_handle;
#line 613 "../src/client/accounts/accounts-manager.vala"
		if (!accounts_manager_is_valid_goa_account (_data_->self, _data_->_tmp106_)) {
#line 618 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp107_ = _data_->account;
#line 618 "../src/client/accounts/accounts-manager.vala"
			accounts_manager_set_available (_data_->self, _data_->_tmp107_, FALSE);
#line 619 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp108_ = g_error_new_literal (ACCOUNTS_CONFIG_ERROR, ACCOUNTS_CONFIG_ERROR_UNAVAILABLE, "GOA Mail service not available");
#line 619 "../src/client/accounts/accounts-manager.vala"
			_data_->_inner_error_ = _data_->_tmp108_;
#line 619 "../src/client/accounts/accounts-manager.vala"
			if (_data_->_inner_error_->domain == ACCOUNTS_CONFIG_ERROR) {
#line 619 "../src/client/accounts/accounts-manager.vala"
				g_task_return_error (_data_->_async_result, _data_->_inner_error_);
#line 619 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->account);
#line 619 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->services);
#line 619 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->accounts);
#line 619 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->mediator);
#line 619 "../src/client/accounts/accounts-manager.vala"
				_g_free0 (_data_->default_provider);
#line 619 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->goa_mediator);
#line 619 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->goa_handle);
#line 619 "../src/client/accounts/accounts-manager.vala"
				_g_free0 (_data_->goa_id);
#line 619 "../src/client/accounts/accounts-manager.vala"
				_geary_config_file_group_unref0 (_data_->metadata_config);
#line 619 "../src/client/accounts/accounts-manager.vala"
				_geary_config_file_unref0 (_data_->config);
#line 619 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->data_dir);
#line 619 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->config_dir);
#line 619 "../src/client/accounts/accounts-manager.vala"
				g_object_unref (_data_->_async_result);
#line 619 "../src/client/accounts/accounts-manager.vala"
				return FALSE;
#line 6431 "accounts-manager.c"
			} else {
#line 619 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->account);
#line 619 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->services);
#line 619 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->accounts);
#line 619 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->mediator);
#line 619 "../src/client/accounts/accounts-manager.vala"
				_g_free0 (_data_->default_provider);
#line 619 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->goa_mediator);
#line 619 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->goa_handle);
#line 619 "../src/client/accounts/accounts-manager.vala"
				_g_free0 (_data_->goa_id);
#line 619 "../src/client/accounts/accounts-manager.vala"
				_geary_config_file_group_unref0 (_data_->metadata_config);
#line 619 "../src/client/accounts/accounts-manager.vala"
				_geary_config_file_unref0 (_data_->config);
#line 619 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->data_dir);
#line 619 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_data_->config_dir);
#line 619 "../src/client/accounts/accounts-manager.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error_->message, g_quark_to_string (_data_->_inner_error_->domain), _data_->_inner_error_->code);
#line 619 "../src/client/accounts/accounts-manager.vala"
				g_clear_error (&_data_->_inner_error_);
#line 619 "../src/client/accounts/accounts-manager.vala"
				g_object_unref (_data_->_async_result);
#line 619 "../src/client/accounts/accounts-manager.vala"
				return FALSE;
#line 6465 "accounts-manager.c"
			}
		}
	}
#line 627 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp109_ = _data_->status;
#line 627 "../src/client/accounts/accounts-manager.vala"
	if (_data_->_tmp109_ == ACCOUNTS_MANAGER_STATUS_DISABLED) {
#line 628 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp110_ = _data_->account;
#line 628 "../src/client/accounts/accounts-manager.vala"
		accounts_manager_set_enabled (_data_->self, _data_->_tmp110_, FALSE);
#line 629 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp111_ = g_error_new_literal (ACCOUNTS_CONFIG_ERROR, ACCOUNTS_CONFIG_ERROR_UNAVAILABLE, "Account disabled");
#line 629 "../src/client/accounts/accounts-manager.vala"
		_data_->_inner_error_ = _data_->_tmp111_;
#line 629 "../src/client/accounts/accounts-manager.vala"
		if (_data_->_inner_error_->domain == ACCOUNTS_CONFIG_ERROR) {
#line 629 "../src/client/accounts/accounts-manager.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error_);
#line 629 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->account);
#line 629 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->services);
#line 629 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->accounts);
#line 629 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->mediator);
#line 629 "../src/client/accounts/accounts-manager.vala"
			_g_free0 (_data_->default_provider);
#line 629 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->goa_mediator);
#line 629 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->goa_handle);
#line 629 "../src/client/accounts/accounts-manager.vala"
			_g_free0 (_data_->goa_id);
#line 629 "../src/client/accounts/accounts-manager.vala"
			_geary_config_file_group_unref0 (_data_->metadata_config);
#line 629 "../src/client/accounts/accounts-manager.vala"
			_geary_config_file_unref0 (_data_->config);
#line 629 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->data_dir);
#line 629 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->config_dir);
#line 629 "../src/client/accounts/accounts-manager.vala"
			g_object_unref (_data_->_async_result);
#line 629 "../src/client/accounts/accounts-manager.vala"
			return FALSE;
#line 6513 "accounts-manager.c"
		} else {
#line 629 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->account);
#line 629 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->services);
#line 629 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->accounts);
#line 629 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->mediator);
#line 629 "../src/client/accounts/accounts-manager.vala"
			_g_free0 (_data_->default_provider);
#line 629 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->goa_mediator);
#line 629 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->goa_handle);
#line 629 "../src/client/accounts/accounts-manager.vala"
			_g_free0 (_data_->goa_id);
#line 629 "../src/client/accounts/accounts-manager.vala"
			_geary_config_file_group_unref0 (_data_->metadata_config);
#line 629 "../src/client/accounts/accounts-manager.vala"
			_geary_config_file_unref0 (_data_->config);
#line 629 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->data_dir);
#line 629 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->config_dir);
#line 629 "../src/client/accounts/accounts-manager.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error_->message, g_quark_to_string (_data_->_inner_error_->domain), _data_->_inner_error_->code);
#line 629 "../src/client/accounts/accounts-manager.vala"
			g_clear_error (&_data_->_inner_error_);
#line 629 "../src/client/accounts/accounts-manager.vala"
			g_object_unref (_data_->_async_result);
#line 629 "../src/client/accounts/accounts-manager.vala"
			return FALSE;
#line 6547 "accounts-manager.c"
		}
	}
#line 632 "../src/client/accounts/accounts-manager.vala"
	_data_->result = _data_->account;
#line 632 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->services);
#line 632 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->accounts);
#line 632 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->mediator);
#line 632 "../src/client/accounts/accounts-manager.vala"
	_g_free0 (_data_->default_provider);
#line 632 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->goa_mediator);
#line 632 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->goa_handle);
#line 632 "../src/client/accounts/accounts-manager.vala"
	_g_free0 (_data_->goa_id);
#line 632 "../src/client/accounts/accounts-manager.vala"
	_geary_config_file_group_unref0 (_data_->metadata_config);
#line 632 "../src/client/accounts/accounts-manager.vala"
	_geary_config_file_unref0 (_data_->config);
#line 632 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->data_dir);
#line 632 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->config_dir);
#line 632 "../src/client/accounts/accounts-manager.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 632 "../src/client/accounts/accounts-manager.vala"
	if (_data_->_state_ != 0) {
#line 632 "../src/client/accounts/accounts-manager.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 632 "../src/client/accounts/accounts-manager.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 6582 "accounts-manager.c"
		}
	}
#line 632 "../src/client/accounts/accounts-manager.vala"
	g_object_unref (_data_->_async_result);
#line 632 "../src/client/accounts/accounts-manager.vala"
	return FALSE;
#line 6589 "accounts-manager.c"
}


static void
accounts_manager_save_account_locked_data_free (gpointer _data)
{
	AccountsManagerSaveAccountLockedData* _data_;
	_data_ = _data;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->account);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->cancellable);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->self);
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_slice_free (AccountsManagerSaveAccountLockedData, _data_);
#line 6606 "accounts-manager.c"
}


static void
accounts_manager_save_account_locked (AccountsManager* self,
                                      GearyAccountInformation* account,
                                      GCancellable* cancellable,
                                      GAsyncReadyCallback _callback_,
                                      gpointer _user_data_)
{
	AccountsManagerSaveAccountLockedData* _data_;
	AccountsManager* _tmp0_;
	GearyAccountInformation* _tmp1_;
	GCancellable* _tmp2_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_ = g_slice_new0 (AccountsManagerSaveAccountLockedData);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_task_set_task_data (_data_->_async_result, _data_, accounts_manager_save_account_locked_data_free);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->self = _tmp0_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_tmp1_ = _g_object_ref0 (account);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->account);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->account = _tmp1_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_tmp2_ = _g_object_ref0 (cancellable);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->cancellable);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->cancellable = _tmp2_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_save_account_locked_co (_data_);
#line 6645 "accounts-manager.c"
}


static void
accounts_manager_save_account_locked_finish (AccountsManager* self,
                                             GAsyncResult* _res_,
                                             GError** error)
{
	AccountsManagerSaveAccountLockedData* _data_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 24 "../src/client/accounts/accounts-manager.vala"
	if (NULL == _data_) {
#line 24 "../src/client/accounts/accounts-manager.vala"
		return;
#line 6661 "accounts-manager.c"
	}
}


static void
accounts_manager_save_account_locked_ready (GObject* source_object,
                                            GAsyncResult* _res_,
                                            gpointer _user_data_)
{
	AccountsManagerSaveAccountLockedData* _data_;
#line 650 "../src/client/accounts/accounts-manager.vala"
	_data_ = _user_data_;
#line 650 "../src/client/accounts/accounts-manager.vala"
	_data_->_source_object_ = source_object;
#line 650 "../src/client/accounts/accounts-manager.vala"
	_data_->_res_ = _res_;
#line 650 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_save_account_locked_co (_data_);
#line 6680 "accounts-manager.c"
}


static gboolean
accounts_manager_save_account_locked_co (AccountsManagerSaveAccountLockedData* _data_)
{
#line 635 "../src/client/accounts/accounts-manager.vala"
	switch (_data_->_state_) {
#line 635 "../src/client/accounts/accounts-manager.vala"
		case 0:
#line 6691 "accounts-manager.c"
		goto _state_0;
#line 635 "../src/client/accounts/accounts-manager.vala"
		case 1:
#line 6695 "accounts-manager.c"
		goto _state_1;
#line 635 "../src/client/accounts/accounts-manager.vala"
		case 2:
#line 6699 "accounts-manager.c"
		goto _state_2;
		default:
#line 635 "../src/client/accounts/accounts-manager.vala"
		g_assert_not_reached ();
#line 6704 "accounts-manager.c"
	}
	_state_0:
#line 638 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp0_ = geary_account_information_get_config_dir (_data_->account);
#line 638 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp1_ = _data_->_tmp0_;
#line 638 "../src/client/accounts/accounts-manager.vala"
	if (_data_->_tmp1_ == NULL) {
#line 639 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp2_ = geary_account_information_get_id (_data_->account);
#line 639 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp3_ = _data_->_tmp2_;
#line 639 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp4_ = g_error_new (G_IO_ERROR, G_IO_ERROR_NOT_SUPPORTED, "Account %s does not have a config directory", _data_->_tmp3_);
#line 639 "../src/client/accounts/accounts-manager.vala"
		_data_->_inner_error_ = _data_->_tmp4_;
#line 639 "../src/client/accounts/accounts-manager.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error_);
#line 639 "../src/client/accounts/accounts-manager.vala"
		g_object_unref (_data_->_async_result);
#line 639 "../src/client/accounts/accounts-manager.vala"
		return FALSE;
#line 6727 "accounts-manager.c"
	}
#line 644 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp5_ = geary_account_information_get_config_dir (_data_->account);
#line 644 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp6_ = _data_->_tmp5_;
#line 644 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp7_ = g_file_get_child (_data_->_tmp6_, ACCOUNTS_MANAGER_SETTINGS_FILENAME);
#line 644 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp8_ = _data_->_tmp7_;
#line 644 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp9_ = geary_config_file_new (_data_->_tmp8_);
#line 644 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp10_ = _data_->_tmp9_;
#line 644 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->_tmp8_);
#line 644 "../src/client/accounts/accounts-manager.vala"
	_data_->config = _data_->_tmp10_;
#line 6745 "accounts-manager.c"
	{
#line 650 "../src/client/accounts/accounts-manager.vala"
		_data_->_state_ = 1;
#line 650 "../src/client/accounts/accounts-manager.vala"
		geary_config_file_load (_data_->config, _data_->cancellable, accounts_manager_save_account_locked_ready, _data_);
#line 650 "../src/client/accounts/accounts-manager.vala"
		return FALSE;
#line 6753 "accounts-manager.c"
		_state_1:
#line 650 "../src/client/accounts/accounts-manager.vala"
		geary_config_file_load_finish (_data_->config, _data_->_res_, &_data_->_inner_error_);
#line 650 "../src/client/accounts/accounts-manager.vala"
		if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 6759 "accounts-manager.c"
			goto __catch92_g_error;
		}
	}
	goto __finally92;
	__catch92_g_error:
	{
#line 649 "../src/client/accounts/accounts-manager.vala"
		_data_->err = _data_->_inner_error_;
#line 649 "../src/client/accounts/accounts-manager.vala"
		_data_->_inner_error_ = NULL;
#line 653 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp11_ = _data_->err;
#line 653 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp12_ = _data_->_tmp11_->message;
#line 653 "../src/client/accounts/accounts-manager.vala"
		g_debug ("accounts-manager.vala:653: Could not load existing config file: %s", _data_->_tmp12_);
#line 649 "../src/client/accounts/accounts-manager.vala"
		_g_error_free0 (_data_->err);
#line 6778 "accounts-manager.c"
	}
	__finally92:
#line 649 "../src/client/accounts/accounts-manager.vala"
	if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 649 "../src/client/accounts/accounts-manager.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error_);
#line 649 "../src/client/accounts/accounts-manager.vala"
		_geary_config_file_unref0 (_data_->config);
#line 649 "../src/client/accounts/accounts-manager.vala"
		g_object_unref (_data_->_async_result);
#line 649 "../src/client/accounts/accounts-manager.vala"
		return FALSE;
#line 6791 "accounts-manager.c"
	}
#line 656 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp13_ = geary_config_file_get_group (_data_->config, ACCOUNTS_MANAGER_GROUP_METADATA);
#line 656 "../src/client/accounts/accounts-manager.vala"
	_data_->metadata_config = _data_->_tmp13_;
#line 658 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp14_ = _data_->metadata_config;
#line 658 "../src/client/accounts/accounts-manager.vala"
	geary_config_file_group_set_int (_data_->_tmp14_, ACCOUNTS_MANAGER_METADATA_VERSION, ACCOUNTS_MANAGER_CONFIG_VERSION);
#line 661 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp15_ = _data_->metadata_config;
#line 661 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp16_ = accounts_manager_status_to_value (accounts_manager_get_status (_data_->self, _data_->account));
#line 661 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp17_ = _data_->_tmp16_;
#line 661 "../src/client/accounts/accounts-manager.vala"
	geary_config_file_group_set_string (_data_->_tmp15_, ACCOUNTS_MANAGER_METADATA_STATUS, _data_->_tmp17_);
#line 661 "../src/client/accounts/accounts-manager.vala"
	_g_free0 (_data_->_tmp17_);
#line 665 "../src/client/accounts/accounts-manager.vala"
	_data_->is_goa = accounts_manager_is_goa_account (_data_->self, _data_->account);
#line 666 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp18_ = _data_->is_goa;
#line 666 "../src/client/accounts/accounts-manager.vala"
	if (_data_->_tmp18_) {
#line 667 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp19_ = _data_->metadata_config;
#line 667 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp20_ = geary_account_information_get_id (_data_->account);
#line 667 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp21_ = _data_->_tmp20_;
#line 667 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp22_ = accounts_manager_to_goa_id (_data_->self, _data_->_tmp21_);
#line 667 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp23_ = _data_->_tmp22_;
#line 667 "../src/client/accounts/accounts-manager.vala"
		geary_config_file_group_set_string (_data_->_tmp19_, ACCOUNTS_MANAGER_METADATA_GOA, _data_->_tmp23_);
#line 667 "../src/client/accounts/accounts-manager.vala"
		_g_free0 (_data_->_tmp23_);
#line 6831 "accounts-manager.c"
	}
#line 670 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp24_ = _data_->is_goa;
#line 670 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp25_ = accounts_account_config_v1_new (_data_->_tmp24_);
#line 670 "../src/client/accounts/accounts-manager.vala"
	_data_->accounts = G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp25_, ACCOUNTS_TYPE_ACCOUNT_CONFIG, AccountsAccountConfig);
#line 671 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp26_ = _data_->accounts;
#line 671 "../src/client/accounts/accounts-manager.vala"
	accounts_account_config_save (_data_->_tmp26_, _data_->account, _data_->config);
#line 673 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp27_ = _data_->is_goa;
#line 673 "../src/client/accounts/accounts-manager.vala"
	if (!_data_->_tmp27_) {
#line 674 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp28_ = accounts_service_config_v1_new ();
#line 674 "../src/client/accounts/accounts-manager.vala"
		_data_->services = G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp28_, ACCOUNTS_TYPE_SERVICE_CONFIG, AccountsServiceConfig);
#line 675 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp29_ = _data_->services;
#line 675 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp30_ = geary_account_information_get_incoming (_data_->account);
#line 675 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp31_ = _data_->_tmp30_;
#line 675 "../src/client/accounts/accounts-manager.vala"
		accounts_service_config_save (_data_->_tmp29_, _data_->account, _data_->_tmp31_, _data_->config);
#line 676 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp32_ = _data_->services;
#line 676 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp33_ = geary_account_information_get_outgoing (_data_->account);
#line 676 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp34_ = _data_->_tmp33_;
#line 676 "../src/client/accounts/accounts-manager.vala"
		accounts_service_config_save (_data_->_tmp32_, _data_->account, _data_->_tmp34_, _data_->config);
#line 673 "../src/client/accounts/accounts-manager.vala"
		_g_object_unref0 (_data_->services);
#line 6869 "accounts-manager.c"
	}
#line 679 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp35_ = geary_config_file_get_file (_data_->config);
#line 679 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp36_ = _data_->_tmp35_;
#line 679 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp37_ = g_file_get_path (_data_->_tmp36_);
#line 679 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp38_ = _data_->_tmp37_;
#line 679 "../src/client/accounts/accounts-manager.vala"
	g_debug ("accounts-manager.vala:679: Writing config to: %s", _data_->_tmp38_);
#line 679 "../src/client/accounts/accounts-manager.vala"
	_g_free0 (_data_->_tmp38_);
#line 680 "../src/client/accounts/accounts-manager.vala"
	_data_->_state_ = 2;
#line 680 "../src/client/accounts/accounts-manager.vala"
	geary_config_file_save (_data_->config, _data_->cancellable, accounts_manager_save_account_locked_ready, _data_);
#line 680 "../src/client/accounts/accounts-manager.vala"
	return FALSE;
#line 6889 "accounts-manager.c"
	_state_2:
#line 680 "../src/client/accounts/accounts-manager.vala"
	geary_config_file_save_finish (_data_->config, _data_->_res_, &_data_->_inner_error_);
#line 680 "../src/client/accounts/accounts-manager.vala"
	if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 680 "../src/client/accounts/accounts-manager.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error_);
#line 680 "../src/client/accounts/accounts-manager.vala"
		_g_object_unref0 (_data_->accounts);
#line 680 "../src/client/accounts/accounts-manager.vala"
		_geary_config_file_group_unref0 (_data_->metadata_config);
#line 680 "../src/client/accounts/accounts-manager.vala"
		_geary_config_file_unref0 (_data_->config);
#line 680 "../src/client/accounts/accounts-manager.vala"
		g_object_unref (_data_->_async_result);
#line 680 "../src/client/accounts/accounts-manager.vala"
		return FALSE;
#line 6907 "accounts-manager.c"
	}
#line 635 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->accounts);
#line 635 "../src/client/accounts/accounts-manager.vala"
	_geary_config_file_group_unref0 (_data_->metadata_config);
#line 635 "../src/client/accounts/accounts-manager.vala"
	_geary_config_file_unref0 (_data_->config);
#line 635 "../src/client/accounts/accounts-manager.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 635 "../src/client/accounts/accounts-manager.vala"
	if (_data_->_state_ != 0) {
#line 635 "../src/client/accounts/accounts-manager.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 635 "../src/client/accounts/accounts-manager.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 6923 "accounts-manager.c"
		}
	}
#line 635 "../src/client/accounts/accounts-manager.vala"
	g_object_unref (_data_->_async_result);
#line 635 "../src/client/accounts/accounts-manager.vala"
	return FALSE;
#line 6930 "accounts-manager.c"
}


static void
accounts_manager_delete_account_data_free (gpointer _data)
{
	AccountsManagerDeleteAccountData* _data_;
	_data_ = _data;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->info);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->cancellable);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->self);
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_slice_free (AccountsManagerDeleteAccountData, _data_);
#line 6947 "accounts-manager.c"
}


static void
accounts_manager_delete_account (AccountsManager* self,
                                 GearyAccountInformation* info,
                                 GCancellable* cancellable,
                                 GAsyncReadyCallback _callback_,
                                 gpointer _user_data_)
{
	AccountsManagerDeleteAccountData* _data_;
	AccountsManager* _tmp0_;
	GearyAccountInformation* _tmp1_;
	GCancellable* _tmp2_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_ = g_slice_new0 (AccountsManagerDeleteAccountData);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_task_set_task_data (_data_->_async_result, _data_, accounts_manager_delete_account_data_free);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->self = _tmp0_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_tmp1_ = _g_object_ref0 (info);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->info);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->info = _tmp1_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_tmp2_ = _g_object_ref0 (cancellable);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->cancellable);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->cancellable = _tmp2_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_delete_account_co (_data_);
#line 6986 "accounts-manager.c"
}


static void
accounts_manager_delete_account_finish (AccountsManager* self,
                                        GAsyncResult* _res_,
                                        GError** error)
{
	AccountsManagerDeleteAccountData* _data_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 24 "../src/client/accounts/accounts-manager.vala"
	if (NULL == _data_) {
#line 24 "../src/client/accounts/accounts-manager.vala"
		return;
#line 7002 "accounts-manager.c"
	}
}


static void
accounts_manager_delete_account_ready (GObject* source_object,
                                       GAsyncResult* _res_,
                                       gpointer _user_data_)
{
	AccountsManagerDeleteAccountData* _data_;
#line 692 "../src/client/accounts/accounts-manager.vala"
	_data_ = _user_data_;
#line 692 "../src/client/accounts/accounts-manager.vala"
	_data_->_source_object_ = source_object;
#line 692 "../src/client/accounts/accounts-manager.vala"
	_data_->_res_ = _res_;
#line 692 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_delete_account_co (_data_);
#line 7021 "accounts-manager.c"
}


static gboolean
accounts_manager_delete_account_co (AccountsManagerDeleteAccountData* _data_)
{
#line 683 "../src/client/accounts/accounts-manager.vala"
	switch (_data_->_state_) {
#line 683 "../src/client/accounts/accounts-manager.vala"
		case 0:
#line 7032 "accounts-manager.c"
		goto _state_0;
#line 683 "../src/client/accounts/accounts-manager.vala"
		case 1:
#line 7036 "accounts-manager.c"
		goto _state_1;
#line 683 "../src/client/accounts/accounts-manager.vala"
		case 2:
#line 7040 "accounts-manager.c"
		goto _state_2;
#line 683 "../src/client/accounts/accounts-manager.vala"
		case 3:
#line 7044 "accounts-manager.c"
		goto _state_3;
#line 683 "../src/client/accounts/accounts-manager.vala"
		case 4:
#line 7048 "accounts-manager.c"
		goto _state_4;
		default:
#line 683 "../src/client/accounts/accounts-manager.vala"
		g_assert_not_reached ();
#line 7053 "accounts-manager.c"
	}
	_state_0:
#line 689 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp0_ = geary_account_information_get_mediator (_data_->info);
#line 689 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp1_ = _data_->_tmp0_;
#line 689 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp2_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_TYPE (_data_->_tmp1_, TYPE_SECRET_MEDIATOR) ? ((SecretMediator*) _data_->_tmp1_) : NULL);
#line 689 "../src/client/accounts/accounts-manager.vala"
	_data_->mediator = _data_->_tmp2_;
#line 690 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp3_ = _data_->mediator;
#line 690 "../src/client/accounts/accounts-manager.vala"
	if (_data_->_tmp3_ != NULL) {
#line 7068 "accounts-manager.c"
		{
#line 692 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp4_ = _data_->mediator;
#line 692 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp5_ = geary_account_information_get_incoming (_data_->info);
#line 692 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp6_ = _data_->_tmp5_;
#line 692 "../src/client/accounts/accounts-manager.vala"
			_data_->_state_ = 1;
#line 692 "../src/client/accounts/accounts-manager.vala"
			secret_mediator_clear_token (_data_->_tmp4_, _data_->info, _data_->_tmp6_, _data_->cancellable, accounts_manager_delete_account_ready, _data_);
#line 692 "../src/client/accounts/accounts-manager.vala"
			return FALSE;
#line 7082 "accounts-manager.c"
			_state_1:
#line 692 "../src/client/accounts/accounts-manager.vala"
			secret_mediator_clear_token_finish (_data_->_tmp4_, _data_->_res_, &_data_->_inner_error_);
#line 692 "../src/client/accounts/accounts-manager.vala"
			if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 7088 "accounts-manager.c"
				goto __catch93_g_error;
			}
		}
		goto __finally93;
		__catch93_g_error:
		{
#line 691 "../src/client/accounts/accounts-manager.vala"
			_data_->e = _data_->_inner_error_;
#line 691 "../src/client/accounts/accounts-manager.vala"
			_data_->_inner_error_ = NULL;
#line 694 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp7_ = _data_->e;
#line 694 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp8_ = _data_->_tmp7_->message;
#line 694 "../src/client/accounts/accounts-manager.vala"
			g_debug ("accounts-manager.vala:694: Error clearing IMAP password: %s", _data_->_tmp8_);
#line 691 "../src/client/accounts/accounts-manager.vala"
			_g_error_free0 (_data_->e);
#line 7107 "accounts-manager.c"
		}
		__finally93:
#line 691 "../src/client/accounts/accounts-manager.vala"
		if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 691 "../src/client/accounts/accounts-manager.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error_);
#line 691 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->mediator);
#line 691 "../src/client/accounts/accounts-manager.vala"
			g_object_unref (_data_->_async_result);
#line 691 "../src/client/accounts/accounts-manager.vala"
			return FALSE;
#line 7120 "accounts-manager.c"
		}
		{
#line 698 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp9_ = _data_->mediator;
#line 698 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp10_ = geary_account_information_get_outgoing (_data_->info);
#line 698 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp11_ = _data_->_tmp10_;
#line 698 "../src/client/accounts/accounts-manager.vala"
			_data_->_state_ = 2;
#line 698 "../src/client/accounts/accounts-manager.vala"
			secret_mediator_clear_token (_data_->_tmp9_, _data_->info, _data_->_tmp11_, _data_->cancellable, accounts_manager_delete_account_ready, _data_);
#line 698 "../src/client/accounts/accounts-manager.vala"
			return FALSE;
#line 7135 "accounts-manager.c"
			_state_2:
#line 698 "../src/client/accounts/accounts-manager.vala"
			secret_mediator_clear_token_finish (_data_->_tmp9_, _data_->_res_, &_data_->_inner_error_);
#line 698 "../src/client/accounts/accounts-manager.vala"
			if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 7141 "accounts-manager.c"
				goto __catch94_g_error;
			}
		}
		goto __finally94;
		__catch94_g_error:
		{
#line 697 "../src/client/accounts/accounts-manager.vala"
			_data_->_vala1_e = _data_->_inner_error_;
#line 697 "../src/client/accounts/accounts-manager.vala"
			_data_->_inner_error_ = NULL;
#line 700 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp12_ = _data_->_vala1_e;
#line 700 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp13_ = _data_->_tmp12_->message;
#line 700 "../src/client/accounts/accounts-manager.vala"
			g_debug ("accounts-manager.vala:700: Error clearing IMAP password: %s", _data_->_tmp13_);
#line 697 "../src/client/accounts/accounts-manager.vala"
			_g_error_free0 (_data_->_vala1_e);
#line 7160 "accounts-manager.c"
		}
		__finally94:
#line 697 "../src/client/accounts/accounts-manager.vala"
		if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 697 "../src/client/accounts/accounts-manager.vala"
			g_task_return_error (_data_->_async_result, _data_->_inner_error_);
#line 697 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->mediator);
#line 697 "../src/client/accounts/accounts-manager.vala"
			g_object_unref (_data_->_async_result);
#line 697 "../src/client/accounts/accounts-manager.vala"
			return FALSE;
#line 7173 "accounts-manager.c"
		}
	}
#line 704 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp14_ = geary_account_information_get_data_dir (_data_->info);
#line 704 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp15_ = _data_->_tmp14_;
#line 704 "../src/client/accounts/accounts-manager.vala"
	if (_data_->_tmp15_ != NULL) {
#line 705 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp16_ = geary_account_information_get_data_dir (_data_->info);
#line 705 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp17_ = _data_->_tmp16_;
#line 705 "../src/client/accounts/accounts-manager.vala"
		_data_->_state_ = 3;
#line 705 "../src/client/accounts/accounts-manager.vala"
		geary_files_recursive_delete_async (_data_->_tmp17_, G_PRIORITY_LOW, _data_->cancellable, accounts_manager_delete_account_ready, _data_);
#line 705 "../src/client/accounts/accounts-manager.vala"
		return FALSE;
#line 7192 "accounts-manager.c"
		_state_3:
#line 705 "../src/client/accounts/accounts-manager.vala"
		geary_files_recursive_delete_finish (_data_->_res_);
#line 7196 "accounts-manager.c"
	}
#line 712 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp18_ = geary_account_information_get_config_dir (_data_->info);
#line 712 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp19_ = _data_->_tmp18_;
#line 712 "../src/client/accounts/accounts-manager.vala"
	if (_data_->_tmp19_ != NULL) {
#line 713 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp20_ = geary_account_information_get_config_dir (_data_->info);
#line 713 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp21_ = _data_->_tmp20_;
#line 713 "../src/client/accounts/accounts-manager.vala"
		_data_->_state_ = 4;
#line 713 "../src/client/accounts/accounts-manager.vala"
		geary_files_recursive_delete_async (_data_->_tmp21_, G_PRIORITY_LOW, _data_->cancellable, accounts_manager_delete_account_ready, _data_);
#line 713 "../src/client/accounts/accounts-manager.vala"
		return FALSE;
#line 7214 "accounts-manager.c"
		_state_4:
#line 713 "../src/client/accounts/accounts-manager.vala"
		geary_files_recursive_delete_finish (_data_->_res_);
#line 7218 "accounts-manager.c"
	}
#line 683 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->mediator);
#line 683 "../src/client/accounts/accounts-manager.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 683 "../src/client/accounts/accounts-manager.vala"
	if (_data_->_state_ != 0) {
#line 683 "../src/client/accounts/accounts-manager.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 683 "../src/client/accounts/accounts-manager.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 7230 "accounts-manager.c"
		}
	}
#line 683 "../src/client/accounts/accounts-manager.vala"
	g_object_unref (_data_->_async_result);
#line 683 "../src/client/accounts/accounts-manager.vala"
	return FALSE;
#line 7237 "accounts-manager.c"
}


static inline AccountsManagerAccountState*
accounts_manager_lookup_state (AccountsManager* self,
                               GearyAccountInformation* account)
{
	AccountsManagerAccountState* result = NULL;
	AccountsManagerAccountState* state = NULL;
	GeeMap* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	gpointer _tmp3_;
	AccountsManagerAccountState* _tmp4_;
#line 719 "../src/client/accounts/accounts-manager.vala"
	g_return_val_if_fail (ACCOUNTS_IS_MANAGER (self), NULL);
#line 719 "../src/client/accounts/accounts-manager.vala"
	g_return_val_if_fail (GEARY_IS_ACCOUNT_INFORMATION (account), NULL);
#line 720 "../src/client/accounts/accounts-manager.vala"
	_tmp0_ = self->priv->accounts;
#line 720 "../src/client/accounts/accounts-manager.vala"
	_tmp1_ = geary_account_information_get_id (account);
#line 720 "../src/client/accounts/accounts-manager.vala"
	_tmp2_ = _tmp1_;
#line 720 "../src/client/accounts/accounts-manager.vala"
	_tmp3_ = gee_map_get (_tmp0_, _tmp2_);
#line 720 "../src/client/accounts/accounts-manager.vala"
	state = (AccountsManagerAccountState*) _tmp3_;
#line 721 "../src/client/accounts/accounts-manager.vala"
	_tmp4_ = state;
#line 721 "../src/client/accounts/accounts-manager.vala"
	if (_tmp4_ == NULL) {
#line 7270 "accounts-manager.c"
		AccountsManagerAccountState* _tmp5_;
		GeeMap* _tmp6_;
		const gchar* _tmp7_;
		const gchar* _tmp8_;
		AccountsManagerAccountState* _tmp9_;
#line 722 "../src/client/accounts/accounts-manager.vala"
		_tmp5_ = accounts_manager_account_state_new (account);
#line 722 "../src/client/accounts/accounts-manager.vala"
		_accounts_manager_account_state_unref0 (state);
#line 722 "../src/client/accounts/accounts-manager.vala"
		state = _tmp5_;
#line 723 "../src/client/accounts/accounts-manager.vala"
		_tmp6_ = self->priv->accounts;
#line 723 "../src/client/accounts/accounts-manager.vala"
		_tmp7_ = geary_account_information_get_id (account);
#line 723 "../src/client/accounts/accounts-manager.vala"
		_tmp8_ = _tmp7_;
#line 723 "../src/client/accounts/accounts-manager.vala"
		_tmp9_ = state;
#line 723 "../src/client/accounts/accounts-manager.vala"
		gee_map_set (_tmp6_, _tmp8_, _tmp9_);
#line 7292 "accounts-manager.c"
	}
#line 725 "../src/client/accounts/accounts-manager.vala"
	result = state;
#line 725 "../src/client/accounts/accounts-manager.vala"
	return result;
#line 7298 "accounts-manager.c"
}


static gboolean
accounts_manager_set_enabled (AccountsManager* self,
                              GearyAccountInformation* account,
                              gboolean is_enabled)
{
	gboolean result = FALSE;
	gboolean was_added = FALSE;
	GeeMap* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	AccountsManagerAccountState* state = NULL;
	AccountsManagerAccountState* _tmp3_;
	AccountsManagerStatus existing_status = 0;
	AccountsManagerAccountState* _tmp4_;
	AccountsManagerStatus _tmp5_;
	AccountsManagerStatus _tmp6_;
	AccountsManagerAccountState* _tmp7_;
	gboolean ret = FALSE;
	gboolean _tmp8_;
#line 728 "../src/client/accounts/accounts-manager.vala"
	g_return_val_if_fail (ACCOUNTS_IS_MANAGER (self), FALSE);
#line 728 "../src/client/accounts/accounts-manager.vala"
	g_return_val_if_fail (GEARY_IS_ACCOUNT_INFORMATION (account), FALSE);
#line 729 "../src/client/accounts/accounts-manager.vala"
	_tmp0_ = self->priv->accounts;
#line 729 "../src/client/accounts/accounts-manager.vala"
	_tmp1_ = geary_account_information_get_id (account);
#line 729 "../src/client/accounts/accounts-manager.vala"
	_tmp2_ = _tmp1_;
#line 729 "../src/client/accounts/accounts-manager.vala"
	was_added = !gee_map_has_key (_tmp0_, _tmp2_);
#line 730 "../src/client/accounts/accounts-manager.vala"
	_tmp3_ = accounts_manager_lookup_state (self, account);
#line 730 "../src/client/accounts/accounts-manager.vala"
	state = _tmp3_;
#line 731 "../src/client/accounts/accounts-manager.vala"
	_tmp4_ = state;
#line 731 "../src/client/accounts/accounts-manager.vala"
	_tmp5_ = accounts_manager_account_state_get_status (_tmp4_);
#line 731 "../src/client/accounts/accounts-manager.vala"
	_tmp6_ = _tmp5_;
#line 731 "../src/client/accounts/accounts-manager.vala"
	existing_status = _tmp6_;
#line 732 "../src/client/accounts/accounts-manager.vala"
	_tmp7_ = state;
#line 732 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_account_state_set_enabled (_tmp7_, is_enabled);
#line 734 "../src/client/accounts/accounts-manager.vala"
	ret = FALSE;
#line 735 "../src/client/accounts/accounts-manager.vala"
	_tmp8_ = was_added;
#line 735 "../src/client/accounts/accounts-manager.vala"
	if (_tmp8_) {
#line 7355 "accounts-manager.c"
		AccountsManagerAccountState* _tmp9_;
		GearyAccountInformation* _tmp10_;
		GearyAccountInformation* _tmp11_;
		AccountsManagerAccountState* _tmp12_;
		AccountsManagerStatus _tmp13_;
		AccountsManagerStatus _tmp14_;
#line 736 "../src/client/accounts/accounts-manager.vala"
		_tmp9_ = state;
#line 736 "../src/client/accounts/accounts-manager.vala"
		_tmp10_ = accounts_manager_account_state_get_account (_tmp9_);
#line 736 "../src/client/accounts/accounts-manager.vala"
		_tmp11_ = _tmp10_;
#line 736 "../src/client/accounts/accounts-manager.vala"
		_tmp12_ = state;
#line 736 "../src/client/accounts/accounts-manager.vala"
		_tmp13_ = accounts_manager_account_state_get_status (_tmp12_);
#line 736 "../src/client/accounts/accounts-manager.vala"
		_tmp14_ = _tmp13_;
#line 736 "../src/client/accounts/accounts-manager.vala"
		g_signal_emit (self, accounts_manager_signals[ACCOUNTS_MANAGER_ACCOUNT_ADDED_SIGNAL], 0, _tmp11_, _tmp14_);
#line 737 "../src/client/accounts/accounts-manager.vala"
		g_signal_connect_object (account, "changed", (GCallback) _accounts_manager_on_account_changed_geary_account_information_changed, self, 0);
#line 738 "../src/client/accounts/accounts-manager.vala"
		ret = TRUE;
#line 7380 "accounts-manager.c"
	} else {
		AccountsManagerAccountState* _tmp15_;
		AccountsManagerStatus _tmp16_;
		AccountsManagerStatus _tmp17_;
		AccountsManagerStatus _tmp18_;
#line 739 "../src/client/accounts/accounts-manager.vala"
		_tmp15_ = state;
#line 739 "../src/client/accounts/accounts-manager.vala"
		_tmp16_ = accounts_manager_account_state_get_status (_tmp15_);
#line 739 "../src/client/accounts/accounts-manager.vala"
		_tmp17_ = _tmp16_;
#line 739 "../src/client/accounts/accounts-manager.vala"
		_tmp18_ = existing_status;
#line 739 "../src/client/accounts/accounts-manager.vala"
		if (_tmp17_ != _tmp18_) {
#line 7396 "accounts-manager.c"
			AccountsManagerAccountState* _tmp19_;
			GearyAccountInformation* _tmp20_;
			GearyAccountInformation* _tmp21_;
			AccountsManagerAccountState* _tmp22_;
			AccountsManagerStatus _tmp23_;
			AccountsManagerStatus _tmp24_;
#line 740 "../src/client/accounts/accounts-manager.vala"
			_tmp19_ = state;
#line 740 "../src/client/accounts/accounts-manager.vala"
			_tmp20_ = accounts_manager_account_state_get_account (_tmp19_);
#line 740 "../src/client/accounts/accounts-manager.vala"
			_tmp21_ = _tmp20_;
#line 740 "../src/client/accounts/accounts-manager.vala"
			_tmp22_ = state;
#line 740 "../src/client/accounts/accounts-manager.vala"
			_tmp23_ = accounts_manager_account_state_get_status (_tmp22_);
#line 740 "../src/client/accounts/accounts-manager.vala"
			_tmp24_ = _tmp23_;
#line 740 "../src/client/accounts/accounts-manager.vala"
			g_signal_emit (self, accounts_manager_signals[ACCOUNTS_MANAGER_ACCOUNT_STATUS_CHANGED_SIGNAL], 0, _tmp21_, _tmp24_);
#line 741 "../src/client/accounts/accounts-manager.vala"
			ret = TRUE;
#line 7419 "accounts-manager.c"
		}
	}
#line 743 "../src/client/accounts/accounts-manager.vala"
	result = ret;
#line 743 "../src/client/accounts/accounts-manager.vala"
	_accounts_manager_account_state_unref0 (state);
#line 743 "../src/client/accounts/accounts-manager.vala"
	return result;
#line 7428 "accounts-manager.c"
}


static gboolean
accounts_manager_set_available (AccountsManager* self,
                                GearyAccountInformation* account,
                                gboolean is_available)
{
	gboolean result = FALSE;
	gboolean was_added = FALSE;
	GeeMap* _tmp0_;
	const gchar* _tmp1_;
	const gchar* _tmp2_;
	AccountsManagerAccountState* state = NULL;
	AccountsManagerAccountState* _tmp3_;
	AccountsManagerStatus existing_status = 0;
	AccountsManagerAccountState* _tmp4_;
	AccountsManagerStatus _tmp5_;
	AccountsManagerStatus _tmp6_;
	AccountsManagerAccountState* _tmp7_;
	gboolean ret = FALSE;
	gboolean _tmp8_;
#line 746 "../src/client/accounts/accounts-manager.vala"
	g_return_val_if_fail (ACCOUNTS_IS_MANAGER (self), FALSE);
#line 746 "../src/client/accounts/accounts-manager.vala"
	g_return_val_if_fail (GEARY_IS_ACCOUNT_INFORMATION (account), FALSE);
#line 747 "../src/client/accounts/accounts-manager.vala"
	_tmp0_ = self->priv->accounts;
#line 747 "../src/client/accounts/accounts-manager.vala"
	_tmp1_ = geary_account_information_get_id (account);
#line 747 "../src/client/accounts/accounts-manager.vala"
	_tmp2_ = _tmp1_;
#line 747 "../src/client/accounts/accounts-manager.vala"
	was_added = !gee_map_has_key (_tmp0_, _tmp2_);
#line 748 "../src/client/accounts/accounts-manager.vala"
	_tmp3_ = accounts_manager_lookup_state (self, account);
#line 748 "../src/client/accounts/accounts-manager.vala"
	state = _tmp3_;
#line 749 "../src/client/accounts/accounts-manager.vala"
	_tmp4_ = state;
#line 749 "../src/client/accounts/accounts-manager.vala"
	_tmp5_ = accounts_manager_account_state_get_status (_tmp4_);
#line 749 "../src/client/accounts/accounts-manager.vala"
	_tmp6_ = _tmp5_;
#line 749 "../src/client/accounts/accounts-manager.vala"
	existing_status = _tmp6_;
#line 750 "../src/client/accounts/accounts-manager.vala"
	_tmp7_ = state;
#line 750 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_account_state_set_available (_tmp7_, is_available);
#line 752 "../src/client/accounts/accounts-manager.vala"
	ret = FALSE;
#line 753 "../src/client/accounts/accounts-manager.vala"
	_tmp8_ = was_added;
#line 753 "../src/client/accounts/accounts-manager.vala"
	if (_tmp8_) {
#line 7485 "accounts-manager.c"
		AccountsManagerAccountState* _tmp9_;
		GearyAccountInformation* _tmp10_;
		GearyAccountInformation* _tmp11_;
		AccountsManagerAccountState* _tmp12_;
		AccountsManagerStatus _tmp13_;
		AccountsManagerStatus _tmp14_;
#line 754 "../src/client/accounts/accounts-manager.vala"
		_tmp9_ = state;
#line 754 "../src/client/accounts/accounts-manager.vala"
		_tmp10_ = accounts_manager_account_state_get_account (_tmp9_);
#line 754 "../src/client/accounts/accounts-manager.vala"
		_tmp11_ = _tmp10_;
#line 754 "../src/client/accounts/accounts-manager.vala"
		_tmp12_ = state;
#line 754 "../src/client/accounts/accounts-manager.vala"
		_tmp13_ = accounts_manager_account_state_get_status (_tmp12_);
#line 754 "../src/client/accounts/accounts-manager.vala"
		_tmp14_ = _tmp13_;
#line 754 "../src/client/accounts/accounts-manager.vala"
		g_signal_emit (self, accounts_manager_signals[ACCOUNTS_MANAGER_ACCOUNT_ADDED_SIGNAL], 0, _tmp11_, _tmp14_);
#line 755 "../src/client/accounts/accounts-manager.vala"
		g_signal_connect_object (account, "changed", (GCallback) _accounts_manager_on_account_changed_geary_account_information_changed, self, 0);
#line 756 "../src/client/accounts/accounts-manager.vala"
		ret = TRUE;
#line 7510 "accounts-manager.c"
	} else {
		AccountsManagerAccountState* _tmp15_;
		AccountsManagerStatus _tmp16_;
		AccountsManagerStatus _tmp17_;
		AccountsManagerStatus _tmp18_;
#line 757 "../src/client/accounts/accounts-manager.vala"
		_tmp15_ = state;
#line 757 "../src/client/accounts/accounts-manager.vala"
		_tmp16_ = accounts_manager_account_state_get_status (_tmp15_);
#line 757 "../src/client/accounts/accounts-manager.vala"
		_tmp17_ = _tmp16_;
#line 757 "../src/client/accounts/accounts-manager.vala"
		_tmp18_ = existing_status;
#line 757 "../src/client/accounts/accounts-manager.vala"
		if (_tmp17_ != _tmp18_) {
#line 7526 "accounts-manager.c"
			AccountsManagerAccountState* _tmp19_;
			GearyAccountInformation* _tmp20_;
			GearyAccountInformation* _tmp21_;
			AccountsManagerAccountState* _tmp22_;
			AccountsManagerStatus _tmp23_;
			AccountsManagerStatus _tmp24_;
#line 758 "../src/client/accounts/accounts-manager.vala"
			_tmp19_ = state;
#line 758 "../src/client/accounts/accounts-manager.vala"
			_tmp20_ = accounts_manager_account_state_get_account (_tmp19_);
#line 758 "../src/client/accounts/accounts-manager.vala"
			_tmp21_ = _tmp20_;
#line 758 "../src/client/accounts/accounts-manager.vala"
			_tmp22_ = state;
#line 758 "../src/client/accounts/accounts-manager.vala"
			_tmp23_ = accounts_manager_account_state_get_status (_tmp22_);
#line 758 "../src/client/accounts/accounts-manager.vala"
			_tmp24_ = _tmp23_;
#line 758 "../src/client/accounts/accounts-manager.vala"
			g_signal_emit (self, accounts_manager_signals[ACCOUNTS_MANAGER_ACCOUNT_STATUS_CHANGED_SIGNAL], 0, _tmp21_, _tmp24_);
#line 759 "../src/client/accounts/accounts-manager.vala"
			ret = TRUE;
#line 7549 "accounts-manager.c"
		}
	}
#line 761 "../src/client/accounts/accounts-manager.vala"
	result = ret;
#line 761 "../src/client/accounts/accounts-manager.vala"
	_accounts_manager_account_state_unref0 (state);
#line 761 "../src/client/accounts/accounts-manager.vala"
	return result;
#line 7558 "accounts-manager.c"
}


static void
accounts_manager_create_account_dirs_data_free (gpointer _data)
{
	AccountsManagerCreateAccountDirsData* _data_;
	_data_ = _data;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->info);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->cancellable);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->self);
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_slice_free (AccountsManagerCreateAccountDirsData, _data_);
#line 7575 "accounts-manager.c"
}


static void
accounts_manager_create_account_dirs (AccountsManager* self,
                                      GearyAccountInformation* info,
                                      GCancellable* cancellable,
                                      GAsyncReadyCallback _callback_,
                                      gpointer _user_data_)
{
	AccountsManagerCreateAccountDirsData* _data_;
	AccountsManager* _tmp0_;
	GearyAccountInformation* _tmp1_;
	GCancellable* _tmp2_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_ = g_slice_new0 (AccountsManagerCreateAccountDirsData);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_task_set_task_data (_data_->_async_result, _data_, accounts_manager_create_account_dirs_data_free);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->self = _tmp0_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_tmp1_ = _g_object_ref0 (info);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->info);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->info = _tmp1_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_tmp2_ = _g_object_ref0 (cancellable);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->cancellable);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->cancellable = _tmp2_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_create_account_dirs_co (_data_);
#line 7614 "accounts-manager.c"
}


static void
accounts_manager_create_account_dirs_finish (AccountsManager* self,
                                             GAsyncResult* _res_,
                                             GError** error)
{
	AccountsManagerCreateAccountDirsData* _data_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 24 "../src/client/accounts/accounts-manager.vala"
	if (NULL == _data_) {
#line 24 "../src/client/accounts/accounts-manager.vala"
		return;
#line 7630 "accounts-manager.c"
	}
}


static void
accounts_manager_create_account_dirs_ready (GObject* source_object,
                                            GAsyncResult* _res_,
                                            gpointer _user_data_)
{
	AccountsManagerCreateAccountDirsData* _data_;
#line 770 "../src/client/accounts/accounts-manager.vala"
	_data_ = _user_data_;
#line 770 "../src/client/accounts/accounts-manager.vala"
	_data_->_source_object_ = source_object;
#line 770 "../src/client/accounts/accounts-manager.vala"
	_data_->_res_ = _res_;
#line 770 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_create_account_dirs_co (_data_);
#line 7649 "accounts-manager.c"
}


static gboolean
accounts_manager_create_account_dirs_co (AccountsManagerCreateAccountDirsData* _data_)
{
#line 764 "../src/client/accounts/accounts-manager.vala"
	switch (_data_->_state_) {
#line 764 "../src/client/accounts/accounts-manager.vala"
		case 0:
#line 7660 "accounts-manager.c"
		goto _state_0;
#line 764 "../src/client/accounts/accounts-manager.vala"
		case 1:
#line 7664 "accounts-manager.c"
		goto _state_1;
#line 764 "../src/client/accounts/accounts-manager.vala"
		case 2:
#line 7668 "accounts-manager.c"
		goto _state_2;
		default:
#line 764 "../src/client/accounts/accounts-manager.vala"
		g_assert_not_reached ();
#line 7673 "accounts-manager.c"
	}
	_state_0:
#line 767 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp0_ = _data_->self->priv->_config_dir;
#line 767 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp1_ = geary_account_information_get_id (_data_->info);
#line 767 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp2_ = _data_->_tmp1_;
#line 767 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp3_ = g_file_get_child (_data_->_tmp0_, _data_->_tmp2_);
#line 767 "../src/client/accounts/accounts-manager.vala"
	_data_->config = _data_->_tmp3_;
#line 768 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp4_ = _data_->self->priv->_data_dir;
#line 768 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp5_ = geary_account_information_get_id (_data_->info);
#line 768 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp6_ = _data_->_tmp5_;
#line 768 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp7_ = g_file_get_child (_data_->_tmp4_, _data_->_tmp6_);
#line 768 "../src/client/accounts/accounts-manager.vala"
	_data_->data = _data_->_tmp7_;
#line 770 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp8_ = _data_->config;
#line 770 "../src/client/accounts/accounts-manager.vala"
	_data_->_state_ = 1;
#line 770 "../src/client/accounts/accounts-manager.vala"
	geary_files_make_directory_with_parents (_data_->_tmp8_, _data_->cancellable, accounts_manager_create_account_dirs_ready, _data_);
#line 770 "../src/client/accounts/accounts-manager.vala"
	return FALSE;
#line 7704 "accounts-manager.c"
	_state_1:
#line 770 "../src/client/accounts/accounts-manager.vala"
	geary_files_make_directory_with_parents_finish (_data_->_res_, &_data_->_inner_error_);
#line 770 "../src/client/accounts/accounts-manager.vala"
	if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 770 "../src/client/accounts/accounts-manager.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error_);
#line 770 "../src/client/accounts/accounts-manager.vala"
		_g_object_unref0 (_data_->data);
#line 770 "../src/client/accounts/accounts-manager.vala"
		_g_object_unref0 (_data_->config);
#line 770 "../src/client/accounts/accounts-manager.vala"
		g_object_unref (_data_->_async_result);
#line 770 "../src/client/accounts/accounts-manager.vala"
		return FALSE;
#line 7720 "accounts-manager.c"
	}
#line 771 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp9_ = _data_->data;
#line 771 "../src/client/accounts/accounts-manager.vala"
	_data_->_state_ = 2;
#line 771 "../src/client/accounts/accounts-manager.vala"
	geary_files_make_directory_with_parents (_data_->_tmp9_, _data_->cancellable, accounts_manager_create_account_dirs_ready, _data_);
#line 771 "../src/client/accounts/accounts-manager.vala"
	return FALSE;
#line 7730 "accounts-manager.c"
	_state_2:
#line 771 "../src/client/accounts/accounts-manager.vala"
	geary_files_make_directory_with_parents_finish (_data_->_res_, &_data_->_inner_error_);
#line 771 "../src/client/accounts/accounts-manager.vala"
	if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 771 "../src/client/accounts/accounts-manager.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error_);
#line 771 "../src/client/accounts/accounts-manager.vala"
		_g_object_unref0 (_data_->data);
#line 771 "../src/client/accounts/accounts-manager.vala"
		_g_object_unref0 (_data_->config);
#line 771 "../src/client/accounts/accounts-manager.vala"
		g_object_unref (_data_->_async_result);
#line 771 "../src/client/accounts/accounts-manager.vala"
		return FALSE;
#line 7746 "accounts-manager.c"
	}
#line 773 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp10_ = _data_->config;
#line 773 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp11_ = _data_->data;
#line 773 "../src/client/accounts/accounts-manager.vala"
	geary_account_information_set_account_directories (_data_->info, _data_->_tmp10_, _data_->_tmp11_);
#line 764 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->data);
#line 764 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->config);
#line 764 "../src/client/accounts/accounts-manager.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 764 "../src/client/accounts/accounts-manager.vala"
	if (_data_->_state_ != 0) {
#line 764 "../src/client/accounts/accounts-manager.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 764 "../src/client/accounts/accounts-manager.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 7766 "accounts-manager.c"
		}
	}
#line 764 "../src/client/accounts/accounts-manager.vala"
	g_object_unref (_data_->_async_result);
#line 764 "../src/client/accounts/accounts-manager.vala"
	return FALSE;
#line 7773 "accounts-manager.c"
}


static inline gchar*
accounts_manager_to_geary_id (AccountsManager* self,
                              GoaObject* account)
{
	gchar* result = NULL;
	GoaAccount* _tmp0_;
	GoaAccount* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
#line 776 "../src/client/accounts/accounts-manager.vala"
	g_return_val_if_fail (ACCOUNTS_IS_MANAGER (self), NULL);
#line 776 "../src/client/accounts/accounts-manager.vala"
	g_return_val_if_fail (GOA_IS_OBJECT (account), NULL);
#line 777 "../src/client/accounts/accounts-manager.vala"
	_tmp0_ = goa_object_get_account (account);
#line 777 "../src/client/accounts/accounts-manager.vala"
	_tmp1_ = _tmp0_;
#line 777 "../src/client/accounts/accounts-manager.vala"
	g_object_get (_tmp1_, "id", &_tmp2_, NULL);
#line 777 "../src/client/accounts/accounts-manager.vala"
	_tmp3_ = _tmp2_;
#line 777 "../src/client/accounts/accounts-manager.vala"
	_tmp4_ = _tmp3_;
#line 777 "../src/client/accounts/accounts-manager.vala"
	_tmp5_ = g_strconcat (ACCOUNTS_MANAGER_GOA_ID_PREFIX, _tmp4_, NULL);
#line 777 "../src/client/accounts/accounts-manager.vala"
	_tmp6_ = _tmp5_;
#line 777 "../src/client/accounts/accounts-manager.vala"
	_g_free0 (_tmp4_);
#line 777 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_tmp1_);
#line 777 "../src/client/accounts/accounts-manager.vala"
	result = _tmp6_;
#line 777 "../src/client/accounts/accounts-manager.vala"
	return result;
#line 7815 "accounts-manager.c"
}


static inline gchar*
accounts_manager_to_goa_id (AccountsManager* self,
                            const gchar* id)
{
	gchar* result = NULL;
	gchar* _tmp0_ = NULL;
#line 780 "../src/client/accounts/accounts-manager.vala"
	g_return_val_if_fail (ACCOUNTS_IS_MANAGER (self), NULL);
#line 780 "../src/client/accounts/accounts-manager.vala"
	g_return_val_if_fail (id != NULL, NULL);
#line 781 "../src/client/accounts/accounts-manager.vala"
	if (g_str_has_prefix (id, ACCOUNTS_MANAGER_GOA_ID_PREFIX)) {
#line 7831 "accounts-manager.c"
		gint _tmp1_;
		gint _tmp2_;
		gchar* _tmp3_;
#line 782 "../src/client/accounts/accounts-manager.vala"
		_tmp1_ = strlen (ACCOUNTS_MANAGER_GOA_ID_PREFIX);
#line 782 "../src/client/accounts/accounts-manager.vala"
		_tmp2_ = _tmp1_;
#line 782 "../src/client/accounts/accounts-manager.vala"
		_tmp3_ = string_substring (id, (glong) _tmp2_, (glong) -1);
#line 782 "../src/client/accounts/accounts-manager.vala"
		_g_free0 (_tmp0_);
#line 782 "../src/client/accounts/accounts-manager.vala"
		_tmp0_ = _tmp3_;
#line 7845 "accounts-manager.c"
	} else {
		gchar* _tmp4_;
#line 783 "../src/client/accounts/accounts-manager.vala"
		_tmp4_ = g_strdup (id);
#line 783 "../src/client/accounts/accounts-manager.vala"
		_g_free0 (_tmp0_);
#line 783 "../src/client/accounts/accounts-manager.vala"
		_tmp0_ = _tmp4_;
#line 7854 "accounts-manager.c"
	}
#line 781 "../src/client/accounts/accounts-manager.vala"
	result = _tmp0_;
#line 781 "../src/client/accounts/accounts-manager.vala"
	return result;
#line 7860 "accounts-manager.c"
}


static gboolean
accounts_manager_is_valid_goa_account (AccountsManager* self,
                                       GoaObject* handle)
{
	gboolean result = FALSE;
	GoaMail* mail = NULL;
	GoaMail* _tmp0_;
	gboolean _tmp1_ = FALSE;
	gboolean _tmp2_ = FALSE;
	gboolean _tmp3_ = FALSE;
	GoaMail* _tmp4_;
#line 786 "../src/client/accounts/accounts-manager.vala"
	g_return_val_if_fail (ACCOUNTS_IS_MANAGER (self), FALSE);
#line 786 "../src/client/accounts/accounts-manager.vala"
	g_return_val_if_fail (GOA_IS_OBJECT (handle), FALSE);
#line 787 "../src/client/accounts/accounts-manager.vala"
	_tmp0_ = goa_object_get_mail (handle);
#line 787 "../src/client/accounts/accounts-manager.vala"
	mail = _tmp0_;
#line 789 "../src/client/accounts/accounts-manager.vala"
	_tmp4_ = mail;
#line 789 "../src/client/accounts/accounts-manager.vala"
	if (_tmp4_ != NULL) {
#line 7887 "accounts-manager.c"
		GoaAccount* _tmp5_;
		GoaAccount* _tmp6_;
		gboolean _tmp7_;
		gboolean _tmp8_;
#line 790 "../src/client/accounts/accounts-manager.vala"
		_tmp5_ = goa_object_get_account (handle);
#line 790 "../src/client/accounts/accounts-manager.vala"
		_tmp6_ = _tmp5_;
#line 790 "../src/client/accounts/accounts-manager.vala"
		g_object_get (_tmp6_, "mail-disabled", &_tmp7_, NULL);
#line 790 "../src/client/accounts/accounts-manager.vala"
		_tmp8_ = _tmp7_;
#line 790 "../src/client/accounts/accounts-manager.vala"
		_tmp3_ = !_tmp8_;
#line 790 "../src/client/accounts/accounts-manager.vala"
		_g_object_unref0 (_tmp6_);
#line 7904 "accounts-manager.c"
	} else {
#line 789 "../src/client/accounts/accounts-manager.vala"
		_tmp3_ = FALSE;
#line 7908 "accounts-manager.c"
	}
#line 789 "../src/client/accounts/accounts-manager.vala"
	if (_tmp3_) {
#line 7912 "accounts-manager.c"
		GoaMail* _tmp9_;
		gchar* _tmp10_;
		gchar* _tmp11_;
		gchar* _tmp12_;
#line 791 "../src/client/accounts/accounts-manager.vala"
		_tmp9_ = mail;
#line 791 "../src/client/accounts/accounts-manager.vala"
		g_object_get (_tmp9_, "imap-host", &_tmp10_, NULL);
#line 791 "../src/client/accounts/accounts-manager.vala"
		_tmp11_ = _tmp10_;
#line 791 "../src/client/accounts/accounts-manager.vala"
		_tmp12_ = _tmp11_;
#line 791 "../src/client/accounts/accounts-manager.vala"
		_tmp2_ = !geary_string_is_empty (_tmp12_);
#line 791 "../src/client/accounts/accounts-manager.vala"
		_g_free0 (_tmp12_);
#line 7929 "accounts-manager.c"
	} else {
#line 789 "../src/client/accounts/accounts-manager.vala"
		_tmp2_ = FALSE;
#line 7933 "accounts-manager.c"
	}
#line 789 "../src/client/accounts/accounts-manager.vala"
	if (_tmp2_) {
#line 7937 "accounts-manager.c"
		GoaMail* _tmp13_;
		gchar* _tmp14_;
		gchar* _tmp15_;
		gchar* _tmp16_;
#line 792 "../src/client/accounts/accounts-manager.vala"
		_tmp13_ = mail;
#line 792 "../src/client/accounts/accounts-manager.vala"
		g_object_get (_tmp13_, "smtp-host", &_tmp14_, NULL);
#line 792 "../src/client/accounts/accounts-manager.vala"
		_tmp15_ = _tmp14_;
#line 792 "../src/client/accounts/accounts-manager.vala"
		_tmp16_ = _tmp15_;
#line 792 "../src/client/accounts/accounts-manager.vala"
		_tmp1_ = !geary_string_is_empty (_tmp16_);
#line 792 "../src/client/accounts/accounts-manager.vala"
		_g_free0 (_tmp16_);
#line 7954 "accounts-manager.c"
	} else {
#line 789 "../src/client/accounts/accounts-manager.vala"
		_tmp1_ = FALSE;
#line 7958 "accounts-manager.c"
	}
#line 788 "../src/client/accounts/accounts-manager.vala"
	result = _tmp1_;
#line 788 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (mail);
#line 788 "../src/client/accounts/accounts-manager.vala"
	return result;
#line 7966 "accounts-manager.c"
}


static void
accounts_manager_create_goa_account_data_free (gpointer _data)
{
	AccountsManagerCreateGoaAccountData* _data_;
	_data_ = _data;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->account);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->cancellable);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->self);
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_slice_free (AccountsManagerCreateGoaAccountData, _data_);
#line 7983 "accounts-manager.c"
}


static void
accounts_manager_create_goa_account (AccountsManager* self,
                                     GoaObject* account,
                                     GCancellable* cancellable,
                                     GAsyncReadyCallback _callback_,
                                     gpointer _user_data_)
{
	AccountsManagerCreateGoaAccountData* _data_;
	AccountsManager* _tmp0_;
	GoaObject* _tmp1_;
	GCancellable* _tmp2_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_ = g_slice_new0 (AccountsManagerCreateGoaAccountData);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_task_set_task_data (_data_->_async_result, _data_, accounts_manager_create_goa_account_data_free);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->self = _tmp0_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_tmp1_ = _g_object_ref0 (account);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->account);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->account = _tmp1_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_tmp2_ = _g_object_ref0 (cancellable);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->cancellable);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->cancellable = _tmp2_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_create_goa_account_co (_data_);
#line 8022 "accounts-manager.c"
}


static void
accounts_manager_create_goa_account_finish (AccountsManager* self,
                                            GAsyncResult* _res_)
{
	AccountsManagerCreateGoaAccountData* _data_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 24 "../src/client/accounts/accounts-manager.vala"
	if (NULL == _data_) {
#line 24 "../src/client/accounts/accounts-manager.vala"
		return;
#line 8037 "accounts-manager.c"
	}
}


static void
accounts_manager_create_goa_account_ready (GObject* source_object,
                                           GAsyncResult* _res_,
                                           gpointer _user_data_)
{
	AccountsManagerCreateGoaAccountData* _data_;
#line 818 "../src/client/accounts/accounts-manager.vala"
	_data_ = _user_data_;
#line 818 "../src/client/accounts/accounts-manager.vala"
	_data_->_source_object_ = source_object;
#line 818 "../src/client/accounts/accounts-manager.vala"
	_data_->_res_ = _res_;
#line 818 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_create_goa_account_co (_data_);
#line 8056 "accounts-manager.c"
}


static gboolean
accounts_manager_create_goa_account_co (AccountsManagerCreateGoaAccountData* _data_)
{
#line 796 "../src/client/accounts/accounts-manager.vala"
	switch (_data_->_state_) {
#line 796 "../src/client/accounts/accounts-manager.vala"
		case 0:
#line 8067 "accounts-manager.c"
		goto _state_0;
#line 796 "../src/client/accounts/accounts-manager.vala"
		case 1:
#line 8071 "accounts-manager.c"
		goto _state_1;
#line 796 "../src/client/accounts/accounts-manager.vala"
		case 2:
#line 8075 "accounts-manager.c"
		goto _state_2;
#line 796 "../src/client/accounts/accounts-manager.vala"
		case 3:
#line 8079 "accounts-manager.c"
		goto _state_3;
		default:
#line 796 "../src/client/accounts/accounts-manager.vala"
		g_assert_not_reached ();
#line 8084 "accounts-manager.c"
	}
	_state_0:
#line 798 "../src/client/accounts/accounts-manager.vala"
	if (accounts_manager_is_valid_goa_account (_data_->self, _data_->account)) {
#line 799 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp0_ = goa_object_get_mail (_data_->account);
#line 799 "../src/client/accounts/accounts-manager.vala"
		_data_->mail = _data_->_tmp0_;
#line 800 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp1_ = _data_->mail;
#line 800 "../src/client/accounts/accounts-manager.vala"
		g_object_get (_data_->_tmp1_, "name", &_data_->_tmp2_, NULL);
#line 800 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp3_ = _data_->_tmp2_;
#line 800 "../src/client/accounts/accounts-manager.vala"
		_data_->name = _data_->_tmp3_;
#line 801 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp4_ = _data_->name;
#line 801 "../src/client/accounts/accounts-manager.vala"
		if (geary_string_is_empty_or_whitespace (_data_->_tmp4_)) {
#line 802 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp5_ = accounts_manager_get_account_name (_data_->self);
#line 802 "../src/client/accounts/accounts-manager.vala"
			_g_free0 (_data_->name);
#line 802 "../src/client/accounts/accounts-manager.vala"
			_data_->name = _data_->_tmp5_;
#line 8111 "accounts-manager.c"
		}
#line 805 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp6_ = goa_mediator_new (_data_->account);
#line 805 "../src/client/accounts/accounts-manager.vala"
		_data_->mediator = _data_->_tmp6_;
#line 806 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp7_ = accounts_manager_to_geary_id (_data_->self, _data_->account);
#line 806 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp8_ = _data_->_tmp7_;
#line 806 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp9_ = _data_->mediator;
#line 806 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp10_ = _data_->mediator;
#line 806 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp11_ = _data_->name;
#line 806 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp12_ = _data_->mail;
#line 806 "../src/client/accounts/accounts-manager.vala"
		g_object_get (_data_->_tmp12_, "email-address", &_data_->_tmp13_, NULL);
#line 806 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp14_ = _data_->_tmp13_;
#line 806 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp15_ = _data_->_tmp14_;
#line 806 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp16_ = geary_rf_c822_mailbox_address_new (_data_->_tmp11_, _data_->_tmp15_);
#line 806 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp17_ = _data_->_tmp16_;
#line 806 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp18_ = geary_account_information_new (_data_->_tmp8_, goa_mediator_get_service_provider (_data_->_tmp9_), G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp10_, GEARY_TYPE_CREDENTIALS_MEDIATOR, GearyCredentialsMediator), _data_->_tmp17_);
#line 806 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp19_ = _data_->_tmp18_;
#line 806 "../src/client/accounts/accounts-manager.vala"
		_g_object_unref0 (_data_->_tmp17_);
#line 806 "../src/client/accounts/accounts-manager.vala"
		_g_free0 (_data_->_tmp15_);
#line 806 "../src/client/accounts/accounts-manager.vala"
		_g_free0 (_data_->_tmp8_);
#line 806 "../src/client/accounts/accounts-manager.vala"
		_data_->info = _data_->_tmp19_;
#line 813 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp20_ = _data_->info;
#line 813 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp21_ = geary_account_information_next_ordinal;
#line 813 "../src/client/accounts/accounts-manager.vala"
		geary_account_information_next_ordinal = _data_->_tmp21_ + 1;
#line 813 "../src/client/accounts/accounts-manager.vala"
		geary_account_information_set_ordinal (_data_->_tmp20_, _data_->_tmp21_);
#line 814 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp22_ = _data_->info;
#line 814 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp23_ = _data_->mediator;
#line 814 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp24_ = goa_mediator_get_service_label (_data_->_tmp23_);
#line 814 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp25_ = _data_->_tmp24_;
#line 814 "../src/client/accounts/accounts-manager.vala"
		geary_account_information_set_service_label (_data_->_tmp22_, _data_->_tmp25_);
#line 814 "../src/client/accounts/accounts-manager.vala"
		_g_free0 (_data_->_tmp25_);
#line 815 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp26_ = _data_->info;
#line 815 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp27_ = goa_object_get_account (_data_->account);
#line 815 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp28_ = _data_->_tmp27_;
#line 815 "../src/client/accounts/accounts-manager.vala"
		g_object_get (_data_->_tmp28_, "presentation-identity", &_data_->_tmp29_, NULL);
#line 815 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp30_ = _data_->_tmp29_;
#line 815 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp31_ = _data_->_tmp30_;
#line 815 "../src/client/accounts/accounts-manager.vala"
		geary_account_information_set_label (_data_->_tmp26_, _data_->_tmp31_);
#line 815 "../src/client/accounts/accounts-manager.vala"
		_g_free0 (_data_->_tmp31_);
#line 815 "../src/client/accounts/accounts-manager.vala"
		_g_object_unref0 (_data_->_tmp28_);
#line 8189 "accounts-manager.c"
		{
#line 818 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp32_ = _data_->info;
#line 818 "../src/client/accounts/accounts-manager.vala"
			_data_->_state_ = 1;
#line 818 "../src/client/accounts/accounts-manager.vala"
			accounts_manager_create_account_dirs (_data_->self, _data_->_tmp32_, _data_->cancellable, accounts_manager_create_goa_account_ready, _data_);
#line 818 "../src/client/accounts/accounts-manager.vala"
			return FALSE;
#line 8199 "accounts-manager.c"
			_state_1:
#line 818 "../src/client/accounts/accounts-manager.vala"
			accounts_manager_create_account_dirs_finish (_data_->self, _data_->_res_, &_data_->_inner_error_);
#line 818 "../src/client/accounts/accounts-manager.vala"
			if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 8205 "accounts-manager.c"
				goto __catch95_g_error;
			}
#line 819 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp33_ = _data_->info;
#line 819 "../src/client/accounts/accounts-manager.vala"
			_data_->_state_ = 2;
#line 819 "../src/client/accounts/accounts-manager.vala"
			accounts_manager_save_account (_data_->self, _data_->_tmp33_, _data_->cancellable, accounts_manager_create_goa_account_ready, _data_);
#line 819 "../src/client/accounts/accounts-manager.vala"
			return FALSE;
#line 8216 "accounts-manager.c"
			_state_2:
#line 819 "../src/client/accounts/accounts-manager.vala"
			accounts_manager_save_account_finish (_data_->self, _data_->_res_, &_data_->_inner_error_);
#line 819 "../src/client/accounts/accounts-manager.vala"
			if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 8222 "accounts-manager.c"
				goto __catch95_g_error;
			}
#line 820 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp34_ = _data_->mediator;
#line 820 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp35_ = _data_->info;
#line 820 "../src/client/accounts/accounts-manager.vala"
			_data_->_state_ = 3;
#line 820 "../src/client/accounts/accounts-manager.vala"
			goa_mediator_update (_data_->_tmp34_, _data_->_tmp35_, _data_->cancellable, accounts_manager_create_goa_account_ready, _data_);
#line 820 "../src/client/accounts/accounts-manager.vala"
			return FALSE;
#line 8235 "accounts-manager.c"
			_state_3:
#line 820 "../src/client/accounts/accounts-manager.vala"
			goa_mediator_update_finish (_data_->_tmp34_, _data_->_res_, &_data_->_inner_error_);
#line 820 "../src/client/accounts/accounts-manager.vala"
			if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 8241 "accounts-manager.c"
				goto __catch95_g_error;
			}
		}
		goto __finally95;
		__catch95_g_error:
		{
#line 817 "../src/client/accounts/accounts-manager.vala"
			_data_->err = _data_->_inner_error_;
#line 817 "../src/client/accounts/accounts-manager.vala"
			_data_->_inner_error_ = NULL;
#line 822 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp36_ = _data_->err;
#line 822 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp37_ = geary_problem_report_new (GEARY_PROBLEM_TYPE_GENERIC_ERROR, _data_->_tmp36_);
#line 822 "../src/client/accounts/accounts-manager.vala"
			_data_->_tmp38_ = _data_->_tmp37_;
#line 822 "../src/client/accounts/accounts-manager.vala"
			g_signal_emit (_data_->self, accounts_manager_signals[ACCOUNTS_MANAGER_REPORT_PROBLEM_SIGNAL], 0, _data_->_tmp38_);
#line 822 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->_tmp38_);
#line 817 "../src/client/accounts/accounts-manager.vala"
			_g_error_free0 (_data_->err);
#line 8264 "accounts-manager.c"
		}
		__finally95:
#line 817 "../src/client/accounts/accounts-manager.vala"
		if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 817 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->info);
#line 817 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->mediator);
#line 817 "../src/client/accounts/accounts-manager.vala"
			_g_free0 (_data_->name);
#line 817 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_data_->mail);
#line 817 "../src/client/accounts/accounts-manager.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error_->message, g_quark_to_string (_data_->_inner_error_->domain), _data_->_inner_error_->code);
#line 817 "../src/client/accounts/accounts-manager.vala"
			g_clear_error (&_data_->_inner_error_);
#line 817 "../src/client/accounts/accounts-manager.vala"
			g_object_unref (_data_->_async_result);
#line 817 "../src/client/accounts/accounts-manager.vala"
			return FALSE;
#line 8285 "accounts-manager.c"
		}
#line 829 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp39_ = _data_->info;
#line 829 "../src/client/accounts/accounts-manager.vala"
		accounts_manager_set_enabled (_data_->self, _data_->_tmp39_, TRUE);
#line 798 "../src/client/accounts/accounts-manager.vala"
		_g_object_unref0 (_data_->info);
#line 798 "../src/client/accounts/accounts-manager.vala"
		_g_object_unref0 (_data_->mediator);
#line 798 "../src/client/accounts/accounts-manager.vala"
		_g_free0 (_data_->name);
#line 798 "../src/client/accounts/accounts-manager.vala"
		_g_object_unref0 (_data_->mail);
#line 8299 "accounts-manager.c"
	} else {
#line 831 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp40_ = goa_object_get_account (_data_->account);
#line 831 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp41_ = _data_->_tmp40_;
#line 831 "../src/client/accounts/accounts-manager.vala"
		g_object_get (_data_->_tmp41_, "provider-type", &_data_->_tmp42_, NULL);
#line 831 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp43_ = _data_->_tmp42_;
#line 831 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp44_ = _data_->_tmp43_;
#line 831 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp45_ = goa_object_get_account (_data_->account);
#line 831 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp46_ = _data_->_tmp45_;
#line 831 "../src/client/accounts/accounts-manager.vala"
		g_object_get (_data_->_tmp46_, "id", &_data_->_tmp47_, NULL);
#line 831 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp48_ = _data_->_tmp47_;
#line 831 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp49_ = _data_->_tmp48_;
#line 831 "../src/client/accounts/accounts-manager.vala"
		g_debug ("accounts-manager.vala:831: Ignoring GOA %s account %s, mail service no" \
"t enabled", _data_->_tmp44_, _data_->_tmp49_);
#line 831 "../src/client/accounts/accounts-manager.vala"
		_g_free0 (_data_->_tmp49_);
#line 831 "../src/client/accounts/accounts-manager.vala"
		_g_object_unref0 (_data_->_tmp46_);
#line 831 "../src/client/accounts/accounts-manager.vala"
		_g_free0 (_data_->_tmp44_);
#line 831 "../src/client/accounts/accounts-manager.vala"
		_g_object_unref0 (_data_->_tmp41_);
#line 8331 "accounts-manager.c"
	}
#line 796 "../src/client/accounts/accounts-manager.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 796 "../src/client/accounts/accounts-manager.vala"
	if (_data_->_state_ != 0) {
#line 796 "../src/client/accounts/accounts-manager.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 796 "../src/client/accounts/accounts-manager.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 8341 "accounts-manager.c"
		}
	}
#line 796 "../src/client/accounts/accounts-manager.vala"
	g_object_unref (_data_->_async_result);
#line 796 "../src/client/accounts/accounts-manager.vala"
	return FALSE;
#line 8348 "accounts-manager.c"
}


static void
accounts_manager_update_goa_account_data_free (gpointer _data)
{
	AccountsManagerUpdateGoaAccountData* _data_;
	_data_ = _data;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->account);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->cancellable);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->self);
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_slice_free (AccountsManagerUpdateGoaAccountData, _data_);
#line 8365 "accounts-manager.c"
}


static void
accounts_manager_update_goa_account (AccountsManager* self,
                                     GearyAccountInformation* account,
                                     gboolean is_available,
                                     GCancellable* cancellable,
                                     GAsyncReadyCallback _callback_,
                                     gpointer _user_data_)
{
	AccountsManagerUpdateGoaAccountData* _data_;
	AccountsManager* _tmp0_;
	GearyAccountInformation* _tmp1_;
	GCancellable* _tmp2_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_ = g_slice_new0 (AccountsManagerUpdateGoaAccountData);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_task_set_task_data (_data_->_async_result, _data_, accounts_manager_update_goa_account_data_free);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->self = _tmp0_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_tmp1_ = _g_object_ref0 (account);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->account);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->account = _tmp1_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->is_available = is_available;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_tmp2_ = _g_object_ref0 (cancellable);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->cancellable);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->cancellable = _tmp2_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_update_goa_account_co (_data_);
#line 8407 "accounts-manager.c"
}


static void
accounts_manager_update_goa_account_finish (AccountsManager* self,
                                            GAsyncResult* _res_)
{
	AccountsManagerUpdateGoaAccountData* _data_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), NULL);
#line 24 "../src/client/accounts/accounts-manager.vala"
	if (NULL == _data_) {
#line 24 "../src/client/accounts/accounts-manager.vala"
		return;
#line 8422 "accounts-manager.c"
	}
}


static void
accounts_manager_update_goa_account_ready (GObject* source_object,
                                           GAsyncResult* _res_,
                                           gpointer _user_data_)
{
	AccountsManagerUpdateGoaAccountData* _data_;
#line 844 "../src/client/accounts/accounts-manager.vala"
	_data_ = _user_data_;
#line 844 "../src/client/accounts/accounts-manager.vala"
	_data_->_source_object_ = source_object;
#line 844 "../src/client/accounts/accounts-manager.vala"
	_data_->_res_ = _res_;
#line 844 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_update_goa_account_co (_data_);
#line 8441 "accounts-manager.c"
}


static gboolean
accounts_manager_update_goa_account_co (AccountsManagerUpdateGoaAccountData* _data_)
{
#line 839 "../src/client/accounts/accounts-manager.vala"
	switch (_data_->_state_) {
#line 839 "../src/client/accounts/accounts-manager.vala"
		case 0:
#line 8452 "accounts-manager.c"
		goto _state_0;
#line 839 "../src/client/accounts/accounts-manager.vala"
		case 1:
#line 8456 "accounts-manager.c"
		goto _state_1;
#line 839 "../src/client/accounts/accounts-manager.vala"
		case 2:
#line 8460 "accounts-manager.c"
		goto _state_2;
#line 839 "../src/client/accounts/accounts-manager.vala"
		case 3:
#line 8464 "accounts-manager.c"
		goto _state_3;
		default:
#line 839 "../src/client/accounts/accounts-manager.vala"
		g_assert_not_reached ();
#line 8469 "accounts-manager.c"
	}
	_state_0:
#line 842 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp0_ = geary_account_information_get_mediator (_data_->account);
#line 842 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp1_ = _data_->_tmp0_;
#line 842 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp2_ = _g_object_ref0 (G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp1_, TYPE_GOA_MEDIATOR, GoaMediator));
#line 842 "../src/client/accounts/accounts-manager.vala"
	_data_->mediator = _data_->_tmp2_;
#line 8480 "accounts-manager.c"
	{
#line 844 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp3_ = _data_->mediator;
#line 844 "../src/client/accounts/accounts-manager.vala"
		_data_->_state_ = 1;
#line 844 "../src/client/accounts/accounts-manager.vala"
		goa_mediator_update (_data_->_tmp3_, _data_->account, _data_->cancellable, accounts_manager_update_goa_account_ready, _data_);
#line 844 "../src/client/accounts/accounts-manager.vala"
		return FALSE;
#line 8490 "accounts-manager.c"
		_state_1:
#line 844 "../src/client/accounts/accounts-manager.vala"
		goa_mediator_update_finish (_data_->_tmp3_, _data_->_res_, &_data_->_inner_error_);
#line 844 "../src/client/accounts/accounts-manager.vala"
		if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 8496 "accounts-manager.c"
			goto __catch96_g_error;
		}
#line 846 "../src/client/accounts/accounts-manager.vala"
		if (_data_->is_available) {
#line 849 "../src/client/accounts/accounts-manager.vala"
			_data_->_state_ = 2;
#line 849 "../src/client/accounts/accounts-manager.vala"
			geary_account_information_load_outgoing_credentials (_data_->account, _data_->cancellable, accounts_manager_update_goa_account_ready, _data_);
#line 849 "../src/client/accounts/accounts-manager.vala"
			return FALSE;
#line 8507 "accounts-manager.c"
			_state_2:
#line 849 "../src/client/accounts/accounts-manager.vala"
			geary_account_information_load_outgoing_credentials_finish (_data_->account, _data_->_res_, &_data_->_inner_error_);
#line 849 "../src/client/accounts/accounts-manager.vala"
			if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 8513 "accounts-manager.c"
				goto __catch96_g_error;
			}
#line 850 "../src/client/accounts/accounts-manager.vala"
			_data_->_state_ = 3;
#line 850 "../src/client/accounts/accounts-manager.vala"
			geary_account_information_load_incoming_credentials (_data_->account, _data_->cancellable, accounts_manager_update_goa_account_ready, _data_);
#line 850 "../src/client/accounts/accounts-manager.vala"
			return FALSE;
#line 8522 "accounts-manager.c"
			_state_3:
#line 850 "../src/client/accounts/accounts-manager.vala"
			geary_account_information_load_incoming_credentials_finish (_data_->account, _data_->_res_, &_data_->_inner_error_);
#line 850 "../src/client/accounts/accounts-manager.vala"
			if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 8528 "accounts-manager.c"
				goto __catch96_g_error;
			}
		}
	}
	goto __finally96;
	__catch96_g_error:
	{
#line 843 "../src/client/accounts/accounts-manager.vala"
		_data_->err = _data_->_inner_error_;
#line 843 "../src/client/accounts/accounts-manager.vala"
		_data_->_inner_error_ = NULL;
#line 853 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp4_ = _data_->err;
#line 853 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp5_ = geary_account_problem_report_new (GEARY_PROBLEM_TYPE_GENERIC_ERROR, _data_->account, _data_->_tmp4_);
#line 853 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp6_ = _data_->_tmp5_;
#line 853 "../src/client/accounts/accounts-manager.vala"
		g_signal_emit (_data_->self, accounts_manager_signals[ACCOUNTS_MANAGER_REPORT_PROBLEM_SIGNAL], 0, G_TYPE_CHECK_INSTANCE_CAST (_data_->_tmp6_, GEARY_TYPE_PROBLEM_REPORT, GearyProblemReport));
#line 853 "../src/client/accounts/accounts-manager.vala"
		_g_object_unref0 (_data_->_tmp6_);
#line 843 "../src/client/accounts/accounts-manager.vala"
		_g_error_free0 (_data_->err);
#line 8552 "accounts-manager.c"
	}
	__finally96:
#line 843 "../src/client/accounts/accounts-manager.vala"
	if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 843 "../src/client/accounts/accounts-manager.vala"
		_g_object_unref0 (_data_->mediator);
#line 843 "../src/client/accounts/accounts-manager.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _data_->_inner_error_->message, g_quark_to_string (_data_->_inner_error_->domain), _data_->_inner_error_->code);
#line 843 "../src/client/accounts/accounts-manager.vala"
		g_clear_error (&_data_->_inner_error_);
#line 843 "../src/client/accounts/accounts-manager.vala"
		g_object_unref (_data_->_async_result);
#line 843 "../src/client/accounts/accounts-manager.vala"
		return FALSE;
#line 8567 "accounts-manager.c"
	}
#line 861 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_set_available (_data_->self, _data_->account, _data_->is_available);
#line 839 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->mediator);
#line 839 "../src/client/accounts/accounts-manager.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 839 "../src/client/accounts/accounts-manager.vala"
	if (_data_->_state_ != 0) {
#line 839 "../src/client/accounts/accounts-manager.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 839 "../src/client/accounts/accounts-manager.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 8581 "accounts-manager.c"
		}
	}
#line 839 "../src/client/accounts/accounts-manager.vala"
	g_object_unref (_data_->_async_result);
#line 839 "../src/client/accounts/accounts-manager.vala"
	return FALSE;
#line 8588 "accounts-manager.c"
}


static void
accounts_manager_open_goa_settings_data_free (gpointer _data)
{
	AccountsManagerOpenGoaSettingsData* _data_;
	_data_ = _data;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_free0 (_data_->action);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_free0 (_data_->param);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->cancellable);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->self);
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_slice_free (AccountsManagerOpenGoaSettingsData, _data_);
#line 8607 "accounts-manager.c"
}


static void
accounts_manager_open_goa_settings (AccountsManager* self,
                                    const gchar* action,
                                    const gchar* param,
                                    GCancellable* cancellable,
                                    GAsyncReadyCallback _callback_,
                                    gpointer _user_data_)
{
	AccountsManagerOpenGoaSettingsData* _data_;
	AccountsManager* _tmp0_;
	gchar* _tmp1_;
	gchar* _tmp2_;
	GCancellable* _tmp3_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_ = g_slice_new0 (AccountsManagerOpenGoaSettingsData);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->_async_result = g_task_new (G_OBJECT (self), cancellable, _callback_, _user_data_);
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_task_set_task_data (_data_->_async_result, _data_, accounts_manager_open_goa_settings_data_free);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_tmp0_ = _g_object_ref0 (self);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->self = _tmp0_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_tmp1_ = g_strdup (action);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_free0 (_data_->action);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->action = _tmp1_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_tmp2_ = g_strdup (param);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_free0 (_data_->param);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->param = _tmp2_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_tmp3_ = _g_object_ref0 (cancellable);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->cancellable);
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_->cancellable = _tmp3_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_open_goa_settings_co (_data_);
#line 8654 "accounts-manager.c"
}


static void
accounts_manager_open_goa_settings_finish (AccountsManager* self,
                                           GAsyncResult* _res_,
                                           GError** error)
{
	AccountsManagerOpenGoaSettingsData* _data_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	_data_ = g_task_propagate_pointer (G_TASK (_res_), error);
#line 24 "../src/client/accounts/accounts-manager.vala"
	if (NULL == _data_) {
#line 24 "../src/client/accounts/accounts-manager.vala"
		return;
#line 8670 "accounts-manager.c"
	}
}


static void
accounts_manager_open_goa_settings_ready (GObject* source_object,
                                          GAsyncResult* _res_,
                                          gpointer _user_data_)
{
	AccountsManagerOpenGoaSettingsData* _data_;
#line 872 "../src/client/accounts/accounts-manager.vala"
	_data_ = _user_data_;
#line 872 "../src/client/accounts/accounts-manager.vala"
	_data_->_source_object_ = source_object;
#line 872 "../src/client/accounts/accounts-manager.vala"
	_data_->_res_ = _res_;
#line 872 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_open_goa_settings_co (_data_);
#line 8689 "accounts-manager.c"
}


static void
_vala_array_add1 (GVariant** * array,
                  int* length,
                  int* size,
                  GVariant* value)
{
#line 890 "../src/client/accounts/accounts-manager.vala"
	if ((*length) == (*size)) {
#line 890 "../src/client/accounts/accounts-manager.vala"
		*size = (*size) ? (2 * (*size)) : 4;
#line 890 "../src/client/accounts/accounts-manager.vala"
		*array = g_renew (GVariant*, *array, (*size) + 1);
#line 8705 "accounts-manager.c"
	}
#line 890 "../src/client/accounts/accounts-manager.vala"
	(*array)[(*length)++] = value;
#line 890 "../src/client/accounts/accounts-manager.vala"
	(*array)[*length] = NULL;
#line 8711 "accounts-manager.c"
}


static gboolean
accounts_manager_open_goa_settings_co (AccountsManagerOpenGoaSettingsData* _data_)
{
#line 865 "../src/client/accounts/accounts-manager.vala"
	switch (_data_->_state_) {
#line 865 "../src/client/accounts/accounts-manager.vala"
		case 0:
#line 8722 "accounts-manager.c"
		goto _state_0;
#line 865 "../src/client/accounts/accounts-manager.vala"
		case 1:
#line 8726 "accounts-manager.c"
		goto _state_1;
#line 865 "../src/client/accounts/accounts-manager.vala"
		case 2:
#line 8730 "accounts-manager.c"
		goto _state_2;
		default:
#line 865 "../src/client/accounts/accounts-manager.vala"
		g_assert_not_reached ();
#line 8735 "accounts-manager.c"
	}
	_state_0:
#line 872 "../src/client/accounts/accounts-manager.vala"
	_data_->_state_ = 1;
#line 872 "../src/client/accounts/accounts-manager.vala"
	g_dbus_proxy_new_for_bus (G_BUS_TYPE_SESSION, G_DBUS_PROXY_FLAGS_NONE, NULL, "org.gnome.ControlCenter", "/org/gnome/ControlCenter", "org.gtk.Actions", _data_->cancellable, accounts_manager_open_goa_settings_ready, _data_);
#line 872 "../src/client/accounts/accounts-manager.vala"
	return FALSE;
#line 8744 "accounts-manager.c"
	_state_1:
#line 872 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp0_ = g_dbus_proxy_new_for_bus_finish (_data_->_res_, &_data_->_inner_error_);
#line 872 "../src/client/accounts/accounts-manager.vala"
	_data_->settings = _data_->_tmp0_;
#line 872 "../src/client/accounts/accounts-manager.vala"
	if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 872 "../src/client/accounts/accounts-manager.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error_);
#line 872 "../src/client/accounts/accounts-manager.vala"
		g_object_unref (_data_->_async_result);
#line 872 "../src/client/accounts/accounts-manager.vala"
		return FALSE;
#line 8758 "accounts-manager.c"
	}
#line 886 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp1_ = g_variant_new_string (_data_->action);
#line 886 "../src/client/accounts/accounts-manager.vala"
	g_variant_ref_sink (_data_->_tmp1_);
#line 886 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp2_ = _data_->_tmp1_;
#line 886 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp3_ = g_variant_new_variant (_data_->_tmp2_);
#line 886 "../src/client/accounts/accounts-manager.vala"
	g_variant_ref_sink (_data_->_tmp3_);
#line 886 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp4_ = g_new0 (GVariant*, 1 + 1);
#line 886 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp4_[0] = _data_->_tmp3_;
#line 886 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp5_ = _data_->_tmp4_;
#line 886 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp5__length1 = 1;
#line 886 "../src/client/accounts/accounts-manager.vala"
	_g_variant_unref0 (_data_->_tmp2_);
#line 886 "../src/client/accounts/accounts-manager.vala"
	_data_->args = _data_->_tmp5_;
#line 886 "../src/client/accounts/accounts-manager.vala"
	_data_->args_length1 = _data_->_tmp5__length1;
#line 886 "../src/client/accounts/accounts-manager.vala"
	_data_->_args_size_ = _data_->args_length1;
#line 889 "../src/client/accounts/accounts-manager.vala"
	if (_data_->param != NULL) {
#line 890 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp6_ = _data_->args;
#line 890 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp6__length1 = _data_->args_length1;
#line 890 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp7_ = g_variant_new_string (_data_->param);
#line 890 "../src/client/accounts/accounts-manager.vala"
		g_variant_ref_sink (_data_->_tmp7_);
#line 890 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp8_ = _data_->_tmp7_;
#line 890 "../src/client/accounts/accounts-manager.vala"
		_data_->_tmp9_ = g_variant_new_variant (_data_->_tmp8_);
#line 890 "../src/client/accounts/accounts-manager.vala"
		g_variant_ref_sink (_data_->_tmp9_);
#line 890 "../src/client/accounts/accounts-manager.vala"
		_vala_array_add1 (&_data_->args, &_data_->args_length1, &_data_->_args_size_, _data_->_tmp9_);
#line 890 "../src/client/accounts/accounts-manager.vala"
		_g_variant_unref0 (_data_->_tmp8_);
#line 8806 "accounts-manager.c"
	}
#line 893 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp10_ = g_variant_new_string ("online-accounts");
#line 893 "../src/client/accounts/accounts-manager.vala"
	g_variant_ref_sink (_data_->_tmp10_);
#line 893 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp11_ = G_VARIANT_TYPE_VARIANT;
#line 893 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp12_ = _data_->args;
#line 893 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp12__length1 = _data_->args_length1;
#line 893 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp13_ = g_variant_new_array (_data_->_tmp11_, _data_->_tmp12_, _data_->_tmp12__length1);
#line 893 "../src/client/accounts/accounts-manager.vala"
	g_variant_ref_sink (_data_->_tmp13_);
#line 893 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp14_ = g_new0 (GVariant*, 2 + 1);
#line 893 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp14_[0] = _data_->_tmp10_;
#line 893 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp14_[1] = _data_->_tmp13_;
#line 893 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp15_ = _data_->_tmp14_;
#line 893 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp15__length1 = 2;
#line 893 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp16_ = g_variant_new_tuple (_data_->_tmp15_, 2);
#line 893 "../src/client/accounts/accounts-manager.vala"
	g_variant_ref_sink (_data_->_tmp16_);
#line 893 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp17_ = _data_->_tmp16_;
#line 893 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp15_ = (_vala_array_free (_data_->_tmp15_, _data_->_tmp15__length1, (GDestroyNotify) g_variant_unref), NULL);
#line 893 "../src/client/accounts/accounts-manager.vala"
	_data_->command = _data_->_tmp17_;
#line 900 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp18_ = g_variant_new_string ("launch-panel");
#line 900 "../src/client/accounts/accounts-manager.vala"
	g_variant_ref_sink (_data_->_tmp18_);
#line 900 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp19_ = G_VARIANT_TYPE_VARIANT;
#line 900 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp20_ = _data_->command;
#line 900 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp21_ = g_variant_new_variant (_data_->_tmp20_);
#line 900 "../src/client/accounts/accounts-manager.vala"
	g_variant_ref_sink (_data_->_tmp21_);
#line 900 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp22_ = g_new0 (GVariant*, 1 + 1);
#line 900 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp22_[0] = _data_->_tmp21_;
#line 900 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp23_ = _data_->_tmp22_;
#line 900 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp23__length1 = 1;
#line 900 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp24_ = g_variant_new_array (_data_->_tmp19_, _data_->_tmp23_, 1);
#line 900 "../src/client/accounts/accounts-manager.vala"
	g_variant_ref_sink (_data_->_tmp24_);
#line 900 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp25_ = g_variant_new ("a{sv}", NULL);
#line 900 "../src/client/accounts/accounts-manager.vala"
	g_variant_ref_sink (_data_->_tmp25_);
#line 900 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp26_ = g_new0 (GVariant*, 3 + 1);
#line 900 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp26_[0] = _data_->_tmp18_;
#line 900 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp26_[1] = _data_->_tmp24_;
#line 900 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp26_[2] = _data_->_tmp25_;
#line 900 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp27_ = _data_->_tmp26_;
#line 900 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp27__length1 = 3;
#line 900 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp28_ = g_variant_new_tuple (_data_->_tmp27_, 3);
#line 900 "../src/client/accounts/accounts-manager.vala"
	g_variant_ref_sink (_data_->_tmp28_);
#line 900 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp29_ = _data_->_tmp28_;
#line 900 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp27_ = (_vala_array_free (_data_->_tmp27_, _data_->_tmp27__length1, (GDestroyNotify) g_variant_unref), NULL);
#line 900 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp23_ = (_vala_array_free (_data_->_tmp23_, _data_->_tmp23__length1, (GDestroyNotify) g_variant_unref), NULL);
#line 900 "../src/client/accounts/accounts-manager.vala"
	_data_->params = _data_->_tmp29_;
#line 913 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp30_ = _data_->settings;
#line 913 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp31_ = _data_->params;
#line 913 "../src/client/accounts/accounts-manager.vala"
	_data_->_state_ = 2;
#line 913 "../src/client/accounts/accounts-manager.vala"
	g_dbus_proxy_call (_data_->_tmp30_, "Activate", _data_->_tmp31_, G_DBUS_CALL_FLAGS_NONE, -1, _data_->cancellable, accounts_manager_open_goa_settings_ready, _data_);
#line 913 "../src/client/accounts/accounts-manager.vala"
	return FALSE;
#line 8904 "accounts-manager.c"
	_state_2:
#line 913 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp32_ = g_dbus_proxy_call_finish (_data_->_tmp30_, _data_->_res_, &_data_->_inner_error_);
#line 913 "../src/client/accounts/accounts-manager.vala"
	_data_->_tmp33_ = _data_->_tmp32_;
#line 913 "../src/client/accounts/accounts-manager.vala"
	_g_variant_unref0 (_data_->_tmp33_);
#line 913 "../src/client/accounts/accounts-manager.vala"
	if (G_UNLIKELY (_data_->_inner_error_ != NULL)) {
#line 913 "../src/client/accounts/accounts-manager.vala"
		g_task_return_error (_data_->_async_result, _data_->_inner_error_);
#line 913 "../src/client/accounts/accounts-manager.vala"
		_g_variant_unref0 (_data_->params);
#line 913 "../src/client/accounts/accounts-manager.vala"
		_g_variant_unref0 (_data_->command);
#line 913 "../src/client/accounts/accounts-manager.vala"
		_data_->args = (_vala_array_free (_data_->args, _data_->args_length1, (GDestroyNotify) g_variant_unref), NULL);
#line 913 "../src/client/accounts/accounts-manager.vala"
		_g_object_unref0 (_data_->settings);
#line 913 "../src/client/accounts/accounts-manager.vala"
		g_object_unref (_data_->_async_result);
#line 913 "../src/client/accounts/accounts-manager.vala"
		return FALSE;
#line 8928 "accounts-manager.c"
	}
#line 865 "../src/client/accounts/accounts-manager.vala"
	_g_variant_unref0 (_data_->params);
#line 865 "../src/client/accounts/accounts-manager.vala"
	_g_variant_unref0 (_data_->command);
#line 865 "../src/client/accounts/accounts-manager.vala"
	_data_->args = (_vala_array_free (_data_->args, _data_->args_length1, (GDestroyNotify) g_variant_unref), NULL);
#line 865 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data_->settings);
#line 865 "../src/client/accounts/accounts-manager.vala"
	g_task_return_pointer (_data_->_async_result, _data_, NULL);
#line 865 "../src/client/accounts/accounts-manager.vala"
	if (_data_->_state_ != 0) {
#line 865 "../src/client/accounts/accounts-manager.vala"
		while (!g_task_get_completed (_data_->_async_result)) {
#line 865 "../src/client/accounts/accounts-manager.vala"
			g_main_context_iteration (g_task_get_context (_data_->_async_result), TRUE);
#line 8946 "accounts-manager.c"
		}
	}
#line 865 "../src/client/accounts/accounts-manager.vala"
	g_object_unref (_data_->_async_result);
#line 865 "../src/client/accounts/accounts-manager.vala"
	return FALSE;
#line 8953 "accounts-manager.c"
}


static void
accounts_manager_on_goa_account_added (AccountsManager* self,
                                       GoaObject* account)
{
	GoaAccount* _tmp0_;
	GoaAccount* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
#line 918 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail (ACCOUNTS_IS_MANAGER (self));
#line 918 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail (GOA_IS_OBJECT (account));
#line 919 "../src/client/accounts/accounts-manager.vala"
	_tmp0_ = goa_object_get_account (account);
#line 919 "../src/client/accounts/accounts-manager.vala"
	_tmp1_ = _tmp0_;
#line 919 "../src/client/accounts/accounts-manager.vala"
	g_object_get (_tmp1_, "id", &_tmp2_, NULL);
#line 919 "../src/client/accounts/accounts-manager.vala"
	_tmp3_ = _tmp2_;
#line 919 "../src/client/accounts/accounts-manager.vala"
	_tmp4_ = _tmp3_;
#line 919 "../src/client/accounts/accounts-manager.vala"
	g_debug ("accounts-manager.vala:919: GOA account added: %s", _tmp4_);
#line 919 "../src/client/accounts/accounts-manager.vala"
	_g_free0 (_tmp4_);
#line 919 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_tmp1_);
#line 921 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_create_goa_account (self, account, NULL, NULL, NULL);
#line 8988 "accounts-manager.c"
}


static void
accounts_manager_on_goa_account_changed (AccountsManager* self,
                                         GoaObject* account)
{
	GoaAccount* _tmp0_;
	GoaAccount* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	AccountsManagerAccountState* state = NULL;
	GeeMap* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gpointer _tmp8_;
	AccountsManagerAccountState* _tmp9_;
	AccountsManagerAccountState* _tmp10_;
#line 924 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail (ACCOUNTS_IS_MANAGER (self));
#line 924 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail (GOA_IS_OBJECT (account));
#line 925 "../src/client/accounts/accounts-manager.vala"
	_tmp0_ = goa_object_get_account (account);
#line 925 "../src/client/accounts/accounts-manager.vala"
	_tmp1_ = _tmp0_;
#line 925 "../src/client/accounts/accounts-manager.vala"
	g_object_get (_tmp1_, "id", &_tmp2_, NULL);
#line 925 "../src/client/accounts/accounts-manager.vala"
	_tmp3_ = _tmp2_;
#line 925 "../src/client/accounts/accounts-manager.vala"
	_tmp4_ = _tmp3_;
#line 925 "../src/client/accounts/accounts-manager.vala"
	g_debug ("accounts-manager.vala:925: GOA account changed: %s", _tmp4_);
#line 925 "../src/client/accounts/accounts-manager.vala"
	_g_free0 (_tmp4_);
#line 925 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_tmp1_);
#line 926 "../src/client/accounts/accounts-manager.vala"
	_tmp5_ = self->priv->accounts;
#line 926 "../src/client/accounts/accounts-manager.vala"
	_tmp6_ = accounts_manager_to_geary_id (self, account);
#line 926 "../src/client/accounts/accounts-manager.vala"
	_tmp7_ = _tmp6_;
#line 926 "../src/client/accounts/accounts-manager.vala"
	_tmp8_ = gee_map_get (_tmp5_, _tmp7_);
#line 926 "../src/client/accounts/accounts-manager.vala"
	_tmp9_ = (AccountsManagerAccountState*) _tmp8_;
#line 926 "../src/client/accounts/accounts-manager.vala"
	_g_free0 (_tmp7_);
#line 926 "../src/client/accounts/accounts-manager.vala"
	state = _tmp9_;
#line 928 "../src/client/accounts/accounts-manager.vala"
	_tmp10_ = state;
#line 928 "../src/client/accounts/accounts-manager.vala"
	if (_tmp10_ != NULL) {
#line 9046 "accounts-manager.c"
		AccountsManagerAccountState* _tmp11_;
		GearyAccountInformation* _tmp12_;
		GearyAccountInformation* _tmp13_;
#line 932 "../src/client/accounts/accounts-manager.vala"
		_tmp11_ = state;
#line 932 "../src/client/accounts/accounts-manager.vala"
		_tmp12_ = accounts_manager_account_state_get_account (_tmp11_);
#line 932 "../src/client/accounts/accounts-manager.vala"
		_tmp13_ = _tmp12_;
#line 932 "../src/client/accounts/accounts-manager.vala"
		accounts_manager_update_goa_account (self, _tmp13_, accounts_manager_is_valid_goa_account (self, account), NULL, NULL, NULL);
#line 9058 "accounts-manager.c"
	} else {
#line 942 "../src/client/accounts/accounts-manager.vala"
		accounts_manager_create_goa_account (self, account, NULL, NULL, NULL);
#line 9062 "accounts-manager.c"
	}
#line 924 "../src/client/accounts/accounts-manager.vala"
	_accounts_manager_account_state_unref0 (state);
#line 9066 "accounts-manager.c"
}


static void
accounts_manager_on_goa_account_removed (AccountsManager* self,
                                         GoaObject* account)
{
	GoaAccount* _tmp0_;
	GoaAccount* _tmp1_;
	gchar* _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	AccountsManagerAccountState* state = NULL;
	GeeMap* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gpointer _tmp8_;
	AccountsManagerAccountState* _tmp9_;
	AccountsManagerAccountState* _tmp10_;
#line 946 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail (ACCOUNTS_IS_MANAGER (self));
#line 946 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail (GOA_IS_OBJECT (account));
#line 947 "../src/client/accounts/accounts-manager.vala"
	_tmp0_ = goa_object_get_account (account);
#line 947 "../src/client/accounts/accounts-manager.vala"
	_tmp1_ = _tmp0_;
#line 947 "../src/client/accounts/accounts-manager.vala"
	g_object_get (_tmp1_, "id", &_tmp2_, NULL);
#line 947 "../src/client/accounts/accounts-manager.vala"
	_tmp3_ = _tmp2_;
#line 947 "../src/client/accounts/accounts-manager.vala"
	_tmp4_ = _tmp3_;
#line 947 "../src/client/accounts/accounts-manager.vala"
	g_debug ("accounts-manager.vala:947: GOA account removed: %s", _tmp4_);
#line 947 "../src/client/accounts/accounts-manager.vala"
	_g_free0 (_tmp4_);
#line 947 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_tmp1_);
#line 948 "../src/client/accounts/accounts-manager.vala"
	_tmp5_ = self->priv->accounts;
#line 948 "../src/client/accounts/accounts-manager.vala"
	_tmp6_ = accounts_manager_to_geary_id (self, account);
#line 948 "../src/client/accounts/accounts-manager.vala"
	_tmp7_ = _tmp6_;
#line 948 "../src/client/accounts/accounts-manager.vala"
	_tmp8_ = gee_map_get (_tmp5_, _tmp7_);
#line 948 "../src/client/accounts/accounts-manager.vala"
	_tmp9_ = (AccountsManagerAccountState*) _tmp8_;
#line 948 "../src/client/accounts/accounts-manager.vala"
	_g_free0 (_tmp7_);
#line 948 "../src/client/accounts/accounts-manager.vala"
	state = _tmp9_;
#line 949 "../src/client/accounts/accounts-manager.vala"
	_tmp10_ = state;
#line 949 "../src/client/accounts/accounts-manager.vala"
	if (_tmp10_ != NULL) {
#line 9124 "accounts-manager.c"
		AccountsManagerAccountState* _tmp11_;
		GearyAccountInformation* _tmp12_;
		GearyAccountInformation* _tmp13_;
#line 952 "../src/client/accounts/accounts-manager.vala"
		_tmp11_ = state;
#line 952 "../src/client/accounts/accounts-manager.vala"
		_tmp12_ = accounts_manager_account_state_get_account (_tmp11_);
#line 952 "../src/client/accounts/accounts-manager.vala"
		_tmp13_ = _tmp12_;
#line 952 "../src/client/accounts/accounts-manager.vala"
		accounts_manager_set_available (self, _tmp13_, FALSE);
#line 9136 "accounts-manager.c"
	}
#line 946 "../src/client/accounts/accounts-manager.vala"
	_accounts_manager_account_state_unref0 (state);
#line 9140 "accounts-manager.c"
}


static Block23Data*
block23_data_ref (Block23Data* _data23_)
{
#line 956 "../src/client/accounts/accounts-manager.vala"
	g_atomic_int_inc (&_data23_->_ref_count_);
#line 956 "../src/client/accounts/accounts-manager.vala"
	return _data23_;
#line 9151 "accounts-manager.c"
}


static void
block23_data_unref (void * _userdata_)
{
	Block23Data* _data23_;
	_data23_ = (Block23Data*) _userdata_;
#line 956 "../src/client/accounts/accounts-manager.vala"
	if (g_atomic_int_dec_and_test (&_data23_->_ref_count_)) {
#line 9162 "accounts-manager.c"
		AccountsManager* self;
#line 956 "../src/client/accounts/accounts-manager.vala"
		self = _data23_->self;
#line 956 "../src/client/accounts/accounts-manager.vala"
		_g_object_unref0 (_data23_->account);
#line 956 "../src/client/accounts/accounts-manager.vala"
		_g_object_unref0 (self);
#line 956 "../src/client/accounts/accounts-manager.vala"
		g_slice_free (Block23Data, _data23_);
#line 9172 "accounts-manager.c"
	}
}


static void
__lambda8_ (Block23Data* _data23_,
            GObject* obj,
            GAsyncResult* res)
{
	AccountsManager* self;
	GError * _inner_error_ = NULL;
#line 959 "../src/client/accounts/accounts-manager.vala"
	self = _data23_->self;
#line 959 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail ((obj == NULL) || G_IS_OBJECT (obj));
#line 959 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail (G_IS_ASYNC_RESULT (res));
#line 9190 "accounts-manager.c"
	{
#line 961 "../src/client/accounts/accounts-manager.vala"
		accounts_manager_save_account_finish (self, res, &_inner_error_);
#line 961 "../src/client/accounts/accounts-manager.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 9196 "accounts-manager.c"
			goto __catch97_g_error;
		}
	}
	goto __finally97;
	__catch97_g_error:
	{
		GError* err = NULL;
		GError* _tmp0_;
		GearyAccountProblemReport* _tmp1_;
		GearyAccountProblemReport* _tmp2_;
#line 960 "../src/client/accounts/accounts-manager.vala"
		err = _inner_error_;
#line 960 "../src/client/accounts/accounts-manager.vala"
		_inner_error_ = NULL;
#line 963 "../src/client/accounts/accounts-manager.vala"
		_tmp0_ = err;
#line 963 "../src/client/accounts/accounts-manager.vala"
		_tmp1_ = geary_account_problem_report_new (GEARY_PROBLEM_TYPE_GENERIC_ERROR, _data23_->account, _tmp0_);
#line 963 "../src/client/accounts/accounts-manager.vala"
		_tmp2_ = _tmp1_;
#line 963 "../src/client/accounts/accounts-manager.vala"
		g_signal_emit (self, accounts_manager_signals[ACCOUNTS_MANAGER_REPORT_PROBLEM_SIGNAL], 0, G_TYPE_CHECK_INSTANCE_CAST (_tmp2_, GEARY_TYPE_PROBLEM_REPORT, GearyProblemReport));
#line 963 "../src/client/accounts/accounts-manager.vala"
		_g_object_unref0 (_tmp2_);
#line 960 "../src/client/accounts/accounts-manager.vala"
		_g_error_free0 (err);
#line 9223 "accounts-manager.c"
	}
	__finally97:
#line 960 "../src/client/accounts/accounts-manager.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 960 "../src/client/accounts/accounts-manager.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 960 "../src/client/accounts/accounts-manager.vala"
		g_clear_error (&_inner_error_);
#line 960 "../src/client/accounts/accounts-manager.vala"
		return;
#line 9234 "accounts-manager.c"
	}
}


static void
___lambda8__gasync_ready_callback (GObject* source_object,
                                   GAsyncResult* res,
                                   gpointer self)
{
#line 957 "../src/client/accounts/accounts-manager.vala"
	__lambda8_ (self, source_object, res);
#line 957 "../src/client/accounts/accounts-manager.vala"
	block23_data_unref (self);
#line 9248 "accounts-manager.c"
}


static void
accounts_manager_on_account_changed (AccountsManager* self,
                                     GearyAccountInformation* account)
{
	Block23Data* _data23_;
	GearyAccountInformation* _tmp0_;
#line 956 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail (ACCOUNTS_IS_MANAGER (self));
#line 956 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail (GEARY_IS_ACCOUNT_INFORMATION (account));
#line 956 "../src/client/accounts/accounts-manager.vala"
	_data23_ = g_slice_new0 (Block23Data);
#line 956 "../src/client/accounts/accounts-manager.vala"
	_data23_->_ref_count_ = 1;
#line 956 "../src/client/accounts/accounts-manager.vala"
	_data23_->self = g_object_ref (self);
#line 956 "../src/client/accounts/accounts-manager.vala"
	_tmp0_ = _g_object_ref0 (account);
#line 956 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_data23_->account);
#line 956 "../src/client/accounts/accounts-manager.vala"
	_data23_->account = _tmp0_;
#line 957 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_save_account (self, _data23_->account, NULL, ___lambda8__gasync_ready_callback, block23_data_ref (_data23_));
#line 956 "../src/client/accounts/accounts-manager.vala"
	block23_data_unref (_data23_);
#line 956 "../src/client/accounts/accounts-manager.vala"
	_data23_ = NULL;
#line 9280 "accounts-manager.c"
}


gint
accounts_manager_get_size (AccountsManager* self)
{
	gint result;
	GeeMap* _tmp0_;
	gint _tmp1_;
	gint _tmp2_;
#line 110 "../src/client/accounts/accounts-manager.vala"
	g_return_val_if_fail (ACCOUNTS_IS_MANAGER (self), 0);
#line 110 "../src/client/accounts/accounts-manager.vala"
	_tmp0_ = self->priv->accounts;
#line 110 "../src/client/accounts/accounts-manager.vala"
	_tmp1_ = gee_map_get_size (_tmp0_);
#line 110 "../src/client/accounts/accounts-manager.vala"
	_tmp2_ = _tmp1_;
#line 110 "../src/client/accounts/accounts-manager.vala"
	result = _tmp2_;
#line 110 "../src/client/accounts/accounts-manager.vala"
	return result;
#line 9303 "accounts-manager.c"
}


GFile*
accounts_manager_get_config_dir (AccountsManager* self)
{
	GFile* result;
	GFile* _tmp0_;
#line 113 "../src/client/accounts/accounts-manager.vala"
	g_return_val_if_fail (ACCOUNTS_IS_MANAGER (self), NULL);
#line 113 "../src/client/accounts/accounts-manager.vala"
	_tmp0_ = self->priv->_config_dir;
#line 113 "../src/client/accounts/accounts-manager.vala"
	result = _tmp0_;
#line 113 "../src/client/accounts/accounts-manager.vala"
	return result;
#line 9320 "accounts-manager.c"
}


static void
accounts_manager_set_config_dir (AccountsManager* self,
                                 GFile* value)
{
#line 113 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail (ACCOUNTS_IS_MANAGER (self));
#line 113 "../src/client/accounts/accounts-manager.vala"
	if (accounts_manager_get_config_dir (self) != value) {
#line 9332 "accounts-manager.c"
		GFile* _tmp0_;
#line 113 "../src/client/accounts/accounts-manager.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 113 "../src/client/accounts/accounts-manager.vala"
		_g_object_unref0 (self->priv->_config_dir);
#line 113 "../src/client/accounts/accounts-manager.vala"
		self->priv->_config_dir = _tmp0_;
#line 113 "../src/client/accounts/accounts-manager.vala"
		g_object_notify_by_pspec ((GObject *) self, accounts_manager_properties[ACCOUNTS_MANAGER_CONFIG_DIR_PROPERTY]);
#line 9342 "accounts-manager.c"
	}
}


GFile*
accounts_manager_get_data_dir (AccountsManager* self)
{
	GFile* result;
	GFile* _tmp0_;
#line 116 "../src/client/accounts/accounts-manager.vala"
	g_return_val_if_fail (ACCOUNTS_IS_MANAGER (self), NULL);
#line 116 "../src/client/accounts/accounts-manager.vala"
	_tmp0_ = self->priv->_data_dir;
#line 116 "../src/client/accounts/accounts-manager.vala"
	result = _tmp0_;
#line 116 "../src/client/accounts/accounts-manager.vala"
	return result;
#line 9360 "accounts-manager.c"
}


static void
accounts_manager_set_data_dir (AccountsManager* self,
                               GFile* value)
{
#line 116 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail (ACCOUNTS_IS_MANAGER (self));
#line 116 "../src/client/accounts/accounts-manager.vala"
	if (accounts_manager_get_data_dir (self) != value) {
#line 9372 "accounts-manager.c"
		GFile* _tmp0_;
#line 116 "../src/client/accounts/accounts-manager.vala"
		_tmp0_ = _g_object_ref0 (value);
#line 116 "../src/client/accounts/accounts-manager.vala"
		_g_object_unref0 (self->priv->_data_dir);
#line 116 "../src/client/accounts/accounts-manager.vala"
		self->priv->_data_dir = _tmp0_;
#line 116 "../src/client/accounts/accounts-manager.vala"
		g_object_notify_by_pspec ((GObject *) self, accounts_manager_properties[ACCOUNTS_MANAGER_DATA_DIR_PROPERTY]);
#line 9382 "accounts-manager.c"
	}
}


static void
g_cclosure_user_marshal_VOID__OBJECT_ENUM (GClosure * closure,
                                           GValue * return_value,
                                           guint n_param_values,
                                           const GValue * param_values,
                                           gpointer invocation_hint,
                                           gpointer marshal_data)
{
	typedef void (*GMarshalFunc_VOID__OBJECT_ENUM) (gpointer data1, gpointer arg_1, gint arg_2, gpointer data2);
	register GMarshalFunc_VOID__OBJECT_ENUM callback;
	register GCClosure * cc;
	register gpointer data1;
	register gpointer data2;
	cc = (GCClosure *) closure;
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail (n_param_values == 3);
#line 24 "../src/client/accounts/accounts-manager.vala"
	if (G_CCLOSURE_SWAP_DATA (closure)) {
#line 24 "../src/client/accounts/accounts-manager.vala"
		data1 = closure->data;
#line 24 "../src/client/accounts/accounts-manager.vala"
		data2 = param_values->data[0].v_pointer;
#line 9409 "accounts-manager.c"
	} else {
#line 24 "../src/client/accounts/accounts-manager.vala"
		data1 = param_values->data[0].v_pointer;
#line 24 "../src/client/accounts/accounts-manager.vala"
		data2 = closure->data;
#line 9415 "accounts-manager.c"
	}
#line 24 "../src/client/accounts/accounts-manager.vala"
	callback = (GMarshalFunc_VOID__OBJECT_ENUM) (marshal_data ? marshal_data : cc->callback);
#line 24 "../src/client/accounts/accounts-manager.vala"
	callback (data1, g_value_get_object (param_values + 1), g_value_get_enum (param_values + 2), data2);
#line 9421 "accounts-manager.c"
}


static inline gpointer
accounts_manager_account_state_get_instance_private (AccountsManagerAccountState* self)
{
	return G_STRUCT_MEMBER_P (self, AccountsManagerAccountState_private_offset);
}


static AccountsManagerAccountState*
accounts_manager_account_state_construct (GType object_type,
                                          GearyAccountInformation* account)
{
	AccountsManagerAccountState* self = NULL;
#line 102 "../src/client/accounts/accounts-manager.vala"
	g_return_val_if_fail (GEARY_IS_ACCOUNT_INFORMATION (account), NULL);
#line 102 "../src/client/accounts/accounts-manager.vala"
	self = (AccountsManagerAccountState*) g_type_create_instance (object_type);
#line 103 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_account_state_set_account (self, account);
#line 102 "../src/client/accounts/accounts-manager.vala"
	return self;
#line 9445 "accounts-manager.c"
}


static AccountsManagerAccountState*
accounts_manager_account_state_new (GearyAccountInformation* account)
{
#line 102 "../src/client/accounts/accounts-manager.vala"
	return accounts_manager_account_state_construct (ACCOUNTS_MANAGER_TYPE_ACCOUNT_STATE, account);
#line 9454 "accounts-manager.c"
}


static GearyAccountInformation*
accounts_manager_account_state_get_account (AccountsManagerAccountState* self)
{
	GearyAccountInformation* result;
	GearyAccountInformation* _tmp0_;
#line 79 "../src/client/accounts/accounts-manager.vala"
	g_return_val_if_fail (ACCOUNTS_MANAGER_IS_ACCOUNT_STATE (self), NULL);
#line 79 "../src/client/accounts/accounts-manager.vala"
	_tmp0_ = self->priv->_account;
#line 79 "../src/client/accounts/accounts-manager.vala"
	result = _tmp0_;
#line 79 "../src/client/accounts/accounts-manager.vala"
	return result;
#line 9471 "accounts-manager.c"
}


static void
accounts_manager_account_state_set_account (AccountsManagerAccountState* self,
                                            GearyAccountInformation* value)
{
	GearyAccountInformation* _tmp0_;
#line 79 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail (ACCOUNTS_MANAGER_IS_ACCOUNT_STATE (self));
#line 79 "../src/client/accounts/accounts-manager.vala"
	_tmp0_ = _g_object_ref0 (value);
#line 79 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (self->priv->_account);
#line 79 "../src/client/accounts/accounts-manager.vala"
	self->priv->_account = _tmp0_;
#line 9488 "accounts-manager.c"
}


static AccountsManagerStatus
accounts_manager_account_state_get_status (AccountsManagerAccountState* self)
{
	AccountsManagerStatus result;
	AccountsManagerStatus status = 0;
	gboolean _tmp0_;
	gboolean _tmp1_;
	AccountsManagerStatus _tmp2_;
#line 83 "../src/client/accounts/accounts-manager.vala"
	g_return_val_if_fail (ACCOUNTS_MANAGER_IS_ACCOUNT_STATE (self), 0);
#line 84 "../src/client/accounts/accounts-manager.vala"
	status = ACCOUNTS_MANAGER_STATUS_ENABLED;
#line 85 "../src/client/accounts/accounts-manager.vala"
	_tmp0_ = self->priv->_enabled;
#line 85 "../src/client/accounts/accounts-manager.vala"
	if (!_tmp0_) {
#line 86 "../src/client/accounts/accounts-manager.vala"
		status = ACCOUNTS_MANAGER_STATUS_DISABLED;
#line 9510 "accounts-manager.c"
	}
#line 88 "../src/client/accounts/accounts-manager.vala"
	_tmp1_ = self->priv->_available;
#line 88 "../src/client/accounts/accounts-manager.vala"
	if (!_tmp1_) {
#line 89 "../src/client/accounts/accounts-manager.vala"
		status = ACCOUNTS_MANAGER_STATUS_UNAVAILABLE;
#line 9518 "accounts-manager.c"
	}
#line 91 "../src/client/accounts/accounts-manager.vala"
	_tmp2_ = status;
#line 91 "../src/client/accounts/accounts-manager.vala"
	result = _tmp2_;
#line 91 "../src/client/accounts/accounts-manager.vala"
	return result;
#line 9526 "accounts-manager.c"
}


static gboolean
accounts_manager_account_state_get_enabled (AccountsManagerAccountState* self)
{
	gboolean result;
	gboolean _tmp0_;
#line 96 "../src/client/accounts/accounts-manager.vala"
	g_return_val_if_fail (ACCOUNTS_MANAGER_IS_ACCOUNT_STATE (self), FALSE);
#line 96 "../src/client/accounts/accounts-manager.vala"
	_tmp0_ = self->priv->_enabled;
#line 96 "../src/client/accounts/accounts-manager.vala"
	result = _tmp0_;
#line 96 "../src/client/accounts/accounts-manager.vala"
	return result;
#line 9543 "accounts-manager.c"
}


static void
accounts_manager_account_state_set_enabled (AccountsManagerAccountState* self,
                                            gboolean value)
{
#line 96 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail (ACCOUNTS_MANAGER_IS_ACCOUNT_STATE (self));
#line 96 "../src/client/accounts/accounts-manager.vala"
	self->priv->_enabled = value;
#line 9555 "accounts-manager.c"
}


static gboolean
accounts_manager_account_state_get_available (AccountsManagerAccountState* self)
{
	gboolean result;
	gboolean _tmp0_;
#line 99 "../src/client/accounts/accounts-manager.vala"
	g_return_val_if_fail (ACCOUNTS_MANAGER_IS_ACCOUNT_STATE (self), FALSE);
#line 99 "../src/client/accounts/accounts-manager.vala"
	_tmp0_ = self->priv->_available;
#line 99 "../src/client/accounts/accounts-manager.vala"
	result = _tmp0_;
#line 99 "../src/client/accounts/accounts-manager.vala"
	return result;
#line 9572 "accounts-manager.c"
}


static void
accounts_manager_account_state_set_available (AccountsManagerAccountState* self,
                                              gboolean value)
{
#line 99 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail (ACCOUNTS_MANAGER_IS_ACCOUNT_STATE (self));
#line 99 "../src/client/accounts/accounts-manager.vala"
	self->priv->_available = value;
#line 9584 "accounts-manager.c"
}


static void
accounts_manager_value_account_state_init (GValue* value)
{
#line 75 "../src/client/accounts/accounts-manager.vala"
	value->data[0].v_pointer = NULL;
#line 9593 "accounts-manager.c"
}


static void
accounts_manager_value_account_state_free_value (GValue* value)
{
#line 75 "../src/client/accounts/accounts-manager.vala"
	if (value->data[0].v_pointer) {
#line 75 "../src/client/accounts/accounts-manager.vala"
		accounts_manager_account_state_unref (value->data[0].v_pointer);
#line 9604 "accounts-manager.c"
	}
}


static void
accounts_manager_value_account_state_copy_value (const GValue* src_value,
                                                 GValue* dest_value)
{
#line 75 "../src/client/accounts/accounts-manager.vala"
	if (src_value->data[0].v_pointer) {
#line 75 "../src/client/accounts/accounts-manager.vala"
		dest_value->data[0].v_pointer = accounts_manager_account_state_ref (src_value->data[0].v_pointer);
#line 9617 "accounts-manager.c"
	} else {
#line 75 "../src/client/accounts/accounts-manager.vala"
		dest_value->data[0].v_pointer = NULL;
#line 9621 "accounts-manager.c"
	}
}


static gpointer
accounts_manager_value_account_state_peek_pointer (const GValue* value)
{
#line 75 "../src/client/accounts/accounts-manager.vala"
	return value->data[0].v_pointer;
#line 9631 "accounts-manager.c"
}


static gchar*
accounts_manager_value_account_state_collect_value (GValue* value,
                                                    guint n_collect_values,
                                                    GTypeCValue* collect_values,
                                                    guint collect_flags)
{
#line 75 "../src/client/accounts/accounts-manager.vala"
	if (collect_values[0].v_pointer) {
#line 9643 "accounts-manager.c"
		AccountsManagerAccountState * object;
		object = collect_values[0].v_pointer;
#line 75 "../src/client/accounts/accounts-manager.vala"
		if (object->parent_instance.g_class == NULL) {
#line 75 "../src/client/accounts/accounts-manager.vala"
			return g_strconcat ("invalid unclassed object pointer for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 9650 "accounts-manager.c"
		} else if (!g_value_type_compatible (G_TYPE_FROM_INSTANCE (object), G_VALUE_TYPE (value))) {
#line 75 "../src/client/accounts/accounts-manager.vala"
			return g_strconcat ("invalid object type `", g_type_name (G_TYPE_FROM_INSTANCE (object)), "' for value type `", G_VALUE_TYPE_NAME (value), "'", NULL);
#line 9654 "accounts-manager.c"
		}
#line 75 "../src/client/accounts/accounts-manager.vala"
		value->data[0].v_pointer = accounts_manager_account_state_ref (object);
#line 9658 "accounts-manager.c"
	} else {
#line 75 "../src/client/accounts/accounts-manager.vala"
		value->data[0].v_pointer = NULL;
#line 9662 "accounts-manager.c"
	}
#line 75 "../src/client/accounts/accounts-manager.vala"
	return NULL;
#line 9666 "accounts-manager.c"
}


static gchar*
accounts_manager_value_account_state_lcopy_value (const GValue* value,
                                                  guint n_collect_values,
                                                  GTypeCValue* collect_values,
                                                  guint collect_flags)
{
	AccountsManagerAccountState ** object_p;
	object_p = collect_values[0].v_pointer;
#line 75 "../src/client/accounts/accounts-manager.vala"
	if (!object_p) {
#line 75 "../src/client/accounts/accounts-manager.vala"
		return g_strdup_printf ("value location for `%s' passed as NULL", G_VALUE_TYPE_NAME (value));
#line 9682 "accounts-manager.c"
	}
#line 75 "../src/client/accounts/accounts-manager.vala"
	if (!value->data[0].v_pointer) {
#line 75 "../src/client/accounts/accounts-manager.vala"
		*object_p = NULL;
#line 9688 "accounts-manager.c"
	} else if (collect_flags & G_VALUE_NOCOPY_CONTENTS) {
#line 75 "../src/client/accounts/accounts-manager.vala"
		*object_p = value->data[0].v_pointer;
#line 9692 "accounts-manager.c"
	} else {
#line 75 "../src/client/accounts/accounts-manager.vala"
		*object_p = accounts_manager_account_state_ref (value->data[0].v_pointer);
#line 9696 "accounts-manager.c"
	}
#line 75 "../src/client/accounts/accounts-manager.vala"
	return NULL;
#line 9700 "accounts-manager.c"
}


static GParamSpec*
accounts_manager_param_spec_account_state (const gchar* name,
                                           const gchar* nick,
                                           const gchar* blurb,
                                           GType object_type,
                                           GParamFlags flags)
{
	AccountsManagerParamSpecAccountState* spec;
#line 75 "../src/client/accounts/accounts-manager.vala"
	g_return_val_if_fail (g_type_is_a (object_type, ACCOUNTS_MANAGER_TYPE_ACCOUNT_STATE), NULL);
#line 75 "../src/client/accounts/accounts-manager.vala"
	spec = g_param_spec_internal (G_TYPE_PARAM_OBJECT, name, nick, blurb, flags);
#line 75 "../src/client/accounts/accounts-manager.vala"
	G_PARAM_SPEC (spec)->value_type = object_type;
#line 75 "../src/client/accounts/accounts-manager.vala"
	return G_PARAM_SPEC (spec);
#line 9720 "accounts-manager.c"
}


static gpointer
accounts_manager_value_get_account_state (const GValue* value)
{
#line 75 "../src/client/accounts/accounts-manager.vala"
	g_return_val_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, ACCOUNTS_MANAGER_TYPE_ACCOUNT_STATE), NULL);
#line 75 "../src/client/accounts/accounts-manager.vala"
	return value->data[0].v_pointer;
#line 9731 "accounts-manager.c"
}


static void
accounts_manager_value_set_account_state (GValue* value,
                                          gpointer v_object)
{
	AccountsManagerAccountState * old;
#line 75 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, ACCOUNTS_MANAGER_TYPE_ACCOUNT_STATE));
#line 75 "../src/client/accounts/accounts-manager.vala"
	old = value->data[0].v_pointer;
#line 75 "../src/client/accounts/accounts-manager.vala"
	if (v_object) {
#line 75 "../src/client/accounts/accounts-manager.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, ACCOUNTS_MANAGER_TYPE_ACCOUNT_STATE));
#line 75 "../src/client/accounts/accounts-manager.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 75 "../src/client/accounts/accounts-manager.vala"
		value->data[0].v_pointer = v_object;
#line 75 "../src/client/accounts/accounts-manager.vala"
		accounts_manager_account_state_ref (value->data[0].v_pointer);
#line 9754 "accounts-manager.c"
	} else {
#line 75 "../src/client/accounts/accounts-manager.vala"
		value->data[0].v_pointer = NULL;
#line 9758 "accounts-manager.c"
	}
#line 75 "../src/client/accounts/accounts-manager.vala"
	if (old) {
#line 75 "../src/client/accounts/accounts-manager.vala"
		accounts_manager_account_state_unref (old);
#line 9764 "accounts-manager.c"
	}
}


static void
accounts_manager_value_take_account_state (GValue* value,
                                           gpointer v_object)
{
	AccountsManagerAccountState * old;
#line 75 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail (G_TYPE_CHECK_VALUE_TYPE (value, ACCOUNTS_MANAGER_TYPE_ACCOUNT_STATE));
#line 75 "../src/client/accounts/accounts-manager.vala"
	old = value->data[0].v_pointer;
#line 75 "../src/client/accounts/accounts-manager.vala"
	if (v_object) {
#line 75 "../src/client/accounts/accounts-manager.vala"
		g_return_if_fail (G_TYPE_CHECK_INSTANCE_TYPE (v_object, ACCOUNTS_MANAGER_TYPE_ACCOUNT_STATE));
#line 75 "../src/client/accounts/accounts-manager.vala"
		g_return_if_fail (g_value_type_compatible (G_TYPE_FROM_INSTANCE (v_object), G_VALUE_TYPE (value)));
#line 75 "../src/client/accounts/accounts-manager.vala"
		value->data[0].v_pointer = v_object;
#line 9786 "accounts-manager.c"
	} else {
#line 75 "../src/client/accounts/accounts-manager.vala"
		value->data[0].v_pointer = NULL;
#line 9790 "accounts-manager.c"
	}
#line 75 "../src/client/accounts/accounts-manager.vala"
	if (old) {
#line 75 "../src/client/accounts/accounts-manager.vala"
		accounts_manager_account_state_unref (old);
#line 9796 "accounts-manager.c"
	}
}


static void
accounts_manager_account_state_class_init (AccountsManagerAccountStateClass * klass)
{
#line 75 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_account_state_parent_class = g_type_class_peek_parent (klass);
#line 75 "../src/client/accounts/accounts-manager.vala"
	((AccountsManagerAccountStateClass *) klass)->finalize = accounts_manager_account_state_finalize;
#line 75 "../src/client/accounts/accounts-manager.vala"
	g_type_class_adjust_private_offset (klass, &AccountsManagerAccountState_private_offset);
#line 9810 "accounts-manager.c"
}


static void
accounts_manager_account_state_instance_init (AccountsManagerAccountState * self)
{
#line 75 "../src/client/accounts/accounts-manager.vala"
	self->priv = accounts_manager_account_state_get_instance_private (self);
#line 96 "../src/client/accounts/accounts-manager.vala"
	self->priv->_enabled = TRUE;
#line 99 "../src/client/accounts/accounts-manager.vala"
	self->priv->_available = TRUE;
#line 75 "../src/client/accounts/accounts-manager.vala"
	self->ref_count = 1;
#line 9825 "accounts-manager.c"
}


static void
accounts_manager_account_state_finalize (AccountsManagerAccountState * obj)
{
	AccountsManagerAccountState * self;
#line 75 "../src/client/accounts/accounts-manager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, ACCOUNTS_MANAGER_TYPE_ACCOUNT_STATE, AccountsManagerAccountState);
#line 75 "../src/client/accounts/accounts-manager.vala"
	g_signal_handlers_destroy (self);
#line 79 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (self->priv->_account);
#line 9839 "accounts-manager.c"
}


/** Specifies an account's current state. */
static GType
accounts_manager_account_state_get_type (void)
{
	static volatile gsize accounts_manager_account_state_type_id__volatile = 0;
	if (g_once_init_enter (&accounts_manager_account_state_type_id__volatile)) {
		static const GTypeValueTable g_define_type_value_table = { accounts_manager_value_account_state_init, accounts_manager_value_account_state_free_value, accounts_manager_value_account_state_copy_value, accounts_manager_value_account_state_peek_pointer, "p", accounts_manager_value_account_state_collect_value, "p", accounts_manager_value_account_state_lcopy_value };
		static const GTypeInfo g_define_type_info = { sizeof (AccountsManagerAccountStateClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) accounts_manager_account_state_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (AccountsManagerAccountState), 0, (GInstanceInitFunc) accounts_manager_account_state_instance_init, &g_define_type_value_table };
		static const GTypeFundamentalInfo g_define_type_fundamental_info = { (G_TYPE_FLAG_CLASSED | G_TYPE_FLAG_INSTANTIATABLE | G_TYPE_FLAG_DERIVABLE | G_TYPE_FLAG_DEEP_DERIVABLE) };
		GType accounts_manager_account_state_type_id;
		accounts_manager_account_state_type_id = g_type_register_fundamental (g_type_fundamental_next (), "AccountsManagerAccountState", &g_define_type_info, &g_define_type_fundamental_info, 0);
		AccountsManagerAccountState_private_offset = g_type_add_instance_private (accounts_manager_account_state_type_id, sizeof (AccountsManagerAccountStatePrivate));
		g_once_init_leave (&accounts_manager_account_state_type_id__volatile, accounts_manager_account_state_type_id);
	}
	return accounts_manager_account_state_type_id__volatile;
}


static gpointer
accounts_manager_account_state_ref (gpointer instance)
{
	AccountsManagerAccountState * self;
	self = instance;
#line 75 "../src/client/accounts/accounts-manager.vala"
	g_atomic_int_inc (&self->ref_count);
#line 75 "../src/client/accounts/accounts-manager.vala"
	return instance;
#line 9870 "accounts-manager.c"
}


static void
accounts_manager_account_state_unref (gpointer instance)
{
	AccountsManagerAccountState * self;
	self = instance;
#line 75 "../src/client/accounts/accounts-manager.vala"
	if (g_atomic_int_dec_and_test (&self->ref_count)) {
#line 75 "../src/client/accounts/accounts-manager.vala"
		ACCOUNTS_MANAGER_ACCOUNT_STATE_GET_CLASS (self)->finalize (self);
#line 75 "../src/client/accounts/accounts-manager.vala"
		g_type_free_instance ((GTypeInstance *) self);
#line 9885 "accounts-manager.c"
	}
}


static void
accounts_manager_class_init (AccountsManagerClass * klass)
{
#line 24 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_parent_class = g_type_class_peek_parent (klass);
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_type_class_adjust_private_offset (klass, &AccountsManager_private_offset);
#line 24 "../src/client/accounts/accounts-manager.vala"
	G_OBJECT_CLASS (klass)->get_property = _vala_accounts_manager_get_property;
#line 24 "../src/client/accounts/accounts-manager.vala"
	G_OBJECT_CLASS (klass)->set_property = _vala_accounts_manager_set_property;
#line 24 "../src/client/accounts/accounts-manager.vala"
	G_OBJECT_CLASS (klass)->finalize = accounts_manager_finalize;
#line 9903 "accounts-manager.c"
	/** Returns the number of currently known accounts. */
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), ACCOUNTS_MANAGER_SIZE_PROPERTY, accounts_manager_properties[ACCOUNTS_MANAGER_SIZE_PROPERTY] = g_param_spec_int ("size", "size", "size", G_MININT, G_MAXINT, 0, G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 9907 "accounts-manager.c"
	/** Returns the base directory for account configuration. */
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), ACCOUNTS_MANAGER_CONFIG_DIR_PROPERTY, accounts_manager_properties[ACCOUNTS_MANAGER_CONFIG_DIR_PROPERTY] = g_param_spec_object ("config-dir", "config-dir", "config-dir", g_file_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 9911 "accounts-manager.c"
	/** Returns the base directory for account data. */
#line 24 "../src/client/accounts/accounts-manager.vala"
	g_object_class_install_property (G_OBJECT_CLASS (klass), ACCOUNTS_MANAGER_DATA_DIR_PROPERTY, accounts_manager_properties[ACCOUNTS_MANAGER_DATA_DIR_PROPERTY] = g_param_spec_object ("data-dir", "data-dir", "data-dir", g_file_get_type (), G_PARAM_STATIC_STRINGS | G_PARAM_READABLE));
#line 9915 "accounts-manager.c"
	/** Fired when a new account is created. */
#line 24 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_signals[ACCOUNTS_MANAGER_ACCOUNT_ADDED_SIGNAL] = g_signal_new ("account-added", ACCOUNTS_TYPE_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_ENUM, G_TYPE_NONE, 2, GEARY_TYPE_ACCOUNT_INFORMATION, ACCOUNTS_MANAGER_TYPE_STATUS);
#line 9919 "accounts-manager.c"
	/** Fired when an existing account's state has changed. */
#line 24 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_signals[ACCOUNTS_MANAGER_ACCOUNT_STATUS_CHANGED_SIGNAL] = g_signal_new ("account-status-changed", ACCOUNTS_TYPE_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_user_marshal_VOID__OBJECT_ENUM, G_TYPE_NONE, 2, GEARY_TYPE_ACCOUNT_INFORMATION, ACCOUNTS_MANAGER_TYPE_STATUS);
#line 9923 "accounts-manager.c"
	/** Fired when an account is deleted. */
#line 24 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_signals[ACCOUNTS_MANAGER_ACCOUNT_REMOVED_SIGNAL] = g_signal_new ("account-removed", ACCOUNTS_TYPE_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEARY_TYPE_ACCOUNT_INFORMATION);
#line 9927 "accounts-manager.c"
	/** Emitted to notify an account problem has occurred. */
#line 24 "../src/client/accounts/accounts-manager.vala"
	accounts_manager_signals[ACCOUNTS_MANAGER_REPORT_PROBLEM_SIGNAL] = g_signal_new ("report-problem", ACCOUNTS_TYPE_MANAGER, G_SIGNAL_RUN_LAST, 0, NULL, NULL, g_cclosure_marshal_VOID__OBJECT, G_TYPE_NONE, 1, GEARY_TYPE_PROBLEM_REPORT);
#line 9931 "accounts-manager.c"
}


static void
accounts_manager_instance_init (AccountsManager * self)
{
	GeeHashMap* _tmp0_;
	GeeLinkedList* _tmp1_;
#line 24 "../src/client/accounts/accounts-manager.vala"
	self->priv = accounts_manager_get_instance_private (self);
#line 119 "../src/client/accounts/accounts-manager.vala"
	_tmp0_ = gee_hash_map_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, ACCOUNTS_MANAGER_TYPE_ACCOUNT_STATE, (GBoxedCopyFunc) accounts_manager_account_state_ref, (GDestroyNotify) accounts_manager_account_state_unref, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL, NULL);
#line 119 "../src/client/accounts/accounts-manager.vala"
	self->priv->accounts = G_TYPE_CHECK_INSTANCE_CAST (_tmp0_, GEE_TYPE_MAP, GeeMap);
#line 122 "../src/client/accounts/accounts-manager.vala"
	_tmp1_ = gee_linked_list_new (GEARY_TYPE_ACCOUNT_INFORMATION, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 122 "../src/client/accounts/accounts-manager.vala"
	self->priv->removed = _tmp1_;
#line 127 "../src/client/accounts/accounts-manager.vala"
	self->priv->goa_service = NULL;
#line 9952 "accounts-manager.c"
}


static void
accounts_manager_finalize (GObject * obj)
{
	AccountsManager * self;
#line 24 "../src/client/accounts/accounts-manager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, ACCOUNTS_TYPE_MANAGER, AccountsManager);
#line 113 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (self->priv->_config_dir);
#line 116 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (self->priv->_data_dir);
#line 119 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (self->priv->accounts);
#line 122 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (self->priv->removed);
#line 126 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (self->priv->local_mediator);
#line 127 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (self->priv->goa_service);
#line 24 "../src/client/accounts/accounts-manager.vala"
	G_OBJECT_CLASS (accounts_manager_parent_class)->finalize (obj);
#line 9976 "accounts-manager.c"
}


/**
 * Manages email account lifecycle for Geary.
 *
 * This class is responsible for creating, loading, saving and
 * removing accounts and their persisted data (configuration,
 * databases, caches, authentication tokens). The manager supports
 * both locally-specified accounts (i.e. those created by the user in
 * the app) and from SSO systems such as GOA via the Accounts.Provider
 * interface.
 *
 * Newly loaded and newly created accounts are first added to the
 * manager with a particular status (enabled, disabled, etc). Accounts
 * can have their enabled or disabled status updated manually,
 */
GType
accounts_manager_get_type (void)
{
	static volatile gsize accounts_manager_type_id__volatile = 0;
	if (g_once_init_enter (&accounts_manager_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (AccountsManagerClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) accounts_manager_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (AccountsManager), 0, (GInstanceInitFunc) accounts_manager_instance_init, NULL };
		GType accounts_manager_type_id;
		accounts_manager_type_id = g_type_register_static (G_TYPE_OBJECT, "AccountsManager", &g_define_type_info, 0);
		AccountsManager_private_offset = g_type_add_instance_private (accounts_manager_type_id, sizeof (AccountsManagerPrivate));
		g_once_init_leave (&accounts_manager_type_id__volatile, accounts_manager_type_id);
	}
	return accounts_manager_type_id__volatile;
}


static void
_vala_accounts_manager_get_property (GObject * object,
                                     guint property_id,
                                     GValue * value,
                                     GParamSpec * pspec)
{
	AccountsManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, ACCOUNTS_TYPE_MANAGER, AccountsManager);
#line 24 "../src/client/accounts/accounts-manager.vala"
	switch (property_id) {
#line 24 "../src/client/accounts/accounts-manager.vala"
		case ACCOUNTS_MANAGER_SIZE_PROPERTY:
#line 24 "../src/client/accounts/accounts-manager.vala"
		g_value_set_int (value, accounts_manager_get_size (self));
#line 24 "../src/client/accounts/accounts-manager.vala"
		break;
#line 24 "../src/client/accounts/accounts-manager.vala"
		case ACCOUNTS_MANAGER_CONFIG_DIR_PROPERTY:
#line 24 "../src/client/accounts/accounts-manager.vala"
		g_value_set_object (value, accounts_manager_get_config_dir (self));
#line 24 "../src/client/accounts/accounts-manager.vala"
		break;
#line 24 "../src/client/accounts/accounts-manager.vala"
		case ACCOUNTS_MANAGER_DATA_DIR_PROPERTY:
#line 24 "../src/client/accounts/accounts-manager.vala"
		g_value_set_object (value, accounts_manager_get_data_dir (self));
#line 24 "../src/client/accounts/accounts-manager.vala"
		break;
#line 10037 "accounts-manager.c"
		default:
#line 24 "../src/client/accounts/accounts-manager.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../src/client/accounts/accounts-manager.vala"
		break;
#line 10043 "accounts-manager.c"
	}
}


static void
_vala_accounts_manager_set_property (GObject * object,
                                     guint property_id,
                                     const GValue * value,
                                     GParamSpec * pspec)
{
	AccountsManager * self;
	self = G_TYPE_CHECK_INSTANCE_CAST (object, ACCOUNTS_TYPE_MANAGER, AccountsManager);
#line 24 "../src/client/accounts/accounts-manager.vala"
	switch (property_id) {
#line 24 "../src/client/accounts/accounts-manager.vala"
		case ACCOUNTS_MANAGER_CONFIG_DIR_PROPERTY:
#line 24 "../src/client/accounts/accounts-manager.vala"
		accounts_manager_set_config_dir (self, g_value_get_object (value));
#line 24 "../src/client/accounts/accounts-manager.vala"
		break;
#line 24 "../src/client/accounts/accounts-manager.vala"
		case ACCOUNTS_MANAGER_DATA_DIR_PROPERTY:
#line 24 "../src/client/accounts/accounts-manager.vala"
		accounts_manager_set_data_dir (self, g_value_get_object (value));
#line 24 "../src/client/accounts/accounts-manager.vala"
		break;
#line 10070 "accounts-manager.c"
		default:
#line 24 "../src/client/accounts/accounts-manager.vala"
		G_OBJECT_WARN_INVALID_PROPERTY_ID (object, property_id, pspec);
#line 24 "../src/client/accounts/accounts-manager.vala"
		break;
#line 10076 "accounts-manager.c"
	}
}


/** Loads a supported account from a config file. */
GearyAccountInformation*
accounts_account_config_load (AccountsAccountConfig* self,
                              GearyConfigFile* config,
                              const gchar* id,
                              GearyCredentialsMediator* mediator,
                              GearyServiceProvider* default_provider,
                              const gchar* default_name,
                              GError** error)
{
#line 981 "../src/client/accounts/accounts-manager.vala"
	g_return_val_if_fail (ACCOUNTS_IS_ACCOUNT_CONFIG (self), NULL);
#line 981 "../src/client/accounts/accounts-manager.vala"
	return ACCOUNTS_ACCOUNT_CONFIG_GET_INTERFACE (self)->load (self, config, id, mediator, default_provider, default_name, error);
#line 10095 "accounts-manager.c"
}


/** Saves an account to a config file. */
void
accounts_account_config_save (AccountsAccountConfig* self,
                              GearyAccountInformation* account,
                              GearyConfigFile* config)
{
#line 990 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail (ACCOUNTS_IS_ACCOUNT_CONFIG (self));
#line 990 "../src/client/accounts/accounts-manager.vala"
	ACCOUNTS_ACCOUNT_CONFIG_GET_INTERFACE (self)->save (self, account, config);
#line 10109 "accounts-manager.c"
}


static void
accounts_account_config_default_init (AccountsAccountConfigIface * iface)
{
}


/** Objects that can be used to load/save account configuration. */
GType
accounts_account_config_get_type (void)
{
	static volatile gsize accounts_account_config_type_id__volatile = 0;
	if (g_once_init_enter (&accounts_account_config_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (AccountsAccountConfigIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) accounts_account_config_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType accounts_account_config_type_id;
		accounts_account_config_type_id = g_type_register_static (G_TYPE_INTERFACE, "AccountsAccountConfig", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (accounts_account_config_type_id, G_TYPE_OBJECT);
		g_once_init_leave (&accounts_account_config_type_id__volatile, accounts_account_config_type_id);
	}
	return accounts_account_config_type_id__volatile;
}


/** Loads a service from a config file. */
void
accounts_service_config_load (AccountsServiceConfig* self,
                              GearyConfigFile* config,
                              GearyAccountInformation* account,
                              GearyServiceInformation* service,
                              GError** error)
{
#line 1000 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail (ACCOUNTS_IS_SERVICE_CONFIG (self));
#line 1000 "../src/client/accounts/accounts-manager.vala"
	ACCOUNTS_SERVICE_CONFIG_GET_INTERFACE (self)->load (self, config, account, service, error);
#line 10147 "accounts-manager.c"
}


/** Saves a service to a config file. */
void
accounts_service_config_save (AccountsServiceConfig* self,
                              GearyAccountInformation* account,
                              GearyServiceInformation* service,
                              GearyConfigFile* config)
{
#line 1006 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail (ACCOUNTS_IS_SERVICE_CONFIG (self));
#line 1006 "../src/client/accounts/accounts-manager.vala"
	ACCOUNTS_SERVICE_CONFIG_GET_INTERFACE (self)->save (self, account, service, config);
#line 10162 "accounts-manager.c"
}


static void
accounts_service_config_default_init (AccountsServiceConfigIface * iface)
{
}


/** Objects that can be used to load/save service configuration. */
GType
accounts_service_config_get_type (void)
{
	static volatile gsize accounts_service_config_type_id__volatile = 0;
	if (g_once_init_enter (&accounts_service_config_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (AccountsServiceConfigIface), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) accounts_service_config_default_init, (GClassFinalizeFunc) NULL, NULL, 0, 0, (GInstanceInitFunc) NULL, NULL };
		GType accounts_service_config_type_id;
		accounts_service_config_type_id = g_type_register_static (G_TYPE_INTERFACE, "AccountsServiceConfig", &g_define_type_info, 0);
		g_type_interface_add_prerequisite (accounts_service_config_type_id, G_TYPE_OBJECT);
		g_once_init_leave (&accounts_service_config_type_id__volatile, accounts_service_config_type_id);
	}
	return accounts_service_config_type_id__volatile;
}


GQuark
accounts_config_error_quark (void)
{
	return g_quark_from_static_string ("accounts-config-error-quark");
}


static inline gpointer
accounts_account_config_v1_get_instance_private (AccountsAccountConfigV1* self)
{
	return G_STRUCT_MEMBER_P (self, AccountsAccountConfigV1_private_offset);
}


AccountsAccountConfigV1*
accounts_account_config_v1_construct (GType object_type,
                                      gboolean is_managed)
{
	AccountsAccountConfigV1 * self = NULL;
#line 1051 "../src/client/accounts/accounts-manager.vala"
	self = (AccountsAccountConfigV1*) g_object_new (object_type, NULL);
#line 1052 "../src/client/accounts/accounts-manager.vala"
	self->priv->is_managed = is_managed;
#line 1051 "../src/client/accounts/accounts-manager.vala"
	return self;
#line 10213 "accounts-manager.c"
}


AccountsAccountConfigV1*
accounts_account_config_v1_new (gboolean is_managed)
{
#line 1051 "../src/client/accounts/accounts-manager.vala"
	return accounts_account_config_v1_construct (ACCOUNTS_TYPE_ACCOUNT_CONFIG_V1, is_managed);
#line 10222 "accounts-manager.c"
}


static GearyServiceProvider
___lambda4_ (AccountsAccountConfigV1* self,
             const gchar* value,
             GError** error)
{
	GearyServiceProvider result = 0;
	GError * _inner_error_ = NULL;
#line 1088 "../src/client/accounts/accounts-manager.vala"
	g_return_val_if_fail (value != NULL, 0);
#line 10235 "accounts-manager.c"
	{
		GearyServiceProvider _tmp0_ = 0;
#line 1090 "../src/client/accounts/accounts-manager.vala"
		_tmp0_ = geary_service_provider_for_value (value, &_inner_error_);
#line 1090 "../src/client/accounts/accounts-manager.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1090 "../src/client/accounts/accounts-manager.vala"
			if (_inner_error_->domain == GEARY_ENGINE_ERROR) {
#line 10244 "accounts-manager.c"
				goto __catch99_geary_engine_error;
			}
#line 1090 "../src/client/accounts/accounts-manager.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1090 "../src/client/accounts/accounts-manager.vala"
			g_clear_error (&_inner_error_);
#line 1090 "../src/client/accounts/accounts-manager.vala"
			return 0;
#line 10253 "accounts-manager.c"
		}
#line 1090 "../src/client/accounts/accounts-manager.vala"
		result = _tmp0_;
#line 1090 "../src/client/accounts/accounts-manager.vala"
		return result;
#line 10259 "accounts-manager.c"
	}
	goto __finally99;
	__catch99_geary_engine_error:
	{
		GError* err = NULL;
		GError* _tmp1_;
		const gchar* _tmp2_;
		GError* _tmp3_;
#line 1089 "../src/client/accounts/accounts-manager.vala"
		err = _inner_error_;
#line 1089 "../src/client/accounts/accounts-manager.vala"
		_inner_error_ = NULL;
#line 1092 "../src/client/accounts/accounts-manager.vala"
		_tmp1_ = err;
#line 1092 "../src/client/accounts/accounts-manager.vala"
		_tmp2_ = _tmp1_->message;
#line 1092 "../src/client/accounts/accounts-manager.vala"
		_tmp3_ = g_error_new_literal (G_KEY_FILE_ERROR, G_KEY_FILE_ERROR_INVALID_VALUE, _tmp2_);
#line 1092 "../src/client/accounts/accounts-manager.vala"
		_inner_error_ = _tmp3_;
#line 1092 "../src/client/accounts/accounts-manager.vala"
		_g_error_free0 (err);
#line 10282 "accounts-manager.c"
		goto __finally99;
	}
	__finally99:
#line 1089 "../src/client/accounts/accounts-manager.vala"
	if (_inner_error_->domain == G_KEY_FILE_ERROR) {
#line 1089 "../src/client/accounts/accounts-manager.vala"
		g_propagate_error (error, _inner_error_);
#line 1089 "../src/client/accounts/accounts-manager.vala"
		return 0;
#line 10292 "accounts-manager.c"
	} else {
#line 1089 "../src/client/accounts/accounts-manager.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1089 "../src/client/accounts/accounts-manager.vala"
		g_clear_error (&_inner_error_);
#line 1089 "../src/client/accounts/accounts-manager.vala"
		return 0;
#line 10300 "accounts-manager.c"
	}
}


static gpointer
____lambda4__geary_config_file_parser (const gchar* value,
                                       gpointer self,
                                       GError** error)
{
	gpointer result;
	result = (gpointer) ((gintptr) ___lambda4_ ((AccountsAccountConfigV1*) self, value, error));
#line 1086 "../src/client/accounts/accounts-manager.vala"
	return result;
#line 10314 "accounts-manager.c"
}


static GearyAccountInformation*
accounts_account_config_v1_real_load (AccountsAccountConfig* base,
                                      GearyConfigFile* config,
                                      const gchar* id,
                                      GearyCredentialsMediator* mediator,
                                      GearyServiceProvider* default_provider,
                                      const gchar* default_name,
                                      GError** error)
{
	AccountsAccountConfigV1 * self;
	GearyAccountInformation* result = NULL;
	GearyConfigFileGroup* account_config = NULL;
	GearyConfigFileGroup* _tmp0_;
	GeeList* senders = NULL;
	GeeLinkedList* _tmp1_;
	GeeList* _tmp2_ = NULL;
	GearyConfigFileGroup* _tmp3_;
	GeeList* _tmp4_;
	GeeList* _tmp21_;
	gboolean _tmp22_;
	gboolean _tmp23_;
	GearyServiceProvider* _tmp25_ = NULL;
	GearyServiceProvider provider = 0;
	GearyAccountInformation* account = NULL;
	GearyServiceProvider _tmp31_;
	GeeList* _tmp32_;
	gpointer _tmp33_;
	GearyRFC822MailboxAddress* _tmp34_;
	GearyAccountInformation* _tmp35_;
	GearyAccountInformation* _tmp36_;
	GearyAccountInformation* _tmp37_;
	GearyConfigFileGroup* _tmp38_;
	gint _tmp39_;
	GearyAccountInformation* _tmp40_;
	GearyConfigFileGroup* _tmp41_;
	GearyAccountInformation* _tmp42_;
	const gchar* _tmp43_;
	const gchar* _tmp44_;
	gchar* _tmp45_;
	gchar* _tmp46_;
	GearyAccountInformation* _tmp47_;
	GearyConfigFileGroup* _tmp48_;
	GearyAccountInformation* _tmp49_;
	gint _tmp50_;
	gint _tmp51_;
	GearyAccountInformation* _tmp52_;
	GearyConfigFileGroup* _tmp53_;
	GearyAccountInformation* _tmp54_;
	gboolean _tmp55_;
	gboolean _tmp56_;
	GearyAccountInformation* _tmp57_;
	GearyConfigFileGroup* _tmp58_;
	GearyAccountInformation* _tmp59_;
	gboolean _tmp60_;
	gboolean _tmp61_;
	GearyAccountInformation* _tmp62_;
	GearyConfigFileGroup* _tmp63_;
	GearyAccountInformation* _tmp64_;
	gboolean _tmp65_;
	gboolean _tmp66_;
	GearyAccountInformation* _tmp67_;
	GearyConfigFileGroup* _tmp68_;
	GearyAccountInformation* _tmp69_;
	const gchar* _tmp70_;
	const gchar* _tmp71_;
	gchar* _tmp72_;
	gchar* _tmp73_;
	GearyConfigFileGroup* folder_config = NULL;
	GearyConfigFileGroup* _tmp87_;
	GearyAccountInformation* _tmp88_;
	GearyConfigFileGroup* _tmp89_;
	GearyFolderPath* _tmp90_;
	GearyFolderPath* _tmp91_;
	GearyAccountInformation* _tmp92_;
	GearyConfigFileGroup* _tmp93_;
	GearyFolderPath* _tmp94_;
	GearyFolderPath* _tmp95_;
	GearyAccountInformation* _tmp96_;
	GearyConfigFileGroup* _tmp97_;
	GearyFolderPath* _tmp98_;
	GearyFolderPath* _tmp99_;
	GearyAccountInformation* _tmp100_;
	GearyConfigFileGroup* _tmp101_;
	GearyFolderPath* _tmp102_;
	GearyFolderPath* _tmp103_;
	GearyAccountInformation* _tmp104_;
	GearyConfigFileGroup* _tmp105_;
	GearyFolderPath* _tmp106_;
	GearyFolderPath* _tmp107_;
	GError * _inner_error_ = NULL;
#line 1055 "../src/client/accounts/accounts-manager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, ACCOUNTS_TYPE_ACCOUNT_CONFIG_V1, AccountsAccountConfigV1);
#line 1055 "../src/client/accounts/accounts-manager.vala"
	g_return_val_if_fail (GEARY_IS_CONFIG_FILE (config), NULL);
#line 1055 "../src/client/accounts/accounts-manager.vala"
	g_return_val_if_fail (id != NULL, NULL);
#line 1055 "../src/client/accounts/accounts-manager.vala"
	g_return_val_if_fail (GEARY_IS_CREDENTIALS_MEDIATOR (mediator), NULL);
#line 1061 "../src/client/accounts/accounts-manager.vala"
	_tmp0_ = geary_config_file_get_group (config, ACCOUNTS_ACCOUNT_CONFIG_V1_GROUP_ACCOUNT);
#line 1061 "../src/client/accounts/accounts-manager.vala"
	account_config = _tmp0_;
#line 1064 "../src/client/accounts/accounts-manager.vala"
	_tmp1_ = gee_linked_list_new (GEARY_RF_C822_TYPE_MAILBOX_ADDRESS, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, NULL, NULL, NULL);
#line 1064 "../src/client/accounts/accounts-manager.vala"
	senders = G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_LIST, GeeList);
#line 1067 "../src/client/accounts/accounts-manager.vala"
	_tmp3_ = account_config;
#line 1067 "../src/client/accounts/accounts-manager.vala"
	_tmp4_ = geary_config_file_group_get_required_string_list (_tmp3_, ACCOUNTS_ACCOUNT_CONFIG_V1_ACCOUNT_SENDERS, &_inner_error_);
#line 1067 "../src/client/accounts/accounts-manager.vala"
	_tmp2_ = _tmp4_;
#line 1067 "../src/client/accounts/accounts-manager.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1067 "../src/client/accounts/accounts-manager.vala"
		if ((_inner_error_->domain == ACCOUNTS_CONFIG_ERROR) || (_inner_error_->domain == G_KEY_FILE_ERROR)) {
#line 1067 "../src/client/accounts/accounts-manager.vala"
			g_propagate_error (error, _inner_error_);
#line 1067 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (senders);
#line 1067 "../src/client/accounts/accounts-manager.vala"
			_geary_config_file_group_unref0 (account_config);
#line 1067 "../src/client/accounts/accounts-manager.vala"
			return NULL;
#line 10442 "accounts-manager.c"
		} else {
#line 1067 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (senders);
#line 1067 "../src/client/accounts/accounts-manager.vala"
			_geary_config_file_group_unref0 (account_config);
#line 1067 "../src/client/accounts/accounts-manager.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1067 "../src/client/accounts/accounts-manager.vala"
			g_clear_error (&_inner_error_);
#line 1067 "../src/client/accounts/accounts-manager.vala"
			return NULL;
#line 10454 "accounts-manager.c"
		}
	}
	{
		GeeList* _sender_list = NULL;
		GeeList* _tmp5_;
		gint _sender_size = 0;
		GeeList* _tmp6_;
		gint _tmp7_;
		gint _tmp8_;
		gint _sender_index = 0;
#line 1066 "../src/client/accounts/accounts-manager.vala"
		_tmp5_ = _g_object_ref0 (_tmp2_);
#line 1066 "../src/client/accounts/accounts-manager.vala"
		_sender_list = _tmp5_;
#line 1066 "../src/client/accounts/accounts-manager.vala"
		_tmp6_ = _sender_list;
#line 1066 "../src/client/accounts/accounts-manager.vala"
		_tmp7_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp6_, GEE_TYPE_COLLECTION, GeeCollection));
#line 1066 "../src/client/accounts/accounts-manager.vala"
		_tmp8_ = _tmp7_;
#line 1066 "../src/client/accounts/accounts-manager.vala"
		_sender_size = _tmp8_;
#line 1066 "../src/client/accounts/accounts-manager.vala"
		_sender_index = -1;
#line 1066 "../src/client/accounts/accounts-manager.vala"
		while (TRUE) {
#line 10481 "accounts-manager.c"
			gint _tmp9_;
			gint _tmp10_;
			gint _tmp11_;
			gchar* sender = NULL;
			GeeList* _tmp12_;
			gint _tmp13_;
			gpointer _tmp14_;
#line 1066 "../src/client/accounts/accounts-manager.vala"
			_tmp9_ = _sender_index;
#line 1066 "../src/client/accounts/accounts-manager.vala"
			_sender_index = _tmp9_ + 1;
#line 1066 "../src/client/accounts/accounts-manager.vala"
			_tmp10_ = _sender_index;
#line 1066 "../src/client/accounts/accounts-manager.vala"
			_tmp11_ = _sender_size;
#line 1066 "../src/client/accounts/accounts-manager.vala"
			if (!(_tmp10_ < _tmp11_)) {
#line 1066 "../src/client/accounts/accounts-manager.vala"
				break;
#line 10501 "accounts-manager.c"
			}
#line 1066 "../src/client/accounts/accounts-manager.vala"
			_tmp12_ = _sender_list;
#line 1066 "../src/client/accounts/accounts-manager.vala"
			_tmp13_ = _sender_index;
#line 1066 "../src/client/accounts/accounts-manager.vala"
			_tmp14_ = gee_list_get (_tmp12_, _tmp13_);
#line 1066 "../src/client/accounts/accounts-manager.vala"
			sender = (gchar*) _tmp14_;
#line 10511 "accounts-manager.c"
			{
				GearyRFC822MailboxAddress* _tmp15_ = NULL;
				const gchar* _tmp16_;
				GearyRFC822MailboxAddress* _tmp17_;
				GeeList* _tmp18_;
#line 1070 "../src/client/accounts/accounts-manager.vala"
				_tmp16_ = sender;
#line 1070 "../src/client/accounts/accounts-manager.vala"
				_tmp17_ = geary_rf_c822_mailbox_address_new_from_rfc822_string (_tmp16_, &_inner_error_);
#line 1070 "../src/client/accounts/accounts-manager.vala"
				_tmp15_ = _tmp17_;
#line 1070 "../src/client/accounts/accounts-manager.vala"
				if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1070 "../src/client/accounts/accounts-manager.vala"
					if (_inner_error_->domain == GEARY_RF_C822_ERROR) {
#line 10527 "accounts-manager.c"
						goto __catch98_geary_rf_c822_error;
					}
#line 1070 "../src/client/accounts/accounts-manager.vala"
					_g_free0 (sender);
#line 1070 "../src/client/accounts/accounts-manager.vala"
					_g_object_unref0 (_sender_list);
#line 1070 "../src/client/accounts/accounts-manager.vala"
					_g_object_unref0 (_tmp2_);
#line 1070 "../src/client/accounts/accounts-manager.vala"
					_g_object_unref0 (senders);
#line 1070 "../src/client/accounts/accounts-manager.vala"
					_geary_config_file_group_unref0 (account_config);
#line 1070 "../src/client/accounts/accounts-manager.vala"
					g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1070 "../src/client/accounts/accounts-manager.vala"
					g_clear_error (&_inner_error_);
#line 1070 "../src/client/accounts/accounts-manager.vala"
					return NULL;
#line 10546 "accounts-manager.c"
				}
#line 1069 "../src/client/accounts/accounts-manager.vala"
				_tmp18_ = senders;
#line 1069 "../src/client/accounts/accounts-manager.vala"
				gee_collection_add (G_TYPE_CHECK_INSTANCE_CAST (_tmp18_, GEE_TYPE_COLLECTION, GeeCollection), _tmp15_);
#line 1068 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_tmp15_);
#line 10554 "accounts-manager.c"
			}
			goto __finally98;
			__catch98_geary_rf_c822_error:
			{
				GError* err = NULL;
				const gchar* _tmp19_;
				GError* _tmp20_;
#line 1068 "../src/client/accounts/accounts-manager.vala"
				err = _inner_error_;
#line 1068 "../src/client/accounts/accounts-manager.vala"
				_inner_error_ = NULL;
#line 1073 "../src/client/accounts/accounts-manager.vala"
				_tmp19_ = sender;
#line 1073 "../src/client/accounts/accounts-manager.vala"
				_tmp20_ = g_error_new (ACCOUNTS_CONFIG_ERROR, ACCOUNTS_CONFIG_ERROR_SYNTAX, "%s: Invalid sender address: %s", id, _tmp19_);
#line 1073 "../src/client/accounts/accounts-manager.vala"
				_inner_error_ = _tmp20_;
#line 1073 "../src/client/accounts/accounts-manager.vala"
				_g_error_free0 (err);
#line 10574 "accounts-manager.c"
				goto __finally98;
			}
			__finally98:
#line 1068 "../src/client/accounts/accounts-manager.vala"
			if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1068 "../src/client/accounts/accounts-manager.vala"
				if ((_inner_error_->domain == ACCOUNTS_CONFIG_ERROR) || (_inner_error_->domain == G_KEY_FILE_ERROR)) {
#line 1068 "../src/client/accounts/accounts-manager.vala"
					g_propagate_error (error, _inner_error_);
#line 1068 "../src/client/accounts/accounts-manager.vala"
					_g_free0 (sender);
#line 1068 "../src/client/accounts/accounts-manager.vala"
					_g_object_unref0 (_sender_list);
#line 1068 "../src/client/accounts/accounts-manager.vala"
					_g_object_unref0 (_tmp2_);
#line 1068 "../src/client/accounts/accounts-manager.vala"
					_g_object_unref0 (senders);
#line 1068 "../src/client/accounts/accounts-manager.vala"
					_geary_config_file_group_unref0 (account_config);
#line 1068 "../src/client/accounts/accounts-manager.vala"
					return NULL;
#line 10596 "accounts-manager.c"
				} else {
#line 1068 "../src/client/accounts/accounts-manager.vala"
					_g_free0 (sender);
#line 1068 "../src/client/accounts/accounts-manager.vala"
					_g_object_unref0 (_sender_list);
#line 1068 "../src/client/accounts/accounts-manager.vala"
					_g_object_unref0 (_tmp2_);
#line 1068 "../src/client/accounts/accounts-manager.vala"
					_g_object_unref0 (senders);
#line 1068 "../src/client/accounts/accounts-manager.vala"
					_geary_config_file_group_unref0 (account_config);
#line 1068 "../src/client/accounts/accounts-manager.vala"
					g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1068 "../src/client/accounts/accounts-manager.vala"
					g_clear_error (&_inner_error_);
#line 1068 "../src/client/accounts/accounts-manager.vala"
					return NULL;
#line 10614 "accounts-manager.c"
				}
			}
#line 1066 "../src/client/accounts/accounts-manager.vala"
			_g_free0 (sender);
#line 10619 "accounts-manager.c"
		}
#line 1066 "../src/client/accounts/accounts-manager.vala"
		_g_object_unref0 (_sender_list);
#line 10623 "accounts-manager.c"
	}
#line 1079 "../src/client/accounts/accounts-manager.vala"
	_tmp21_ = senders;
#line 1079 "../src/client/accounts/accounts-manager.vala"
	_tmp22_ = gee_collection_get_is_empty (G_TYPE_CHECK_INSTANCE_CAST (_tmp21_, GEE_TYPE_COLLECTION, GeeCollection));
#line 1079 "../src/client/accounts/accounts-manager.vala"
	_tmp23_ = _tmp22_;
#line 1079 "../src/client/accounts/accounts-manager.vala"
	if (_tmp23_) {
#line 10633 "accounts-manager.c"
		GError* _tmp24_;
#line 1080 "../src/client/accounts/accounts-manager.vala"
		_tmp24_ = g_error_new (ACCOUNTS_CONFIG_ERROR, ACCOUNTS_CONFIG_ERROR_SYNTAX, "%s: No sender addresses found", id);
#line 1080 "../src/client/accounts/accounts-manager.vala"
		_inner_error_ = _tmp24_;
#line 1080 "../src/client/accounts/accounts-manager.vala"
		if ((_inner_error_->domain == ACCOUNTS_CONFIG_ERROR) || (_inner_error_->domain == G_KEY_FILE_ERROR)) {
#line 1080 "../src/client/accounts/accounts-manager.vala"
			g_propagate_error (error, _inner_error_);
#line 1080 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_tmp2_);
#line 1080 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (senders);
#line 1080 "../src/client/accounts/accounts-manager.vala"
			_geary_config_file_group_unref0 (account_config);
#line 1080 "../src/client/accounts/accounts-manager.vala"
			return NULL;
#line 10651 "accounts-manager.c"
		} else {
#line 1080 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (_tmp2_);
#line 1080 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (senders);
#line 1080 "../src/client/accounts/accounts-manager.vala"
			_geary_config_file_group_unref0 (account_config);
#line 1080 "../src/client/accounts/accounts-manager.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1080 "../src/client/accounts/accounts-manager.vala"
			g_clear_error (&_inner_error_);
#line 1080 "../src/client/accounts/accounts-manager.vala"
			return NULL;
#line 10665 "accounts-manager.c"
		}
	}
#line 1084 "../src/client/accounts/accounts-manager.vala"
	if (default_provider != NULL) {
#line 10670 "accounts-manager.c"
		GearyServiceProvider* _tmp26_;
#line 1085 "../src/client/accounts/accounts-manager.vala"
		_tmp26_ = __geary_service_provider_dup0 (default_provider);
#line 1085 "../src/client/accounts/accounts-manager.vala"
		_g_free0 (_tmp25_);
#line 1085 "../src/client/accounts/accounts-manager.vala"
		_tmp25_ = _tmp26_;
#line 10678 "accounts-manager.c"
	} else {
		GearyConfigFileGroup* _tmp27_;
		gpointer _tmp28_;
		GearyServiceProvider _tmp29_;
		GearyServiceProvider* _tmp30_;
#line 1086 "../src/client/accounts/accounts-manager.vala"
		_tmp27_ = account_config;
#line 1086 "../src/client/accounts/accounts-manager.vala"
		_tmp28_ = geary_config_file_group_parse_required_value (_tmp27_, GEARY_TYPE_SERVICE_PROVIDER, NULL, NULL, ACCOUNTS_ACCOUNT_CONFIG_V1_ACCOUNT_PROVIDER, ____lambda4__geary_config_file_parser, self, &_inner_error_);
#line 1086 "../src/client/accounts/accounts-manager.vala"
		_tmp29_ = (GearyServiceProvider) ((gintptr) _tmp28_);
#line 1086 "../src/client/accounts/accounts-manager.vala"
		_tmp30_ = __geary_service_provider_dup0 (&_tmp29_);
#line 1086 "../src/client/accounts/accounts-manager.vala"
		_g_free0 (_tmp25_);
#line 1086 "../src/client/accounts/accounts-manager.vala"
		_tmp25_ = _tmp30_;
#line 1086 "../src/client/accounts/accounts-manager.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1086 "../src/client/accounts/accounts-manager.vala"
			if ((_inner_error_->domain == ACCOUNTS_CONFIG_ERROR) || (_inner_error_->domain == G_KEY_FILE_ERROR)) {
#line 1086 "../src/client/accounts/accounts-manager.vala"
				g_propagate_error (error, _inner_error_);
#line 1086 "../src/client/accounts/accounts-manager.vala"
				_g_free0 (_tmp25_);
#line 1086 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_tmp2_);
#line 1086 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (senders);
#line 1086 "../src/client/accounts/accounts-manager.vala"
				_geary_config_file_group_unref0 (account_config);
#line 1086 "../src/client/accounts/accounts-manager.vala"
				return NULL;
#line 10712 "accounts-manager.c"
			} else {
#line 1086 "../src/client/accounts/accounts-manager.vala"
				_g_free0 (_tmp25_);
#line 1086 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_tmp2_);
#line 1086 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (senders);
#line 1086 "../src/client/accounts/accounts-manager.vala"
				_geary_config_file_group_unref0 (account_config);
#line 1086 "../src/client/accounts/accounts-manager.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1086 "../src/client/accounts/accounts-manager.vala"
				g_clear_error (&_inner_error_);
#line 1086 "../src/client/accounts/accounts-manager.vala"
				return NULL;
#line 10728 "accounts-manager.c"
			}
		}
	}
#line 1083 "../src/client/accounts/accounts-manager.vala"
	provider = *_tmp25_;
#line 1098 "../src/client/accounts/accounts-manager.vala"
	_tmp31_ = provider;
#line 1098 "../src/client/accounts/accounts-manager.vala"
	_tmp32_ = senders;
#line 1098 "../src/client/accounts/accounts-manager.vala"
	_tmp33_ = gee_list_remove_at (_tmp32_, 0);
#line 1098 "../src/client/accounts/accounts-manager.vala"
	_tmp34_ = (GearyRFC822MailboxAddress*) _tmp33_;
#line 1098 "../src/client/accounts/accounts-manager.vala"
	_tmp35_ = geary_account_information_new (id, _tmp31_, mediator, _tmp34_);
#line 1098 "../src/client/accounts/accounts-manager.vala"
	_tmp36_ = _tmp35_;
#line 1098 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_tmp34_);
#line 1098 "../src/client/accounts/accounts-manager.vala"
	account = _tmp36_;
#line 1102 "../src/client/accounts/accounts-manager.vala"
	_tmp37_ = account;
#line 1102 "../src/client/accounts/accounts-manager.vala"
	_tmp38_ = account_config;
#line 1102 "../src/client/accounts/accounts-manager.vala"
	_tmp39_ = geary_account_information_next_ordinal;
#line 1102 "../src/client/accounts/accounts-manager.vala"
	geary_account_information_next_ordinal = _tmp39_ + 1;
#line 1102 "../src/client/accounts/accounts-manager.vala"
	geary_account_information_set_ordinal (_tmp37_, geary_config_file_group_get_int (_tmp38_, ACCOUNTS_ACCOUNT_CONFIG_V1_ACCOUNT_ORDINAL, _tmp39_));
#line 1105 "../src/client/accounts/accounts-manager.vala"
	_tmp40_ = account;
#line 1105 "../src/client/accounts/accounts-manager.vala"
	_tmp41_ = account_config;
#line 1105 "../src/client/accounts/accounts-manager.vala"
	_tmp42_ = account;
#line 1105 "../src/client/accounts/accounts-manager.vala"
	_tmp43_ = geary_account_information_get_label (_tmp42_);
#line 1105 "../src/client/accounts/accounts-manager.vala"
	_tmp44_ = _tmp43_;
#line 1105 "../src/client/accounts/accounts-manager.vala"
	_tmp45_ = geary_config_file_group_get_string (_tmp41_, ACCOUNTS_ACCOUNT_CONFIG_V1_ACCOUNT_LABEL, _tmp44_);
#line 1105 "../src/client/accounts/accounts-manager.vala"
	_tmp46_ = _tmp45_;
#line 1105 "../src/client/accounts/accounts-manager.vala"
	geary_account_information_set_label (_tmp40_, _tmp46_);
#line 1105 "../src/client/accounts/accounts-manager.vala"
	_g_free0 (_tmp46_);
#line 1108 "../src/client/accounts/accounts-manager.vala"
	_tmp47_ = account;
#line 1108 "../src/client/accounts/accounts-manager.vala"
	_tmp48_ = account_config;
#line 1108 "../src/client/accounts/accounts-manager.vala"
	_tmp49_ = account;
#line 1108 "../src/client/accounts/accounts-manager.vala"
	_tmp50_ = geary_account_information_get_prefetch_period_days (_tmp49_);
#line 1108 "../src/client/accounts/accounts-manager.vala"
	_tmp51_ = _tmp50_;
#line 1108 "../src/client/accounts/accounts-manager.vala"
	geary_account_information_set_prefetch_period_days (_tmp47_, geary_config_file_group_get_int (_tmp48_, ACCOUNTS_ACCOUNT_CONFIG_V1_ACCOUNT_PREFETCH, _tmp51_));
#line 1111 "../src/client/accounts/accounts-manager.vala"
	_tmp52_ = account;
#line 1111 "../src/client/accounts/accounts-manager.vala"
	_tmp53_ = account_config;
#line 1111 "../src/client/accounts/accounts-manager.vala"
	_tmp54_ = account;
#line 1111 "../src/client/accounts/accounts-manager.vala"
	_tmp55_ = geary_account_information_get_save_drafts (_tmp54_);
#line 1111 "../src/client/accounts/accounts-manager.vala"
	_tmp56_ = _tmp55_;
#line 1111 "../src/client/accounts/accounts-manager.vala"
	geary_account_information_set_save_drafts (_tmp52_, geary_config_file_group_get_bool (_tmp53_, ACCOUNTS_ACCOUNT_CONFIG_V1_ACCOUNT_SAVE_DRAFTS, _tmp56_));
#line 1114 "../src/client/accounts/accounts-manager.vala"
	_tmp57_ = account;
#line 1114 "../src/client/accounts/accounts-manager.vala"
	_tmp58_ = account_config;
#line 1114 "../src/client/accounts/accounts-manager.vala"
	_tmp59_ = account;
#line 1114 "../src/client/accounts/accounts-manager.vala"
	_tmp60_ = geary_account_information_get_save_sent (_tmp59_);
#line 1114 "../src/client/accounts/accounts-manager.vala"
	_tmp61_ = _tmp60_;
#line 1114 "../src/client/accounts/accounts-manager.vala"
	geary_account_information_set_save_sent (_tmp57_, geary_config_file_group_get_bool (_tmp58_, ACCOUNTS_ACCOUNT_CONFIG_V1_ACCOUNT_SAVE_SENT, _tmp61_));
#line 1117 "../src/client/accounts/accounts-manager.vala"
	_tmp62_ = account;
#line 1117 "../src/client/accounts/accounts-manager.vala"
	_tmp63_ = account_config;
#line 1117 "../src/client/accounts/accounts-manager.vala"
	_tmp64_ = account;
#line 1117 "../src/client/accounts/accounts-manager.vala"
	_tmp65_ = geary_account_information_get_use_signature (_tmp64_);
#line 1117 "../src/client/accounts/accounts-manager.vala"
	_tmp66_ = _tmp65_;
#line 1117 "../src/client/accounts/accounts-manager.vala"
	geary_account_information_set_use_signature (_tmp62_, geary_config_file_group_get_bool (_tmp63_, ACCOUNTS_ACCOUNT_CONFIG_V1_ACCOUNT_USE_SIG, _tmp66_));
#line 1120 "../src/client/accounts/accounts-manager.vala"
	_tmp67_ = account;
#line 1120 "../src/client/accounts/accounts-manager.vala"
	_tmp68_ = account_config;
#line 1120 "../src/client/accounts/accounts-manager.vala"
	_tmp69_ = account;
#line 1120 "../src/client/accounts/accounts-manager.vala"
	_tmp70_ = geary_account_information_get_signature (_tmp69_);
#line 1120 "../src/client/accounts/accounts-manager.vala"
	_tmp71_ = _tmp70_;
#line 1120 "../src/client/accounts/accounts-manager.vala"
	_tmp72_ = geary_config_file_group_get_string (_tmp68_, ACCOUNTS_ACCOUNT_CONFIG_V1_ACCOUNT_SIG, _tmp71_);
#line 1120 "../src/client/accounts/accounts-manager.vala"
	_tmp73_ = _tmp72_;
#line 1120 "../src/client/accounts/accounts-manager.vala"
	geary_account_information_set_signature (_tmp67_, _tmp73_);
#line 1120 "../src/client/accounts/accounts-manager.vala"
	_g_free0 (_tmp73_);
#line 10844 "accounts-manager.c"
	{
		GeeList* _sender_list = NULL;
		GeeList* _tmp74_;
		GeeList* _tmp75_;
		gint _sender_size = 0;
		GeeList* _tmp76_;
		gint _tmp77_;
		gint _tmp78_;
		gint _sender_index = 0;
#line 1123 "../src/client/accounts/accounts-manager.vala"
		_tmp74_ = senders;
#line 1123 "../src/client/accounts/accounts-manager.vala"
		_tmp75_ = _g_object_ref0 (_tmp74_);
#line 1123 "../src/client/accounts/accounts-manager.vala"
		_sender_list = _tmp75_;
#line 1123 "../src/client/accounts/accounts-manager.vala"
		_tmp76_ = _sender_list;
#line 1123 "../src/client/accounts/accounts-manager.vala"
		_tmp77_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp76_, GEE_TYPE_COLLECTION, GeeCollection));
#line 1123 "../src/client/accounts/accounts-manager.vala"
		_tmp78_ = _tmp77_;
#line 1123 "../src/client/accounts/accounts-manager.vala"
		_sender_size = _tmp78_;
#line 1123 "../src/client/accounts/accounts-manager.vala"
		_sender_index = -1;
#line 1123 "../src/client/accounts/accounts-manager.vala"
		while (TRUE) {
#line 10872 "accounts-manager.c"
			gint _tmp79_;
			gint _tmp80_;
			gint _tmp81_;
			GearyRFC822MailboxAddress* sender = NULL;
			GeeList* _tmp82_;
			gint _tmp83_;
			gpointer _tmp84_;
			GearyAccountInformation* _tmp85_;
			GearyRFC822MailboxAddress* _tmp86_;
#line 1123 "../src/client/accounts/accounts-manager.vala"
			_tmp79_ = _sender_index;
#line 1123 "../src/client/accounts/accounts-manager.vala"
			_sender_index = _tmp79_ + 1;
#line 1123 "../src/client/accounts/accounts-manager.vala"
			_tmp80_ = _sender_index;
#line 1123 "../src/client/accounts/accounts-manager.vala"
			_tmp81_ = _sender_size;
#line 1123 "../src/client/accounts/accounts-manager.vala"
			if (!(_tmp80_ < _tmp81_)) {
#line 1123 "../src/client/accounts/accounts-manager.vala"
				break;
#line 10894 "accounts-manager.c"
			}
#line 1123 "../src/client/accounts/accounts-manager.vala"
			_tmp82_ = _sender_list;
#line 1123 "../src/client/accounts/accounts-manager.vala"
			_tmp83_ = _sender_index;
#line 1123 "../src/client/accounts/accounts-manager.vala"
			_tmp84_ = gee_list_get (_tmp82_, _tmp83_);
#line 1123 "../src/client/accounts/accounts-manager.vala"
			sender = (GearyRFC822MailboxAddress*) _tmp84_;
#line 1124 "../src/client/accounts/accounts-manager.vala"
			_tmp85_ = account;
#line 1124 "../src/client/accounts/accounts-manager.vala"
			_tmp86_ = sender;
#line 1124 "../src/client/accounts/accounts-manager.vala"
			geary_account_information_append_sender (_tmp85_, _tmp86_);
#line 1123 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (sender);
#line 10912 "accounts-manager.c"
		}
#line 1123 "../src/client/accounts/accounts-manager.vala"
		_g_object_unref0 (_sender_list);
#line 10916 "accounts-manager.c"
	}
#line 1127 "../src/client/accounts/accounts-manager.vala"
	_tmp87_ = geary_config_file_get_group (config, ACCOUNTS_ACCOUNT_CONFIG_V1_GROUP_FOLDERS);
#line 1127 "../src/client/accounts/accounts-manager.vala"
	folder_config = _tmp87_;
#line 1129 "../src/client/accounts/accounts-manager.vala"
	_tmp88_ = account;
#line 1129 "../src/client/accounts/accounts-manager.vala"
	_tmp89_ = folder_config;
#line 1129 "../src/client/accounts/accounts-manager.vala"
	_tmp90_ = accounts_account_config_v1_load_folder (self, _tmp89_, ACCOUNTS_ACCOUNT_CONFIG_V1_FOLDER_ARCHIVE);
#line 1129 "../src/client/accounts/accounts-manager.vala"
	_tmp91_ = _tmp90_;
#line 1129 "../src/client/accounts/accounts-manager.vala"
	geary_account_information_set_archive_folder_path (_tmp88_, _tmp91_);
#line 1129 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_tmp91_);
#line 1130 "../src/client/accounts/accounts-manager.vala"
	_tmp92_ = account;
#line 1130 "../src/client/accounts/accounts-manager.vala"
	_tmp93_ = folder_config;
#line 1130 "../src/client/accounts/accounts-manager.vala"
	_tmp94_ = accounts_account_config_v1_load_folder (self, _tmp93_, ACCOUNTS_ACCOUNT_CONFIG_V1_FOLDER_DRAFTS);
#line 1130 "../src/client/accounts/accounts-manager.vala"
	_tmp95_ = _tmp94_;
#line 1130 "../src/client/accounts/accounts-manager.vala"
	geary_account_information_set_drafts_folder_path (_tmp92_, _tmp95_);
#line 1130 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_tmp95_);
#line 1131 "../src/client/accounts/accounts-manager.vala"
	_tmp96_ = account;
#line 1131 "../src/client/accounts/accounts-manager.vala"
	_tmp97_ = folder_config;
#line 1131 "../src/client/accounts/accounts-manager.vala"
	_tmp98_ = accounts_account_config_v1_load_folder (self, _tmp97_, ACCOUNTS_ACCOUNT_CONFIG_V1_FOLDER_SENT);
#line 1131 "../src/client/accounts/accounts-manager.vala"
	_tmp99_ = _tmp98_;
#line 1131 "../src/client/accounts/accounts-manager.vala"
	geary_account_information_set_sent_folder_path (_tmp96_, _tmp99_);
#line 1131 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_tmp99_);
#line 1132 "../src/client/accounts/accounts-manager.vala"
	_tmp100_ = account;
#line 1132 "../src/client/accounts/accounts-manager.vala"
	_tmp101_ = folder_config;
#line 1132 "../src/client/accounts/accounts-manager.vala"
	_tmp102_ = accounts_account_config_v1_load_folder (self, _tmp101_, ACCOUNTS_ACCOUNT_CONFIG_V1_FOLDER_SPAM);
#line 1132 "../src/client/accounts/accounts-manager.vala"
	_tmp103_ = _tmp102_;
#line 1132 "../src/client/accounts/accounts-manager.vala"
	geary_account_information_set_spam_folder_path (_tmp100_, _tmp103_);
#line 1132 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_tmp103_);
#line 1133 "../src/client/accounts/accounts-manager.vala"
	_tmp104_ = account;
#line 1133 "../src/client/accounts/accounts-manager.vala"
	_tmp105_ = folder_config;
#line 1133 "../src/client/accounts/accounts-manager.vala"
	_tmp106_ = accounts_account_config_v1_load_folder (self, _tmp105_, ACCOUNTS_ACCOUNT_CONFIG_V1_FOLDER_TRASH);
#line 1133 "../src/client/accounts/accounts-manager.vala"
	_tmp107_ = _tmp106_;
#line 1133 "../src/client/accounts/accounts-manager.vala"
	geary_account_information_set_trash_folder_path (_tmp104_, _tmp107_);
#line 1133 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_tmp107_);
#line 1135 "../src/client/accounts/accounts-manager.vala"
	result = account;
#line 1135 "../src/client/accounts/accounts-manager.vala"
	_geary_config_file_group_unref0 (folder_config);
#line 1135 "../src/client/accounts/accounts-manager.vala"
	_g_free0 (_tmp25_);
#line 1135 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_tmp2_);
#line 1135 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (senders);
#line 1135 "../src/client/accounts/accounts-manager.vala"
	_geary_config_file_group_unref0 (account_config);
#line 1135 "../src/client/accounts/accounts-manager.vala"
	return result;
#line 10996 "accounts-manager.c"
}


/** Saves an account to a config file. */
static gchar*
__lambda5_ (AccountsAccountConfigV1* self,
            GearyRFC822MailboxAddress* sender)
{
	gchar* result = NULL;
	gchar* _tmp0_;
#line 1153 "../src/client/accounts/accounts-manager.vala"
	g_return_val_if_fail (GEARY_RF_C822_IS_MAILBOX_ADDRESS (sender), NULL);
#line 1153 "../src/client/accounts/accounts-manager.vala"
	_tmp0_ = geary_rf_c822_mailbox_address_to_rfc822_string (sender);
#line 1153 "../src/client/accounts/accounts-manager.vala"
	result = _tmp0_;
#line 1153 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (sender);
#line 1153 "../src/client/accounts/accounts-manager.vala"
	return result;
#line 11017 "accounts-manager.c"
}


static gpointer
___lambda5__gee_map_func (gpointer g,
                          gpointer self)
{
	gpointer result;
	result = __lambda5_ ((AccountsAccountConfigV1*) self, (GearyRFC822MailboxAddress*) g);
#line 1150 "../src/client/accounts/accounts-manager.vala"
	return result;
#line 11029 "accounts-manager.c"
}


static void
accounts_account_config_v1_real_save (AccountsAccountConfig* base,
                                      GearyAccountInformation* account,
                                      GearyConfigFile* config)
{
	AccountsAccountConfigV1 * self;
	GearyConfigFileGroup* account_config = NULL;
	GearyConfigFileGroup* _tmp0_;
	GearyConfigFileGroup* _tmp1_;
	gint _tmp2_;
	gint _tmp3_;
	GearyConfigFileGroup* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	GearyConfigFileGroup* _tmp7_;
	gint _tmp8_;
	gint _tmp9_;
	GearyConfigFileGroup* _tmp10_;
	gboolean _tmp11_;
	gboolean _tmp12_;
	GearyConfigFileGroup* _tmp13_;
	gboolean _tmp14_;
	gboolean _tmp15_;
	GearyConfigFileGroup* _tmp16_;
	gboolean _tmp17_;
	gboolean _tmp18_;
	GearyConfigFileGroup* _tmp19_;
	const gchar* _tmp20_;
	const gchar* _tmp21_;
	GearyConfigFileGroup* _tmp22_;
	GeeList* _tmp23_;
	GeeList* _tmp24_;
	GeeList* _tmp25_;
	GearyIterable* _tmp26_;
	GearyIterable* _tmp27_;
	GearyIterable* _tmp28_;
	GearyIterable* _tmp29_;
	GeeArrayList* _tmp30_;
	GeeArrayList* _tmp31_;
	gboolean _tmp32_;
	GearyConfigFileGroup* folder_config = NULL;
	GearyConfigFileGroup* _tmp38_;
	GearyFolderPath* _tmp39_;
	GearyFolderPath* _tmp40_;
	GearyFolderPath* _tmp41_;
	GearyFolderPath* _tmp42_;
	GearyFolderPath* _tmp43_;
	GearyFolderPath* _tmp44_;
	GearyFolderPath* _tmp45_;
	GearyFolderPath* _tmp46_;
	GearyFolderPath* _tmp47_;
	GearyFolderPath* _tmp48_;
#line 1139 "../src/client/accounts/accounts-manager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, ACCOUNTS_TYPE_ACCOUNT_CONFIG_V1, AccountsAccountConfigV1);
#line 1139 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail (GEARY_IS_ACCOUNT_INFORMATION (account));
#line 1139 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail (GEARY_IS_CONFIG_FILE (config));
#line 1141 "../src/client/accounts/accounts-manager.vala"
	_tmp0_ = geary_config_file_get_group (config, ACCOUNTS_ACCOUNT_CONFIG_V1_GROUP_ACCOUNT);
#line 1141 "../src/client/accounts/accounts-manager.vala"
	account_config = _tmp0_;
#line 1143 "../src/client/accounts/accounts-manager.vala"
	_tmp1_ = account_config;
#line 1143 "../src/client/accounts/accounts-manager.vala"
	_tmp2_ = geary_account_information_get_ordinal (account);
#line 1143 "../src/client/accounts/accounts-manager.vala"
	_tmp3_ = _tmp2_;
#line 1143 "../src/client/accounts/accounts-manager.vala"
	geary_config_file_group_set_int (_tmp1_, ACCOUNTS_ACCOUNT_CONFIG_V1_ACCOUNT_ORDINAL, _tmp3_);
#line 1144 "../src/client/accounts/accounts-manager.vala"
	_tmp4_ = account_config;
#line 1144 "../src/client/accounts/accounts-manager.vala"
	_tmp5_ = geary_account_information_get_label (account);
#line 1144 "../src/client/accounts/accounts-manager.vala"
	_tmp6_ = _tmp5_;
#line 1144 "../src/client/accounts/accounts-manager.vala"
	geary_config_file_group_set_string (_tmp4_, ACCOUNTS_ACCOUNT_CONFIG_V1_ACCOUNT_LABEL, _tmp6_);
#line 1145 "../src/client/accounts/accounts-manager.vala"
	_tmp7_ = account_config;
#line 1145 "../src/client/accounts/accounts-manager.vala"
	_tmp8_ = geary_account_information_get_prefetch_period_days (account);
#line 1145 "../src/client/accounts/accounts-manager.vala"
	_tmp9_ = _tmp8_;
#line 1145 "../src/client/accounts/accounts-manager.vala"
	geary_config_file_group_set_int (_tmp7_, ACCOUNTS_ACCOUNT_CONFIG_V1_ACCOUNT_PREFETCH, _tmp9_);
#line 1146 "../src/client/accounts/accounts-manager.vala"
	_tmp10_ = account_config;
#line 1146 "../src/client/accounts/accounts-manager.vala"
	_tmp11_ = geary_account_information_get_save_drafts (account);
#line 1146 "../src/client/accounts/accounts-manager.vala"
	_tmp12_ = _tmp11_;
#line 1146 "../src/client/accounts/accounts-manager.vala"
	geary_config_file_group_set_bool (_tmp10_, ACCOUNTS_ACCOUNT_CONFIG_V1_ACCOUNT_SAVE_DRAFTS, _tmp12_);
#line 1147 "../src/client/accounts/accounts-manager.vala"
	_tmp13_ = account_config;
#line 1147 "../src/client/accounts/accounts-manager.vala"
	_tmp14_ = geary_account_information_get_save_sent (account);
#line 1147 "../src/client/accounts/accounts-manager.vala"
	_tmp15_ = _tmp14_;
#line 1147 "../src/client/accounts/accounts-manager.vala"
	geary_config_file_group_set_bool (_tmp13_, ACCOUNTS_ACCOUNT_CONFIG_V1_ACCOUNT_SAVE_SENT, _tmp15_);
#line 1148 "../src/client/accounts/accounts-manager.vala"
	_tmp16_ = account_config;
#line 1148 "../src/client/accounts/accounts-manager.vala"
	_tmp17_ = geary_account_information_get_use_signature (account);
#line 1148 "../src/client/accounts/accounts-manager.vala"
	_tmp18_ = _tmp17_;
#line 1148 "../src/client/accounts/accounts-manager.vala"
	geary_config_file_group_set_bool (_tmp16_, ACCOUNTS_ACCOUNT_CONFIG_V1_ACCOUNT_USE_SIG, _tmp18_);
#line 1149 "../src/client/accounts/accounts-manager.vala"
	_tmp19_ = account_config;
#line 1149 "../src/client/accounts/accounts-manager.vala"
	_tmp20_ = geary_account_information_get_signature (account);
#line 1149 "../src/client/accounts/accounts-manager.vala"
	_tmp21_ = _tmp20_;
#line 1149 "../src/client/accounts/accounts-manager.vala"
	geary_config_file_group_set_string (_tmp19_, ACCOUNTS_ACCOUNT_CONFIG_V1_ACCOUNT_SIG, _tmp21_);
#line 1150 "../src/client/accounts/accounts-manager.vala"
	_tmp22_ = account_config;
#line 1150 "../src/client/accounts/accounts-manager.vala"
	_tmp23_ = geary_account_information_get_sender_mailboxes (account);
#line 1150 "../src/client/accounts/accounts-manager.vala"
	_tmp24_ = _tmp23_;
#line 1150 "../src/client/accounts/accounts-manager.vala"
	_tmp25_ = _tmp24_;
#line 1150 "../src/client/accounts/accounts-manager.vala"
	_tmp26_ = geary_traverse (GEARY_RF_C822_TYPE_MAILBOX_ADDRESS, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, G_TYPE_CHECK_INSTANCE_CAST (_tmp25_, GEE_TYPE_ITERABLE, GeeIterable));
#line 1150 "../src/client/accounts/accounts-manager.vala"
	_tmp27_ = _tmp26_;
#line 1150 "../src/client/accounts/accounts-manager.vala"
	_tmp28_ = geary_iterable_map (_tmp27_, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, ___lambda5__gee_map_func, self);
#line 1150 "../src/client/accounts/accounts-manager.vala"
	_tmp29_ = _tmp28_;
#line 1150 "../src/client/accounts/accounts-manager.vala"
	_tmp30_ = geary_iterable_to_array_list (_tmp29_, NULL, NULL, NULL);
#line 1150 "../src/client/accounts/accounts-manager.vala"
	_tmp31_ = _tmp30_;
#line 1150 "../src/client/accounts/accounts-manager.vala"
	geary_config_file_group_set_string_list (_tmp22_, ACCOUNTS_ACCOUNT_CONFIG_V1_ACCOUNT_SENDERS, G_TYPE_CHECK_INSTANCE_CAST (_tmp31_, GEE_TYPE_LIST, GeeList));
#line 1150 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_tmp31_);
#line 1150 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_tmp29_);
#line 1150 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_tmp27_);
#line 1150 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_tmp25_);
#line 1157 "../src/client/accounts/accounts-manager.vala"
	_tmp32_ = self->priv->is_managed;
#line 1157 "../src/client/accounts/accounts-manager.vala"
	if (!_tmp32_) {
#line 11185 "accounts-manager.c"
		GearyConfigFileGroup* _tmp33_;
		GearyServiceProvider _tmp34_;
		GearyServiceProvider _tmp35_;
		gchar* _tmp36_;
		gchar* _tmp37_;
#line 1158 "../src/client/accounts/accounts-manager.vala"
		_tmp33_ = account_config;
#line 1158 "../src/client/accounts/accounts-manager.vala"
		_tmp34_ = geary_account_information_get_service_provider (account);
#line 1158 "../src/client/accounts/accounts-manager.vala"
		_tmp35_ = _tmp34_;
#line 1158 "../src/client/accounts/accounts-manager.vala"
		_tmp36_ = geary_service_provider_to_value (_tmp35_);
#line 1158 "../src/client/accounts/accounts-manager.vala"
		_tmp37_ = _tmp36_;
#line 1158 "../src/client/accounts/accounts-manager.vala"
		geary_config_file_group_set_string (_tmp33_, ACCOUNTS_ACCOUNT_CONFIG_V1_ACCOUNT_PROVIDER, _tmp37_);
#line 1158 "../src/client/accounts/accounts-manager.vala"
		_g_free0 (_tmp37_);
#line 11205 "accounts-manager.c"
	}
#line 1163 "../src/client/accounts/accounts-manager.vala"
	_tmp38_ = geary_config_file_get_group (config, ACCOUNTS_ACCOUNT_CONFIG_V1_GROUP_FOLDERS);
#line 1163 "../src/client/accounts/accounts-manager.vala"
	folder_config = _tmp38_;
#line 1165 "../src/client/accounts/accounts-manager.vala"
	_tmp39_ = geary_account_information_get_archive_folder_path (account);
#line 1165 "../src/client/accounts/accounts-manager.vala"
	_tmp40_ = _tmp39_;
#line 1165 "../src/client/accounts/accounts-manager.vala"
	accounts_account_config_v1_save_folder (self, folder_config, ACCOUNTS_ACCOUNT_CONFIG_V1_FOLDER_ARCHIVE, _tmp40_);
#line 1166 "../src/client/accounts/accounts-manager.vala"
	_tmp41_ = geary_account_information_get_drafts_folder_path (account);
#line 1166 "../src/client/accounts/accounts-manager.vala"
	_tmp42_ = _tmp41_;
#line 1166 "../src/client/accounts/accounts-manager.vala"
	accounts_account_config_v1_save_folder (self, folder_config, ACCOUNTS_ACCOUNT_CONFIG_V1_FOLDER_DRAFTS, _tmp42_);
#line 1167 "../src/client/accounts/accounts-manager.vala"
	_tmp43_ = geary_account_information_get_sent_folder_path (account);
#line 1167 "../src/client/accounts/accounts-manager.vala"
	_tmp44_ = _tmp43_;
#line 1167 "../src/client/accounts/accounts-manager.vala"
	accounts_account_config_v1_save_folder (self, folder_config, ACCOUNTS_ACCOUNT_CONFIG_V1_FOLDER_SENT, _tmp44_);
#line 1168 "../src/client/accounts/accounts-manager.vala"
	_tmp45_ = geary_account_information_get_spam_folder_path (account);
#line 1168 "../src/client/accounts/accounts-manager.vala"
	_tmp46_ = _tmp45_;
#line 1168 "../src/client/accounts/accounts-manager.vala"
	accounts_account_config_v1_save_folder (self, folder_config, ACCOUNTS_ACCOUNT_CONFIG_V1_FOLDER_SPAM, _tmp46_);
#line 1169 "../src/client/accounts/accounts-manager.vala"
	_tmp47_ = geary_account_information_get_trash_folder_path (account);
#line 1169 "../src/client/accounts/accounts-manager.vala"
	_tmp48_ = _tmp47_;
#line 1169 "../src/client/accounts/accounts-manager.vala"
	accounts_account_config_v1_save_folder (self, folder_config, ACCOUNTS_ACCOUNT_CONFIG_V1_FOLDER_TRASH, _tmp48_);
#line 1139 "../src/client/accounts/accounts-manager.vala"
	_geary_config_file_group_unref0 (folder_config);
#line 1139 "../src/client/accounts/accounts-manager.vala"
	_geary_config_file_group_unref0 (account_config);
#line 11245 "accounts-manager.c"
}


static void
accounts_account_config_v1_save_folder (AccountsAccountConfigV1* self,
                                        GearyConfigFileGroup* config,
                                        const gchar* key,
                                        GearyFolderPath* path)
{
#line 1172 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail (ACCOUNTS_IS_ACCOUNT_CONFIG_V1 (self));
#line 1172 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail (GEARY_CONFIG_FILE_IS_GROUP (config));
#line 1172 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail (key != NULL);
#line 1172 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail ((path == NULL) || GEARY_IS_FOLDER_PATH (path));
#line 1175 "../src/client/accounts/accounts-manager.vala"
	if (path != NULL) {
#line 11265 "accounts-manager.c"
		gint _tmp0_ = 0;
		gchar** _tmp1_;
		GeeArrayList* _tmp2_;
		GeeArrayList* _tmp3_;
#line 1176 "../src/client/accounts/accounts-manager.vala"
		_tmp1_ = geary_folder_path_as_array (path, &_tmp0_);
#line 1176 "../src/client/accounts/accounts-manager.vala"
		_tmp2_ = gee_array_list_new_wrap (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, _tmp1_, _tmp0_, NULL, NULL, NULL);
#line 1176 "../src/client/accounts/accounts-manager.vala"
		_tmp3_ = _tmp2_;
#line 1176 "../src/client/accounts/accounts-manager.vala"
		geary_config_file_group_set_string_list (config, key, G_TYPE_CHECK_INSTANCE_CAST (_tmp3_, GEE_TYPE_LIST, GeeList));
#line 1176 "../src/client/accounts/accounts-manager.vala"
		_g_object_unref0 (_tmp3_);
#line 11280 "accounts-manager.c"
	}
}


static GearyFolderPath*
accounts_account_config_v1_load_folder (AccountsAccountConfigV1* self,
                                        GearyConfigFileGroup* config,
                                        const gchar* key)
{
	GearyFolderPath* result = NULL;
	GearyFolderPath* path = NULL;
	GeeList* parts = NULL;
	GeeList* _tmp0_;
	GeeList* _tmp1_;
	gboolean _tmp2_;
	gboolean _tmp3_;
#line 1182 "../src/client/accounts/accounts-manager.vala"
	g_return_val_if_fail (ACCOUNTS_IS_ACCOUNT_CONFIG_V1 (self), NULL);
#line 1182 "../src/client/accounts/accounts-manager.vala"
	g_return_val_if_fail (GEARY_CONFIG_FILE_IS_GROUP (config), NULL);
#line 1182 "../src/client/accounts/accounts-manager.vala"
	g_return_val_if_fail (key != NULL, NULL);
#line 1184 "../src/client/accounts/accounts-manager.vala"
	path = NULL;
#line 1185 "../src/client/accounts/accounts-manager.vala"
	_tmp0_ = geary_config_file_group_get_string_list (config, key);
#line 1185 "../src/client/accounts/accounts-manager.vala"
	parts = _tmp0_;
#line 1186 "../src/client/accounts/accounts-manager.vala"
	_tmp1_ = parts;
#line 1186 "../src/client/accounts/accounts-manager.vala"
	_tmp2_ = gee_collection_get_is_empty (G_TYPE_CHECK_INSTANCE_CAST (_tmp1_, GEE_TYPE_COLLECTION, GeeCollection));
#line 1186 "../src/client/accounts/accounts-manager.vala"
	_tmp3_ = _tmp2_;
#line 1186 "../src/client/accounts/accounts-manager.vala"
	if (!_tmp3_) {
#line 11317 "accounts-manager.c"
		GeeList* _tmp4_;
		GearyFolderPath* _tmp5_;
#line 1187 "../src/client/accounts/accounts-manager.vala"
		_tmp4_ = parts;
#line 1187 "../src/client/accounts/accounts-manager.vala"
		_tmp5_ = geary_account_information_build_folder_path (_tmp4_);
#line 1187 "../src/client/accounts/accounts-manager.vala"
		_g_object_unref0 (path);
#line 1187 "../src/client/accounts/accounts-manager.vala"
		path = _tmp5_;
#line 11328 "accounts-manager.c"
	}
#line 1189 "../src/client/accounts/accounts-manager.vala"
	result = path;
#line 1189 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (parts);
#line 1189 "../src/client/accounts/accounts-manager.vala"
	return result;
#line 11336 "accounts-manager.c"
}


static void
accounts_account_config_v1_class_init (AccountsAccountConfigV1Class * klass)
{
#line 1026 "../src/client/accounts/accounts-manager.vala"
	accounts_account_config_v1_parent_class = g_type_class_peek_parent (klass);
#line 1026 "../src/client/accounts/accounts-manager.vala"
	g_type_class_adjust_private_offset (klass, &AccountsAccountConfigV1_private_offset);
#line 1026 "../src/client/accounts/accounts-manager.vala"
	G_OBJECT_CLASS (klass)->finalize = accounts_account_config_v1_finalize;
#line 11349 "accounts-manager.c"
}


static void
accounts_account_config_v1_accounts_account_config_interface_init (AccountsAccountConfigIface * iface)
{
#line 1026 "../src/client/accounts/accounts-manager.vala"
	accounts_account_config_v1_accounts_account_config_parent_iface = g_type_interface_peek_parent (iface);
#line 1026 "../src/client/accounts/accounts-manager.vala"
	iface->load = (GearyAccountInformation* (*) (AccountsAccountConfig*, GearyConfigFile*, const gchar*, GearyCredentialsMediator*, GearyServiceProvider*, const gchar*, GError**)) accounts_account_config_v1_real_load;
#line 1026 "../src/client/accounts/accounts-manager.vala"
	iface->save = (void (*) (AccountsAccountConfig*, GearyAccountInformation*, GearyConfigFile*)) accounts_account_config_v1_real_save;
#line 11362 "accounts-manager.c"
}


static void
accounts_account_config_v1_instance_init (AccountsAccountConfigV1 * self)
{
#line 1026 "../src/client/accounts/accounts-manager.vala"
	self->priv = accounts_account_config_v1_get_instance_private (self);
#line 11371 "accounts-manager.c"
}


static void
accounts_account_config_v1_finalize (GObject * obj)
{
	AccountsAccountConfigV1 * self;
#line 1026 "../src/client/accounts/accounts-manager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (obj, ACCOUNTS_TYPE_ACCOUNT_CONFIG_V1, AccountsAccountConfigV1);
#line 1026 "../src/client/accounts/accounts-manager.vala"
	G_OBJECT_CLASS (accounts_account_config_v1_parent_class)->finalize (obj);
#line 11383 "accounts-manager.c"
}


/**
 * Manages persistence for version 1 config files.
 */
GType
accounts_account_config_v1_get_type (void)
{
	static volatile gsize accounts_account_config_v1_type_id__volatile = 0;
	if (g_once_init_enter (&accounts_account_config_v1_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (AccountsAccountConfigV1Class), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) accounts_account_config_v1_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (AccountsAccountConfigV1), 0, (GInstanceInitFunc) accounts_account_config_v1_instance_init, NULL };
		static const GInterfaceInfo accounts_account_config_info = { (GInterfaceInitFunc) accounts_account_config_v1_accounts_account_config_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType accounts_account_config_v1_type_id;
		accounts_account_config_v1_type_id = g_type_register_static (G_TYPE_OBJECT, "AccountsAccountConfigV1", &g_define_type_info, 0);
		g_type_add_interface_static (accounts_account_config_v1_type_id, ACCOUNTS_TYPE_ACCOUNT_CONFIG, &accounts_account_config_info);
		AccountsAccountConfigV1_private_offset = g_type_add_instance_private (accounts_account_config_v1_type_id, sizeof (AccountsAccountConfigV1Private));
		g_once_init_leave (&accounts_account_config_v1_type_id__volatile, accounts_account_config_v1_type_id);
	}
	return accounts_account_config_v1_type_id__volatile;
}


static GearyServiceProvider
___lambda11_ (AccountsAccountConfigLegacy* self,
              const gchar* value,
              GError** error)
{
	GearyServiceProvider result = 0;
	GError * _inner_error_ = NULL;
#line 1238 "../src/client/accounts/accounts-manager.vala"
	g_return_val_if_fail (value != NULL, 0);
#line 11416 "accounts-manager.c"
	{
		GearyServiceProvider _tmp0_ = 0;
#line 1240 "../src/client/accounts/accounts-manager.vala"
		_tmp0_ = geary_service_provider_for_value (value, &_inner_error_);
#line 1240 "../src/client/accounts/accounts-manager.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1240 "../src/client/accounts/accounts-manager.vala"
			if (_inner_error_->domain == GEARY_ENGINE_ERROR) {
#line 11425 "accounts-manager.c"
				goto __catch100_geary_engine_error;
			}
#line 1240 "../src/client/accounts/accounts-manager.vala"
			g_critical ("file %s: line %d: unexpected error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1240 "../src/client/accounts/accounts-manager.vala"
			g_clear_error (&_inner_error_);
#line 1240 "../src/client/accounts/accounts-manager.vala"
			return 0;
#line 11434 "accounts-manager.c"
		}
#line 1240 "../src/client/accounts/accounts-manager.vala"
		result = _tmp0_;
#line 1240 "../src/client/accounts/accounts-manager.vala"
		return result;
#line 11440 "accounts-manager.c"
	}
	goto __finally100;
	__catch100_geary_engine_error:
	{
		GError* err = NULL;
		GError* _tmp1_;
		const gchar* _tmp2_;
		GError* _tmp3_;
#line 1239 "../src/client/accounts/accounts-manager.vala"
		err = _inner_error_;
#line 1239 "../src/client/accounts/accounts-manager.vala"
		_inner_error_ = NULL;
#line 1242 "../src/client/accounts/accounts-manager.vala"
		_tmp1_ = err;
#line 1242 "../src/client/accounts/accounts-manager.vala"
		_tmp2_ = _tmp1_->message;
#line 1242 "../src/client/accounts/accounts-manager.vala"
		_tmp3_ = g_error_new_literal (G_KEY_FILE_ERROR, G_KEY_FILE_ERROR_INVALID_VALUE, _tmp2_);
#line 1242 "../src/client/accounts/accounts-manager.vala"
		_inner_error_ = _tmp3_;
#line 1242 "../src/client/accounts/accounts-manager.vala"
		_g_error_free0 (err);
#line 11463 "accounts-manager.c"
		goto __finally100;
	}
	__finally100:
#line 1239 "../src/client/accounts/accounts-manager.vala"
	if (_inner_error_->domain == G_KEY_FILE_ERROR) {
#line 1239 "../src/client/accounts/accounts-manager.vala"
		g_propagate_error (error, _inner_error_);
#line 1239 "../src/client/accounts/accounts-manager.vala"
		return 0;
#line 11473 "accounts-manager.c"
	} else {
#line 1239 "../src/client/accounts/accounts-manager.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1239 "../src/client/accounts/accounts-manager.vala"
		g_clear_error (&_inner_error_);
#line 1239 "../src/client/accounts/accounts-manager.vala"
		return 0;
#line 11481 "accounts-manager.c"
	}
}


static gpointer
____lambda11__geary_config_file_parser (const gchar* value,
                                        gpointer self,
                                        GError** error)
{
	gpointer result;
	result = (gpointer) ((gintptr) ___lambda11_ ((AccountsAccountConfigLegacy*) self, value, error));
#line 1236 "../src/client/accounts/accounts-manager.vala"
	return result;
#line 11495 "accounts-manager.c"
}


static GearyAccountInformation*
accounts_account_config_legacy_real_load (AccountsAccountConfig* base,
                                          GearyConfigFile* config_file,
                                          const gchar* id,
                                          GearyCredentialsMediator* mediator,
                                          GearyServiceProvider* default_provider,
                                          const gchar* default_name,
                                          GError** error)
{
	AccountsAccountConfigLegacy * self;
	GearyAccountInformation* result = NULL;
	GearyConfigFileGroup* config = NULL;
	GearyConfigFileGroup* _tmp0_;
	gchar* primary_email = NULL;
	GearyConfigFileGroup* _tmp1_;
	gchar* _tmp2_;
	gchar* real_name = NULL;
	GearyConfigFileGroup* _tmp3_;
	gchar* _tmp4_;
	GearyServiceProvider* _tmp5_ = NULL;
	GearyServiceProvider provider = 0;
	GearyAccountInformation* info = NULL;
	GearyServiceProvider _tmp11_;
	const gchar* _tmp12_;
	const gchar* _tmp13_;
	GearyRFC822MailboxAddress* _tmp14_;
	GearyRFC822MailboxAddress* _tmp15_;
	GearyAccountInformation* _tmp16_;
	GearyAccountInformation* _tmp17_;
	GearyAccountInformation* _tmp18_;
	GearyConfigFileGroup* _tmp19_;
	GearyAccountInformation* _tmp20_;
	gint _tmp21_;
	gint _tmp22_;
	GearyAccountInformation* _tmp23_;
	gint _tmp24_;
	gint _tmp25_;
	gint _tmp26_;
	GearyAccountInformation* _tmp30_;
	GearyConfigFileGroup* _tmp31_;
	gchar* _tmp32_;
	gchar* _tmp33_;
	const gchar* _tmp34_;
	GearyRFC822MailboxAddress* _tmp35_;
	GearyRFC822MailboxAddress* _tmp36_;
	GearyAccountInformation* _tmp37_;
	GearyConfigFileGroup* _tmp38_;
	gchar* _tmp39_;
	gchar* _tmp40_;
	GeeList* alt_email_list = NULL;
	GearyConfigFileGroup* _tmp41_;
	GeeList* _tmp42_;
	GearyAccountInformation* _tmp69_;
	GearyConfigFileGroup* _tmp70_;
	GearyAccountInformation* _tmp71_;
	gint _tmp72_;
	gint _tmp73_;
	GearyAccountInformation* _tmp74_;
	GearyConfigFileGroup* _tmp75_;
	GearyAccountInformation* _tmp76_;
	gboolean _tmp77_;
	gboolean _tmp78_;
	GearyAccountInformation* _tmp79_;
	GearyConfigFileGroup* _tmp80_;
	GearyAccountInformation* _tmp81_;
	gboolean _tmp82_;
	gboolean _tmp83_;
	GearyAccountInformation* _tmp84_;
	GearyConfigFileGroup* _tmp85_;
	GearyAccountInformation* _tmp86_;
	const gchar* _tmp87_;
	const gchar* _tmp88_;
	gchar* _tmp89_;
	gchar* _tmp90_;
	GearyAccountInformation* _tmp91_;
	GearyConfigFileGroup* _tmp92_;
	GeeList* _tmp93_;
	GeeList* _tmp94_;
	GearyFolderPath* _tmp95_;
	GearyFolderPath* _tmp96_;
	GearyAccountInformation* _tmp97_;
	GearyConfigFileGroup* _tmp98_;
	GeeList* _tmp99_;
	GeeList* _tmp100_;
	GearyFolderPath* _tmp101_;
	GearyFolderPath* _tmp102_;
	GearyAccountInformation* _tmp103_;
	GearyConfigFileGroup* _tmp104_;
	GeeList* _tmp105_;
	GeeList* _tmp106_;
	GearyFolderPath* _tmp107_;
	GearyFolderPath* _tmp108_;
	GearyAccountInformation* _tmp109_;
	GearyConfigFileGroup* _tmp110_;
	GeeList* _tmp111_;
	GeeList* _tmp112_;
	GearyFolderPath* _tmp113_;
	GearyFolderPath* _tmp114_;
	GearyAccountInformation* _tmp115_;
	GearyConfigFileGroup* _tmp116_;
	GeeList* _tmp117_;
	GeeList* _tmp118_;
	GearyFolderPath* _tmp119_;
	GearyFolderPath* _tmp120_;
	GearyAccountInformation* _tmp121_;
	GearyConfigFileGroup* _tmp122_;
	GError * _inner_error_ = NULL;
#line 1222 "../src/client/accounts/accounts-manager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, ACCOUNTS_TYPE_ACCOUNT_CONFIG_LEGACY, AccountsAccountConfigLegacy);
#line 1222 "../src/client/accounts/accounts-manager.vala"
	g_return_val_if_fail (GEARY_IS_CONFIG_FILE (config_file), NULL);
#line 1222 "../src/client/accounts/accounts-manager.vala"
	g_return_val_if_fail (id != NULL, NULL);
#line 1222 "../src/client/accounts/accounts-manager.vala"
	g_return_val_if_fail (GEARY_IS_CREDENTIALS_MEDIATOR (mediator), NULL);
#line 1228 "../src/client/accounts/accounts-manager.vala"
	_tmp0_ = geary_config_file_get_group (config_file, ACCOUNTS_ACCOUNT_CONFIG_LEGACY_GROUP);
#line 1228 "../src/client/accounts/accounts-manager.vala"
	config = _tmp0_;
#line 1230 "../src/client/accounts/accounts-manager.vala"
	_tmp1_ = config;
#line 1230 "../src/client/accounts/accounts-manager.vala"
	_tmp2_ = geary_config_file_group_get_required_string (_tmp1_, ACCOUNTS_ACCOUNT_CONFIG_LEGACY_PRIMARY_EMAIL_KEY, &_inner_error_);
#line 1230 "../src/client/accounts/accounts-manager.vala"
	primary_email = _tmp2_;
#line 1230 "../src/client/accounts/accounts-manager.vala"
	if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1230 "../src/client/accounts/accounts-manager.vala"
		if ((_inner_error_->domain == ACCOUNTS_CONFIG_ERROR) || (_inner_error_->domain == G_KEY_FILE_ERROR)) {
#line 1230 "../src/client/accounts/accounts-manager.vala"
			g_propagate_error (error, _inner_error_);
#line 1230 "../src/client/accounts/accounts-manager.vala"
			_geary_config_file_group_unref0 (config);
#line 1230 "../src/client/accounts/accounts-manager.vala"
			return NULL;
#line 11634 "accounts-manager.c"
		} else {
#line 1230 "../src/client/accounts/accounts-manager.vala"
			_geary_config_file_group_unref0 (config);
#line 1230 "../src/client/accounts/accounts-manager.vala"
			g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1230 "../src/client/accounts/accounts-manager.vala"
			g_clear_error (&_inner_error_);
#line 1230 "../src/client/accounts/accounts-manager.vala"
			return NULL;
#line 11644 "accounts-manager.c"
		}
	}
#line 1231 "../src/client/accounts/accounts-manager.vala"
	_tmp3_ = config;
#line 1231 "../src/client/accounts/accounts-manager.vala"
	_tmp4_ = geary_config_file_group_get_string (_tmp3_, ACCOUNTS_ACCOUNT_CONFIG_LEGACY_REAL_NAME_KEY, default_name);
#line 1231 "../src/client/accounts/accounts-manager.vala"
	real_name = _tmp4_;
#line 1234 "../src/client/accounts/accounts-manager.vala"
	if (default_provider != NULL) {
#line 11655 "accounts-manager.c"
		GearyServiceProvider* _tmp6_;
#line 1235 "../src/client/accounts/accounts-manager.vala"
		_tmp6_ = __geary_service_provider_dup0 (default_provider);
#line 1235 "../src/client/accounts/accounts-manager.vala"
		_g_free0 (_tmp5_);
#line 1235 "../src/client/accounts/accounts-manager.vala"
		_tmp5_ = _tmp6_;
#line 11663 "accounts-manager.c"
	} else {
		GearyConfigFileGroup* _tmp7_;
		gpointer _tmp8_;
		GearyServiceProvider _tmp9_;
		GearyServiceProvider* _tmp10_;
#line 1236 "../src/client/accounts/accounts-manager.vala"
		_tmp7_ = config;
#line 1236 "../src/client/accounts/accounts-manager.vala"
		_tmp8_ = geary_config_file_group_parse_required_value (_tmp7_, GEARY_TYPE_SERVICE_PROVIDER, NULL, NULL, ACCOUNTS_ACCOUNT_CONFIG_LEGACY_SERVICE_PROVIDER_KEY, ____lambda11__geary_config_file_parser, self, &_inner_error_);
#line 1236 "../src/client/accounts/accounts-manager.vala"
		_tmp9_ = (GearyServiceProvider) ((gintptr) _tmp8_);
#line 1236 "../src/client/accounts/accounts-manager.vala"
		_tmp10_ = __geary_service_provider_dup0 (&_tmp9_);
#line 1236 "../src/client/accounts/accounts-manager.vala"
		_g_free0 (_tmp5_);
#line 1236 "../src/client/accounts/accounts-manager.vala"
		_tmp5_ = _tmp10_;
#line 1236 "../src/client/accounts/accounts-manager.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1236 "../src/client/accounts/accounts-manager.vala"
			if ((_inner_error_->domain == ACCOUNTS_CONFIG_ERROR) || (_inner_error_->domain == G_KEY_FILE_ERROR)) {
#line 1236 "../src/client/accounts/accounts-manager.vala"
				g_propagate_error (error, _inner_error_);
#line 1236 "../src/client/accounts/accounts-manager.vala"
				_g_free0 (_tmp5_);
#line 1236 "../src/client/accounts/accounts-manager.vala"
				_g_free0 (real_name);
#line 1236 "../src/client/accounts/accounts-manager.vala"
				_g_free0 (primary_email);
#line 1236 "../src/client/accounts/accounts-manager.vala"
				_geary_config_file_group_unref0 (config);
#line 1236 "../src/client/accounts/accounts-manager.vala"
				return NULL;
#line 11697 "accounts-manager.c"
			} else {
#line 1236 "../src/client/accounts/accounts-manager.vala"
				_g_free0 (_tmp5_);
#line 1236 "../src/client/accounts/accounts-manager.vala"
				_g_free0 (real_name);
#line 1236 "../src/client/accounts/accounts-manager.vala"
				_g_free0 (primary_email);
#line 1236 "../src/client/accounts/accounts-manager.vala"
				_geary_config_file_group_unref0 (config);
#line 1236 "../src/client/accounts/accounts-manager.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1236 "../src/client/accounts/accounts-manager.vala"
				g_clear_error (&_inner_error_);
#line 1236 "../src/client/accounts/accounts-manager.vala"
				return NULL;
#line 11713 "accounts-manager.c"
			}
		}
	}
#line 1233 "../src/client/accounts/accounts-manager.vala"
	provider = *_tmp5_;
#line 1248 "../src/client/accounts/accounts-manager.vala"
	_tmp11_ = provider;
#line 1248 "../src/client/accounts/accounts-manager.vala"
	_tmp12_ = real_name;
#line 1248 "../src/client/accounts/accounts-manager.vala"
	_tmp13_ = primary_email;
#line 1248 "../src/client/accounts/accounts-manager.vala"
	_tmp14_ = geary_rf_c822_mailbox_address_new (_tmp12_, _tmp13_);
#line 1248 "../src/client/accounts/accounts-manager.vala"
	_tmp15_ = _tmp14_;
#line 1248 "../src/client/accounts/accounts-manager.vala"
	_tmp16_ = geary_account_information_new (id, _tmp11_, mediator, _tmp15_);
#line 1248 "../src/client/accounts/accounts-manager.vala"
	_tmp17_ = _tmp16_;
#line 1248 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_tmp15_);
#line 1248 "../src/client/accounts/accounts-manager.vala"
	info = _tmp17_;
#line 1253 "../src/client/accounts/accounts-manager.vala"
	_tmp18_ = info;
#line 1253 "../src/client/accounts/accounts-manager.vala"
	_tmp19_ = config;
#line 1253 "../src/client/accounts/accounts-manager.vala"
	_tmp20_ = info;
#line 1253 "../src/client/accounts/accounts-manager.vala"
	_tmp21_ = geary_account_information_get_ordinal (_tmp20_);
#line 1253 "../src/client/accounts/accounts-manager.vala"
	_tmp22_ = _tmp21_;
#line 1253 "../src/client/accounts/accounts-manager.vala"
	geary_account_information_set_ordinal (_tmp18_, geary_config_file_group_get_int (_tmp19_, ACCOUNTS_ACCOUNT_CONFIG_LEGACY_ORDINAL_KEY, _tmp22_));
#line 1254 "../src/client/accounts/accounts-manager.vala"
	_tmp23_ = info;
#line 1254 "../src/client/accounts/accounts-manager.vala"
	_tmp24_ = geary_account_information_get_ordinal (_tmp23_);
#line 1254 "../src/client/accounts/accounts-manager.vala"
	_tmp25_ = _tmp24_;
#line 1254 "../src/client/accounts/accounts-manager.vala"
	_tmp26_ = geary_account_information_next_ordinal;
#line 1254 "../src/client/accounts/accounts-manager.vala"
	if (_tmp25_ >= _tmp26_) {
#line 11759 "accounts-manager.c"
		GearyAccountInformation* _tmp27_;
		gint _tmp28_;
		gint _tmp29_;
#line 1255 "../src/client/accounts/accounts-manager.vala"
		_tmp27_ = info;
#line 1255 "../src/client/accounts/accounts-manager.vala"
		_tmp28_ = geary_account_information_get_ordinal (_tmp27_);
#line 1255 "../src/client/accounts/accounts-manager.vala"
		_tmp29_ = _tmp28_;
#line 1255 "../src/client/accounts/accounts-manager.vala"
		geary_account_information_next_ordinal = _tmp29_ + 1;
#line 11771 "accounts-manager.c"
	}
#line 1258 "../src/client/accounts/accounts-manager.vala"
	_tmp30_ = info;
#line 1258 "../src/client/accounts/accounts-manager.vala"
	_tmp31_ = config;
#line 1258 "../src/client/accounts/accounts-manager.vala"
	_tmp32_ = geary_config_file_group_get_string (_tmp31_, ACCOUNTS_ACCOUNT_CONFIG_LEGACY_REAL_NAME_KEY, NULL);
#line 1258 "../src/client/accounts/accounts-manager.vala"
	_tmp33_ = _tmp32_;
#line 1258 "../src/client/accounts/accounts-manager.vala"
	_tmp34_ = primary_email;
#line 1258 "../src/client/accounts/accounts-manager.vala"
	_tmp35_ = geary_rf_c822_mailbox_address_new (_tmp33_, _tmp34_);
#line 1258 "../src/client/accounts/accounts-manager.vala"
	_tmp36_ = _tmp35_;
#line 1258 "../src/client/accounts/accounts-manager.vala"
	geary_account_information_append_sender (_tmp30_, _tmp36_);
#line 1258 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_tmp36_);
#line 1258 "../src/client/accounts/accounts-manager.vala"
	_g_free0 (_tmp33_);
#line 1262 "../src/client/accounts/accounts-manager.vala"
	_tmp37_ = info;
#line 1262 "../src/client/accounts/accounts-manager.vala"
	_tmp38_ = config;
#line 1262 "../src/client/accounts/accounts-manager.vala"
	_tmp39_ = geary_config_file_group_get_string (_tmp38_, ACCOUNTS_ACCOUNT_CONFIG_LEGACY_NICKNAME_KEY, NULL);
#line 1262 "../src/client/accounts/accounts-manager.vala"
	_tmp40_ = _tmp39_;
#line 1262 "../src/client/accounts/accounts-manager.vala"
	geary_account_information_set_label (_tmp37_, _tmp40_);
#line 1262 "../src/client/accounts/accounts-manager.vala"
	_g_free0 (_tmp40_);
#line 1265 "../src/client/accounts/accounts-manager.vala"
	_tmp41_ = config;
#line 1265 "../src/client/accounts/accounts-manager.vala"
	_tmp42_ = geary_config_file_group_get_string_list (_tmp41_, ACCOUNTS_ACCOUNT_CONFIG_LEGACY_ALTERNATE_EMAILS_KEY);
#line 1265 "../src/client/accounts/accounts-manager.vala"
	alt_email_list = _tmp42_;
#line 11811 "accounts-manager.c"
	{
		GeeList* _alt_email_list = NULL;
		GeeList* _tmp43_;
		GeeList* _tmp44_;
		gint _alt_email_size = 0;
		GeeList* _tmp45_;
		gint _tmp46_;
		gint _tmp47_;
		gint _alt_email_index = 0;
#line 1268 "../src/client/accounts/accounts-manager.vala"
		_tmp43_ = alt_email_list;
#line 1268 "../src/client/accounts/accounts-manager.vala"
		_tmp44_ = _g_object_ref0 (_tmp43_);
#line 1268 "../src/client/accounts/accounts-manager.vala"
		_alt_email_list = _tmp44_;
#line 1268 "../src/client/accounts/accounts-manager.vala"
		_tmp45_ = _alt_email_list;
#line 1268 "../src/client/accounts/accounts-manager.vala"
		_tmp46_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp45_, GEE_TYPE_COLLECTION, GeeCollection));
#line 1268 "../src/client/accounts/accounts-manager.vala"
		_tmp47_ = _tmp46_;
#line 1268 "../src/client/accounts/accounts-manager.vala"
		_alt_email_size = _tmp47_;
#line 1268 "../src/client/accounts/accounts-manager.vala"
		_alt_email_index = -1;
#line 1268 "../src/client/accounts/accounts-manager.vala"
		while (TRUE) {
#line 11839 "accounts-manager.c"
			gint _tmp48_;
			gint _tmp49_;
			gint _tmp50_;
			gchar* alt_email = NULL;
			GeeList* _tmp51_;
			gint _tmp52_;
			gpointer _tmp53_;
			GearyRFC822MailboxAddresses* mailboxes = NULL;
			const gchar* _tmp54_;
			GearyRFC822MailboxAddresses* _tmp55_;
#line 1268 "../src/client/accounts/accounts-manager.vala"
			_tmp48_ = _alt_email_index;
#line 1268 "../src/client/accounts/accounts-manager.vala"
			_alt_email_index = _tmp48_ + 1;
#line 1268 "../src/client/accounts/accounts-manager.vala"
			_tmp49_ = _alt_email_index;
#line 1268 "../src/client/accounts/accounts-manager.vala"
			_tmp50_ = _alt_email_size;
#line 1268 "../src/client/accounts/accounts-manager.vala"
			if (!(_tmp49_ < _tmp50_)) {
#line 1268 "../src/client/accounts/accounts-manager.vala"
				break;
#line 11862 "accounts-manager.c"
			}
#line 1268 "../src/client/accounts/accounts-manager.vala"
			_tmp51_ = _alt_email_list;
#line 1268 "../src/client/accounts/accounts-manager.vala"
			_tmp52_ = _alt_email_index;
#line 1268 "../src/client/accounts/accounts-manager.vala"
			_tmp53_ = gee_list_get (_tmp51_, _tmp52_);
#line 1268 "../src/client/accounts/accounts-manager.vala"
			alt_email = (gchar*) _tmp53_;
#line 1269 "../src/client/accounts/accounts-manager.vala"
			_tmp54_ = alt_email;
#line 1269 "../src/client/accounts/accounts-manager.vala"
			_tmp55_ = geary_rf_c822_mailbox_addresses_new_from_rfc822_string (_tmp54_);
#line 1269 "../src/client/accounts/accounts-manager.vala"
			mailboxes = _tmp55_;
#line 11878 "accounts-manager.c"
			{
				GeeList* _mailbox_list = NULL;
				GearyRFC822MailboxAddresses* _tmp56_;
				GeeList* _tmp57_;
				gint _mailbox_size = 0;
				GeeList* _tmp58_;
				gint _tmp59_;
				gint _tmp60_;
				gint _mailbox_index = 0;
#line 1271 "../src/client/accounts/accounts-manager.vala"
				_tmp56_ = mailboxes;
#line 1271 "../src/client/accounts/accounts-manager.vala"
				_tmp57_ = geary_rf_c822_mailbox_addresses_get_all (_tmp56_);
#line 1271 "../src/client/accounts/accounts-manager.vala"
				_mailbox_list = _tmp57_;
#line 1271 "../src/client/accounts/accounts-manager.vala"
				_tmp58_ = _mailbox_list;
#line 1271 "../src/client/accounts/accounts-manager.vala"
				_tmp59_ = gee_collection_get_size (G_TYPE_CHECK_INSTANCE_CAST (_tmp58_, GEE_TYPE_COLLECTION, GeeCollection));
#line 1271 "../src/client/accounts/accounts-manager.vala"
				_tmp60_ = _tmp59_;
#line 1271 "../src/client/accounts/accounts-manager.vala"
				_mailbox_size = _tmp60_;
#line 1271 "../src/client/accounts/accounts-manager.vala"
				_mailbox_index = -1;
#line 1271 "../src/client/accounts/accounts-manager.vala"
				while (TRUE) {
#line 11906 "accounts-manager.c"
					gint _tmp61_;
					gint _tmp62_;
					gint _tmp63_;
					GearyRFC822MailboxAddress* mailbox = NULL;
					GeeList* _tmp64_;
					gint _tmp65_;
					gpointer _tmp66_;
					GearyAccountInformation* _tmp67_;
					GearyRFC822MailboxAddress* _tmp68_;
#line 1271 "../src/client/accounts/accounts-manager.vala"
					_tmp61_ = _mailbox_index;
#line 1271 "../src/client/accounts/accounts-manager.vala"
					_mailbox_index = _tmp61_ + 1;
#line 1271 "../src/client/accounts/accounts-manager.vala"
					_tmp62_ = _mailbox_index;
#line 1271 "../src/client/accounts/accounts-manager.vala"
					_tmp63_ = _mailbox_size;
#line 1271 "../src/client/accounts/accounts-manager.vala"
					if (!(_tmp62_ < _tmp63_)) {
#line 1271 "../src/client/accounts/accounts-manager.vala"
						break;
#line 11928 "accounts-manager.c"
					}
#line 1271 "../src/client/accounts/accounts-manager.vala"
					_tmp64_ = _mailbox_list;
#line 1271 "../src/client/accounts/accounts-manager.vala"
					_tmp65_ = _mailbox_index;
#line 1271 "../src/client/accounts/accounts-manager.vala"
					_tmp66_ = gee_list_get (_tmp64_, _tmp65_);
#line 1271 "../src/client/accounts/accounts-manager.vala"
					mailbox = (GearyRFC822MailboxAddress*) _tmp66_;
#line 1272 "../src/client/accounts/accounts-manager.vala"
					_tmp67_ = info;
#line 1272 "../src/client/accounts/accounts-manager.vala"
					_tmp68_ = mailbox;
#line 1272 "../src/client/accounts/accounts-manager.vala"
					geary_account_information_append_sender (_tmp67_, _tmp68_);
#line 1271 "../src/client/accounts/accounts-manager.vala"
					_g_object_unref0 (mailbox);
#line 11946 "accounts-manager.c"
				}
#line 1271 "../src/client/accounts/accounts-manager.vala"
				_g_object_unref0 (_mailbox_list);
#line 11950 "accounts-manager.c"
			}
#line 1268 "../src/client/accounts/accounts-manager.vala"
			_g_object_unref0 (mailboxes);
#line 1268 "../src/client/accounts/accounts-manager.vala"
			_g_free0 (alt_email);
#line 11956 "accounts-manager.c"
		}
#line 1268 "../src/client/accounts/accounts-manager.vala"
		_g_object_unref0 (_alt_email_list);
#line 11960 "accounts-manager.c"
	}
#line 1276 "../src/client/accounts/accounts-manager.vala"
	_tmp69_ = info;
#line 1276 "../src/client/accounts/accounts-manager.vala"
	_tmp70_ = config;
#line 1276 "../src/client/accounts/accounts-manager.vala"
	_tmp71_ = info;
#line 1276 "../src/client/accounts/accounts-manager.vala"
	_tmp72_ = geary_account_information_get_prefetch_period_days (_tmp71_);
#line 1276 "../src/client/accounts/accounts-manager.vala"
	_tmp73_ = _tmp72_;
#line 1276 "../src/client/accounts/accounts-manager.vala"
	geary_account_information_set_prefetch_period_days (_tmp69_, geary_config_file_group_get_int (_tmp70_, ACCOUNTS_ACCOUNT_CONFIG_LEGACY_PREFETCH_PERIOD_DAYS_KEY, _tmp73_));
#line 1279 "../src/client/accounts/accounts-manager.vala"
	_tmp74_ = info;
#line 1279 "../src/client/accounts/accounts-manager.vala"
	_tmp75_ = config;
#line 1279 "../src/client/accounts/accounts-manager.vala"
	_tmp76_ = info;
#line 1279 "../src/client/accounts/accounts-manager.vala"
	_tmp77_ = geary_account_information_get_save_sent (_tmp76_);
#line 1279 "../src/client/accounts/accounts-manager.vala"
	_tmp78_ = _tmp77_;
#line 1279 "../src/client/accounts/accounts-manager.vala"
	geary_account_information_set_save_sent (_tmp74_, geary_config_file_group_get_bool (_tmp75_, ACCOUNTS_ACCOUNT_CONFIG_LEGACY_SAVE_SENT_MAIL_KEY, _tmp78_));
#line 1282 "../src/client/accounts/accounts-manager.vala"
	_tmp79_ = info;
#line 1282 "../src/client/accounts/accounts-manager.vala"
	_tmp80_ = config;
#line 1282 "../src/client/accounts/accounts-manager.vala"
	_tmp81_ = info;
#line 1282 "../src/client/accounts/accounts-manager.vala"
	_tmp82_ = geary_account_information_get_use_signature (_tmp81_);
#line 1282 "../src/client/accounts/accounts-manager.vala"
	_tmp83_ = _tmp82_;
#line 1282 "../src/client/accounts/accounts-manager.vala"
	geary_account_information_set_use_signature (_tmp79_, geary_config_file_group_get_bool (_tmp80_, ACCOUNTS_ACCOUNT_CONFIG_LEGACY_USE_EMAIL_SIGNATURE_KEY, _tmp83_));
#line 1285 "../src/client/accounts/accounts-manager.vala"
	_tmp84_ = info;
#line 1285 "../src/client/accounts/accounts-manager.vala"
	_tmp85_ = config;
#line 1285 "../src/client/accounts/accounts-manager.vala"
	_tmp86_ = info;
#line 1285 "../src/client/accounts/accounts-manager.vala"
	_tmp87_ = geary_account_information_get_signature (_tmp86_);
#line 1285 "../src/client/accounts/accounts-manager.vala"
	_tmp88_ = _tmp87_;
#line 1285 "../src/client/accounts/accounts-manager.vala"
	_tmp89_ = geary_config_file_group_get_string (_tmp85_, ACCOUNTS_ACCOUNT_CONFIG_LEGACY_EMAIL_SIGNATURE_KEY, _tmp88_);
#line 1285 "../src/client/accounts/accounts-manager.vala"
	_tmp90_ = _tmp89_;
#line 1285 "../src/client/accounts/accounts-manager.vala"
	geary_account_information_set_signature (_tmp84_, _tmp90_);
#line 1285 "../src/client/accounts/accounts-manager.vala"
	_g_free0 (_tmp90_);
#line 1289 "../src/client/accounts/accounts-manager.vala"
	_tmp91_ = info;
#line 1289 "../src/client/accounts/accounts-manager.vala"
	_tmp92_ = config;
#line 1289 "../src/client/accounts/accounts-manager.vala"
	_tmp93_ = geary_config_file_group_get_string_list (_tmp92_, ACCOUNTS_ACCOUNT_CONFIG_LEGACY_DRAFTS_FOLDER_KEY);
#line 1289 "../src/client/accounts/accounts-manager.vala"
	_tmp94_ = _tmp93_;
#line 1289 "../src/client/accounts/accounts-manager.vala"
	_tmp95_ = geary_account_information_build_folder_path (_tmp94_);
#line 1289 "../src/client/accounts/accounts-manager.vala"
	_tmp96_ = _tmp95_;
#line 1289 "../src/client/accounts/accounts-manager.vala"
	geary_account_information_set_drafts_folder_path (_tmp91_, _tmp96_);
#line 1289 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_tmp96_);
#line 1289 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_tmp94_);
#line 1292 "../src/client/accounts/accounts-manager.vala"
	_tmp97_ = info;
#line 1292 "../src/client/accounts/accounts-manager.vala"
	_tmp98_ = config;
#line 1292 "../src/client/accounts/accounts-manager.vala"
	_tmp99_ = geary_config_file_group_get_string_list (_tmp98_, ACCOUNTS_ACCOUNT_CONFIG_LEGACY_SENT_MAIL_FOLDER_KEY);
#line 1292 "../src/client/accounts/accounts-manager.vala"
	_tmp100_ = _tmp99_;
#line 1292 "../src/client/accounts/accounts-manager.vala"
	_tmp101_ = geary_account_information_build_folder_path (_tmp100_);
#line 1292 "../src/client/accounts/accounts-manager.vala"
	_tmp102_ = _tmp101_;
#line 1292 "../src/client/accounts/accounts-manager.vala"
	geary_account_information_set_sent_folder_path (_tmp97_, _tmp102_);
#line 1292 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_tmp102_);
#line 1292 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_tmp100_);
#line 1295 "../src/client/accounts/accounts-manager.vala"
	_tmp103_ = info;
#line 1295 "../src/client/accounts/accounts-manager.vala"
	_tmp104_ = config;
#line 1295 "../src/client/accounts/accounts-manager.vala"
	_tmp105_ = geary_config_file_group_get_string_list (_tmp104_, ACCOUNTS_ACCOUNT_CONFIG_LEGACY_SPAM_FOLDER_KEY);
#line 1295 "../src/client/accounts/accounts-manager.vala"
	_tmp106_ = _tmp105_;
#line 1295 "../src/client/accounts/accounts-manager.vala"
	_tmp107_ = geary_account_information_build_folder_path (_tmp106_);
#line 1295 "../src/client/accounts/accounts-manager.vala"
	_tmp108_ = _tmp107_;
#line 1295 "../src/client/accounts/accounts-manager.vala"
	geary_account_information_set_spam_folder_path (_tmp103_, _tmp108_);
#line 1295 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_tmp108_);
#line 1295 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_tmp106_);
#line 1298 "../src/client/accounts/accounts-manager.vala"
	_tmp109_ = info;
#line 1298 "../src/client/accounts/accounts-manager.vala"
	_tmp110_ = config;
#line 1298 "../src/client/accounts/accounts-manager.vala"
	_tmp111_ = geary_config_file_group_get_string_list (_tmp110_, ACCOUNTS_ACCOUNT_CONFIG_LEGACY_TRASH_FOLDER_KEY);
#line 1298 "../src/client/accounts/accounts-manager.vala"
	_tmp112_ = _tmp111_;
#line 1298 "../src/client/accounts/accounts-manager.vala"
	_tmp113_ = geary_account_information_build_folder_path (_tmp112_);
#line 1298 "../src/client/accounts/accounts-manager.vala"
	_tmp114_ = _tmp113_;
#line 1298 "../src/client/accounts/accounts-manager.vala"
	geary_account_information_set_trash_folder_path (_tmp109_, _tmp114_);
#line 1298 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_tmp114_);
#line 1298 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_tmp112_);
#line 1301 "../src/client/accounts/accounts-manager.vala"
	_tmp115_ = info;
#line 1301 "../src/client/accounts/accounts-manager.vala"
	_tmp116_ = config;
#line 1301 "../src/client/accounts/accounts-manager.vala"
	_tmp117_ = geary_config_file_group_get_string_list (_tmp116_, ACCOUNTS_ACCOUNT_CONFIG_LEGACY_ARCHIVE_FOLDER_KEY);
#line 1301 "../src/client/accounts/accounts-manager.vala"
	_tmp118_ = _tmp117_;
#line 1301 "../src/client/accounts/accounts-manager.vala"
	_tmp119_ = geary_account_information_build_folder_path (_tmp118_);
#line 1301 "../src/client/accounts/accounts-manager.vala"
	_tmp120_ = _tmp119_;
#line 1301 "../src/client/accounts/accounts-manager.vala"
	geary_account_information_set_archive_folder_path (_tmp115_, _tmp120_);
#line 1301 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_tmp120_);
#line 1301 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_tmp118_);
#line 1305 "../src/client/accounts/accounts-manager.vala"
	_tmp121_ = info;
#line 1305 "../src/client/accounts/accounts-manager.vala"
	_tmp122_ = config;
#line 1305 "../src/client/accounts/accounts-manager.vala"
	geary_account_information_set_save_drafts (_tmp121_, geary_config_file_group_get_bool (_tmp122_, ACCOUNTS_ACCOUNT_CONFIG_LEGACY_SAVE_DRAFTS_KEY, TRUE));
#line 1307 "../src/client/accounts/accounts-manager.vala"
	result = info;
#line 1307 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (alt_email_list);
#line 1307 "../src/client/accounts/accounts-manager.vala"
	_g_free0 (_tmp5_);
#line 1307 "../src/client/accounts/accounts-manager.vala"
	_g_free0 (real_name);
#line 1307 "../src/client/accounts/accounts-manager.vala"
	_g_free0 (primary_email);
#line 1307 "../src/client/accounts/accounts-manager.vala"
	_geary_config_file_group_unref0 (config);
#line 1307 "../src/client/accounts/accounts-manager.vala"
	return result;
#line 12126 "accounts-manager.c"
}


static gchar*
___lambda12_ (AccountsAccountConfigLegacy* self,
              GearyRFC822MailboxAddress* alt)
{
	gchar* result = NULL;
	gchar* _tmp0_;
#line 1332 "../src/client/accounts/accounts-manager.vala"
	g_return_val_if_fail (GEARY_RF_C822_IS_MAILBOX_ADDRESS (alt), NULL);
#line 1332 "../src/client/accounts/accounts-manager.vala"
	_tmp0_ = geary_rf_c822_mailbox_address_to_rfc822_string (alt);
#line 1332 "../src/client/accounts/accounts-manager.vala"
	result = _tmp0_;
#line 1332 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (alt);
#line 1332 "../src/client/accounts/accounts-manager.vala"
	return result;
#line 12146 "accounts-manager.c"
}


static gpointer
____lambda12__gee_map_func (gpointer g,
                            gpointer self)
{
	gpointer result;
	result = ___lambda12_ ((AccountsAccountConfigLegacy*) self, (GearyRFC822MailboxAddress*) g);
#line 1329 "../src/client/accounts/accounts-manager.vala"
	return result;
#line 12158 "accounts-manager.c"
}


static void
accounts_account_config_legacy_real_save (AccountsAccountConfig* base,
                                          GearyAccountInformation* info,
                                          GearyConfigFile* config_file)
{
	AccountsAccountConfigLegacy * self;
	GearyConfigFileGroup* config = NULL;
	GearyConfigFileGroup* _tmp0_;
	const gchar* _tmp1_ = NULL;
	GearyRFC822MailboxAddress* _tmp2_;
	GearyRFC822MailboxAddress* _tmp3_;
	GearyRFC822MailboxAddress* _tmp4_;
	const gchar* _tmp5_;
	const gchar* _tmp6_;
	const gchar* _tmp7_;
	GearyConfigFileGroup* _tmp8_;
	GearyConfigFileGroup* _tmp9_;
	GearyRFC822MailboxAddress* _tmp10_;
	GearyRFC822MailboxAddress* _tmp11_;
	GearyRFC822MailboxAddress* _tmp12_;
	const gchar* _tmp13_;
	const gchar* _tmp14_;
	GearyConfigFileGroup* _tmp15_;
	const gchar* _tmp16_;
	const gchar* _tmp17_;
	GearyConfigFileGroup* _tmp18_;
	GearyServiceProvider _tmp19_;
	GearyServiceProvider _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	GearyConfigFileGroup* _tmp23_;
	gint _tmp24_;
	gint _tmp25_;
	GearyConfigFileGroup* _tmp26_;
	gint _tmp27_;
	gint _tmp28_;
	GearyConfigFileGroup* _tmp29_;
	gboolean _tmp30_;
	gboolean _tmp31_;
	GearyConfigFileGroup* _tmp32_;
	gboolean _tmp33_;
	gboolean _tmp34_;
	GearyConfigFileGroup* _tmp35_;
	const gchar* _tmp36_;
	const gchar* _tmp37_;
	gboolean _tmp38_;
	gboolean _tmp39_;
	GeeArrayList* empty = NULL;
	GeeArrayList* _tmp53_;
	GeeArrayList* _tmp54_ = NULL;
	GearyFolderPath* _tmp55_;
	GearyFolderPath* _tmp56_;
	GearyConfigFileGroup* _tmp64_;
	GeeArrayList* _tmp65_ = NULL;
	GearyFolderPath* _tmp66_;
	GearyFolderPath* _tmp67_;
	GearyConfigFileGroup* _tmp75_;
	GeeArrayList* _tmp76_ = NULL;
	GearyFolderPath* _tmp77_;
	GearyFolderPath* _tmp78_;
	GearyConfigFileGroup* _tmp86_;
	GeeArrayList* _tmp87_ = NULL;
	GearyFolderPath* _tmp88_;
	GearyFolderPath* _tmp89_;
	GearyConfigFileGroup* _tmp97_;
	GeeArrayList* _tmp98_ = NULL;
	GearyFolderPath* _tmp99_;
	GearyFolderPath* _tmp100_;
	GearyConfigFileGroup* _tmp108_;
	GearyConfigFileGroup* _tmp109_;
	gboolean _tmp110_;
	gboolean _tmp111_;
#line 1310 "../src/client/accounts/accounts-manager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, ACCOUNTS_TYPE_ACCOUNT_CONFIG_LEGACY, AccountsAccountConfigLegacy);
#line 1310 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail (GEARY_IS_ACCOUNT_INFORMATION (info));
#line 1310 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail (GEARY_IS_CONFIG_FILE (config_file));
#line 1313 "../src/client/accounts/accounts-manager.vala"
	_tmp0_ = geary_config_file_get_group (config_file, ACCOUNTS_ACCOUNT_CONFIG_LEGACY_GROUP);
#line 1313 "../src/client/accounts/accounts-manager.vala"
	config = _tmp0_;
#line 1315 "../src/client/accounts/accounts-manager.vala"
	_tmp2_ = geary_account_information_get_primary_mailbox (info);
#line 1315 "../src/client/accounts/accounts-manager.vala"
	_tmp3_ = _tmp2_;
#line 1315 "../src/client/accounts/accounts-manager.vala"
	_tmp4_ = _tmp3_;
#line 1315 "../src/client/accounts/accounts-manager.vala"
	_tmp5_ = geary_rf_c822_mailbox_address_get_name (_tmp4_);
#line 1315 "../src/client/accounts/accounts-manager.vala"
	_tmp6_ = _tmp5_;
#line 1315 "../src/client/accounts/accounts-manager.vala"
	_tmp7_ = _tmp6_;
#line 1315 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_tmp4_);
#line 1315 "../src/client/accounts/accounts-manager.vala"
	_tmp1_ = _tmp7_;
#line 1315 "../src/client/accounts/accounts-manager.vala"
	if (_tmp1_ == NULL) {
#line 1315 "../src/client/accounts/accounts-manager.vala"
		_tmp1_ = "";
#line 12264 "accounts-manager.c"
	}
#line 1315 "../src/client/accounts/accounts-manager.vala"
	_tmp8_ = config;
#line 1315 "../src/client/accounts/accounts-manager.vala"
	geary_config_file_group_set_string (_tmp8_, ACCOUNTS_ACCOUNT_CONFIG_LEGACY_REAL_NAME_KEY, _tmp1_);
#line 1316 "../src/client/accounts/accounts-manager.vala"
	_tmp9_ = config;
#line 1316 "../src/client/accounts/accounts-manager.vala"
	_tmp10_ = geary_account_information_get_primary_mailbox (info);
#line 1316 "../src/client/accounts/accounts-manager.vala"
	_tmp11_ = _tmp10_;
#line 1316 "../src/client/accounts/accounts-manager.vala"
	_tmp12_ = _tmp11_;
#line 1316 "../src/client/accounts/accounts-manager.vala"
	_tmp13_ = geary_rf_c822_mailbox_address_get_address (_tmp12_);
#line 1316 "../src/client/accounts/accounts-manager.vala"
	_tmp14_ = _tmp13_;
#line 1316 "../src/client/accounts/accounts-manager.vala"
	geary_config_file_group_set_string (_tmp9_, ACCOUNTS_ACCOUNT_CONFIG_LEGACY_PRIMARY_EMAIL_KEY, _tmp14_);
#line 1316 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_tmp12_);
#line 1317 "../src/client/accounts/accounts-manager.vala"
	_tmp15_ = config;
#line 1317 "../src/client/accounts/accounts-manager.vala"
	_tmp16_ = geary_account_information_get_label (info);
#line 1317 "../src/client/accounts/accounts-manager.vala"
	_tmp17_ = _tmp16_;
#line 1317 "../src/client/accounts/accounts-manager.vala"
	geary_config_file_group_set_string (_tmp15_, ACCOUNTS_ACCOUNT_CONFIG_LEGACY_NICKNAME_KEY, _tmp17_);
#line 1318 "../src/client/accounts/accounts-manager.vala"
	_tmp18_ = config;
#line 1318 "../src/client/accounts/accounts-manager.vala"
	_tmp19_ = geary_account_information_get_service_provider (info);
#line 1318 "../src/client/accounts/accounts-manager.vala"
	_tmp20_ = _tmp19_;
#line 1318 "../src/client/accounts/accounts-manager.vala"
	_tmp21_ = geary_service_provider_to_value (_tmp20_);
#line 1318 "../src/client/accounts/accounts-manager.vala"
	_tmp22_ = _tmp21_;
#line 1318 "../src/client/accounts/accounts-manager.vala"
	geary_config_file_group_set_string (_tmp18_, ACCOUNTS_ACCOUNT_CONFIG_LEGACY_SERVICE_PROVIDER_KEY, _tmp22_);
#line 1318 "../src/client/accounts/accounts-manager.vala"
	_g_free0 (_tmp22_);
#line 1319 "../src/client/accounts/accounts-manager.vala"
	_tmp23_ = config;
#line 1319 "../src/client/accounts/accounts-manager.vala"
	_tmp24_ = geary_account_information_get_ordinal (info);
#line 1319 "../src/client/accounts/accounts-manager.vala"
	_tmp25_ = _tmp24_;
#line 1319 "../src/client/accounts/accounts-manager.vala"
	geary_config_file_group_set_int (_tmp23_, ACCOUNTS_ACCOUNT_CONFIG_LEGACY_ORDINAL_KEY, _tmp25_);
#line 1320 "../src/client/accounts/accounts-manager.vala"
	_tmp26_ = config;
#line 1320 "../src/client/accounts/accounts-manager.vala"
	_tmp27_ = geary_account_information_get_prefetch_period_days (info);
#line 1320 "../src/client/accounts/accounts-manager.vala"
	_tmp28_ = _tmp27_;
#line 1320 "../src/client/accounts/accounts-manager.vala"
	geary_config_file_group_set_int (_tmp26_, ACCOUNTS_ACCOUNT_CONFIG_LEGACY_PREFETCH_PERIOD_DAYS_KEY, _tmp28_);
#line 1321 "../src/client/accounts/accounts-manager.vala"
	_tmp29_ = config;
#line 1321 "../src/client/accounts/accounts-manager.vala"
	_tmp30_ = geary_account_information_get_save_sent (info);
#line 1321 "../src/client/accounts/accounts-manager.vala"
	_tmp31_ = _tmp30_;
#line 1321 "../src/client/accounts/accounts-manager.vala"
	geary_config_file_group_set_bool (_tmp29_, ACCOUNTS_ACCOUNT_CONFIG_LEGACY_SAVE_SENT_MAIL_KEY, _tmp31_);
#line 1322 "../src/client/accounts/accounts-manager.vala"
	_tmp32_ = config;
#line 1322 "../src/client/accounts/accounts-manager.vala"
	_tmp33_ = geary_account_information_get_use_signature (info);
#line 1322 "../src/client/accounts/accounts-manager.vala"
	_tmp34_ = _tmp33_;
#line 1322 "../src/client/accounts/accounts-manager.vala"
	geary_config_file_group_set_bool (_tmp32_, ACCOUNTS_ACCOUNT_CONFIG_LEGACY_USE_EMAIL_SIGNATURE_KEY, _tmp34_);
#line 1323 "../src/client/accounts/accounts-manager.vala"
	_tmp35_ = config;
#line 1323 "../src/client/accounts/accounts-manager.vala"
	_tmp36_ = geary_account_information_get_signature (info);
#line 1323 "../src/client/accounts/accounts-manager.vala"
	_tmp37_ = _tmp36_;
#line 1323 "../src/client/accounts/accounts-manager.vala"
	geary_config_file_group_set_string (_tmp35_, ACCOUNTS_ACCOUNT_CONFIG_LEGACY_EMAIL_SIGNATURE_KEY, _tmp37_);
#line 1324 "../src/client/accounts/accounts-manager.vala"
	_tmp38_ = geary_account_information_get_has_sender_aliases (info);
#line 1324 "../src/client/accounts/accounts-manager.vala"
	_tmp39_ = _tmp38_;
#line 1324 "../src/client/accounts/accounts-manager.vala"
	if (_tmp39_) {
#line 12354 "accounts-manager.c"
		GeeList* alts = NULL;
		GeeList* _tmp40_;
		GeeList* _tmp41_;
		GeeList* _tmp42_;
		gpointer _tmp43_;
		GearyRFC822MailboxAddress* _tmp44_;
		GearyConfigFileGroup* _tmp45_;
		GeeList* _tmp46_;
		GearyIterable* _tmp47_;
		GearyIterable* _tmp48_;
		GearyIterable* _tmp49_;
		GearyIterable* _tmp50_;
		GeeArrayList* _tmp51_;
		GeeArrayList* _tmp52_;
#line 1325 "../src/client/accounts/accounts-manager.vala"
		_tmp40_ = geary_account_information_get_sender_mailboxes (info);
#line 1325 "../src/client/accounts/accounts-manager.vala"
		_tmp41_ = _tmp40_;
#line 1325 "../src/client/accounts/accounts-manager.vala"
		alts = _tmp41_;
#line 1327 "../src/client/accounts/accounts-manager.vala"
		_tmp42_ = alts;
#line 1327 "../src/client/accounts/accounts-manager.vala"
		_tmp43_ = gee_list_remove_at (_tmp42_, 0);
#line 1327 "../src/client/accounts/accounts-manager.vala"
		_tmp44_ = (GearyRFC822MailboxAddress*) _tmp43_;
#line 1327 "../src/client/accounts/accounts-manager.vala"
		_g_object_unref0 (_tmp44_);
#line 1329 "../src/client/accounts/accounts-manager.vala"
		_tmp45_ = config;
#line 1329 "../src/client/accounts/accounts-manager.vala"
		_tmp46_ = alts;
#line 1329 "../src/client/accounts/accounts-manager.vala"
		_tmp47_ = geary_traverse (GEARY_RF_C822_TYPE_MAILBOX_ADDRESS, (GBoxedCopyFunc) g_object_ref, (GDestroyNotify) g_object_unref, G_TYPE_CHECK_INSTANCE_CAST (_tmp46_, GEE_TYPE_ITERABLE, GeeIterable));
#line 1329 "../src/client/accounts/accounts-manager.vala"
		_tmp48_ = _tmp47_;
#line 1329 "../src/client/accounts/accounts-manager.vala"
		_tmp49_ = geary_iterable_map (_tmp48_, G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, ____lambda12__gee_map_func, self);
#line 1329 "../src/client/accounts/accounts-manager.vala"
		_tmp50_ = _tmp49_;
#line 1329 "../src/client/accounts/accounts-manager.vala"
		_tmp51_ = geary_iterable_to_array_list (_tmp50_, NULL, NULL, NULL);
#line 1329 "../src/client/accounts/accounts-manager.vala"
		_tmp52_ = _tmp51_;
#line 1329 "../src/client/accounts/accounts-manager.vala"
		geary_config_file_group_set_string_list (_tmp45_, ACCOUNTS_ACCOUNT_CONFIG_LEGACY_ALTERNATE_EMAILS_KEY, G_TYPE_CHECK_INSTANCE_CAST (_tmp52_, GEE_TYPE_LIST, GeeList));
#line 1329 "../src/client/accounts/accounts-manager.vala"
		_g_object_unref0 (_tmp52_);
#line 1329 "../src/client/accounts/accounts-manager.vala"
		_g_object_unref0 (_tmp50_);
#line 1329 "../src/client/accounts/accounts-manager.vala"
		_g_object_unref0 (_tmp48_);
#line 1324 "../src/client/accounts/accounts-manager.vala"
		_g_object_unref0 (alts);
#line 12409 "accounts-manager.c"
	}
#line 1337 "../src/client/accounts/accounts-manager.vala"
	_tmp53_ = gee_array_list_new (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, NULL, NULL, NULL);
#line 1337 "../src/client/accounts/accounts-manager.vala"
	empty = _tmp53_;
#line 1340 "../src/client/accounts/accounts-manager.vala"
	_tmp55_ = geary_account_information_get_drafts_folder_path (info);
#line 1340 "../src/client/accounts/accounts-manager.vala"
	_tmp56_ = _tmp55_;
#line 1340 "../src/client/accounts/accounts-manager.vala"
	if (_tmp56_ != NULL) {
#line 12421 "accounts-manager.c"
		GearyFolderPath* _tmp57_;
		GearyFolderPath* _tmp58_;
		gint _tmp59_ = 0;
		gchar** _tmp60_;
		GeeArrayList* _tmp61_;
#line 1341 "../src/client/accounts/accounts-manager.vala"
		_tmp57_ = geary_account_information_get_drafts_folder_path (info);
#line 1341 "../src/client/accounts/accounts-manager.vala"
		_tmp58_ = _tmp57_;
#line 1341 "../src/client/accounts/accounts-manager.vala"
		_tmp60_ = geary_folder_path_as_array (_tmp58_, &_tmp59_);
#line 1341 "../src/client/accounts/accounts-manager.vala"
		_tmp61_ = gee_array_list_new_wrap (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, _tmp60_, _tmp59_, NULL, NULL, NULL);
#line 1341 "../src/client/accounts/accounts-manager.vala"
		_g_object_unref0 (_tmp54_);
#line 1341 "../src/client/accounts/accounts-manager.vala"
		_tmp54_ = _tmp61_;
#line 12439 "accounts-manager.c"
	} else {
		GeeArrayList* _tmp62_;
		GeeArrayList* _tmp63_;
#line 1342 "../src/client/accounts/accounts-manager.vala"
		_tmp62_ = empty;
#line 1342 "../src/client/accounts/accounts-manager.vala"
		_tmp63_ = _g_object_ref0 (_tmp62_);
#line 1342 "../src/client/accounts/accounts-manager.vala"
		_g_object_unref0 (_tmp54_);
#line 1342 "../src/client/accounts/accounts-manager.vala"
		_tmp54_ = _tmp63_;
#line 12451 "accounts-manager.c"
	}
#line 1338 "../src/client/accounts/accounts-manager.vala"
	_tmp64_ = config;
#line 1338 "../src/client/accounts/accounts-manager.vala"
	geary_config_file_group_set_string_list (_tmp64_, ACCOUNTS_ACCOUNT_CONFIG_LEGACY_DRAFTS_FOLDER_KEY, G_TYPE_CHECK_INSTANCE_CAST (_tmp54_, GEE_TYPE_LIST, GeeList));
#line 1346 "../src/client/accounts/accounts-manager.vala"
	_tmp66_ = geary_account_information_get_sent_folder_path (info);
#line 1346 "../src/client/accounts/accounts-manager.vala"
	_tmp67_ = _tmp66_;
#line 1346 "../src/client/accounts/accounts-manager.vala"
	if (_tmp67_ != NULL) {
#line 12463 "accounts-manager.c"
		GearyFolderPath* _tmp68_;
		GearyFolderPath* _tmp69_;
		gint _tmp70_ = 0;
		gchar** _tmp71_;
		GeeArrayList* _tmp72_;
#line 1347 "../src/client/accounts/accounts-manager.vala"
		_tmp68_ = geary_account_information_get_sent_folder_path (info);
#line 1347 "../src/client/accounts/accounts-manager.vala"
		_tmp69_ = _tmp68_;
#line 1347 "../src/client/accounts/accounts-manager.vala"
		_tmp71_ = geary_folder_path_as_array (_tmp69_, &_tmp70_);
#line 1347 "../src/client/accounts/accounts-manager.vala"
		_tmp72_ = gee_array_list_new_wrap (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, _tmp71_, _tmp70_, NULL, NULL, NULL);
#line 1347 "../src/client/accounts/accounts-manager.vala"
		_g_object_unref0 (_tmp65_);
#line 1347 "../src/client/accounts/accounts-manager.vala"
		_tmp65_ = _tmp72_;
#line 12481 "accounts-manager.c"
	} else {
		GeeArrayList* _tmp73_;
		GeeArrayList* _tmp74_;
#line 1348 "../src/client/accounts/accounts-manager.vala"
		_tmp73_ = empty;
#line 1348 "../src/client/accounts/accounts-manager.vala"
		_tmp74_ = _g_object_ref0 (_tmp73_);
#line 1348 "../src/client/accounts/accounts-manager.vala"
		_g_object_unref0 (_tmp65_);
#line 1348 "../src/client/accounts/accounts-manager.vala"
		_tmp65_ = _tmp74_;
#line 12493 "accounts-manager.c"
	}
#line 1344 "../src/client/accounts/accounts-manager.vala"
	_tmp75_ = config;
#line 1344 "../src/client/accounts/accounts-manager.vala"
	geary_config_file_group_set_string_list (_tmp75_, ACCOUNTS_ACCOUNT_CONFIG_LEGACY_SENT_MAIL_FOLDER_KEY, G_TYPE_CHECK_INSTANCE_CAST (_tmp65_, GEE_TYPE_LIST, GeeList));
#line 1352 "../src/client/accounts/accounts-manager.vala"
	_tmp77_ = geary_account_information_get_spam_folder_path (info);
#line 1352 "../src/client/accounts/accounts-manager.vala"
	_tmp78_ = _tmp77_;
#line 1352 "../src/client/accounts/accounts-manager.vala"
	if (_tmp78_ != NULL) {
#line 12505 "accounts-manager.c"
		GearyFolderPath* _tmp79_;
		GearyFolderPath* _tmp80_;
		gint _tmp81_ = 0;
		gchar** _tmp82_;
		GeeArrayList* _tmp83_;
#line 1353 "../src/client/accounts/accounts-manager.vala"
		_tmp79_ = geary_account_information_get_spam_folder_path (info);
#line 1353 "../src/client/accounts/accounts-manager.vala"
		_tmp80_ = _tmp79_;
#line 1353 "../src/client/accounts/accounts-manager.vala"
		_tmp82_ = geary_folder_path_as_array (_tmp80_, &_tmp81_);
#line 1353 "../src/client/accounts/accounts-manager.vala"
		_tmp83_ = gee_array_list_new_wrap (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, _tmp82_, _tmp81_, NULL, NULL, NULL);
#line 1353 "../src/client/accounts/accounts-manager.vala"
		_g_object_unref0 (_tmp76_);
#line 1353 "../src/client/accounts/accounts-manager.vala"
		_tmp76_ = _tmp83_;
#line 12523 "accounts-manager.c"
	} else {
		GeeArrayList* _tmp84_;
		GeeArrayList* _tmp85_;
#line 1354 "../src/client/accounts/accounts-manager.vala"
		_tmp84_ = empty;
#line 1354 "../src/client/accounts/accounts-manager.vala"
		_tmp85_ = _g_object_ref0 (_tmp84_);
#line 1354 "../src/client/accounts/accounts-manager.vala"
		_g_object_unref0 (_tmp76_);
#line 1354 "../src/client/accounts/accounts-manager.vala"
		_tmp76_ = _tmp85_;
#line 12535 "accounts-manager.c"
	}
#line 1350 "../src/client/accounts/accounts-manager.vala"
	_tmp86_ = config;
#line 1350 "../src/client/accounts/accounts-manager.vala"
	geary_config_file_group_set_string_list (_tmp86_, ACCOUNTS_ACCOUNT_CONFIG_LEGACY_SPAM_FOLDER_KEY, G_TYPE_CHECK_INSTANCE_CAST (_tmp76_, GEE_TYPE_LIST, GeeList));
#line 1358 "../src/client/accounts/accounts-manager.vala"
	_tmp88_ = geary_account_information_get_trash_folder_path (info);
#line 1358 "../src/client/accounts/accounts-manager.vala"
	_tmp89_ = _tmp88_;
#line 1358 "../src/client/accounts/accounts-manager.vala"
	if (_tmp89_ != NULL) {
#line 12547 "accounts-manager.c"
		GearyFolderPath* _tmp90_;
		GearyFolderPath* _tmp91_;
		gint _tmp92_ = 0;
		gchar** _tmp93_;
		GeeArrayList* _tmp94_;
#line 1359 "../src/client/accounts/accounts-manager.vala"
		_tmp90_ = geary_account_information_get_trash_folder_path (info);
#line 1359 "../src/client/accounts/accounts-manager.vala"
		_tmp91_ = _tmp90_;
#line 1359 "../src/client/accounts/accounts-manager.vala"
		_tmp93_ = geary_folder_path_as_array (_tmp91_, &_tmp92_);
#line 1359 "../src/client/accounts/accounts-manager.vala"
		_tmp94_ = gee_array_list_new_wrap (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, _tmp93_, _tmp92_, NULL, NULL, NULL);
#line 1359 "../src/client/accounts/accounts-manager.vala"
		_g_object_unref0 (_tmp87_);
#line 1359 "../src/client/accounts/accounts-manager.vala"
		_tmp87_ = _tmp94_;
#line 12565 "accounts-manager.c"
	} else {
		GeeArrayList* _tmp95_;
		GeeArrayList* _tmp96_;
#line 1360 "../src/client/accounts/accounts-manager.vala"
		_tmp95_ = empty;
#line 1360 "../src/client/accounts/accounts-manager.vala"
		_tmp96_ = _g_object_ref0 (_tmp95_);
#line 1360 "../src/client/accounts/accounts-manager.vala"
		_g_object_unref0 (_tmp87_);
#line 1360 "../src/client/accounts/accounts-manager.vala"
		_tmp87_ = _tmp96_;
#line 12577 "accounts-manager.c"
	}
#line 1356 "../src/client/accounts/accounts-manager.vala"
	_tmp97_ = config;
#line 1356 "../src/client/accounts/accounts-manager.vala"
	geary_config_file_group_set_string_list (_tmp97_, ACCOUNTS_ACCOUNT_CONFIG_LEGACY_TRASH_FOLDER_KEY, G_TYPE_CHECK_INSTANCE_CAST (_tmp87_, GEE_TYPE_LIST, GeeList));
#line 1364 "../src/client/accounts/accounts-manager.vala"
	_tmp99_ = geary_account_information_get_archive_folder_path (info);
#line 1364 "../src/client/accounts/accounts-manager.vala"
	_tmp100_ = _tmp99_;
#line 1364 "../src/client/accounts/accounts-manager.vala"
	if (_tmp100_ != NULL) {
#line 12589 "accounts-manager.c"
		GearyFolderPath* _tmp101_;
		GearyFolderPath* _tmp102_;
		gint _tmp103_ = 0;
		gchar** _tmp104_;
		GeeArrayList* _tmp105_;
#line 1365 "../src/client/accounts/accounts-manager.vala"
		_tmp101_ = geary_account_information_get_archive_folder_path (info);
#line 1365 "../src/client/accounts/accounts-manager.vala"
		_tmp102_ = _tmp101_;
#line 1365 "../src/client/accounts/accounts-manager.vala"
		_tmp104_ = geary_folder_path_as_array (_tmp102_, &_tmp103_);
#line 1365 "../src/client/accounts/accounts-manager.vala"
		_tmp105_ = gee_array_list_new_wrap (G_TYPE_STRING, (GBoxedCopyFunc) g_strdup, (GDestroyNotify) g_free, _tmp104_, _tmp103_, NULL, NULL, NULL);
#line 1365 "../src/client/accounts/accounts-manager.vala"
		_g_object_unref0 (_tmp98_);
#line 1365 "../src/client/accounts/accounts-manager.vala"
		_tmp98_ = _tmp105_;
#line 12607 "accounts-manager.c"
	} else {
		GeeArrayList* _tmp106_;
		GeeArrayList* _tmp107_;
#line 1366 "../src/client/accounts/accounts-manager.vala"
		_tmp106_ = empty;
#line 1366 "../src/client/accounts/accounts-manager.vala"
		_tmp107_ = _g_object_ref0 (_tmp106_);
#line 1366 "../src/client/accounts/accounts-manager.vala"
		_g_object_unref0 (_tmp98_);
#line 1366 "../src/client/accounts/accounts-manager.vala"
		_tmp98_ = _tmp107_;
#line 12619 "accounts-manager.c"
	}
#line 1362 "../src/client/accounts/accounts-manager.vala"
	_tmp108_ = config;
#line 1362 "../src/client/accounts/accounts-manager.vala"
	geary_config_file_group_set_string_list (_tmp108_, ACCOUNTS_ACCOUNT_CONFIG_LEGACY_ARCHIVE_FOLDER_KEY, G_TYPE_CHECK_INSTANCE_CAST (_tmp98_, GEE_TYPE_LIST, GeeList));
#line 1369 "../src/client/accounts/accounts-manager.vala"
	_tmp109_ = config;
#line 1369 "../src/client/accounts/accounts-manager.vala"
	_tmp110_ = geary_account_information_get_save_drafts (info);
#line 1369 "../src/client/accounts/accounts-manager.vala"
	_tmp111_ = _tmp110_;
#line 1369 "../src/client/accounts/accounts-manager.vala"
	geary_config_file_group_set_bool (_tmp109_, ACCOUNTS_ACCOUNT_CONFIG_LEGACY_SAVE_DRAFTS_KEY, _tmp111_);
#line 1310 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_tmp98_);
#line 1310 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_tmp87_);
#line 1310 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_tmp76_);
#line 1310 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_tmp65_);
#line 1310 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_tmp54_);
#line 1310 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (empty);
#line 1310 "../src/client/accounts/accounts-manager.vala"
	_geary_config_file_group_unref0 (config);
#line 12647 "accounts-manager.c"
}


AccountsAccountConfigLegacy*
accounts_account_config_legacy_construct (GType object_type)
{
	AccountsAccountConfigLegacy * self = NULL;
#line 1198 "../src/client/accounts/accounts-manager.vala"
	self = (AccountsAccountConfigLegacy*) g_object_new (object_type, NULL);
#line 1198 "../src/client/accounts/accounts-manager.vala"
	return self;
#line 12659 "accounts-manager.c"
}


AccountsAccountConfigLegacy*
accounts_account_config_legacy_new (void)
{
#line 1198 "../src/client/accounts/accounts-manager.vala"
	return accounts_account_config_legacy_construct (ACCOUNTS_TYPE_ACCOUNT_CONFIG_LEGACY);
#line 12668 "accounts-manager.c"
}


static void
accounts_account_config_legacy_class_init (AccountsAccountConfigLegacyClass * klass)
{
#line 1198 "../src/client/accounts/accounts-manager.vala"
	accounts_account_config_legacy_parent_class = g_type_class_peek_parent (klass);
#line 12677 "accounts-manager.c"
}


static void
accounts_account_config_legacy_accounts_account_config_interface_init (AccountsAccountConfigIface * iface)
{
#line 1198 "../src/client/accounts/accounts-manager.vala"
	accounts_account_config_legacy_accounts_account_config_parent_iface = g_type_interface_peek_parent (iface);
#line 1198 "../src/client/accounts/accounts-manager.vala"
	iface->load = (GearyAccountInformation* (*) (AccountsAccountConfig*, GearyConfigFile*, const gchar*, GearyCredentialsMediator*, GearyServiceProvider*, const gchar*, GError**)) accounts_account_config_legacy_real_load;
#line 1198 "../src/client/accounts/accounts-manager.vala"
	iface->save = (void (*) (AccountsAccountConfig*, GearyAccountInformation*, GearyConfigFile*)) accounts_account_config_legacy_real_save;
#line 12690 "accounts-manager.c"
}


static void
accounts_account_config_legacy_instance_init (AccountsAccountConfigLegacy * self)
{
}


/**
 * Manages persistence for un-versioned account configuration.
 */
GType
accounts_account_config_legacy_get_type (void)
{
	static volatile gsize accounts_account_config_legacy_type_id__volatile = 0;
	if (g_once_init_enter (&accounts_account_config_legacy_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (AccountsAccountConfigLegacyClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) accounts_account_config_legacy_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (AccountsAccountConfigLegacy), 0, (GInstanceInitFunc) accounts_account_config_legacy_instance_init, NULL };
		static const GInterfaceInfo accounts_account_config_info = { (GInterfaceInitFunc) accounts_account_config_legacy_accounts_account_config_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType accounts_account_config_legacy_type_id;
		accounts_account_config_legacy_type_id = g_type_register_static (G_TYPE_OBJECT, "AccountsAccountConfigLegacy", &g_define_type_info, 0);
		g_type_add_interface_static (accounts_account_config_legacy_type_id, ACCOUNTS_TYPE_ACCOUNT_CONFIG, &accounts_account_config_info);
		g_once_init_leave (&accounts_account_config_legacy_type_id__volatile, accounts_account_config_legacy_type_id);
	}
	return accounts_account_config_legacy_type_id__volatile;
}


/** Loads a supported service from a config file. */
static GearyTlsNegotiationMethod
___lambda6_ (AccountsServiceConfigV1* self,
             const gchar* value,
             GError** error)
{
	GearyTlsNegotiationMethod result = 0;
	GError * _inner_error_ = NULL;
#line 1418 "../src/client/accounts/accounts-manager.vala"
	g_return_val_if_fail (value != NULL, 0);
#line 12729 "accounts-manager.c"
	{
		GearyTlsNegotiationMethod _tmp0_ = 0;
#line 1420 "../src/client/accounts/accounts-manager.vala"
		_tmp0_ = geary_tls_negotiation_method_for_value (value, &_inner_error_);
#line 1420 "../src/client/accounts/accounts-manager.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 12736 "accounts-manager.c"
			goto __catch101_g_error;
		}
#line 1420 "../src/client/accounts/accounts-manager.vala"
		result = _tmp0_;
#line 1420 "../src/client/accounts/accounts-manager.vala"
		return result;
#line 12743 "accounts-manager.c"
	}
	goto __finally101;
	__catch101_g_error:
	{
		GError* err = NULL;
		GError* _tmp1_;
		const gchar* _tmp2_;
		GError* _tmp3_;
#line 1419 "../src/client/accounts/accounts-manager.vala"
		err = _inner_error_;
#line 1419 "../src/client/accounts/accounts-manager.vala"
		_inner_error_ = NULL;
#line 1422 "../src/client/accounts/accounts-manager.vala"
		_tmp1_ = err;
#line 1422 "../src/client/accounts/accounts-manager.vala"
		_tmp2_ = _tmp1_->message;
#line 1422 "../src/client/accounts/accounts-manager.vala"
		_tmp3_ = g_error_new_literal (G_KEY_FILE_ERROR, G_KEY_FILE_ERROR_INVALID_VALUE, _tmp2_);
#line 1422 "../src/client/accounts/accounts-manager.vala"
		_inner_error_ = _tmp3_;
#line 1422 "../src/client/accounts/accounts-manager.vala"
		_g_error_free0 (err);
#line 12766 "accounts-manager.c"
		goto __finally101;
	}
	__finally101:
#line 1419 "../src/client/accounts/accounts-manager.vala"
	if (_inner_error_->domain == G_KEY_FILE_ERROR) {
#line 1419 "../src/client/accounts/accounts-manager.vala"
		g_propagate_error (error, _inner_error_);
#line 1419 "../src/client/accounts/accounts-manager.vala"
		return 0;
#line 12776 "accounts-manager.c"
	} else {
#line 1419 "../src/client/accounts/accounts-manager.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1419 "../src/client/accounts/accounts-manager.vala"
		g_clear_error (&_inner_error_);
#line 1419 "../src/client/accounts/accounts-manager.vala"
		return 0;
#line 12784 "accounts-manager.c"
	}
}


static gpointer
____lambda6__geary_config_file_parser (const gchar* value,
                                       gpointer self,
                                       GError** error)
{
	gpointer result;
	result = (gpointer) ((gintptr) ___lambda6_ ((AccountsServiceConfigV1*) self, value, error));
#line 1415 "../src/client/accounts/accounts-manager.vala"
	return result;
#line 12798 "accounts-manager.c"
}


static GearyCredentialsRequirement
___lambda7_ (AccountsServiceConfigV1* self,
             const gchar* value,
             GError** error)
{
	GearyCredentialsRequirement result = 0;
	GError * _inner_error_ = NULL;
#line 1430 "../src/client/accounts/accounts-manager.vala"
	g_return_val_if_fail (value != NULL, 0);
#line 12811 "accounts-manager.c"
	{
		GearyCredentialsRequirement _tmp0_ = 0;
#line 1432 "../src/client/accounts/accounts-manager.vala"
		_tmp0_ = geary_credentials_requirement_for_value (value, &_inner_error_);
#line 1432 "../src/client/accounts/accounts-manager.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 12818 "accounts-manager.c"
			goto __catch102_g_error;
		}
#line 1432 "../src/client/accounts/accounts-manager.vala"
		result = _tmp0_;
#line 1432 "../src/client/accounts/accounts-manager.vala"
		return result;
#line 12825 "accounts-manager.c"
	}
	goto __finally102;
	__catch102_g_error:
	{
		GError* err = NULL;
		GError* _tmp1_;
		const gchar* _tmp2_;
		GError* _tmp3_;
#line 1431 "../src/client/accounts/accounts-manager.vala"
		err = _inner_error_;
#line 1431 "../src/client/accounts/accounts-manager.vala"
		_inner_error_ = NULL;
#line 1434 "../src/client/accounts/accounts-manager.vala"
		_tmp1_ = err;
#line 1434 "../src/client/accounts/accounts-manager.vala"
		_tmp2_ = _tmp1_->message;
#line 1434 "../src/client/accounts/accounts-manager.vala"
		_tmp3_ = g_error_new_literal (G_KEY_FILE_ERROR, G_KEY_FILE_ERROR_INVALID_VALUE, _tmp2_);
#line 1434 "../src/client/accounts/accounts-manager.vala"
		_inner_error_ = _tmp3_;
#line 1434 "../src/client/accounts/accounts-manager.vala"
		_g_error_free0 (err);
#line 12848 "accounts-manager.c"
		goto __finally102;
	}
	__finally102:
#line 1431 "../src/client/accounts/accounts-manager.vala"
	if (_inner_error_->domain == G_KEY_FILE_ERROR) {
#line 1431 "../src/client/accounts/accounts-manager.vala"
		g_propagate_error (error, _inner_error_);
#line 1431 "../src/client/accounts/accounts-manager.vala"
		return 0;
#line 12858 "accounts-manager.c"
	} else {
#line 1431 "../src/client/accounts/accounts-manager.vala"
		g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1431 "../src/client/accounts/accounts-manager.vala"
		g_clear_error (&_inner_error_);
#line 1431 "../src/client/accounts/accounts-manager.vala"
		return 0;
#line 12866 "accounts-manager.c"
	}
}


static gpointer
____lambda7__geary_config_file_parser (const gchar* value,
                                       gpointer self,
                                       GError** error)
{
	gpointer result;
	result = (gpointer) ((gintptr) ___lambda7_ ((AccountsServiceConfigV1*) self, value, error));
#line 1427 "../src/client/accounts/accounts-manager.vala"
	return result;
#line 12880 "accounts-manager.c"
}


static void
accounts_service_config_v1_real_load (AccountsServiceConfig* base,
                                      GearyConfigFile* config,
                                      GearyAccountInformation* account,
                                      GearyServiceInformation* service,
                                      GError** error)
{
	AccountsServiceConfigV1 * self;
	const gchar* _tmp0_ = NULL;
	GearyProtocol _tmp1_;
	GearyProtocol _tmp2_;
	GearyConfigFileGroup* service_config = NULL;
	GearyConfigFileGroup* _tmp3_;
	gchar* login = NULL;
	GearyConfigFileGroup* _tmp4_;
	gchar* _tmp5_;
	const gchar* _tmp6_;
	GearyConfigFileGroup* _tmp10_;
	gboolean _tmp11_;
	gboolean _tmp12_;
	GearyServiceProvider _tmp13_;
	GearyServiceProvider _tmp14_;
	GError * _inner_error_ = NULL;
#line 1392 "../src/client/accounts/accounts-manager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, ACCOUNTS_TYPE_SERVICE_CONFIG_V1, AccountsServiceConfigV1);
#line 1392 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail (GEARY_IS_CONFIG_FILE (config));
#line 1392 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail (GEARY_IS_ACCOUNT_INFORMATION (account));
#line 1392 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail (GEARY_IS_SERVICE_INFORMATION (service));
#line 1397 "../src/client/accounts/accounts-manager.vala"
	_tmp1_ = geary_service_information_get_protocol (service);
#line 1397 "../src/client/accounts/accounts-manager.vala"
	_tmp2_ = _tmp1_;
#line 1397 "../src/client/accounts/accounts-manager.vala"
	if (_tmp2_ == GEARY_PROTOCOL_IMAP) {
#line 1397 "../src/client/accounts/accounts-manager.vala"
		_tmp0_ = ACCOUNTS_SERVICE_CONFIG_V1_GROUP_INCOMING;
#line 12923 "accounts-manager.c"
	} else {
#line 1397 "../src/client/accounts/accounts-manager.vala"
		_tmp0_ = ACCOUNTS_SERVICE_CONFIG_V1_GROUP_OUTGOING;
#line 12927 "accounts-manager.c"
	}
#line 1396 "../src/client/accounts/accounts-manager.vala"
	_tmp3_ = geary_config_file_get_group (config, _tmp0_);
#line 1396 "../src/client/accounts/accounts-manager.vala"
	service_config = _tmp3_;
#line 1400 "../src/client/accounts/accounts-manager.vala"
	_tmp4_ = service_config;
#line 1400 "../src/client/accounts/accounts-manager.vala"
	_tmp5_ = geary_config_file_group_get_string (_tmp4_, ACCOUNTS_SERVICE_CONFIG_V1_LOGIN, NULL);
#line 1400 "../src/client/accounts/accounts-manager.vala"
	login = _tmp5_;
#line 1401 "../src/client/accounts/accounts-manager.vala"
	_tmp6_ = login;
#line 1401 "../src/client/accounts/accounts-manager.vala"
	if (_tmp6_ != NULL) {
#line 12943 "accounts-manager.c"
		const gchar* _tmp7_;
		GearyCredentials* _tmp8_;
		GearyCredentials* _tmp9_;
#line 1402 "../src/client/accounts/accounts-manager.vala"
		_tmp7_ = login;
#line 1402 "../src/client/accounts/accounts-manager.vala"
		_tmp8_ = geary_credentials_new (GEARY_CREDENTIALS_METHOD_PASSWORD, _tmp7_, NULL);
#line 1402 "../src/client/accounts/accounts-manager.vala"
		_tmp9_ = _tmp8_;
#line 1402 "../src/client/accounts/accounts-manager.vala"
		geary_service_information_set_credentials (service, _tmp9_);
#line 1402 "../src/client/accounts/accounts-manager.vala"
		_g_object_unref0 (_tmp9_);
#line 12957 "accounts-manager.c"
	}
#line 1406 "../src/client/accounts/accounts-manager.vala"
	_tmp10_ = service_config;
#line 1406 "../src/client/accounts/accounts-manager.vala"
	_tmp11_ = geary_service_information_get_remember_password (service);
#line 1406 "../src/client/accounts/accounts-manager.vala"
	_tmp12_ = _tmp11_;
#line 1406 "../src/client/accounts/accounts-manager.vala"
	geary_service_information_set_remember_password (service, geary_config_file_group_get_bool (_tmp10_, ACCOUNTS_SERVICE_CONFIG_V1_REMEMBER_PASSWORD, _tmp12_));
#line 1411 "../src/client/accounts/accounts-manager.vala"
	_tmp13_ = geary_account_information_get_service_provider (account);
#line 1411 "../src/client/accounts/accounts-manager.vala"
	_tmp14_ = _tmp13_;
#line 1411 "../src/client/accounts/accounts-manager.vala"
	if (_tmp14_ == GEARY_SERVICE_PROVIDER_OTHER) {
#line 12973 "accounts-manager.c"
		gchar* _tmp15_ = NULL;
		GearyConfigFileGroup* _tmp16_;
		gchar* _tmp17_;
		GearyConfigFileGroup* _tmp18_;
		guint16 _tmp19_;
		guint16 _tmp20_;
		GearyTlsNegotiationMethod _tmp21_ = 0;
		GearyConfigFileGroup* _tmp22_;
		gpointer _tmp23_;
		GearyCredentialsRequirement _tmp24_ = 0;
		GearyConfigFileGroup* _tmp25_;
		gpointer _tmp26_;
		guint16 _tmp27_;
		guint16 _tmp28_;
#line 1412 "../src/client/accounts/accounts-manager.vala"
		_tmp16_ = service_config;
#line 1412 "../src/client/accounts/accounts-manager.vala"
		_tmp17_ = geary_config_file_group_get_required_string (_tmp16_, ACCOUNTS_SERVICE_CONFIG_V1_HOST, &_inner_error_);
#line 1412 "../src/client/accounts/accounts-manager.vala"
		_tmp15_ = _tmp17_;
#line 1412 "../src/client/accounts/accounts-manager.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1412 "../src/client/accounts/accounts-manager.vala"
			if ((_inner_error_->domain == ACCOUNTS_CONFIG_ERROR) || (_inner_error_->domain == G_KEY_FILE_ERROR)) {
#line 1412 "../src/client/accounts/accounts-manager.vala"
				g_propagate_error (error, _inner_error_);
#line 1412 "../src/client/accounts/accounts-manager.vala"
				_g_free0 (login);
#line 1412 "../src/client/accounts/accounts-manager.vala"
				_geary_config_file_group_unref0 (service_config);
#line 1412 "../src/client/accounts/accounts-manager.vala"
				return;
#line 13006 "accounts-manager.c"
			} else {
#line 1412 "../src/client/accounts/accounts-manager.vala"
				_g_free0 (login);
#line 1412 "../src/client/accounts/accounts-manager.vala"
				_geary_config_file_group_unref0 (service_config);
#line 1412 "../src/client/accounts/accounts-manager.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1412 "../src/client/accounts/accounts-manager.vala"
				g_clear_error (&_inner_error_);
#line 1412 "../src/client/accounts/accounts-manager.vala"
				return;
#line 13018 "accounts-manager.c"
			}
		}
#line 1412 "../src/client/accounts/accounts-manager.vala"
		geary_service_information_set_host (service, _tmp15_);
#line 1413 "../src/client/accounts/accounts-manager.vala"
		_tmp18_ = service_config;
#line 1413 "../src/client/accounts/accounts-manager.vala"
		_tmp19_ = geary_service_information_get_port (service);
#line 1413 "../src/client/accounts/accounts-manager.vala"
		_tmp20_ = _tmp19_;
#line 1413 "../src/client/accounts/accounts-manager.vala"
		geary_service_information_set_port (service, (guint16) geary_config_file_group_get_int (_tmp18_, ACCOUNTS_SERVICE_CONFIG_V1_PORT, (gint) _tmp20_));
#line 1415 "../src/client/accounts/accounts-manager.vala"
		_tmp22_ = service_config;
#line 1415 "../src/client/accounts/accounts-manager.vala"
		_tmp23_ = geary_config_file_group_parse_required_value (_tmp22_, GEARY_TYPE_TLS_NEGOTIATION_METHOD, NULL, NULL, ACCOUNTS_SERVICE_CONFIG_V1_SECURITY, ____lambda6__geary_config_file_parser, self, &_inner_error_);
#line 1415 "../src/client/accounts/accounts-manager.vala"
		_tmp21_ = (GearyTlsNegotiationMethod) ((gintptr) _tmp23_);
#line 1415 "../src/client/accounts/accounts-manager.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1415 "../src/client/accounts/accounts-manager.vala"
			if ((_inner_error_->domain == ACCOUNTS_CONFIG_ERROR) || (_inner_error_->domain == G_KEY_FILE_ERROR)) {
#line 1415 "../src/client/accounts/accounts-manager.vala"
				g_propagate_error (error, _inner_error_);
#line 1415 "../src/client/accounts/accounts-manager.vala"
				_g_free0 (_tmp15_);
#line 1415 "../src/client/accounts/accounts-manager.vala"
				_g_free0 (login);
#line 1415 "../src/client/accounts/accounts-manager.vala"
				_geary_config_file_group_unref0 (service_config);
#line 1415 "../src/client/accounts/accounts-manager.vala"
				return;
#line 13051 "accounts-manager.c"
			} else {
#line 1415 "../src/client/accounts/accounts-manager.vala"
				_g_free0 (_tmp15_);
#line 1415 "../src/client/accounts/accounts-manager.vala"
				_g_free0 (login);
#line 1415 "../src/client/accounts/accounts-manager.vala"
				_geary_config_file_group_unref0 (service_config);
#line 1415 "../src/client/accounts/accounts-manager.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1415 "../src/client/accounts/accounts-manager.vala"
				g_clear_error (&_inner_error_);
#line 1415 "../src/client/accounts/accounts-manager.vala"
				return;
#line 13065 "accounts-manager.c"
			}
		}
#line 1415 "../src/client/accounts/accounts-manager.vala"
		geary_service_information_set_transport_security (service, _tmp21_);
#line 1427 "../src/client/accounts/accounts-manager.vala"
		_tmp25_ = service_config;
#line 1427 "../src/client/accounts/accounts-manager.vala"
		_tmp26_ = geary_config_file_group_parse_required_value (_tmp25_, GEARY_CREDENTIALS_TYPE_REQUIREMENT, NULL, NULL, ACCOUNTS_SERVICE_CONFIG_V1_CREDENTIALS, ____lambda7__geary_config_file_parser, self, &_inner_error_);
#line 1427 "../src/client/accounts/accounts-manager.vala"
		_tmp24_ = (GearyCredentialsRequirement) ((gintptr) _tmp26_);
#line 1427 "../src/client/accounts/accounts-manager.vala"
		if (G_UNLIKELY (_inner_error_ != NULL)) {
#line 1427 "../src/client/accounts/accounts-manager.vala"
			if ((_inner_error_->domain == ACCOUNTS_CONFIG_ERROR) || (_inner_error_->domain == G_KEY_FILE_ERROR)) {
#line 1427 "../src/client/accounts/accounts-manager.vala"
				g_propagate_error (error, _inner_error_);
#line 1427 "../src/client/accounts/accounts-manager.vala"
				_g_free0 (_tmp15_);
#line 1427 "../src/client/accounts/accounts-manager.vala"
				_g_free0 (login);
#line 1427 "../src/client/accounts/accounts-manager.vala"
				_geary_config_file_group_unref0 (service_config);
#line 1427 "../src/client/accounts/accounts-manager.vala"
				return;
#line 13090 "accounts-manager.c"
			} else {
#line 1427 "../src/client/accounts/accounts-manager.vala"
				_g_free0 (_tmp15_);
#line 1427 "../src/client/accounts/accounts-manager.vala"
				_g_free0 (login);
#line 1427 "../src/client/accounts/accounts-manager.vala"
				_geary_config_file_group_unref0 (service_config);
#line 1427 "../src/client/accounts/accounts-manager.vala"
				g_critical ("file %s: line %d: uncaught error: %s (%s, %d)", __FILE__, __LINE__, _inner_error_->message, g_quark_to_string (_inner_error_->domain), _inner_error_->code);
#line 1427 "../src/client/accounts/accounts-manager.vala"
				g_clear_error (&_inner_error_);
#line 1427 "../src/client/accounts/accounts-manager.vala"
				return;
#line 13104 "accounts-manager.c"
			}
		}
#line 1427 "../src/client/accounts/accounts-manager.vala"
		geary_service_information_set_credentials_requirement (service, _tmp24_);
#line 1439 "../src/client/accounts/accounts-manager.vala"
		_tmp27_ = geary_service_information_get_port (service);
#line 1439 "../src/client/accounts/accounts-manager.vala"
		_tmp28_ = _tmp27_;
#line 1439 "../src/client/accounts/accounts-manager.vala"
		if (((gint) _tmp28_) == 0) {
#line 1440 "../src/client/accounts/accounts-manager.vala"
			geary_service_information_set_port (service, geary_service_information_get_default_port (service));
#line 13117 "accounts-manager.c"
		}
#line 1411 "../src/client/accounts/accounts-manager.vala"
		_g_free0 (_tmp15_);
#line 13121 "accounts-manager.c"
	}
#line 1392 "../src/client/accounts/accounts-manager.vala"
	_g_free0 (login);
#line 1392 "../src/client/accounts/accounts-manager.vala"
	_geary_config_file_group_unref0 (service_config);
#line 13127 "accounts-manager.c"
}


/** Saves an service to a config file. */
static void
accounts_service_config_v1_real_save (AccountsServiceConfig* base,
                                      GearyAccountInformation* account,
                                      GearyServiceInformation* service,
                                      GearyConfigFile* config)
{
	AccountsServiceConfigV1 * self;
	const gchar* _tmp0_ = NULL;
	GearyProtocol _tmp1_;
	GearyProtocol _tmp2_;
	GearyConfigFileGroup* service_config = NULL;
	GearyConfigFileGroup* _tmp3_;
	GearyCredentials* _tmp4_;
	GearyCredentials* _tmp5_;
	GearyConfigFileGroup* _tmp11_;
	gboolean _tmp12_;
	gboolean _tmp13_;
	GearyServiceProvider _tmp14_;
	GearyServiceProvider _tmp15_;
#line 1446 "../src/client/accounts/accounts-manager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, ACCOUNTS_TYPE_SERVICE_CONFIG_V1, AccountsServiceConfigV1);
#line 1446 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail (GEARY_IS_ACCOUNT_INFORMATION (account));
#line 1446 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail (GEARY_IS_SERVICE_INFORMATION (service));
#line 1446 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail (GEARY_IS_CONFIG_FILE (config));
#line 1450 "../src/client/accounts/accounts-manager.vala"
	_tmp1_ = geary_service_information_get_protocol (service);
#line 1450 "../src/client/accounts/accounts-manager.vala"
	_tmp2_ = _tmp1_;
#line 1450 "../src/client/accounts/accounts-manager.vala"
	if (_tmp2_ == GEARY_PROTOCOL_IMAP) {
#line 1450 "../src/client/accounts/accounts-manager.vala"
		_tmp0_ = ACCOUNTS_SERVICE_CONFIG_V1_GROUP_INCOMING;
#line 13167 "accounts-manager.c"
	} else {
#line 1450 "../src/client/accounts/accounts-manager.vala"
		_tmp0_ = ACCOUNTS_SERVICE_CONFIG_V1_GROUP_OUTGOING;
#line 13171 "accounts-manager.c"
	}
#line 1449 "../src/client/accounts/accounts-manager.vala"
	_tmp3_ = geary_config_file_get_group (config, _tmp0_);
#line 1449 "../src/client/accounts/accounts-manager.vala"
	service_config = _tmp3_;
#line 1453 "../src/client/accounts/accounts-manager.vala"
	_tmp4_ = geary_service_information_get_credentials (service);
#line 1453 "../src/client/accounts/accounts-manager.vala"
	_tmp5_ = _tmp4_;
#line 1453 "../src/client/accounts/accounts-manager.vala"
	if (_tmp5_ != NULL) {
#line 13183 "accounts-manager.c"
		GearyConfigFileGroup* _tmp6_;
		GearyCredentials* _tmp7_;
		GearyCredentials* _tmp8_;
		const gchar* _tmp9_;
		const gchar* _tmp10_;
#line 1454 "../src/client/accounts/accounts-manager.vala"
		_tmp6_ = service_config;
#line 1454 "../src/client/accounts/accounts-manager.vala"
		_tmp7_ = geary_service_information_get_credentials (service);
#line 1454 "../src/client/accounts/accounts-manager.vala"
		_tmp8_ = _tmp7_;
#line 1454 "../src/client/accounts/accounts-manager.vala"
		_tmp9_ = geary_credentials_get_user (_tmp8_);
#line 1454 "../src/client/accounts/accounts-manager.vala"
		_tmp10_ = _tmp9_;
#line 1454 "../src/client/accounts/accounts-manager.vala"
		geary_config_file_group_set_string (_tmp6_, ACCOUNTS_SERVICE_CONFIG_V1_LOGIN, _tmp10_);
#line 13201 "accounts-manager.c"
	}
#line 1456 "../src/client/accounts/accounts-manager.vala"
	_tmp11_ = service_config;
#line 1456 "../src/client/accounts/accounts-manager.vala"
	_tmp12_ = geary_service_information_get_remember_password (service);
#line 1456 "../src/client/accounts/accounts-manager.vala"
	_tmp13_ = _tmp12_;
#line 1456 "../src/client/accounts/accounts-manager.vala"
	geary_config_file_group_set_bool (_tmp11_, ACCOUNTS_SERVICE_CONFIG_V1_REMEMBER_PASSWORD, _tmp13_);
#line 1458 "../src/client/accounts/accounts-manager.vala"
	_tmp14_ = geary_account_information_get_service_provider (account);
#line 1458 "../src/client/accounts/accounts-manager.vala"
	_tmp15_ = _tmp14_;
#line 1458 "../src/client/accounts/accounts-manager.vala"
	if (_tmp15_ == GEARY_SERVICE_PROVIDER_OTHER) {
#line 13217 "accounts-manager.c"
		GearyConfigFileGroup* _tmp16_;
		const gchar* _tmp17_;
		const gchar* _tmp18_;
		GearyConfigFileGroup* _tmp19_;
		guint16 _tmp20_;
		guint16 _tmp21_;
		GearyConfigFileGroup* _tmp22_;
		GearyTlsNegotiationMethod _tmp23_;
		GearyTlsNegotiationMethod _tmp24_;
		gchar* _tmp25_;
		gchar* _tmp26_;
		GearyConfigFileGroup* _tmp27_;
		GearyCredentialsRequirement _tmp28_;
		GearyCredentialsRequirement _tmp29_;
		gchar* _tmp30_;
		gchar* _tmp31_;
#line 1459 "../src/client/accounts/accounts-manager.vala"
		_tmp16_ = service_config;
#line 1459 "../src/client/accounts/accounts-manager.vala"
		_tmp17_ = geary_service_information_get_host (service);
#line 1459 "../src/client/accounts/accounts-manager.vala"
		_tmp18_ = _tmp17_;
#line 1459 "../src/client/accounts/accounts-manager.vala"
		geary_config_file_group_set_string (_tmp16_, ACCOUNTS_SERVICE_CONFIG_V1_HOST, _tmp18_);
#line 1460 "../src/client/accounts/accounts-manager.vala"
		_tmp19_ = service_config;
#line 1460 "../src/client/accounts/accounts-manager.vala"
		_tmp20_ = geary_service_information_get_port (service);
#line 1460 "../src/client/accounts/accounts-manager.vala"
		_tmp21_ = _tmp20_;
#line 1460 "../src/client/accounts/accounts-manager.vala"
		geary_config_file_group_set_int (_tmp19_, ACCOUNTS_SERVICE_CONFIG_V1_PORT, (gint) _tmp21_);
#line 1461 "../src/client/accounts/accounts-manager.vala"
		_tmp22_ = service_config;
#line 1461 "../src/client/accounts/accounts-manager.vala"
		_tmp23_ = geary_service_information_get_transport_security (service);
#line 1461 "../src/client/accounts/accounts-manager.vala"
		_tmp24_ = _tmp23_;
#line 1461 "../src/client/accounts/accounts-manager.vala"
		_tmp25_ = geary_tls_negotiation_method_to_value (_tmp24_);
#line 1461 "../src/client/accounts/accounts-manager.vala"
		_tmp26_ = _tmp25_;
#line 1461 "../src/client/accounts/accounts-manager.vala"
		geary_config_file_group_set_string (_tmp22_, ACCOUNTS_SERVICE_CONFIG_V1_SECURITY, _tmp26_);
#line 1461 "../src/client/accounts/accounts-manager.vala"
		_g_free0 (_tmp26_);
#line 1465 "../src/client/accounts/accounts-manager.vala"
		_tmp27_ = service_config;
#line 1465 "../src/client/accounts/accounts-manager.vala"
		_tmp28_ = geary_service_information_get_credentials_requirement (service);
#line 1465 "../src/client/accounts/accounts-manager.vala"
		_tmp29_ = _tmp28_;
#line 1465 "../src/client/accounts/accounts-manager.vala"
		_tmp30_ = geary_credentials_requirement_to_value (_tmp29_);
#line 1465 "../src/client/accounts/accounts-manager.vala"
		_tmp31_ = _tmp30_;
#line 1465 "../src/client/accounts/accounts-manager.vala"
		geary_config_file_group_set_string (_tmp27_, ACCOUNTS_SERVICE_CONFIG_V1_CREDENTIALS, _tmp31_);
#line 1465 "../src/client/accounts/accounts-manager.vala"
		_g_free0 (_tmp31_);
#line 13278 "accounts-manager.c"
	}
#line 1446 "../src/client/accounts/accounts-manager.vala"
	_geary_config_file_group_unref0 (service_config);
#line 13282 "accounts-manager.c"
}


AccountsServiceConfigV1*
accounts_service_config_v1_construct (GType object_type)
{
	AccountsServiceConfigV1 * self = NULL;
#line 1378 "../src/client/accounts/accounts-manager.vala"
	self = (AccountsServiceConfigV1*) g_object_new (object_type, NULL);
#line 1378 "../src/client/accounts/accounts-manager.vala"
	return self;
#line 13294 "accounts-manager.c"
}


AccountsServiceConfigV1*
accounts_service_config_v1_new (void)
{
#line 1378 "../src/client/accounts/accounts-manager.vala"
	return accounts_service_config_v1_construct (ACCOUNTS_TYPE_SERVICE_CONFIG_V1);
#line 13303 "accounts-manager.c"
}


static void
accounts_service_config_v1_class_init (AccountsServiceConfigV1Class * klass)
{
#line 1378 "../src/client/accounts/accounts-manager.vala"
	accounts_service_config_v1_parent_class = g_type_class_peek_parent (klass);
#line 13312 "accounts-manager.c"
}


static void
accounts_service_config_v1_accounts_service_config_interface_init (AccountsServiceConfigIface * iface)
{
#line 1378 "../src/client/accounts/accounts-manager.vala"
	accounts_service_config_v1_accounts_service_config_parent_iface = g_type_interface_peek_parent (iface);
#line 1378 "../src/client/accounts/accounts-manager.vala"
	iface->load = (void (*) (AccountsServiceConfig*, GearyConfigFile*, GearyAccountInformation*, GearyServiceInformation*, GError**)) accounts_service_config_v1_real_load;
#line 1378 "../src/client/accounts/accounts-manager.vala"
	iface->save = (void (*) (AccountsServiceConfig*, GearyAccountInformation*, GearyServiceInformation*, GearyConfigFile*)) accounts_service_config_v1_real_save;
#line 13325 "accounts-manager.c"
}


static void
accounts_service_config_v1_instance_init (AccountsServiceConfigV1 * self)
{
}


/**
 * Manages persistence for version 1 service configuration.
 */
GType
accounts_service_config_v1_get_type (void)
{
	static volatile gsize accounts_service_config_v1_type_id__volatile = 0;
	if (g_once_init_enter (&accounts_service_config_v1_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (AccountsServiceConfigV1Class), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) accounts_service_config_v1_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (AccountsServiceConfigV1), 0, (GInstanceInitFunc) accounts_service_config_v1_instance_init, NULL };
		static const GInterfaceInfo accounts_service_config_info = { (GInterfaceInitFunc) accounts_service_config_v1_accounts_service_config_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType accounts_service_config_v1_type_id;
		accounts_service_config_v1_type_id = g_type_register_static (G_TYPE_OBJECT, "AccountsServiceConfigV1", &g_define_type_info, 0);
		g_type_add_interface_static (accounts_service_config_v1_type_id, ACCOUNTS_TYPE_SERVICE_CONFIG, &accounts_service_config_info);
		g_once_init_leave (&accounts_service_config_v1_type_id__volatile, accounts_service_config_v1_type_id);
	}
	return accounts_service_config_v1_type_id__volatile;
}


/** Loads a supported service from a config file. */
static void
accounts_service_config_legacy_real_load (AccountsServiceConfig* base,
                                          GearyConfigFile* config,
                                          GearyAccountInformation* account,
                                          GearyServiceInformation* service,
                                          GError** error)
{
	AccountsServiceConfigLegacy * self;
	GearyConfigFileGroup* service_config = NULL;
	GearyConfigFileGroup* _tmp0_;
	const gchar* _tmp1_ = NULL;
	GearyProtocol _tmp2_;
	GearyProtocol _tmp3_;
	gchar* prefix = NULL;
	gchar* _tmp4_;
	gchar* login = NULL;
	GearyConfigFileGroup* _tmp5_;
	const gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	GearyRFC822MailboxAddress* _tmp9_;
	GearyRFC822MailboxAddress* _tmp10_;
	GearyRFC822MailboxAddress* _tmp11_;
	const gchar* _tmp12_;
	const gchar* _tmp13_;
	gchar* _tmp14_;
	gchar* _tmp15_;
	const gchar* _tmp16_;
	GearyConfigFileGroup* _tmp20_;
	const gchar* _tmp21_;
	gchar* _tmp22_;
	gchar* _tmp23_;
	gboolean _tmp24_;
	gboolean _tmp25_;
	GearyServiceProvider _tmp26_;
	GearyServiceProvider _tmp27_;
#line 1492 "../src/client/accounts/accounts-manager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, ACCOUNTS_TYPE_SERVICE_CONFIG_LEGACY, AccountsServiceConfigLegacy);
#line 1492 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail (GEARY_IS_CONFIG_FILE (config));
#line 1492 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail (GEARY_IS_ACCOUNT_INFORMATION (account));
#line 1492 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail (GEARY_IS_SERVICE_INFORMATION (service));
#line 1496 "../src/client/accounts/accounts-manager.vala"
	_tmp0_ = geary_config_file_get_group (config, ACCOUNTS_ACCOUNT_CONFIG_LEGACY_GROUP);
#line 1496 "../src/client/accounts/accounts-manager.vala"
	service_config = _tmp0_;
#line 1499 "../src/client/accounts/accounts-manager.vala"
	_tmp2_ = geary_service_information_get_protocol (service);
#line 1499 "../src/client/accounts/accounts-manager.vala"
	_tmp3_ = _tmp2_;
#line 1499 "../src/client/accounts/accounts-manager.vala"
	if (_tmp3_ == GEARY_PROTOCOL_IMAP) {
#line 1500 "../src/client/accounts/accounts-manager.vala"
		_tmp1_ = "imap_";
#line 13411 "accounts-manager.c"
	} else {
#line 1500 "../src/client/accounts/accounts-manager.vala"
		_tmp1_ = "smtp_";
#line 13415 "accounts-manager.c"
	}
#line 1499 "../src/client/accounts/accounts-manager.vala"
	_tmp4_ = g_strdup (_tmp1_);
#line 1499 "../src/client/accounts/accounts-manager.vala"
	prefix = _tmp4_;
#line 1502 "../src/client/accounts/accounts-manager.vala"
	_tmp5_ = service_config;
#line 1502 "../src/client/accounts/accounts-manager.vala"
	_tmp6_ = prefix;
#line 1502 "../src/client/accounts/accounts-manager.vala"
	_tmp7_ = g_strconcat (_tmp6_, ACCOUNTS_SERVICE_CONFIG_LEGACY_USERNAME, NULL);
#line 1502 "../src/client/accounts/accounts-manager.vala"
	_tmp8_ = _tmp7_;
#line 1502 "../src/client/accounts/accounts-manager.vala"
	_tmp9_ = geary_account_information_get_primary_mailbox (account);
#line 1502 "../src/client/accounts/accounts-manager.vala"
	_tmp10_ = _tmp9_;
#line 1502 "../src/client/accounts/accounts-manager.vala"
	_tmp11_ = _tmp10_;
#line 1502 "../src/client/accounts/accounts-manager.vala"
	_tmp12_ = geary_rf_c822_mailbox_address_get_address (_tmp11_);
#line 1502 "../src/client/accounts/accounts-manager.vala"
	_tmp13_ = _tmp12_;
#line 1502 "../src/client/accounts/accounts-manager.vala"
	_tmp14_ = geary_config_file_group_get_string (_tmp5_, _tmp8_, _tmp13_);
#line 1502 "../src/client/accounts/accounts-manager.vala"
	_tmp15_ = _tmp14_;
#line 1502 "../src/client/accounts/accounts-manager.vala"
	_g_object_unref0 (_tmp11_);
#line 1502 "../src/client/accounts/accounts-manager.vala"
	_g_free0 (_tmp8_);
#line 1502 "../src/client/accounts/accounts-manager.vala"
	login = _tmp15_;
#line 1505 "../src/client/accounts/accounts-manager.vala"
	_tmp16_ = login;
#line 1505 "../src/client/accounts/accounts-manager.vala"
	if (_tmp16_ != NULL) {
#line 13453 "accounts-manager.c"
		const gchar* _tmp17_;
		GearyCredentials* _tmp18_;
		GearyCredentials* _tmp19_;
#line 1506 "../src/client/accounts/accounts-manager.vala"
		_tmp17_ = login;
#line 1506 "../src/client/accounts/accounts-manager.vala"
		_tmp18_ = geary_credentials_new (GEARY_CREDENTIALS_METHOD_PASSWORD, _tmp17_, NULL);
#line 1506 "../src/client/accounts/accounts-manager.vala"
		_tmp19_ = _tmp18_;
#line 1506 "../src/client/accounts/accounts-manager.vala"
		geary_service_information_set_credentials (service, _tmp19_);
#line 1506 "../src/client/accounts/accounts-manager.vala"
		_g_object_unref0 (_tmp19_);
#line 13467 "accounts-manager.c"
	}
#line 1510 "../src/client/accounts/accounts-manager.vala"
	_tmp20_ = service_config;
#line 1510 "../src/client/accounts/accounts-manager.vala"
	_tmp21_ = prefix;
#line 1510 "../src/client/accounts/accounts-manager.vala"
	_tmp22_ = g_strconcat (_tmp21_, ACCOUNTS_SERVICE_CONFIG_LEGACY_REMEMBER_PASSWORD, NULL);
#line 1510 "../src/client/accounts/accounts-manager.vala"
	_tmp23_ = _tmp22_;
#line 1510 "../src/client/accounts/accounts-manager.vala"
	_tmp24_ = geary_service_information_get_remember_password (service);
#line 1510 "../src/client/accounts/accounts-manager.vala"
	_tmp25_ = _tmp24_;
#line 1510 "../src/client/accounts/accounts-manager.vala"
	geary_service_information_set_remember_password (service, geary_config_file_group_get_bool (_tmp20_, _tmp23_, _tmp25_));
#line 1510 "../src/client/accounts/accounts-manager.vala"
	_g_free0 (_tmp23_);
#line 1514 "../src/client/accounts/accounts-manager.vala"
	_tmp26_ = geary_account_information_get_service_provider (account);
#line 1514 "../src/client/accounts/accounts-manager.vala"
	_tmp27_ = _tmp26_;
#line 1514 "../src/client/accounts/accounts-manager.vala"
	if (_tmp27_ == GEARY_SERVICE_PROVIDER_OTHER) {
#line 13491 "accounts-manager.c"
		GearyConfigFileGroup* _tmp28_;
		const gchar* _tmp29_;
		gchar* _tmp30_;
		gchar* _tmp31_;
		const gchar* _tmp32_;
		const gchar* _tmp33_;
		gchar* _tmp34_;
		gchar* _tmp35_;
		GearyConfigFileGroup* _tmp36_;
		const gchar* _tmp37_;
		gchar* _tmp38_;
		gchar* _tmp39_;
		guint16 _tmp40_;
		guint16 _tmp41_;
		gboolean use_tls = FALSE;
		GearyConfigFileGroup* _tmp42_;
		const gchar* _tmp43_;
		gchar* _tmp44_;
		gchar* _tmp45_;
		GearyProtocol _tmp46_;
		GearyProtocol _tmp47_;
		gboolean _tmp48_;
		gboolean use_starttls = FALSE;
		GearyConfigFileGroup* _tmp49_;
		const gchar* _tmp50_;
		gchar* _tmp51_;
		gchar* _tmp52_;
		gboolean _tmp53_;
		gboolean _tmp54_;
		GearyProtocol _tmp56_;
		GearyProtocol _tmp57_;
#line 1515 "../src/client/accounts/accounts-manager.vala"
		_tmp28_ = service_config;
#line 1515 "../src/client/accounts/accounts-manager.vala"
		_tmp29_ = prefix;
#line 1515 "../src/client/accounts/accounts-manager.vala"
		_tmp30_ = g_strconcat (_tmp29_, ACCOUNTS_SERVICE_CONFIG_LEGACY_HOST, NULL);
#line 1515 "../src/client/accounts/accounts-manager.vala"
		_tmp31_ = _tmp30_;
#line 1515 "../src/client/accounts/accounts-manager.vala"
		_tmp32_ = geary_service_information_get_host (service);
#line 1515 "../src/client/accounts/accounts-manager.vala"
		_tmp33_ = _tmp32_;
#line 1515 "../src/client/accounts/accounts-manager.vala"
		_tmp34_ = geary_config_file_group_get_string (_tmp28_, _tmp31_, _tmp33_);
#line 1515 "../src/client/accounts/accounts-manager.vala"
		_tmp35_ = _tmp34_;
#line 1515 "../src/client/accounts/accounts-manager.vala"
		geary_service_information_set_host (service, _tmp35_);
#line 1515 "../src/client/accounts/accounts-manager.vala"
		_g_free0 (_tmp35_);
#line 1515 "../src/client/accounts/accounts-manager.vala"
		_g_free0 (_tmp31_);
#line 1516 "../src/client/accounts/accounts-manager.vala"
		_tmp36_ = service_config;
#line 1516 "../src/client/accounts/accounts-manager.vala"
		_tmp37_ = prefix;
#line 1516 "../src/client/accounts/accounts-manager.vala"
		_tmp38_ = g_strconcat (_tmp37_, ACCOUNTS_SERVICE_CONFIG_LEGACY_PORT, NULL);
#line 1516 "../src/client/accounts/accounts-manager.vala"
		_tmp39_ = _tmp38_;
#line 1516 "../src/client/accounts/accounts-manager.vala"
		_tmp40_ = geary_service_information_get_port (service);
#line 1516 "../src/client/accounts/accounts-manager.vala"
		_tmp41_ = _tmp40_;
#line 1516 "../src/client/accounts/accounts-manager.vala"
		geary_service_information_set_port (service, (guint16) geary_config_file_group_get_int (_tmp36_, _tmp39_, (gint) _tmp41_));
#line 1516 "../src/client/accounts/accounts-manager.vala"
		_g_free0 (_tmp39_);
#line 1520 "../src/client/accounts/accounts-manager.vala"
		_tmp42_ = service_config;
#line 1520 "../src/client/accounts/accounts-manager.vala"
		_tmp43_ = prefix;
#line 1520 "../src/client/accounts/accounts-manager.vala"
		_tmp44_ = g_strconcat (_tmp43_, ACCOUNTS_SERVICE_CONFIG_LEGACY_SSL, NULL);
#line 1520 "../src/client/accounts/accounts-manager.vala"
		_tmp45_ = _tmp44_;
#line 1520 "../src/client/accounts/accounts-manager.vala"
		_tmp46_ = geary_service_information_get_protocol (service);
#line 1520 "../src/client/accounts/accounts-manager.vala"
		_tmp47_ = _tmp46_;
#line 1520 "../src/client/accounts/accounts-manager.vala"
		_tmp48_ = geary_config_file_group_get_bool (_tmp42_, _tmp45_, _tmp47_ == GEARY_PROTOCOL_IMAP);
#line 1520 "../src/client/accounts/accounts-manager.vala"
		_g_free0 (_tmp45_);
#line 1520 "../src/client/accounts/accounts-manager.vala"
		use_tls = _tmp48_;
#line 1523 "../src/client/accounts/accounts-manager.vala"
		_tmp49_ = service_config;
#line 1523 "../src/client/accounts/accounts-manager.vala"
		_tmp50_ = prefix;
#line 1523 "../src/client/accounts/accounts-manager.vala"
		_tmp51_ = g_strconcat (_tmp50_, ACCOUNTS_SERVICE_CONFIG_LEGACY_STARTTLS, NULL);
#line 1523 "../src/client/accounts/accounts-manager.vala"
		_tmp52_ = _tmp51_;
#line 1523 "../src/client/accounts/accounts-manager.vala"
		_tmp53_ = geary_config_file_group_get_bool (_tmp49_, _tmp52_, TRUE);
#line 1523 "../src/client/accounts/accounts-manager.vala"
		_g_free0 (_tmp52_);
#line 1523 "../src/client/accounts/accounts-manager.vala"
		use_starttls = _tmp53_;
#line 1526 "../src/client/accounts/accounts-manager.vala"
		_tmp54_ = use_tls;
#line 1526 "../src/client/accounts/accounts-manager.vala"
		if (_tmp54_) {
#line 1527 "../src/client/accounts/accounts-manager.vala"
			geary_service_information_set_transport_security (service, GEARY_TLS_NEGOTIATION_METHOD_TRANSPORT);
#line 13599 "accounts-manager.c"
		} else {
			gboolean _tmp55_;
#line 1528 "../src/client/accounts/accounts-manager.vala"
			_tmp55_ = use_starttls;
#line 1528 "../src/client/accounts/accounts-manager.vala"
			if (_tmp55_) {
#line 1529 "../src/client/accounts/accounts-manager.vala"
				geary_service_information_set_transport_security (service, GEARY_TLS_NEGOTIATION_METHOD_START_TLS);
#line 13608 "accounts-manager.c"
			} else {
#line 1531 "../src/client/accounts/accounts-manager.vala"
				geary_service_information_set_transport_security (service, GEARY_TLS_NEGOTIATION_METHOD_NONE);
#line 13612 "accounts-manager.c"
			}
		}
#line 1534 "../src/client/accounts/accounts-manager.vala"
		_tmp56_ = geary_service_information_get_protocol (service);
#line 1534 "../src/client/accounts/accounts-manager.vala"
		_tmp57_ = _tmp56_;
#line 1534 "../src/client/accounts/accounts-manager.vala"
		if (_tmp57_ == GEARY_PROTOCOL_SMTP) {
#line 13621 "accounts-manager.c"
			gboolean use_imap = FALSE;
			GearyConfigFileGroup* _tmp58_;
			GearyCredentials* _tmp59_;
			GearyCredentials* _tmp60_;
			gboolean no_auth = FALSE;
			GearyConfigFileGroup* _tmp61_;
			gboolean _tmp62_;
#line 1535 "../src/client/accounts/accounts-manager.vala"
			_tmp58_ = service_config;
#line 1535 "../src/client/accounts/accounts-manager.vala"
			_tmp59_ = geary_service_information_get_credentials (service);
#line 1535 "../src/client/accounts/accounts-manager.vala"
			_tmp60_ = _tmp59_;
#line 1535 "../src/client/accounts/accounts-manager.vala"
			use_imap = geary_config_file_group_get_bool (_tmp58_, ACCOUNTS_SERVICE_CONFIG_LEGACY_SMTP_USE_IMAP_CREDENTIALS, _tmp60_ != NULL);
#line 1538 "../src/client/accounts/accounts-manager.vala"
			_tmp61_ = service_config;
#line 1538 "../src/client/accounts/accounts-manager.vala"
			no_auth = geary_config_file_group_get_bool (_tmp61_, ACCOUNTS_SERVICE_CONFIG_LEGACY_SMTP_NOAUTH, FALSE);
#line 1541 "../src/client/accounts/accounts-manager.vala"
			_tmp62_ = use_imap;
#line 1541 "../src/client/accounts/accounts-manager.vala"
			if (_tmp62_) {
#line 1542 "../src/client/accounts/accounts-manager.vala"
				geary_service_information_set_credentials_requirement (service, GEARY_CREDENTIALS_REQUIREMENT_USE_INCOMING);
#line 13647 "accounts-manager.c"
			} else {
				gboolean _tmp63_;
#line 1544 "../src/client/accounts/accounts-manager.vala"
				_tmp63_ = no_auth;
#line 1544 "../src/client/accounts/accounts-manager.vala"
				if (!_tmp63_) {
#line 1545 "../src/client/accounts/accounts-manager.vala"
					geary_service_information_set_credentials_requirement (service, GEARY_CREDENTIALS_REQUIREMENT_CUSTOM);
#line 13656 "accounts-manager.c"
				} else {
#line 1548 "../src/client/accounts/accounts-manager.vala"
					geary_service_information_set_credentials_requirement (service, GEARY_CREDENTIALS_REQUIREMENT_NONE);
#line 13660 "accounts-manager.c"
				}
			}
		}
	}
#line 1492 "../src/client/accounts/accounts-manager.vala"
	_g_free0 (login);
#line 1492 "../src/client/accounts/accounts-manager.vala"
	_g_free0 (prefix);
#line 1492 "../src/client/accounts/accounts-manager.vala"
	_geary_config_file_group_unref0 (service_config);
#line 13671 "accounts-manager.c"
}


/** Saves an service to a config file. */
static void
accounts_service_config_legacy_real_save (AccountsServiceConfig* base,
                                          GearyAccountInformation* account,
                                          GearyServiceInformation* service,
                                          GearyConfigFile* config)
{
	AccountsServiceConfigLegacy * self;
	GearyConfigFileGroup* service_config = NULL;
	GearyConfigFileGroup* _tmp0_;
	gchar* prefix = NULL;
	GearyProtocol _tmp1_;
	GearyProtocol _tmp2_;
	gchar* _tmp3_;
	gchar* _tmp4_;
	gchar* _tmp5_;
	gchar* _tmp6_;
	gchar* _tmp7_;
	gchar* _tmp8_;
	GearyCredentials* _tmp9_;
	GearyCredentials* _tmp10_;
	GearyConfigFileGroup* _tmp19_;
	const gchar* _tmp20_;
	gchar* _tmp21_;
	gchar* _tmp22_;
	gboolean _tmp23_;
	gboolean _tmp24_;
	GearyServiceProvider _tmp25_;
	GearyServiceProvider _tmp26_;
#line 1556 "../src/client/accounts/accounts-manager.vala"
	self = G_TYPE_CHECK_INSTANCE_CAST (base, ACCOUNTS_TYPE_SERVICE_CONFIG_LEGACY, AccountsServiceConfigLegacy);
#line 1556 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail (GEARY_IS_ACCOUNT_INFORMATION (account));
#line 1556 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail (GEARY_IS_SERVICE_INFORMATION (service));
#line 1556 "../src/client/accounts/accounts-manager.vala"
	g_return_if_fail (GEARY_IS_CONFIG_FILE (config));
#line 1559 "../src/client/accounts/accounts-manager.vala"
	_tmp0_ = geary_config_file_get_group (config, ACCOUNTS_ACCOUNT_CONFIG_LEGACY_GROUP);
#line 1559 "../src/client/accounts/accounts-manager.vala"
	service_config = _tmp0_;
#line 1562 "../src/client/accounts/accounts-manager.vala"
	_tmp1_ = geary_service_information_get_protocol (service);
#line 1562 "../src/client/accounts/accounts-manager.vala"
	_tmp2_ = _tmp1_;
#line 1562 "../src/client/accounts/accounts-manager.vala"
	_tmp3_ = geary_protocol_to_value (_tmp2_);
#line 1562 "../src/client/accounts/accounts-manager.vala"
	_tmp4_ = _tmp3_;
#line 1562 "../src/client/accounts/accounts-manager.vala"
	_tmp5_ = g_ascii_strdown (_tmp4_, (gssize) -1);
#line 1562 "../src/client/accounts/accounts-manager.vala"
	_tmp6_ = _tmp5_;
#line 1562 "../src/client/accounts/accounts-manager.vala"
	_tmp7_ = g_strconcat (_tmp6_, "_", NULL);
#line 1562 "../src/client/accounts/accounts-manager.vala"
	_tmp8_ = _tmp7_;
#line 1562 "../src/client/accounts/accounts-manager.vala"
	_g_free0 (_tmp6_);
#line 1562 "../src/client/accounts/accounts-manager.vala"
	_g_free0 (_tmp4_);
#line 1562 "../src/client/accounts/accounts-manager.vala"
	prefix = _tmp8_;
#line 1564 "../src/client/accounts/accounts-manager.vala"
	_tmp9_ = geary_service_information_get_credentials (service);
#line 1564 "../src/client/accounts/accounts-manager.vala"
	_tmp10_ = _tmp9_;
#line 1564 "../src/client/accounts/accounts-manager.vala"
	if (_tmp10_ != NULL) {
#line 13744 "accounts-manager.c"
		GearyConfigFileGroup* _tmp11_;
		const gchar* _tmp12_;
		gchar* _tmp13_;
		gchar* _tmp14_;
		GearyCredentials* _tmp15_;
		GearyCredentials* _tmp16_;
		const gchar* _tmp17_;
		const gchar* _tmp18_;
#line 1565 "../src/client/accounts/accounts-manager.vala"
		_tmp11_ = service_config;
#line 1565 "../src/client/accounts/accounts-manager.vala"
		_tmp12_ = prefix;
#line 1565 "../src/client/accounts/accounts-manager.vala"
		_tmp13_ = g_strconcat (_tmp12_, ACCOUNTS_SERVICE_CONFIG_LEGACY_USERNAME, NULL);
#line 1565 "../src/client/accounts/accounts-manager.vala"
		_tmp14_ = _tmp13_;
#line 1565 "../src/client/accounts/accounts-manager.vala"
		_tmp15_ = geary_service_information_get_credentials (service);
#line 1565 "../src/client/accounts/accounts-manager.vala"
		_tmp16_ = _tmp15_;
#line 1565 "../src/client/accounts/accounts-manager.vala"
		_tmp17_ = geary_credentials_get_user (_tmp16_);
#line 1565 "../src/client/accounts/accounts-manager.vala"
		_tmp18_ = _tmp17_;
#line 1565 "../src/client/accounts/accounts-manager.vala"
		geary_config_file_group_set_string (_tmp11_, _tmp14_, _tmp18_);
#line 1565 "../src/client/accounts/accounts-manager.vala"
		_g_free0 (_tmp14_);
#line 13773 "accounts-manager.c"
	}
#line 1569 "../src/client/accounts/accounts-manager.vala"
	_tmp19_ = service_config;
#line 1569 "../src/client/accounts/accounts-manager.vala"
	_tmp20_ = prefix;
#line 1569 "../src/client/accounts/accounts-manager.vala"
	_tmp21_ = g_strconcat (_tmp20_, ACCOUNTS_SERVICE_CONFIG_LEGACY_REMEMBER_PASSWORD, NULL);
#line 1569 "../src/client/accounts/accounts-manager.vala"
	_tmp22_ = _tmp21_;
#line 1569 "../src/client/accounts/accounts-manager.vala"
	_tmp23_ = geary_service_information_get_remember_password (service);
#line 1569 "../src/client/accounts/accounts-manager.vala"
	_tmp24_ = _tmp23_;
#line 1569 "../src/client/accounts/accounts-manager.vala"
	geary_config_file_group_set_bool (_tmp19_, _tmp22_, _tmp24_);
#line 1569 "../src/client/accounts/accounts-manager.vala"
	_g_free0 (_tmp22_);
#line 1573 "../src/client/accounts/accounts-manager.vala"
	_tmp25_ = geary_account_information_get_service_provider (account);
#line 1573 "../src/client/accounts/accounts-manager.vala"
	_tmp26_ = _tmp25_;
#line 1573 "../src/client/accounts/accounts-manager.vala"
	if (_tmp26_ == GEARY_SERVICE_PROVIDER_OTHER) {
#line 13797 "accounts-manager.c"
		GearyConfigFileGroup* _tmp27_;
		const gchar* _tmp28_;
		gchar* _tmp29_;
		gchar* _tmp30_;
		const gchar* _tmp31_;
		const gchar* _tmp32_;
		GearyConfigFileGroup* _tmp33_;
		const gchar* _tmp34_;
		gchar* _tmp35_;
		gchar* _tmp36_;
		guint16 _tmp37_;
		guint16 _tmp38_;
		GearyTlsNegotiationMethod _tmp39_;
		GearyTlsNegotiationMethod _tmp40_;
		GearyProtocol _tmp65_;
		GearyProtocol _tmp66_;
#line 1574 "../src/client/accounts/accounts-manager.vala"
		_tmp27_ = service_config;
#line 1574 "../src/client/accounts/accounts-manager.vala"
		_tmp28_ = prefix;
#line 1574 "../src/client/accounts/accounts-manager.vala"
		_tmp29_ = g_strconcat (_tmp28_, ACCOUNTS_SERVICE_CONFIG_LEGACY_HOST, NULL);
#line 1574 "../src/client/accounts/accounts-manager.vala"
		_tmp30_ = _tmp29_;
#line 1574 "../src/client/accounts/accounts-manager.vala"
		_tmp31_ = geary_service_information_get_host (service);
#line 1574 "../src/client/accounts/accounts-manager.vala"
		_tmp32_ = _tmp31_;
#line 1574 "../src/client/accounts/accounts-manager.vala"
		geary_config_file_group_set_string (_tmp27_, _tmp30_, _tmp32_);
#line 1574 "../src/client/accounts/accounts-manager.vala"
		_g_free0 (_tmp30_);
#line 1575 "../src/client/accounts/accounts-manager.vala"
		_tmp33_ = service_config;
#line 1575 "../src/client/accounts/accounts-manager.vala"
		_tmp34_ = prefix;
#line 1575 "../src/client/accounts/accounts-manager.vala"
		_tmp35_ = g_strconcat (_tmp34_, ACCOUNTS_SERVICE_CONFIG_LEGACY_PORT, NULL);
#line 1575 "../src/client/accounts/accounts-manager.vala"
		_tmp36_ = _tmp35_;
#line 1575 "../src/client/accounts/accounts-manager.vala"
		_tmp37_ = geary_service_information_get_port (service);
#line 1575 "../src/client/accounts/accounts-manager.vala"
		_tmp38_ = _tmp37_;
#line 1575 "../src/client/accounts/accounts-manager.vala"
		geary_config_file_group_set_int (_tmp33_, _tmp36_, (gint) _tmp38_);
#line 1575 "../src/client/accounts/accounts-manager.vala"
		_g_free0 (_tmp36_);
#line 1577 "../src/client/accounts/accounts-manager.vala"
		_tmp39_ = geary_service_information_get_transport_security (service);
#line 1577 "../src/client/accounts/accounts-manager.vala"
		_tmp40_ = _tmp39_;
#line 1577 "../src/client/accounts/accounts-manager.vala"
		switch (_tmp40_) {
#line 1577 "../src/client/accounts/accounts-manager.vala"
			case GEARY_TLS_NEGOTIATION_METHOD_NONE:
#line 13854 "accounts-manager.c"
			{
				GearyConfigFileGroup* _tmp41_;
				const gchar* _tmp42_;
				gchar* _tmp43_;
				gchar* _tmp44_;
				GearyConfigFileGroup* _tmp45_;
				const gchar* _tmp46_;
				gchar* _tmp47_;
				gchar* _tmp48_;
#line 1579 "../src/client/accounts/accounts-manager.vala"
				_tmp41_ = service_config;
#line 1579 "../src/client/accounts/accounts-manager.vala"
				_tmp42_ = prefix;
#line 1579 "../src/client/accounts/accounts-manager.vala"
				_tmp43_ = g_strconcat (_tmp42_, ACCOUNTS_SERVICE_CONFIG_LEGACY_SSL, NULL);
#line 1579 "../src/client/accounts/accounts-manager.vala"
				_tmp44_ = _tmp43_;
#line 1579 "../src/client/accounts/accounts-manager.vala"
				geary_config_file_group_set_bool (_tmp41_, _tmp44_, FALSE);
#line 1579 "../src/client/accounts/accounts-manager.vala"
				_g_free0 (_tmp44_);
#line 1580 "../src/client/accounts/accounts-manager.vala"
				_tmp45_ = service_config;
#line 1580 "../src/client/accounts/accounts-manager.vala"
				_tmp46_ = prefix;
#line 1580 "../src/client/accounts/accounts-manager.vala"
				_tmp47_ = g_strconcat (_tmp46_, ACCOUNTS_SERVICE_CONFIG_LEGACY_STARTTLS, NULL);
#line 1580 "../src/client/accounts/accounts-manager.vala"
				_tmp48_ = _tmp47_;
#line 1580 "../src/client/accounts/accounts-manager.vala"
				geary_config_file_group_set_bool (_tmp45_, _tmp48_, FALSE);
#line 1580 "../src/client/accounts/accounts-manager.vala"
				_g_free0 (_tmp48_);
#line 1581 "../src/client/accounts/accounts-manager.vala"
				break;
#line 13890 "accounts-manager.c"
			}
#line 1577 "../src/client/accounts/accounts-manager.vala"
			case GEARY_TLS_NEGOTIATION_METHOD_START_TLS:
#line 13894 "accounts-manager.c"
			{
				GearyConfigFileGroup* _tmp49_;
				const gchar* _tmp50_;
				gchar* _tmp51_;
				gchar* _tmp52_;
				GearyConfigFileGroup* _tmp53_;
				const gchar* _tmp54_;
				gchar* _tmp55_;
				gchar* _tmp56_;
#line 1584 "../src/client/accounts/accounts-manager.vala"
				_tmp49_ = service_config;
#line 1584 "../src/client/accounts/accounts-manager.vala"
				_tmp50_ = prefix;
#line 1584 "../src/client/accounts/accounts-manager.vala"
				_tmp51_ = g_strconcat (_tmp50_, ACCOUNTS_SERVICE_CONFIG_LEGACY_SSL, NULL);
#line 1584 "../src/client/accounts/accounts-manager.vala"
				_tmp52_ = _tmp51_;
#line 1584 "../src/client/accounts/accounts-manager.vala"
				geary_config_file_group_set_bool (_tmp49_, _tmp52_, FALSE);
#line 1584 "../src/client/accounts/accounts-manager.vala"
				_g_free0 (_tmp52_);
#line 1585 "../src/client/accounts/accounts-manager.vala"
				_tmp53_ = service_config;
#line 1585 "../src/client/accounts/accounts-manager.vala"
				_tmp54_ = prefix;
#line 1585 "../src/client/accounts/accounts-manager.vala"
				_tmp55_ = g_strconcat (_tmp54_, ACCOUNTS_SERVICE_CONFIG_LEGACY_STARTTLS, NULL);
#line 1585 "../src/client/accounts/accounts-manager.vala"
				_tmp56_ = _tmp55_;
#line 1585 "../src/client/accounts/accounts-manager.vala"
				geary_config_file_group_set_bool (_tmp53_, _tmp56_, TRUE);
#line 1585 "../src/client/accounts/accounts-manager.vala"
				_g_free0 (_tmp56_);
#line 1586 "../src/client/accounts/accounts-manager.vala"
				break;
#line 13930 "accounts-manager.c"
			}
#line 1577 "../src/client/accounts/accounts-manager.vala"
			case GEARY_TLS_NEGOTIATION_METHOD_TRANSPORT:
#line 13934 "accounts-manager.c"
			{
				GearyConfigFileGroup* _tmp57_;
				const gchar* _tmp58_;
				gchar* _tmp59_;
				gchar* _tmp60_;
				GearyConfigFileGroup* _tmp61_;
				const gchar* _tmp62_;
				gchar* _tmp63_;
				gchar* _tmp64_;
#line 1589 "../src/client/accounts/accounts-manager.vala"
				_tmp57_ = service_config;
#line 1589 "../src/client/accounts/accounts-manager.vala"
				_tmp58_ = prefix;
#line 1589 "../src/client/accounts/accounts-manager.vala"
				_tmp59_ = g_strconcat (_tmp58_, ACCOUNTS_SERVICE_CONFIG_LEGACY_SSL, NULL);
#line 1589 "../src/client/accounts/accounts-manager.vala"
				_tmp60_ = _tmp59_;
#line 1589 "../src/client/accounts/accounts-manager.vala"
				geary_config_file_group_set_bool (_tmp57_, _tmp60_, TRUE);
#line 1589 "../src/client/accounts/accounts-manager.vala"
				_g_free0 (_tmp60_);
#line 1590 "../src/client/accounts/accounts-manager.vala"
				_tmp61_ = service_config;
#line 1590 "../src/client/accounts/accounts-manager.vala"
				_tmp62_ = prefix;
#line 1590 "../src/client/accounts/accounts-manager.vala"
				_tmp63_ = g_strconcat (_tmp62_, ACCOUNTS_SERVICE_CONFIG_LEGACY_STARTTLS, NULL);
#line 1590 "../src/client/accounts/accounts-manager.vala"
				_tmp64_ = _tmp63_;
#line 1590 "../src/client/accounts/accounts-manager.vala"
				geary_config_file_group_set_bool (_tmp61_, _tmp64_, FALSE);
#line 1590 "../src/client/accounts/accounts-manager.vala"
				_g_free0 (_tmp64_);
#line 1591 "../src/client/accounts/accounts-manager.vala"
				break;
#line 13970 "accounts-manager.c"
			}
			default:
#line 1577 "../src/client/accounts/accounts-manager.vala"
			break;
#line 13975 "accounts-manager.c"
		}
#line 1594 "../src/client/accounts/accounts-manager.vala"
		_tmp65_ = geary_service_information_get_protocol (service);
#line 1594 "../src/client/accounts/accounts-manager.vala"
		_tmp66_ = _tmp65_;
#line 1594 "../src/client/accounts/accounts-manager.vala"
		if (_tmp66_ == GEARY_PROTOCOL_SMTP) {
#line 13983 "accounts-manager.c"
			GearyCredentialsRequirement _tmp67_;
			GearyCredentialsRequirement _tmp68_;
#line 1595 "../src/client/accounts/accounts-manager.vala"
			_tmp67_ = geary_service_information_get_credentials_requirement (service);
#line 1595 "../src/client/accounts/accounts-manager.vala"
			_tmp68_ = _tmp67_;
#line 1595 "../src/client/accounts/accounts-manager.vala"
			switch (_tmp68_) {
#line 1595 "../src/client/accounts/accounts-manager.vala"
				case GEARY_CREDENTIALS_REQUIREMENT_NONE:
#line 13994 "accounts-manager.c"
				{
					GearyConfigFileGroup* _tmp69_;
					GearyConfigFileGroup* _tmp70_;
#line 1597 "../src/client/accounts/accounts-manager.vala"
					_tmp69_ = service_config;
#line 1597 "../src/client/accounts/accounts-manager.vala"
					geary_config_file_group_set_bool (_tmp69_, ACCOUNTS_SERVICE_CONFIG_LEGACY_SMTP_USE_IMAP_CREDENTIALS, FALSE);
#line 1598 "../src/client/accounts/accounts-manager.vala"
					_tmp70_ = service_config;
#line 1598 "../src/client/accounts/accounts-manager.vala"
					geary_config_file_group_set_bool (_tmp70_, ACCOUNTS_SERVICE_CONFIG_LEGACY_SMTP_NOAUTH, TRUE);
#line 1599 "../src/client/accounts/accounts-manager.vala"
					break;
#line 14008 "accounts-manager.c"
				}
#line 1595 "../src/client/accounts/accounts-manager.vala"
				case GEARY_CREDENTIALS_REQUIREMENT_USE_INCOMING:
#line 14012 "accounts-manager.c"
				{
					GearyConfigFileGroup* _tmp71_;
					GearyConfigFileGroup* _tmp72_;
#line 1602 "../src/client/accounts/accounts-manager.vala"
					_tmp71_ = service_config;
#line 1602 "../src/client/accounts/accounts-manager.vala"
					geary_config_file_group_set_bool (_tmp71_, ACCOUNTS_SERVICE_CONFIG_LEGACY_SMTP_USE_IMAP_CREDENTIALS, TRUE);
#line 1603 "../src/client/accounts/accounts-manager.vala"
					_tmp72_ = service_config;
#line 1603 "../src/client/accounts/accounts-manager.vala"
					geary_config_file_group_set_bool (_tmp72_, ACCOUNTS_SERVICE_CONFIG_LEGACY_SMTP_NOAUTH, FALSE);
#line 1604 "../src/client/accounts/accounts-manager.vala"
					break;
#line 14026 "accounts-manager.c"
				}
#line 1595 "../src/client/accounts/accounts-manager.vala"
				case GEARY_CREDENTIALS_REQUIREMENT_CUSTOM:
#line 14030 "accounts-manager.c"
				{
					GearyConfigFileGroup* _tmp73_;
					GearyConfigFileGroup* _tmp74_;
#line 1607 "../src/client/accounts/accounts-manager.vala"
					_tmp73_ = service_config;
#line 1607 "../src/client/accounts/accounts-manager.vala"
					geary_config_file_group_set_bool (_tmp73_, ACCOUNTS_SERVICE_CONFIG_LEGACY_SMTP_USE_IMAP_CREDENTIALS, FALSE);
#line 1608 "../src/client/accounts/accounts-manager.vala"
					_tmp74_ = service_config;
#line 1608 "../src/client/accounts/accounts-manager.vala"
					geary_config_file_group_set_bool (_tmp74_, ACCOUNTS_SERVICE_CONFIG_LEGACY_SMTP_NOAUTH, FALSE);
#line 1609 "../src/client/accounts/accounts-manager.vala"
					break;
#line 14044 "accounts-manager.c"
				}
				default:
#line 1595 "../src/client/accounts/accounts-manager.vala"
				break;
#line 14049 "accounts-manager.c"
			}
		}
	}
#line 1556 "../src/client/accounts/accounts-manager.vala"
	_g_free0 (prefix);
#line 1556 "../src/client/accounts/accounts-manager.vala"
	_geary_config_file_group_unref0 (service_config);
#line 14057 "accounts-manager.c"
}


AccountsServiceConfigLegacy*
accounts_service_config_legacy_construct (GType object_type)
{
	AccountsServiceConfigLegacy * self = NULL;
#line 1477 "../src/client/accounts/accounts-manager.vala"
	self = (AccountsServiceConfigLegacy*) g_object_new (object_type, NULL);
#line 1477 "../src/client/accounts/accounts-manager.vala"
	return self;
#line 14069 "accounts-manager.c"
}


AccountsServiceConfigLegacy*
accounts_service_config_legacy_new (void)
{
#line 1477 "../src/client/accounts/accounts-manager.vala"
	return accounts_service_config_legacy_construct (ACCOUNTS_TYPE_SERVICE_CONFIG_LEGACY);
#line 14078 "accounts-manager.c"
}


static void
accounts_service_config_legacy_class_init (AccountsServiceConfigLegacyClass * klass)
{
#line 1477 "../src/client/accounts/accounts-manager.vala"
	accounts_service_config_legacy_parent_class = g_type_class_peek_parent (klass);
#line 14087 "accounts-manager.c"
}


static void
accounts_service_config_legacy_accounts_service_config_interface_init (AccountsServiceConfigIface * iface)
{
#line 1477 "../src/client/accounts/accounts-manager.vala"
	accounts_service_config_legacy_accounts_service_config_parent_iface = g_type_interface_peek_parent (iface);
#line 1477 "../src/client/accounts/accounts-manager.vala"
	iface->load = (void (*) (AccountsServiceConfig*, GearyConfigFile*, GearyAccountInformation*, GearyServiceInformation*, GError**)) accounts_service_config_legacy_real_load;
#line 1477 "../src/client/accounts/accounts-manager.vala"
	iface->save = (void (*) (AccountsServiceConfig*, GearyAccountInformation*, GearyServiceInformation*, GearyConfigFile*)) accounts_service_config_legacy_real_save;
#line 14100 "accounts-manager.c"
}


static void
accounts_service_config_legacy_instance_init (AccountsServiceConfigLegacy * self)
{
}


/**
 * Manages persistence for un-versioned service configuration.
 */
GType
accounts_service_config_legacy_get_type (void)
{
	static volatile gsize accounts_service_config_legacy_type_id__volatile = 0;
	if (g_once_init_enter (&accounts_service_config_legacy_type_id__volatile)) {
		static const GTypeInfo g_define_type_info = { sizeof (AccountsServiceConfigLegacyClass), (GBaseInitFunc) NULL, (GBaseFinalizeFunc) NULL, (GClassInitFunc) accounts_service_config_legacy_class_init, (GClassFinalizeFunc) NULL, NULL, sizeof (AccountsServiceConfigLegacy), 0, (GInstanceInitFunc) accounts_service_config_legacy_instance_init, NULL };
		static const GInterfaceInfo accounts_service_config_info = { (GInterfaceInitFunc) accounts_service_config_legacy_accounts_service_config_interface_init, (GInterfaceFinalizeFunc) NULL, NULL};
		GType accounts_service_config_legacy_type_id;
		accounts_service_config_legacy_type_id = g_type_register_static (G_TYPE_OBJECT, "AccountsServiceConfigLegacy", &g_define_type_info, 0);
		g_type_add_interface_static (accounts_service_config_legacy_type_id, ACCOUNTS_TYPE_SERVICE_CONFIG, &accounts_service_config_info);
		g_once_init_leave (&accounts_service_config_legacy_type_id__volatile, accounts_service_config_legacy_type_id);
	}
	return accounts_service_config_legacy_type_id__volatile;
}


static void
_vala_array_destroy (gpointer array,
                     gint array_length,
                     GDestroyNotify destroy_func)
{
	if ((array != NULL) && (destroy_func != NULL)) {
		int i;
		for (i = 0; i < array_length; i = i + 1) {
			if (((gpointer*) array)[i] != NULL) {
				destroy_func (((gpointer*) array)[i]);
			}
		}
	}
}


static void
_vala_array_free (gpointer array,
                  gint array_length,
                  GDestroyNotify destroy_func)
{
	_vala_array_destroy (array, array_length, destroy_func);
	g_free (array);
}



